// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/ActuatorDirect.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__ACTUATOR_DIRECT__STRUCT_HPP_
#define PX4_MSGS__MSG__ACTUATOR_DIRECT__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__ActuatorDirect __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__ActuatorDirect __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ActuatorDirect_
{
  using Type = ActuatorDirect_<ContainerAllocator>;

  explicit ActuatorDirect_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->nvalues = 0ul;
      std::fill<typename std::array<float, 16>::iterator, float>(this->values.begin(), this->values.end(), 0.0f);
    }
  }

  explicit ActuatorDirect_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : values(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->nvalues = 0ul;
      std::fill<typename std::array<float, 16>::iterator, float>(this->values.begin(), this->values.end(), 0.0f);
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _nvalues_type =
    uint32_t;
  _nvalues_type nvalues;
  using _values_type =
    std::array<float, 16>;
  _values_type values;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__nvalues(
    const uint32_t & _arg)
  {
    this->nvalues = _arg;
    return *this;
  }
  Type & set__values(
    const std::array<float, 16> & _arg)
  {
    this->values = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NUM_ACTUATORS_DIRECT =
    16u;

  // pointer types
  using RawPtr =
    px4_msgs::msg::ActuatorDirect_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::ActuatorDirect_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::ActuatorDirect_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::ActuatorDirect_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::ActuatorDirect_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::ActuatorDirect_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::ActuatorDirect_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::ActuatorDirect_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::ActuatorDirect_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::ActuatorDirect_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__ActuatorDirect
    std::shared_ptr<px4_msgs::msg::ActuatorDirect_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__ActuatorDirect
    std::shared_ptr<px4_msgs::msg::ActuatorDirect_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ActuatorDirect_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->nvalues != other.nvalues) {
      return false;
    }
    if (this->values != other.values) {
      return false;
    }
    return true;
  }
  bool operator!=(const ActuatorDirect_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ActuatorDirect_

// alias to use template instance with default allocator
using ActuatorDirect =
  px4_msgs::msg::ActuatorDirect_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t ActuatorDirect_<ContainerAllocator>::NUM_ACTUATORS_DIRECT;

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__ACTUATOR_DIRECT__STRUCT_HPP_
