#ifndef _H_A930C1803E8758984063561E4FDF8B68_ActuatorArmed_DCPS_H_
#define _H_A930C1803E8758984063561E4FDF8B68_ActuatorArmed_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorArmed_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorArmed_TypeSupportInterface;

            typedef ActuatorArmed_TypeSupportInterface * ActuatorArmed_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorArmed_TypeSupportInterface> ActuatorArmed_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorArmed_TypeSupportInterface> ActuatorArmed_TypeSupportInterface_out;


            class ActuatorArmed_DataWriter;

            typedef ActuatorArmed_DataWriter * ActuatorArmed_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorArmed_DataWriter> ActuatorArmed_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorArmed_DataWriter> ActuatorArmed_DataWriter_out;


            class ActuatorArmed_DataReader;

            typedef ActuatorArmed_DataReader * ActuatorArmed_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorArmed_DataReader> ActuatorArmed_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorArmed_DataReader> ActuatorArmed_DataReader_out;


            class ActuatorArmed_DataReaderView;

            typedef ActuatorArmed_DataReaderView * ActuatorArmed_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorArmed_DataReaderView> ActuatorArmed_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorArmed_DataReaderView> ActuatorArmed_DataReaderView_out;

            struct ActuatorArmed_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorArmed_, struct ActuatorArmed_Seq_uniq_> ActuatorArmed_Seq;
            typedef DDS_DCPSSequence_var < ActuatorArmed_Seq> ActuatorArmed_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorArmed_Seq> ActuatorArmed_Seq_out;

            class  ActuatorArmed_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorArmed_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorArmed_TypeSupportInterface_var _var_type;

                static ActuatorArmed_TypeSupportInterface_ptr _duplicate (ActuatorArmed_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorArmed_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorArmed_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorArmed_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorArmed_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorArmed_TypeSupportInterface () {};
                ~ActuatorArmed_TypeSupportInterface () {};
            private:
                ActuatorArmed_TypeSupportInterface (const ActuatorArmed_TypeSupportInterface &);
                ActuatorArmed_TypeSupportInterface & operator = (const ActuatorArmed_TypeSupportInterface &);
            };

            class  ActuatorArmed_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorArmed_DataWriter_ptr _ptr_type;
                typedef ActuatorArmed_DataWriter_var _var_type;

                static ActuatorArmed_DataWriter_ptr _duplicate (ActuatorArmed_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorArmed_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorArmed_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorArmed_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorArmed_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorArmed_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorArmed_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorArmed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorArmed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorArmed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorArmed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorArmed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorArmed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorArmed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorArmed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorArmed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorArmed_& instance_data) = 0;

            protected:
                ActuatorArmed_DataWriter () {};
                ~ActuatorArmed_DataWriter () {};
            private:
                ActuatorArmed_DataWriter (const ActuatorArmed_DataWriter &);
                ActuatorArmed_DataWriter & operator = (const ActuatorArmed_DataWriter &);
            };

            class  ActuatorArmed_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorArmed_DataReader_ptr _ptr_type;
                typedef ActuatorArmed_DataReader_var _var_type;

                static ActuatorArmed_DataReader_ptr _duplicate (ActuatorArmed_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorArmed_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorArmed_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorArmed_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorArmed_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorArmed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorArmed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorArmed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorArmed_& instance) = 0;

            protected:
                ActuatorArmed_DataReader () {};
                ~ActuatorArmed_DataReader () {};
            private:
                ActuatorArmed_DataReader (const ActuatorArmed_DataReader &);
                ActuatorArmed_DataReader & operator = (const ActuatorArmed_DataReader &);
            };

            class  ActuatorArmed_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorArmed_DataReaderView_ptr _ptr_type;
                typedef ActuatorArmed_DataReaderView_var _var_type;

                static ActuatorArmed_DataReaderView_ptr _duplicate (ActuatorArmed_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorArmed_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorArmed_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorArmed_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorArmed_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorArmed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorArmed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorArmed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorArmed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorArmed_& instance) = 0;

            protected:
                ActuatorArmed_DataReaderView () {};
                ~ActuatorArmed_DataReaderView () {};
            private:
                ActuatorArmed_DataReaderView (const ActuatorArmed_DataReaderView &);
                ActuatorArmed_DataReaderView & operator = (const ActuatorArmed_DataReaderView &);
            };
        }

    }

}

#endif
