#ifndef _H_FCCEF3912C52C079F03DDFB638E2D46E_ActuatorControls0_DCPS_H_
#define _H_FCCEF3912C52C079F03DDFB638E2D46E_ActuatorControls0_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorControls0_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorControls0_TypeSupportInterface;

            typedef ActuatorControls0_TypeSupportInterface * ActuatorControls0_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls0_TypeSupportInterface> ActuatorControls0_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorControls0_TypeSupportInterface> ActuatorControls0_TypeSupportInterface_out;


            class ActuatorControls0_DataWriter;

            typedef ActuatorControls0_DataWriter * ActuatorControls0_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls0_DataWriter> ActuatorControls0_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorControls0_DataWriter> ActuatorControls0_DataWriter_out;


            class ActuatorControls0_DataReader;

            typedef ActuatorControls0_DataReader * ActuatorControls0_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls0_DataReader> ActuatorControls0_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorControls0_DataReader> ActuatorControls0_DataReader_out;


            class ActuatorControls0_DataReaderView;

            typedef ActuatorControls0_DataReaderView * ActuatorControls0_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls0_DataReaderView> ActuatorControls0_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorControls0_DataReaderView> ActuatorControls0_DataReaderView_out;

            struct ActuatorControls0_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorControls0_, struct ActuatorControls0_Seq_uniq_> ActuatorControls0_Seq;
            typedef DDS_DCPSSequence_var < ActuatorControls0_Seq> ActuatorControls0_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorControls0_Seq> ActuatorControls0_Seq_out;

            class  ActuatorControls0_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorControls0_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorControls0_TypeSupportInterface_var _var_type;

                static ActuatorControls0_TypeSupportInterface_ptr _duplicate (ActuatorControls0_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls0_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls0_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls0_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls0_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorControls0_TypeSupportInterface () {};
                ~ActuatorControls0_TypeSupportInterface () {};
            private:
                ActuatorControls0_TypeSupportInterface (const ActuatorControls0_TypeSupportInterface &);
                ActuatorControls0_TypeSupportInterface & operator = (const ActuatorControls0_TypeSupportInterface &);
            };

            class  ActuatorControls0_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorControls0_DataWriter_ptr _ptr_type;
                typedef ActuatorControls0_DataWriter_var _var_type;

                static ActuatorControls0_DataWriter_ptr _duplicate (ActuatorControls0_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls0_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls0_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls0_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls0_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorControls0_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorControls0_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorControls0_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorControls0_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorControls0_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorControls0_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorControls0_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorControls0_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorControls0_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorControls0_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorControls0_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls0_& instance_data) = 0;

            protected:
                ActuatorControls0_DataWriter () {};
                ~ActuatorControls0_DataWriter () {};
            private:
                ActuatorControls0_DataWriter (const ActuatorControls0_DataWriter &);
                ActuatorControls0_DataWriter & operator = (const ActuatorControls0_DataWriter &);
            };

            class  ActuatorControls0_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorControls0_DataReader_ptr _ptr_type;
                typedef ActuatorControls0_DataReader_var _var_type;

                static ActuatorControls0_DataReader_ptr _duplicate (ActuatorControls0_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls0_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls0_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls0_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls0_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls0_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls0_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls0_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls0_& instance) = 0;

            protected:
                ActuatorControls0_DataReader () {};
                ~ActuatorControls0_DataReader () {};
            private:
                ActuatorControls0_DataReader (const ActuatorControls0_DataReader &);
                ActuatorControls0_DataReader & operator = (const ActuatorControls0_DataReader &);
            };

            class  ActuatorControls0_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorControls0_DataReaderView_ptr _ptr_type;
                typedef ActuatorControls0_DataReaderView_var _var_type;

                static ActuatorControls0_DataReaderView_ptr _duplicate (ActuatorControls0_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls0_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls0_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls0_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls0_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls0_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls0_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls0_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls0_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls0_& instance) = 0;

            protected:
                ActuatorControls0_DataReaderView () {};
                ~ActuatorControls0_DataReaderView () {};
            private:
                ActuatorControls0_DataReaderView (const ActuatorControls0_DataReaderView &);
                ActuatorControls0_DataReaderView & operator = (const ActuatorControls0_DataReaderView &);
            };
        }

    }

}

#endif
