#ifndef _H_D7837BD6D2776F077E0AF37C23134B35_ActuatorControls2_DCPS_H_
#define _H_D7837BD6D2776F077E0AF37C23134B35_ActuatorControls2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorControls2_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorControls2_TypeSupportInterface;

            typedef ActuatorControls2_TypeSupportInterface * ActuatorControls2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls2_TypeSupportInterface> ActuatorControls2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorControls2_TypeSupportInterface> ActuatorControls2_TypeSupportInterface_out;


            class ActuatorControls2_DataWriter;

            typedef ActuatorControls2_DataWriter * ActuatorControls2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls2_DataWriter> ActuatorControls2_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorControls2_DataWriter> ActuatorControls2_DataWriter_out;


            class ActuatorControls2_DataReader;

            typedef ActuatorControls2_DataReader * ActuatorControls2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls2_DataReader> ActuatorControls2_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorControls2_DataReader> ActuatorControls2_DataReader_out;


            class ActuatorControls2_DataReaderView;

            typedef ActuatorControls2_DataReaderView * ActuatorControls2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls2_DataReaderView> ActuatorControls2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorControls2_DataReaderView> ActuatorControls2_DataReaderView_out;

            struct ActuatorControls2_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorControls2_, struct ActuatorControls2_Seq_uniq_> ActuatorControls2_Seq;
            typedef DDS_DCPSSequence_var < ActuatorControls2_Seq> ActuatorControls2_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorControls2_Seq> ActuatorControls2_Seq_out;

            class  ActuatorControls2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorControls2_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorControls2_TypeSupportInterface_var _var_type;

                static ActuatorControls2_TypeSupportInterface_ptr _duplicate (ActuatorControls2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorControls2_TypeSupportInterface () {};
                ~ActuatorControls2_TypeSupportInterface () {};
            private:
                ActuatorControls2_TypeSupportInterface (const ActuatorControls2_TypeSupportInterface &);
                ActuatorControls2_TypeSupportInterface & operator = (const ActuatorControls2_TypeSupportInterface &);
            };

            class  ActuatorControls2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorControls2_DataWriter_ptr _ptr_type;
                typedef ActuatorControls2_DataWriter_var _var_type;

                static ActuatorControls2_DataWriter_ptr _duplicate (ActuatorControls2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorControls2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorControls2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorControls2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorControls2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorControls2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorControls2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorControls2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorControls2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorControls2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorControls2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorControls2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls2_& instance_data) = 0;

            protected:
                ActuatorControls2_DataWriter () {};
                ~ActuatorControls2_DataWriter () {};
            private:
                ActuatorControls2_DataWriter (const ActuatorControls2_DataWriter &);
                ActuatorControls2_DataWriter & operator = (const ActuatorControls2_DataWriter &);
            };

            class  ActuatorControls2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorControls2_DataReader_ptr _ptr_type;
                typedef ActuatorControls2_DataReader_var _var_type;

                static ActuatorControls2_DataReader_ptr _duplicate (ActuatorControls2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls2_& instance) = 0;

            protected:
                ActuatorControls2_DataReader () {};
                ~ActuatorControls2_DataReader () {};
            private:
                ActuatorControls2_DataReader (const ActuatorControls2_DataReader &);
                ActuatorControls2_DataReader & operator = (const ActuatorControls2_DataReader &);
            };

            class  ActuatorControls2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorControls2_DataReaderView_ptr _ptr_type;
                typedef ActuatorControls2_DataReaderView_var _var_type;

                static ActuatorControls2_DataReaderView_ptr _duplicate (ActuatorControls2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls2_& instance) = 0;

            protected:
                ActuatorControls2_DataReaderView () {};
                ~ActuatorControls2_DataReaderView () {};
            private:
                ActuatorControls2_DataReaderView (const ActuatorControls2_DataReaderView &);
                ActuatorControls2_DataReaderView & operator = (const ActuatorControls2_DataReaderView &);
            };
        }

    }

}

#endif
