#ifndef _H_F31C61EE0153ACB5A8949F4234C84668_ActuatorControlsVirtualFw__H_
#define _H_F31C61EE0153ACB5A8949F4234C84668_ActuatorControlsVirtualFw__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ActuatorControlsVirtualFw_Constants
            {
                const ::DDS::Octet NUM_ACTUATOR_CONTROLS_ = 8;

                const ::DDS::Octet NUM_ACTUATOR_CONTROL_GROUPS_ = 4;

                const ::DDS::Octet INDEX_ROLL_ = 0;

                const ::DDS::Octet INDEX_PITCH_ = 1;

                const ::DDS::Octet INDEX_YAW_ = 2;

                const ::DDS::Octet INDEX_THROTTLE_ = 3;

                const ::DDS::Octet INDEX_FLAPS_ = 4;

                const ::DDS::Octet INDEX_SPOILERS_ = 5;

                const ::DDS::Octet INDEX_AIRBRAKES_ = 6;

                const ::DDS::Octet INDEX_LANDING_GEAR_ = 7;

                const ::DDS::Octet GROUP_INDEX_ATTITUDE_ = 0;

                const ::DDS::Octet GROUP_INDEX_ATTITUDE_ALTERNATE_ = 1;

            }

            struct  ActuatorControlsVirtualFw_
            {
                struct _control__uniq_{};
                typedef ::DDS::Float _control__slice;
                typedef ::DDS::Float _control_[8];
                typedef DDS_DCPS_FArray_var< _control_, _control__slice, struct _control__uniq_ > _control__var;
                typedef _control_ _control__out;
                typedef DDS_DCPS_Array_forany< _control_, _control__slice, struct _control__uniq_ > _control__forany;
                static _control__slice *_control__alloc();
                static void _control__free(_control__slice *);
                static void _control__copy(_control__slice *to, const _control__slice *from);
                static _control__slice *_control__dup(const _control__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::ULongLong timestamp_sample_;
                _control_ control_;
            };

            typedef DDS_DCPSStruct_var<ActuatorControlsVirtualFw_> ActuatorControlsVirtualFw__var;
            typedef ActuatorControlsVirtualFw_& ActuatorControlsVirtualFw__out;

        }

    }

}

#endif /* _H_F31C61EE0153ACB5A8949F4234C84668_ActuatorControlsVirtualFw__H_ */
