#ifndef _H_4D921B2062EC33A80655FEF606E31880_ActuatorControls_DCPS_H_
#define _H_4D921B2062EC33A80655FEF606E31880_ActuatorControls_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorControls_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorControls_TypeSupportInterface;

            typedef ActuatorControls_TypeSupportInterface * ActuatorControls_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls_TypeSupportInterface> ActuatorControls_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorControls_TypeSupportInterface> ActuatorControls_TypeSupportInterface_out;


            class ActuatorControls_DataWriter;

            typedef ActuatorControls_DataWriter * ActuatorControls_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls_DataWriter> ActuatorControls_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorControls_DataWriter> ActuatorControls_DataWriter_out;


            class ActuatorControls_DataReader;

            typedef ActuatorControls_DataReader * ActuatorControls_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls_DataReader> ActuatorControls_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorControls_DataReader> ActuatorControls_DataReader_out;


            class ActuatorControls_DataReaderView;

            typedef ActuatorControls_DataReaderView * ActuatorControls_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls_DataReaderView> ActuatorControls_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorControls_DataReaderView> ActuatorControls_DataReaderView_out;

            struct ActuatorControls_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorControls_, struct ActuatorControls_Seq_uniq_> ActuatorControls_Seq;
            typedef DDS_DCPSSequence_var < ActuatorControls_Seq> ActuatorControls_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorControls_Seq> ActuatorControls_Seq_out;

            class  ActuatorControls_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorControls_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorControls_TypeSupportInterface_var _var_type;

                static ActuatorControls_TypeSupportInterface_ptr _duplicate (ActuatorControls_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorControls_TypeSupportInterface () {};
                ~ActuatorControls_TypeSupportInterface () {};
            private:
                ActuatorControls_TypeSupportInterface (const ActuatorControls_TypeSupportInterface &);
                ActuatorControls_TypeSupportInterface & operator = (const ActuatorControls_TypeSupportInterface &);
            };

            class  ActuatorControls_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorControls_DataWriter_ptr _ptr_type;
                typedef ActuatorControls_DataWriter_var _var_type;

                static ActuatorControls_DataWriter_ptr _duplicate (ActuatorControls_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorControls_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorControls_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorControls_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorControls_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorControls_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorControls_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorControls_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorControls_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorControls_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorControls_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorControls_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls_& instance_data) = 0;

            protected:
                ActuatorControls_DataWriter () {};
                ~ActuatorControls_DataWriter () {};
            private:
                ActuatorControls_DataWriter (const ActuatorControls_DataWriter &);
                ActuatorControls_DataWriter & operator = (const ActuatorControls_DataWriter &);
            };

            class  ActuatorControls_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorControls_DataReader_ptr _ptr_type;
                typedef ActuatorControls_DataReader_var _var_type;

                static ActuatorControls_DataReader_ptr _duplicate (ActuatorControls_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls_& instance) = 0;

            protected:
                ActuatorControls_DataReader () {};
                ~ActuatorControls_DataReader () {};
            private:
                ActuatorControls_DataReader (const ActuatorControls_DataReader &);
                ActuatorControls_DataReader & operator = (const ActuatorControls_DataReader &);
            };

            class  ActuatorControls_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorControls_DataReaderView_ptr _ptr_type;
                typedef ActuatorControls_DataReaderView_var _var_type;

                static ActuatorControls_DataReaderView_ptr _duplicate (ActuatorControls_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls_& instance) = 0;

            protected:
                ActuatorControls_DataReaderView () {};
                ~ActuatorControls_DataReaderView () {};
            private:
                ActuatorControls_DataReaderView (const ActuatorControls_DataReaderView &);
                ActuatorControls_DataReaderView & operator = (const ActuatorControls_DataReaderView &);
            };
        }

    }

}

#endif
