#ifndef _H_B8449CF71A8EAD3D9218ECAFEF06747B_ActuatorOutputs__H_
#define _H_B8449CF71A8EAD3D9218ECAFEF06747B_ActuatorOutputs__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ActuatorOutputs_Constants
            {
                const ::DDS::Octet NUM_ACTUATOR_OUTPUTS_ = 16;

                const ::DDS::Octet NUM_ACTUATOR_OUTPUT_GROUPS_ = 4;

            }

            struct  ActuatorOutputs_
            {
                struct _output__uniq_{};
                typedef ::DDS::Float _output__slice;
                typedef ::DDS::Float _output_[16];
                typedef DDS_DCPS_FArray_var< _output_, _output__slice, struct _output__uniq_ > _output__var;
                typedef _output_ _output__out;
                typedef DDS_DCPS_Array_forany< _output_, _output__slice, struct _output__uniq_ > _output__forany;
                static _output__slice *_output__alloc();
                static void _output__free(_output__slice *);
                static void _output__copy(_output__slice *to, const _output__slice *from);
                static _output__slice *_output__dup(const _output__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::ULong noutputs_;
                _output_ output_;
            };

            typedef DDS_DCPSStruct_var<ActuatorOutputs_> ActuatorOutputs__var;
            typedef ActuatorOutputs_& ActuatorOutputs__out;

        }

    }

}

#endif /* _H_B8449CF71A8EAD3D9218ECAFEF06747B_ActuatorOutputs__H_ */
