#ifndef _H_1E7C256FE25AE3A24C671E49287ED2C5_AdcReport_DCPS_H_
#define _H_1E7C256FE25AE3A24C671E49287ED2C5_AdcReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AdcReport_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AdcReport_TypeSupportInterface;

            typedef AdcReport_TypeSupportInterface * AdcReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AdcReport_TypeSupportInterface> AdcReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AdcReport_TypeSupportInterface> AdcReport_TypeSupportInterface_out;


            class AdcReport_DataWriter;

            typedef AdcReport_DataWriter * AdcReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AdcReport_DataWriter> AdcReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < AdcReport_DataWriter> AdcReport_DataWriter_out;


            class AdcReport_DataReader;

            typedef AdcReport_DataReader * AdcReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AdcReport_DataReader> AdcReport_DataReader_var;
            typedef DDS_DCPSInterface_out < AdcReport_DataReader> AdcReport_DataReader_out;


            class AdcReport_DataReaderView;

            typedef AdcReport_DataReaderView * AdcReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AdcReport_DataReaderView> AdcReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AdcReport_DataReaderView> AdcReport_DataReaderView_out;

            struct AdcReport_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AdcReport_, struct AdcReport_Seq_uniq_> AdcReport_Seq;
            typedef DDS_DCPSSequence_var < AdcReport_Seq> AdcReport_Seq_var;
            typedef DDS_DCPSSequence_out < AdcReport_Seq> AdcReport_Seq_out;

            class  AdcReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AdcReport_TypeSupportInterface_ptr _ptr_type;
                typedef AdcReport_TypeSupportInterface_var _var_type;

                static AdcReport_TypeSupportInterface_ptr _duplicate (AdcReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdcReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AdcReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdcReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AdcReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AdcReport_TypeSupportInterface () {};
                ~AdcReport_TypeSupportInterface () {};
            private:
                AdcReport_TypeSupportInterface (const AdcReport_TypeSupportInterface &);
                AdcReport_TypeSupportInterface & operator = (const AdcReport_TypeSupportInterface &);
            };

            class  AdcReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AdcReport_DataWriter_ptr _ptr_type;
                typedef AdcReport_DataWriter_var _var_type;

                static AdcReport_DataWriter_ptr _duplicate (AdcReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdcReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AdcReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdcReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AdcReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AdcReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AdcReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AdcReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AdcReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AdcReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AdcReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AdcReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AdcReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AdcReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AdcReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AdcReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdcReport_& instance_data) = 0;

            protected:
                AdcReport_DataWriter () {};
                ~AdcReport_DataWriter () {};
            private:
                AdcReport_DataWriter (const AdcReport_DataWriter &);
                AdcReport_DataWriter & operator = (const AdcReport_DataWriter &);
            };

            class  AdcReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AdcReport_DataReader_ptr _ptr_type;
                typedef AdcReport_DataReader_var _var_type;

                static AdcReport_DataReader_ptr _duplicate (AdcReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdcReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AdcReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdcReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AdcReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AdcReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AdcReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AdcReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdcReport_& instance) = 0;

            protected:
                AdcReport_DataReader () {};
                ~AdcReport_DataReader () {};
            private:
                AdcReport_DataReader (const AdcReport_DataReader &);
                AdcReport_DataReader & operator = (const AdcReport_DataReader &);
            };

            class  AdcReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AdcReport_DataReaderView_ptr _ptr_type;
                typedef AdcReport_DataReaderView_var _var_type;

                static AdcReport_DataReaderView_ptr _duplicate (AdcReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdcReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AdcReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdcReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AdcReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AdcReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AdcReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AdcReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AdcReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdcReport_& instance) = 0;

            protected:
                AdcReport_DataReaderView () {};
                ~AdcReport_DataReaderView () {};
            private:
                AdcReport_DataReaderView (const AdcReport_DataReaderView &);
                AdcReport_DataReaderView & operator = (const AdcReport_DataReaderView &);
            };
        }

    }

}

#endif
