#ifndef _H_FDE438203155428B842D6E53C3B149E6_AirspeedValidated_DCPS_H_
#define _H_FDE438203155428B842D6E53C3B149E6_AirspeedValidated_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AirspeedValidated_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AirspeedValidated_TypeSupportInterface;

            typedef AirspeedValidated_TypeSupportInterface * AirspeedValidated_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AirspeedValidated_TypeSupportInterface> AirspeedValidated_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AirspeedValidated_TypeSupportInterface> AirspeedValidated_TypeSupportInterface_out;


            class AirspeedValidated_DataWriter;

            typedef AirspeedValidated_DataWriter * AirspeedValidated_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AirspeedValidated_DataWriter> AirspeedValidated_DataWriter_var;
            typedef DDS_DCPSInterface_out < AirspeedValidated_DataWriter> AirspeedValidated_DataWriter_out;


            class AirspeedValidated_DataReader;

            typedef AirspeedValidated_DataReader * AirspeedValidated_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AirspeedValidated_DataReader> AirspeedValidated_DataReader_var;
            typedef DDS_DCPSInterface_out < AirspeedValidated_DataReader> AirspeedValidated_DataReader_out;


            class AirspeedValidated_DataReaderView;

            typedef AirspeedValidated_DataReaderView * AirspeedValidated_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AirspeedValidated_DataReaderView> AirspeedValidated_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AirspeedValidated_DataReaderView> AirspeedValidated_DataReaderView_out;

            struct AirspeedValidated_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AirspeedValidated_, struct AirspeedValidated_Seq_uniq_> AirspeedValidated_Seq;
            typedef DDS_DCPSSequence_var < AirspeedValidated_Seq> AirspeedValidated_Seq_var;
            typedef DDS_DCPSSequence_out < AirspeedValidated_Seq> AirspeedValidated_Seq_out;

            class  AirspeedValidated_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AirspeedValidated_TypeSupportInterface_ptr _ptr_type;
                typedef AirspeedValidated_TypeSupportInterface_var _var_type;

                static AirspeedValidated_TypeSupportInterface_ptr _duplicate (AirspeedValidated_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AirspeedValidated_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AirspeedValidated_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AirspeedValidated_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AirspeedValidated_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AirspeedValidated_TypeSupportInterface () {};
                ~AirspeedValidated_TypeSupportInterface () {};
            private:
                AirspeedValidated_TypeSupportInterface (const AirspeedValidated_TypeSupportInterface &);
                AirspeedValidated_TypeSupportInterface & operator = (const AirspeedValidated_TypeSupportInterface &);
            };

            class  AirspeedValidated_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AirspeedValidated_DataWriter_ptr _ptr_type;
                typedef AirspeedValidated_DataWriter_var _var_type;

                static AirspeedValidated_DataWriter_ptr _duplicate (AirspeedValidated_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AirspeedValidated_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AirspeedValidated_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AirspeedValidated_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AirspeedValidated_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AirspeedValidated_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AirspeedValidated_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AirspeedValidated_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AirspeedValidated_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AirspeedValidated_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AirspeedValidated_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AirspeedValidated_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AirspeedValidated_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AirspeedValidated_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AirspeedValidated_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AirspeedValidated_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AirspeedValidated_& instance_data) = 0;

            protected:
                AirspeedValidated_DataWriter () {};
                ~AirspeedValidated_DataWriter () {};
            private:
                AirspeedValidated_DataWriter (const AirspeedValidated_DataWriter &);
                AirspeedValidated_DataWriter & operator = (const AirspeedValidated_DataWriter &);
            };

            class  AirspeedValidated_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AirspeedValidated_DataReader_ptr _ptr_type;
                typedef AirspeedValidated_DataReader_var _var_type;

                static AirspeedValidated_DataReader_ptr _duplicate (AirspeedValidated_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AirspeedValidated_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AirspeedValidated_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AirspeedValidated_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AirspeedValidated_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AirspeedValidated_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AirspeedValidated_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AirspeedValidated_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AirspeedValidated_& instance) = 0;

            protected:
                AirspeedValidated_DataReader () {};
                ~AirspeedValidated_DataReader () {};
            private:
                AirspeedValidated_DataReader (const AirspeedValidated_DataReader &);
                AirspeedValidated_DataReader & operator = (const AirspeedValidated_DataReader &);
            };

            class  AirspeedValidated_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AirspeedValidated_DataReaderView_ptr _ptr_type;
                typedef AirspeedValidated_DataReaderView_var _var_type;

                static AirspeedValidated_DataReaderView_ptr _duplicate (AirspeedValidated_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AirspeedValidated_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AirspeedValidated_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AirspeedValidated_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AirspeedValidated_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AirspeedValidated_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AirspeedValidated_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AirspeedValidated_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AirspeedValidated_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AirspeedValidated_& instance) = 0;

            protected:
                AirspeedValidated_DataReaderView () {};
                ~AirspeedValidated_DataReaderView () {};
            private:
                AirspeedValidated_DataReaderView (const AirspeedValidated_DataReaderView &);
                AirspeedValidated_DataReaderView & operator = (const AirspeedValidated_DataReaderView &);
            };
        }

    }

}

#endif
