#ifndef _H_33D37009E8C3ED79AC06B7160CE12D04_Airspeed_DCPS_H_
#define _H_33D37009E8C3ED79AC06B7160CE12D04_Airspeed_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Airspeed_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Airspeed_TypeSupportInterface;

            typedef Airspeed_TypeSupportInterface * Airspeed_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Airspeed_TypeSupportInterface> Airspeed_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Airspeed_TypeSupportInterface> Airspeed_TypeSupportInterface_out;


            class Airspeed_DataWriter;

            typedef Airspeed_DataWriter * Airspeed_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Airspeed_DataWriter> Airspeed_DataWriter_var;
            typedef DDS_DCPSInterface_out < Airspeed_DataWriter> Airspeed_DataWriter_out;


            class Airspeed_DataReader;

            typedef Airspeed_DataReader * Airspeed_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Airspeed_DataReader> Airspeed_DataReader_var;
            typedef DDS_DCPSInterface_out < Airspeed_DataReader> Airspeed_DataReader_out;


            class Airspeed_DataReaderView;

            typedef Airspeed_DataReaderView * Airspeed_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Airspeed_DataReaderView> Airspeed_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Airspeed_DataReaderView> Airspeed_DataReaderView_out;

            struct Airspeed_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Airspeed_, struct Airspeed_Seq_uniq_> Airspeed_Seq;
            typedef DDS_DCPSSequence_var < Airspeed_Seq> Airspeed_Seq_var;
            typedef DDS_DCPSSequence_out < Airspeed_Seq> Airspeed_Seq_out;

            class  Airspeed_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Airspeed_TypeSupportInterface_ptr _ptr_type;
                typedef Airspeed_TypeSupportInterface_var _var_type;

                static Airspeed_TypeSupportInterface_ptr _duplicate (Airspeed_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Airspeed_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Airspeed_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Airspeed_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Airspeed_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Airspeed_TypeSupportInterface () {};
                ~Airspeed_TypeSupportInterface () {};
            private:
                Airspeed_TypeSupportInterface (const Airspeed_TypeSupportInterface &);
                Airspeed_TypeSupportInterface & operator = (const Airspeed_TypeSupportInterface &);
            };

            class  Airspeed_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Airspeed_DataWriter_ptr _ptr_type;
                typedef Airspeed_DataWriter_var _var_type;

                static Airspeed_DataWriter_ptr _duplicate (Airspeed_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Airspeed_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Airspeed_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Airspeed_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Airspeed_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Airspeed_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Airspeed_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Airspeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Airspeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Airspeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Airspeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Airspeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Airspeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Airspeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Airspeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Airspeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Airspeed_& instance_data) = 0;

            protected:
                Airspeed_DataWriter () {};
                ~Airspeed_DataWriter () {};
            private:
                Airspeed_DataWriter (const Airspeed_DataWriter &);
                Airspeed_DataWriter & operator = (const Airspeed_DataWriter &);
            };

            class  Airspeed_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Airspeed_DataReader_ptr _ptr_type;
                typedef Airspeed_DataReader_var _var_type;

                static Airspeed_DataReader_ptr _duplicate (Airspeed_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Airspeed_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Airspeed_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Airspeed_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Airspeed_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Airspeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Airspeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Airspeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Airspeed_& instance) = 0;

            protected:
                Airspeed_DataReader () {};
                ~Airspeed_DataReader () {};
            private:
                Airspeed_DataReader (const Airspeed_DataReader &);
                Airspeed_DataReader & operator = (const Airspeed_DataReader &);
            };

            class  Airspeed_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Airspeed_DataReaderView_ptr _ptr_type;
                typedef Airspeed_DataReaderView_var _var_type;

                static Airspeed_DataReaderView_ptr _duplicate (Airspeed_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Airspeed_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Airspeed_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Airspeed_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Airspeed_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Airspeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Airspeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Airspeed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Airspeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Airspeed_& instance) = 0;

            protected:
                Airspeed_DataReaderView () {};
                ~Airspeed_DataReaderView () {};
            private:
                Airspeed_DataReaderView (const Airspeed_DataReaderView &);
                Airspeed_DataReaderView & operator = (const Airspeed_DataReaderView &);
            };
        }

    }

}

#endif
