#ifndef _H_E93CEBBE63CAA9C1FA55D6366090C55F_BatteryStatus_DCPS_H_
#define _H_E93CEBBE63CAA9C1FA55D6366090C55F_BatteryStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BatteryStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BatteryStatus_TypeSupportInterface;

            typedef BatteryStatus_TypeSupportInterface * BatteryStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BatteryStatus_TypeSupportInterface> BatteryStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BatteryStatus_TypeSupportInterface> BatteryStatus_TypeSupportInterface_out;


            class BatteryStatus_DataWriter;

            typedef BatteryStatus_DataWriter * BatteryStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BatteryStatus_DataWriter> BatteryStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < BatteryStatus_DataWriter> BatteryStatus_DataWriter_out;


            class BatteryStatus_DataReader;

            typedef BatteryStatus_DataReader * BatteryStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BatteryStatus_DataReader> BatteryStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < BatteryStatus_DataReader> BatteryStatus_DataReader_out;


            class BatteryStatus_DataReaderView;

            typedef BatteryStatus_DataReaderView * BatteryStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BatteryStatus_DataReaderView> BatteryStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BatteryStatus_DataReaderView> BatteryStatus_DataReaderView_out;

            struct BatteryStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < BatteryStatus_, struct BatteryStatus_Seq_uniq_> BatteryStatus_Seq;
            typedef DDS_DCPSSequence_var < BatteryStatus_Seq> BatteryStatus_Seq_var;
            typedef DDS_DCPSSequence_out < BatteryStatus_Seq> BatteryStatus_Seq_out;

            class  BatteryStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BatteryStatus_TypeSupportInterface_ptr _ptr_type;
                typedef BatteryStatus_TypeSupportInterface_var _var_type;

                static BatteryStatus_TypeSupportInterface_ptr _duplicate (BatteryStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BatteryStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BatteryStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BatteryStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BatteryStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BatteryStatus_TypeSupportInterface () {};
                ~BatteryStatus_TypeSupportInterface () {};
            private:
                BatteryStatus_TypeSupportInterface (const BatteryStatus_TypeSupportInterface &);
                BatteryStatus_TypeSupportInterface & operator = (const BatteryStatus_TypeSupportInterface &);
            };

            class  BatteryStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BatteryStatus_DataWriter_ptr _ptr_type;
                typedef BatteryStatus_DataWriter_var _var_type;

                static BatteryStatus_DataWriter_ptr _duplicate (BatteryStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BatteryStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BatteryStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BatteryStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BatteryStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BatteryStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BatteryStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BatteryStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BatteryStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BatteryStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BatteryStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BatteryStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BatteryStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BatteryStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BatteryStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BatteryStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BatteryStatus_& instance_data) = 0;

            protected:
                BatteryStatus_DataWriter () {};
                ~BatteryStatus_DataWriter () {};
            private:
                BatteryStatus_DataWriter (const BatteryStatus_DataWriter &);
                BatteryStatus_DataWriter & operator = (const BatteryStatus_DataWriter &);
            };

            class  BatteryStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BatteryStatus_DataReader_ptr _ptr_type;
                typedef BatteryStatus_DataReader_var _var_type;

                static BatteryStatus_DataReader_ptr _duplicate (BatteryStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BatteryStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BatteryStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BatteryStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BatteryStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BatteryStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BatteryStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BatteryStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BatteryStatus_& instance) = 0;

            protected:
                BatteryStatus_DataReader () {};
                ~BatteryStatus_DataReader () {};
            private:
                BatteryStatus_DataReader (const BatteryStatus_DataReader &);
                BatteryStatus_DataReader & operator = (const BatteryStatus_DataReader &);
            };

            class  BatteryStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BatteryStatus_DataReaderView_ptr _ptr_type;
                typedef BatteryStatus_DataReaderView_var _var_type;

                static BatteryStatus_DataReaderView_ptr _duplicate (BatteryStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BatteryStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BatteryStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BatteryStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BatteryStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BatteryStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BatteryStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BatteryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BatteryStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BatteryStatus_& instance) = 0;

            protected:
                BatteryStatus_DataReaderView () {};
                ~BatteryStatus_DataReaderView () {};
            private:
                BatteryStatus_DataReaderView (const BatteryStatus_DataReaderView &);
                BatteryStatus_DataReaderView & operator = (const BatteryStatus_DataReaderView &);
            };
        }

    }

}

#endif
