#ifndef _H_BDA8B2476E8BA756E5D441F3792D7FE1_CameraTrigger_DCPS_H_
#define _H_BDA8B2476E8BA756E5D441F3792D7FE1_CameraTrigger_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CameraTrigger_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CameraTrigger_TypeSupportInterface;

            typedef CameraTrigger_TypeSupportInterface * CameraTrigger_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CameraTrigger_TypeSupportInterface> CameraTrigger_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CameraTrigger_TypeSupportInterface> CameraTrigger_TypeSupportInterface_out;


            class CameraTrigger_DataWriter;

            typedef CameraTrigger_DataWriter * CameraTrigger_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CameraTrigger_DataWriter> CameraTrigger_DataWriter_var;
            typedef DDS_DCPSInterface_out < CameraTrigger_DataWriter> CameraTrigger_DataWriter_out;


            class CameraTrigger_DataReader;

            typedef CameraTrigger_DataReader * CameraTrigger_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CameraTrigger_DataReader> CameraTrigger_DataReader_var;
            typedef DDS_DCPSInterface_out < CameraTrigger_DataReader> CameraTrigger_DataReader_out;


            class CameraTrigger_DataReaderView;

            typedef CameraTrigger_DataReaderView * CameraTrigger_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CameraTrigger_DataReaderView> CameraTrigger_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CameraTrigger_DataReaderView> CameraTrigger_DataReaderView_out;

            struct CameraTrigger_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CameraTrigger_, struct CameraTrigger_Seq_uniq_> CameraTrigger_Seq;
            typedef DDS_DCPSSequence_var < CameraTrigger_Seq> CameraTrigger_Seq_var;
            typedef DDS_DCPSSequence_out < CameraTrigger_Seq> CameraTrigger_Seq_out;

            class  CameraTrigger_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CameraTrigger_TypeSupportInterface_ptr _ptr_type;
                typedef CameraTrigger_TypeSupportInterface_var _var_type;

                static CameraTrigger_TypeSupportInterface_ptr _duplicate (CameraTrigger_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CameraTrigger_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CameraTrigger_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CameraTrigger_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CameraTrigger_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CameraTrigger_TypeSupportInterface () {};
                ~CameraTrigger_TypeSupportInterface () {};
            private:
                CameraTrigger_TypeSupportInterface (const CameraTrigger_TypeSupportInterface &);
                CameraTrigger_TypeSupportInterface & operator = (const CameraTrigger_TypeSupportInterface &);
            };

            class  CameraTrigger_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CameraTrigger_DataWriter_ptr _ptr_type;
                typedef CameraTrigger_DataWriter_var _var_type;

                static CameraTrigger_DataWriter_ptr _duplicate (CameraTrigger_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CameraTrigger_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CameraTrigger_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CameraTrigger_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CameraTrigger_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CameraTrigger_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CameraTrigger_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CameraTrigger_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CameraTrigger_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CameraTrigger_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CameraTrigger_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CameraTrigger_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CameraTrigger_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CameraTrigger_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CameraTrigger_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CameraTrigger_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CameraTrigger_& instance_data) = 0;

            protected:
                CameraTrigger_DataWriter () {};
                ~CameraTrigger_DataWriter () {};
            private:
                CameraTrigger_DataWriter (const CameraTrigger_DataWriter &);
                CameraTrigger_DataWriter & operator = (const CameraTrigger_DataWriter &);
            };

            class  CameraTrigger_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CameraTrigger_DataReader_ptr _ptr_type;
                typedef CameraTrigger_DataReader_var _var_type;

                static CameraTrigger_DataReader_ptr _duplicate (CameraTrigger_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CameraTrigger_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CameraTrigger_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CameraTrigger_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CameraTrigger_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CameraTrigger_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CameraTrigger_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CameraTrigger_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CameraTrigger_& instance) = 0;

            protected:
                CameraTrigger_DataReader () {};
                ~CameraTrigger_DataReader () {};
            private:
                CameraTrigger_DataReader (const CameraTrigger_DataReader &);
                CameraTrigger_DataReader & operator = (const CameraTrigger_DataReader &);
            };

            class  CameraTrigger_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CameraTrigger_DataReaderView_ptr _ptr_type;
                typedef CameraTrigger_DataReaderView_var _var_type;

                static CameraTrigger_DataReaderView_ptr _duplicate (CameraTrigger_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CameraTrigger_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CameraTrigger_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CameraTrigger_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CameraTrigger_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CameraTrigger_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CameraTrigger_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CameraTrigger_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CameraTrigger_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CameraTrigger_& instance) = 0;

            protected:
                CameraTrigger_DataReaderView () {};
                ~CameraTrigger_DataReaderView () {};
            private:
                CameraTrigger_DataReaderView (const CameraTrigger_DataReaderView &);
                CameraTrigger_DataReaderView & operator = (const CameraTrigger_DataReaderView &);
            };
        }

    }

}

#endif
