#ifndef _H_B543A999C384CC731D006D9F9C3BE80B_CollisionConstraints_DCPS_H_
#define _H_B543A999C384CC731D006D9F9C3BE80B_CollisionConstraints_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CollisionConstraints_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CollisionConstraints_TypeSupportInterface;

            typedef CollisionConstraints_TypeSupportInterface * CollisionConstraints_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CollisionConstraints_TypeSupportInterface> CollisionConstraints_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CollisionConstraints_TypeSupportInterface> CollisionConstraints_TypeSupportInterface_out;


            class CollisionConstraints_DataWriter;

            typedef CollisionConstraints_DataWriter * CollisionConstraints_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CollisionConstraints_DataWriter> CollisionConstraints_DataWriter_var;
            typedef DDS_DCPSInterface_out < CollisionConstraints_DataWriter> CollisionConstraints_DataWriter_out;


            class CollisionConstraints_DataReader;

            typedef CollisionConstraints_DataReader * CollisionConstraints_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CollisionConstraints_DataReader> CollisionConstraints_DataReader_var;
            typedef DDS_DCPSInterface_out < CollisionConstraints_DataReader> CollisionConstraints_DataReader_out;


            class CollisionConstraints_DataReaderView;

            typedef CollisionConstraints_DataReaderView * CollisionConstraints_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CollisionConstraints_DataReaderView> CollisionConstraints_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CollisionConstraints_DataReaderView> CollisionConstraints_DataReaderView_out;

            struct CollisionConstraints_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CollisionConstraints_, struct CollisionConstraints_Seq_uniq_> CollisionConstraints_Seq;
            typedef DDS_DCPSSequence_var < CollisionConstraints_Seq> CollisionConstraints_Seq_var;
            typedef DDS_DCPSSequence_out < CollisionConstraints_Seq> CollisionConstraints_Seq_out;

            class  CollisionConstraints_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CollisionConstraints_TypeSupportInterface_ptr _ptr_type;
                typedef CollisionConstraints_TypeSupportInterface_var _var_type;

                static CollisionConstraints_TypeSupportInterface_ptr _duplicate (CollisionConstraints_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionConstraints_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CollisionConstraints_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionConstraints_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionConstraints_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CollisionConstraints_TypeSupportInterface () {};
                ~CollisionConstraints_TypeSupportInterface () {};
            private:
                CollisionConstraints_TypeSupportInterface (const CollisionConstraints_TypeSupportInterface &);
                CollisionConstraints_TypeSupportInterface & operator = (const CollisionConstraints_TypeSupportInterface &);
            };

            class  CollisionConstraints_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CollisionConstraints_DataWriter_ptr _ptr_type;
                typedef CollisionConstraints_DataWriter_var _var_type;

                static CollisionConstraints_DataWriter_ptr _duplicate (CollisionConstraints_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionConstraints_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CollisionConstraints_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionConstraints_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionConstraints_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CollisionConstraints_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CollisionConstraints_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CollisionConstraints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CollisionConstraints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CollisionConstraints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CollisionConstraints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CollisionConstraints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CollisionConstraints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CollisionConstraints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CollisionConstraints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CollisionConstraints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionConstraints_& instance_data) = 0;

            protected:
                CollisionConstraints_DataWriter () {};
                ~CollisionConstraints_DataWriter () {};
            private:
                CollisionConstraints_DataWriter (const CollisionConstraints_DataWriter &);
                CollisionConstraints_DataWriter & operator = (const CollisionConstraints_DataWriter &);
            };

            class  CollisionConstraints_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CollisionConstraints_DataReader_ptr _ptr_type;
                typedef CollisionConstraints_DataReader_var _var_type;

                static CollisionConstraints_DataReader_ptr _duplicate (CollisionConstraints_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionConstraints_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CollisionConstraints_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionConstraints_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionConstraints_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CollisionConstraints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CollisionConstraints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CollisionConstraints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionConstraints_& instance) = 0;

            protected:
                CollisionConstraints_DataReader () {};
                ~CollisionConstraints_DataReader () {};
            private:
                CollisionConstraints_DataReader (const CollisionConstraints_DataReader &);
                CollisionConstraints_DataReader & operator = (const CollisionConstraints_DataReader &);
            };

            class  CollisionConstraints_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CollisionConstraints_DataReaderView_ptr _ptr_type;
                typedef CollisionConstraints_DataReaderView_var _var_type;

                static CollisionConstraints_DataReaderView_ptr _duplicate (CollisionConstraints_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionConstraints_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CollisionConstraints_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionConstraints_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionConstraints_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CollisionConstraints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CollisionConstraints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CollisionConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CollisionConstraints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionConstraints_& instance) = 0;

            protected:
                CollisionConstraints_DataReaderView () {};
                ~CollisionConstraints_DataReaderView () {};
            private:
                CollisionConstraints_DataReaderView (const CollisionConstraints_DataReaderView &);
                CollisionConstraints_DataReaderView & operator = (const CollisionConstraints_DataReaderView &);
            };
        }

    }

}

#endif
