#ifndef _H_7E26697386E261FC851318C3BE23F49E_CollisionReport__H_
#define _H_7E26697386E261FC851318C3BE23F49E_CollisionReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  CollisionReport_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet src_;
                ::DDS::ULong id_;
                ::DDS::Octet action_;
                ::DDS::Octet threat_level_;
                ::DDS::Float time_to_minimum_delta_;
                ::DDS::Float altitude_minimum_delta_;
                ::DDS::Float horizontal_minimum_delta_;
            };

            typedef DDS_DCPSStruct_var<CollisionReport_> CollisionReport__var;
            typedef CollisionReport_& CollisionReport__out;

        }

    }

}

#endif /* _H_7E26697386E261FC851318C3BE23F49E_CollisionReport__H_ */
