#ifndef _H_7E26697386E261FC851318C3BE23F49E_CollisionReport_DCPS_H_
#define _H_7E26697386E261FC851318C3BE23F49E_CollisionReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CollisionReport_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CollisionReport_TypeSupportInterface;

            typedef CollisionReport_TypeSupportInterface * CollisionReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CollisionReport_TypeSupportInterface> CollisionReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CollisionReport_TypeSupportInterface> CollisionReport_TypeSupportInterface_out;


            class CollisionReport_DataWriter;

            typedef CollisionReport_DataWriter * CollisionReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CollisionReport_DataWriter> CollisionReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < CollisionReport_DataWriter> CollisionReport_DataWriter_out;


            class CollisionReport_DataReader;

            typedef CollisionReport_DataReader * CollisionReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CollisionReport_DataReader> CollisionReport_DataReader_var;
            typedef DDS_DCPSInterface_out < CollisionReport_DataReader> CollisionReport_DataReader_out;


            class CollisionReport_DataReaderView;

            typedef CollisionReport_DataReaderView * CollisionReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CollisionReport_DataReaderView> CollisionReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CollisionReport_DataReaderView> CollisionReport_DataReaderView_out;

            struct CollisionReport_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CollisionReport_, struct CollisionReport_Seq_uniq_> CollisionReport_Seq;
            typedef DDS_DCPSSequence_var < CollisionReport_Seq> CollisionReport_Seq_var;
            typedef DDS_DCPSSequence_out < CollisionReport_Seq> CollisionReport_Seq_out;

            class  CollisionReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CollisionReport_TypeSupportInterface_ptr _ptr_type;
                typedef CollisionReport_TypeSupportInterface_var _var_type;

                static CollisionReport_TypeSupportInterface_ptr _duplicate (CollisionReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CollisionReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CollisionReport_TypeSupportInterface () {};
                ~CollisionReport_TypeSupportInterface () {};
            private:
                CollisionReport_TypeSupportInterface (const CollisionReport_TypeSupportInterface &);
                CollisionReport_TypeSupportInterface & operator = (const CollisionReport_TypeSupportInterface &);
            };

            class  CollisionReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CollisionReport_DataWriter_ptr _ptr_type;
                typedef CollisionReport_DataWriter_var _var_type;

                static CollisionReport_DataWriter_ptr _duplicate (CollisionReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CollisionReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CollisionReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CollisionReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CollisionReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CollisionReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CollisionReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CollisionReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CollisionReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CollisionReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CollisionReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CollisionReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CollisionReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionReport_& instance_data) = 0;

            protected:
                CollisionReport_DataWriter () {};
                ~CollisionReport_DataWriter () {};
            private:
                CollisionReport_DataWriter (const CollisionReport_DataWriter &);
                CollisionReport_DataWriter & operator = (const CollisionReport_DataWriter &);
            };

            class  CollisionReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CollisionReport_DataReader_ptr _ptr_type;
                typedef CollisionReport_DataReader_var _var_type;

                static CollisionReport_DataReader_ptr _duplicate (CollisionReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CollisionReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CollisionReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CollisionReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CollisionReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionReport_& instance) = 0;

            protected:
                CollisionReport_DataReader () {};
                ~CollisionReport_DataReader () {};
            private:
                CollisionReport_DataReader (const CollisionReport_DataReader &);
                CollisionReport_DataReader & operator = (const CollisionReport_DataReader &);
            };

            class  CollisionReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CollisionReport_DataReaderView_ptr _ptr_type;
                typedef CollisionReport_DataReaderView_var _var_type;

                static CollisionReport_DataReaderView_ptr _duplicate (CollisionReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CollisionReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CollisionReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CollisionReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CollisionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CollisionReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionReport_& instance) = 0;

            protected:
                CollisionReport_DataReaderView () {};
                ~CollisionReport_DataReaderView () {};
            private:
                CollisionReport_DataReaderView (const CollisionReport_DataReaderView &);
                CollisionReport_DataReaderView & operator = (const CollisionReport_DataReaderView &);
            };
        }

    }

}

#endif
