#ifndef _H_26992D1EBE663D0B52E61D36FFF51037_Cpuload_DCPS_H_
#define _H_26992D1EBE663D0B52E61D36FFF51037_Cpuload_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Cpuload_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Cpuload_TypeSupportInterface;

            typedef Cpuload_TypeSupportInterface * Cpuload_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Cpuload_TypeSupportInterface> Cpuload_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Cpuload_TypeSupportInterface> Cpuload_TypeSupportInterface_out;


            class Cpuload_DataWriter;

            typedef Cpuload_DataWriter * Cpuload_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Cpuload_DataWriter> Cpuload_DataWriter_var;
            typedef DDS_DCPSInterface_out < Cpuload_DataWriter> Cpuload_DataWriter_out;


            class Cpuload_DataReader;

            typedef Cpuload_DataReader * Cpuload_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Cpuload_DataReader> Cpuload_DataReader_var;
            typedef DDS_DCPSInterface_out < Cpuload_DataReader> Cpuload_DataReader_out;


            class Cpuload_DataReaderView;

            typedef Cpuload_DataReaderView * Cpuload_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Cpuload_DataReaderView> Cpuload_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Cpuload_DataReaderView> Cpuload_DataReaderView_out;

            struct Cpuload_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Cpuload_, struct Cpuload_Seq_uniq_> Cpuload_Seq;
            typedef DDS_DCPSSequence_var < Cpuload_Seq> Cpuload_Seq_var;
            typedef DDS_DCPSSequence_out < Cpuload_Seq> Cpuload_Seq_out;

            class  Cpuload_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Cpuload_TypeSupportInterface_ptr _ptr_type;
                typedef Cpuload_TypeSupportInterface_var _var_type;

                static Cpuload_TypeSupportInterface_ptr _duplicate (Cpuload_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cpuload_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Cpuload_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cpuload_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Cpuload_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Cpuload_TypeSupportInterface () {};
                ~Cpuload_TypeSupportInterface () {};
            private:
                Cpuload_TypeSupportInterface (const Cpuload_TypeSupportInterface &);
                Cpuload_TypeSupportInterface & operator = (const Cpuload_TypeSupportInterface &);
            };

            class  Cpuload_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Cpuload_DataWriter_ptr _ptr_type;
                typedef Cpuload_DataWriter_var _var_type;

                static Cpuload_DataWriter_ptr _duplicate (Cpuload_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cpuload_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Cpuload_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cpuload_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Cpuload_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Cpuload_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Cpuload_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Cpuload_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Cpuload_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Cpuload_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Cpuload_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Cpuload_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Cpuload_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Cpuload_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Cpuload_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Cpuload_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cpuload_& instance_data) = 0;

            protected:
                Cpuload_DataWriter () {};
                ~Cpuload_DataWriter () {};
            private:
                Cpuload_DataWriter (const Cpuload_DataWriter &);
                Cpuload_DataWriter & operator = (const Cpuload_DataWriter &);
            };

            class  Cpuload_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Cpuload_DataReader_ptr _ptr_type;
                typedef Cpuload_DataReader_var _var_type;

                static Cpuload_DataReader_ptr _duplicate (Cpuload_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cpuload_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Cpuload_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cpuload_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Cpuload_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Cpuload_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Cpuload_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Cpuload_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cpuload_& instance) = 0;

            protected:
                Cpuload_DataReader () {};
                ~Cpuload_DataReader () {};
            private:
                Cpuload_DataReader (const Cpuload_DataReader &);
                Cpuload_DataReader & operator = (const Cpuload_DataReader &);
            };

            class  Cpuload_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Cpuload_DataReaderView_ptr _ptr_type;
                typedef Cpuload_DataReaderView_var _var_type;

                static Cpuload_DataReaderView_ptr _duplicate (Cpuload_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cpuload_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Cpuload_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cpuload_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Cpuload_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Cpuload_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Cpuload_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Cpuload_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Cpuload_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cpuload_& instance) = 0;

            protected:
                Cpuload_DataReaderView () {};
                ~Cpuload_DataReaderView () {};
            private:
                Cpuload_DataReaderView (const Cpuload_DataReaderView &);
                Cpuload_DataReaderView & operator = (const Cpuload_DataReaderView &);
            };
        }

    }

}

#endif
