#ifndef _H_C82BC1AA7CFA7C925AADA8E3FB10D22E_DebugArray_DCPS_H_
#define _H_C82BC1AA7CFA7C925AADA8E3FB10D22E_DebugArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DebugArray_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DebugArray_TypeSupportInterface;

            typedef DebugArray_TypeSupportInterface * DebugArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DebugArray_TypeSupportInterface> DebugArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DebugArray_TypeSupportInterface> DebugArray_TypeSupportInterface_out;


            class DebugArray_DataWriter;

            typedef DebugArray_DataWriter * DebugArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DebugArray_DataWriter> DebugArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < DebugArray_DataWriter> DebugArray_DataWriter_out;


            class DebugArray_DataReader;

            typedef DebugArray_DataReader * DebugArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DebugArray_DataReader> DebugArray_DataReader_var;
            typedef DDS_DCPSInterface_out < DebugArray_DataReader> DebugArray_DataReader_out;


            class DebugArray_DataReaderView;

            typedef DebugArray_DataReaderView * DebugArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DebugArray_DataReaderView> DebugArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DebugArray_DataReaderView> DebugArray_DataReaderView_out;

            struct DebugArray_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DebugArray_, struct DebugArray_Seq_uniq_> DebugArray_Seq;
            typedef DDS_DCPSSequence_var < DebugArray_Seq> DebugArray_Seq_var;
            typedef DDS_DCPSSequence_out < DebugArray_Seq> DebugArray_Seq_out;

            class  DebugArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DebugArray_TypeSupportInterface_ptr _ptr_type;
                typedef DebugArray_TypeSupportInterface_var _var_type;

                static DebugArray_TypeSupportInterface_ptr _duplicate (DebugArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DebugArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DebugArray_TypeSupportInterface () {};
                ~DebugArray_TypeSupportInterface () {};
            private:
                DebugArray_TypeSupportInterface (const DebugArray_TypeSupportInterface &);
                DebugArray_TypeSupportInterface & operator = (const DebugArray_TypeSupportInterface &);
            };

            class  DebugArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DebugArray_DataWriter_ptr _ptr_type;
                typedef DebugArray_DataWriter_var _var_type;

                static DebugArray_DataWriter_ptr _duplicate (DebugArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DebugArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DebugArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DebugArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DebugArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DebugArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DebugArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DebugArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DebugArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DebugArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DebugArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DebugArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DebugArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugArray_& instance_data) = 0;

            protected:
                DebugArray_DataWriter () {};
                ~DebugArray_DataWriter () {};
            private:
                DebugArray_DataWriter (const DebugArray_DataWriter &);
                DebugArray_DataWriter & operator = (const DebugArray_DataWriter &);
            };

            class  DebugArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DebugArray_DataReader_ptr _ptr_type;
                typedef DebugArray_DataReader_var _var_type;

                static DebugArray_DataReader_ptr _duplicate (DebugArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DebugArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DebugArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DebugArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DebugArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugArray_& instance) = 0;

            protected:
                DebugArray_DataReader () {};
                ~DebugArray_DataReader () {};
            private:
                DebugArray_DataReader (const DebugArray_DataReader &);
                DebugArray_DataReader & operator = (const DebugArray_DataReader &);
            };

            class  DebugArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DebugArray_DataReaderView_ptr _ptr_type;
                typedef DebugArray_DataReaderView_var _var_type;

                static DebugArray_DataReaderView_ptr _duplicate (DebugArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DebugArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DebugArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DebugArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DebugArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DebugArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugArray_& instance) = 0;

            protected:
                DebugArray_DataReaderView () {};
                ~DebugArray_DataReaderView () {};
            private:
                DebugArray_DataReaderView (const DebugArray_DataReaderView &);
                DebugArray_DataReaderView & operator = (const DebugArray_DataReaderView &);
            };
        }

    }

}

#endif
