#ifndef _H_B8F81583C7EE01C9473BB9A4417C8F7E_DebugValue_DCPS_H_
#define _H_B8F81583C7EE01C9473BB9A4417C8F7E_DebugValue_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DebugValue_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DebugValue_TypeSupportInterface;

            typedef DebugValue_TypeSupportInterface * DebugValue_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DebugValue_TypeSupportInterface> DebugValue_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DebugValue_TypeSupportInterface> DebugValue_TypeSupportInterface_out;


            class DebugValue_DataWriter;

            typedef DebugValue_DataWriter * DebugValue_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DebugValue_DataWriter> DebugValue_DataWriter_var;
            typedef DDS_DCPSInterface_out < DebugValue_DataWriter> DebugValue_DataWriter_out;


            class DebugValue_DataReader;

            typedef DebugValue_DataReader * DebugValue_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DebugValue_DataReader> DebugValue_DataReader_var;
            typedef DDS_DCPSInterface_out < DebugValue_DataReader> DebugValue_DataReader_out;


            class DebugValue_DataReaderView;

            typedef DebugValue_DataReaderView * DebugValue_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DebugValue_DataReaderView> DebugValue_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DebugValue_DataReaderView> DebugValue_DataReaderView_out;

            struct DebugValue_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DebugValue_, struct DebugValue_Seq_uniq_> DebugValue_Seq;
            typedef DDS_DCPSSequence_var < DebugValue_Seq> DebugValue_Seq_var;
            typedef DDS_DCPSSequence_out < DebugValue_Seq> DebugValue_Seq_out;

            class  DebugValue_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DebugValue_TypeSupportInterface_ptr _ptr_type;
                typedef DebugValue_TypeSupportInterface_var _var_type;

                static DebugValue_TypeSupportInterface_ptr _duplicate (DebugValue_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugValue_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DebugValue_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugValue_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugValue_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DebugValue_TypeSupportInterface () {};
                ~DebugValue_TypeSupportInterface () {};
            private:
                DebugValue_TypeSupportInterface (const DebugValue_TypeSupportInterface &);
                DebugValue_TypeSupportInterface & operator = (const DebugValue_TypeSupportInterface &);
            };

            class  DebugValue_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DebugValue_DataWriter_ptr _ptr_type;
                typedef DebugValue_DataWriter_var _var_type;

                static DebugValue_DataWriter_ptr _duplicate (DebugValue_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugValue_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DebugValue_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugValue_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugValue_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DebugValue_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DebugValue_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DebugValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DebugValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DebugValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DebugValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DebugValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DebugValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DebugValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DebugValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DebugValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugValue_& instance_data) = 0;

            protected:
                DebugValue_DataWriter () {};
                ~DebugValue_DataWriter () {};
            private:
                DebugValue_DataWriter (const DebugValue_DataWriter &);
                DebugValue_DataWriter & operator = (const DebugValue_DataWriter &);
            };

            class  DebugValue_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DebugValue_DataReader_ptr _ptr_type;
                typedef DebugValue_DataReader_var _var_type;

                static DebugValue_DataReader_ptr _duplicate (DebugValue_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugValue_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DebugValue_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugValue_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugValue_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DebugValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DebugValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DebugValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugValue_& instance) = 0;

            protected:
                DebugValue_DataReader () {};
                ~DebugValue_DataReader () {};
            private:
                DebugValue_DataReader (const DebugValue_DataReader &);
                DebugValue_DataReader & operator = (const DebugValue_DataReader &);
            };

            class  DebugValue_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DebugValue_DataReaderView_ptr _ptr_type;
                typedef DebugValue_DataReaderView_var _var_type;

                static DebugValue_DataReaderView_ptr _duplicate (DebugValue_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugValue_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DebugValue_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugValue_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugValue_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DebugValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DebugValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DebugValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DebugValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugValue_& instance) = 0;

            protected:
                DebugValue_DataReaderView () {};
                ~DebugValue_DataReaderView () {};
            private:
                DebugValue_DataReaderView (const DebugValue_DataReaderView &);
                DebugValue_DataReaderView & operator = (const DebugValue_DataReaderView &);
            };
        }

    }

}

#endif
