#ifndef _H_B21BEB5F1DACEBE315A5EF42B6C8D652_DebugVect_DCPS_H_
#define _H_B21BEB5F1DACEBE315A5EF42B6C8D652_DebugVect_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DebugVect_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DebugVect_TypeSupportInterface;

            typedef DebugVect_TypeSupportInterface * DebugVect_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DebugVect_TypeSupportInterface> DebugVect_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DebugVect_TypeSupportInterface> DebugVect_TypeSupportInterface_out;


            class DebugVect_DataWriter;

            typedef DebugVect_DataWriter * DebugVect_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DebugVect_DataWriter> DebugVect_DataWriter_var;
            typedef DDS_DCPSInterface_out < DebugVect_DataWriter> DebugVect_DataWriter_out;


            class DebugVect_DataReader;

            typedef DebugVect_DataReader * DebugVect_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DebugVect_DataReader> DebugVect_DataReader_var;
            typedef DDS_DCPSInterface_out < DebugVect_DataReader> DebugVect_DataReader_out;


            class DebugVect_DataReaderView;

            typedef DebugVect_DataReaderView * DebugVect_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DebugVect_DataReaderView> DebugVect_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DebugVect_DataReaderView> DebugVect_DataReaderView_out;

            struct DebugVect_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DebugVect_, struct DebugVect_Seq_uniq_> DebugVect_Seq;
            typedef DDS_DCPSSequence_var < DebugVect_Seq> DebugVect_Seq_var;
            typedef DDS_DCPSSequence_out < DebugVect_Seq> DebugVect_Seq_out;

            class  DebugVect_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DebugVect_TypeSupportInterface_ptr _ptr_type;
                typedef DebugVect_TypeSupportInterface_var _var_type;

                static DebugVect_TypeSupportInterface_ptr _duplicate (DebugVect_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugVect_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DebugVect_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugVect_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugVect_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DebugVect_TypeSupportInterface () {};
                ~DebugVect_TypeSupportInterface () {};
            private:
                DebugVect_TypeSupportInterface (const DebugVect_TypeSupportInterface &);
                DebugVect_TypeSupportInterface & operator = (const DebugVect_TypeSupportInterface &);
            };

            class  DebugVect_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DebugVect_DataWriter_ptr _ptr_type;
                typedef DebugVect_DataWriter_var _var_type;

                static DebugVect_DataWriter_ptr _duplicate (DebugVect_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugVect_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DebugVect_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugVect_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugVect_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DebugVect_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DebugVect_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DebugVect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DebugVect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DebugVect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DebugVect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DebugVect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DebugVect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DebugVect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DebugVect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DebugVect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugVect_& instance_data) = 0;

            protected:
                DebugVect_DataWriter () {};
                ~DebugVect_DataWriter () {};
            private:
                DebugVect_DataWriter (const DebugVect_DataWriter &);
                DebugVect_DataWriter & operator = (const DebugVect_DataWriter &);
            };

            class  DebugVect_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DebugVect_DataReader_ptr _ptr_type;
                typedef DebugVect_DataReader_var _var_type;

                static DebugVect_DataReader_ptr _duplicate (DebugVect_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugVect_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DebugVect_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugVect_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugVect_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DebugVect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DebugVect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DebugVect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugVect_& instance) = 0;

            protected:
                DebugVect_DataReader () {};
                ~DebugVect_DataReader () {};
            private:
                DebugVect_DataReader (const DebugVect_DataReader &);
                DebugVect_DataReader & operator = (const DebugVect_DataReader &);
            };

            class  DebugVect_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DebugVect_DataReaderView_ptr _ptr_type;
                typedef DebugVect_DataReaderView_var _var_type;

                static DebugVect_DataReaderView_ptr _duplicate (DebugVect_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugVect_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DebugVect_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugVect_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugVect_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DebugVect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DebugVect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DebugVect_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DebugVect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugVect_& instance) = 0;

            protected:
                DebugVect_DataReaderView () {};
                ~DebugVect_DataReaderView () {};
            private:
                DebugVect_DataReaderView (const DebugVect_DataReaderView &);
                DebugVect_DataReaderView & operator = (const DebugVect_DataReaderView &);
            };
        }

    }

}

#endif
