#ifndef _H_93864C6CFF92F9517D341406DE6C6C4E_DifferentialPressure_DCPS_H_
#define _H_93864C6CFF92F9517D341406DE6C6C4E_DifferentialPressure_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DifferentialPressure_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DifferentialPressure_TypeSupportInterface;

            typedef DifferentialPressure_TypeSupportInterface * DifferentialPressure_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DifferentialPressure_TypeSupportInterface> DifferentialPressure_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DifferentialPressure_TypeSupportInterface> DifferentialPressure_TypeSupportInterface_out;


            class DifferentialPressure_DataWriter;

            typedef DifferentialPressure_DataWriter * DifferentialPressure_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DifferentialPressure_DataWriter> DifferentialPressure_DataWriter_var;
            typedef DDS_DCPSInterface_out < DifferentialPressure_DataWriter> DifferentialPressure_DataWriter_out;


            class DifferentialPressure_DataReader;

            typedef DifferentialPressure_DataReader * DifferentialPressure_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DifferentialPressure_DataReader> DifferentialPressure_DataReader_var;
            typedef DDS_DCPSInterface_out < DifferentialPressure_DataReader> DifferentialPressure_DataReader_out;


            class DifferentialPressure_DataReaderView;

            typedef DifferentialPressure_DataReaderView * DifferentialPressure_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DifferentialPressure_DataReaderView> DifferentialPressure_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DifferentialPressure_DataReaderView> DifferentialPressure_DataReaderView_out;

            struct DifferentialPressure_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DifferentialPressure_, struct DifferentialPressure_Seq_uniq_> DifferentialPressure_Seq;
            typedef DDS_DCPSSequence_var < DifferentialPressure_Seq> DifferentialPressure_Seq_var;
            typedef DDS_DCPSSequence_out < DifferentialPressure_Seq> DifferentialPressure_Seq_out;

            class  DifferentialPressure_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DifferentialPressure_TypeSupportInterface_ptr _ptr_type;
                typedef DifferentialPressure_TypeSupportInterface_var _var_type;

                static DifferentialPressure_TypeSupportInterface_ptr _duplicate (DifferentialPressure_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DifferentialPressure_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DifferentialPressure_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DifferentialPressure_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DifferentialPressure_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DifferentialPressure_TypeSupportInterface () {};
                ~DifferentialPressure_TypeSupportInterface () {};
            private:
                DifferentialPressure_TypeSupportInterface (const DifferentialPressure_TypeSupportInterface &);
                DifferentialPressure_TypeSupportInterface & operator = (const DifferentialPressure_TypeSupportInterface &);
            };

            class  DifferentialPressure_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DifferentialPressure_DataWriter_ptr _ptr_type;
                typedef DifferentialPressure_DataWriter_var _var_type;

                static DifferentialPressure_DataWriter_ptr _duplicate (DifferentialPressure_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DifferentialPressure_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DifferentialPressure_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DifferentialPressure_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DifferentialPressure_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DifferentialPressure_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DifferentialPressure_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DifferentialPressure_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DifferentialPressure_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DifferentialPressure_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DifferentialPressure_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DifferentialPressure_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DifferentialPressure_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DifferentialPressure_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DifferentialPressure_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DifferentialPressure_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DifferentialPressure_& instance_data) = 0;

            protected:
                DifferentialPressure_DataWriter () {};
                ~DifferentialPressure_DataWriter () {};
            private:
                DifferentialPressure_DataWriter (const DifferentialPressure_DataWriter &);
                DifferentialPressure_DataWriter & operator = (const DifferentialPressure_DataWriter &);
            };

            class  DifferentialPressure_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DifferentialPressure_DataReader_ptr _ptr_type;
                typedef DifferentialPressure_DataReader_var _var_type;

                static DifferentialPressure_DataReader_ptr _duplicate (DifferentialPressure_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DifferentialPressure_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DifferentialPressure_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DifferentialPressure_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DifferentialPressure_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DifferentialPressure_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DifferentialPressure_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DifferentialPressure_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DifferentialPressure_& instance) = 0;

            protected:
                DifferentialPressure_DataReader () {};
                ~DifferentialPressure_DataReader () {};
            private:
                DifferentialPressure_DataReader (const DifferentialPressure_DataReader &);
                DifferentialPressure_DataReader & operator = (const DifferentialPressure_DataReader &);
            };

            class  DifferentialPressure_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DifferentialPressure_DataReaderView_ptr _ptr_type;
                typedef DifferentialPressure_DataReaderView_var _var_type;

                static DifferentialPressure_DataReaderView_ptr _duplicate (DifferentialPressure_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DifferentialPressure_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DifferentialPressure_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DifferentialPressure_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DifferentialPressure_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DifferentialPressure_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DifferentialPressure_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DifferentialPressure_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DifferentialPressure_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DifferentialPressure_& instance) = 0;

            protected:
                DifferentialPressure_DataReaderView () {};
                ~DifferentialPressure_DataReaderView () {};
            private:
                DifferentialPressure_DataReaderView (const DifferentialPressure_DataReaderView &);
                DifferentialPressure_DataReaderView & operator = (const DifferentialPressure_DataReaderView &);
            };
        }

    }

}

#endif
