#ifndef _H_9EF66725BA23C653BB835F9E9B1C8CA4_EkfGpsPosition_DCPS_H_
#define _H_9EF66725BA23C653BB835F9E9B1C8CA4_EkfGpsPosition_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EkfGpsPosition_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EkfGpsPosition_TypeSupportInterface;

            typedef EkfGpsPosition_TypeSupportInterface * EkfGpsPosition_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EkfGpsPosition_TypeSupportInterface> EkfGpsPosition_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EkfGpsPosition_TypeSupportInterface> EkfGpsPosition_TypeSupportInterface_out;


            class EkfGpsPosition_DataWriter;

            typedef EkfGpsPosition_DataWriter * EkfGpsPosition_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EkfGpsPosition_DataWriter> EkfGpsPosition_DataWriter_var;
            typedef DDS_DCPSInterface_out < EkfGpsPosition_DataWriter> EkfGpsPosition_DataWriter_out;


            class EkfGpsPosition_DataReader;

            typedef EkfGpsPosition_DataReader * EkfGpsPosition_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EkfGpsPosition_DataReader> EkfGpsPosition_DataReader_var;
            typedef DDS_DCPSInterface_out < EkfGpsPosition_DataReader> EkfGpsPosition_DataReader_out;


            class EkfGpsPosition_DataReaderView;

            typedef EkfGpsPosition_DataReaderView * EkfGpsPosition_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EkfGpsPosition_DataReaderView> EkfGpsPosition_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EkfGpsPosition_DataReaderView> EkfGpsPosition_DataReaderView_out;

            struct EkfGpsPosition_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < EkfGpsPosition_, struct EkfGpsPosition_Seq_uniq_> EkfGpsPosition_Seq;
            typedef DDS_DCPSSequence_var < EkfGpsPosition_Seq> EkfGpsPosition_Seq_var;
            typedef DDS_DCPSSequence_out < EkfGpsPosition_Seq> EkfGpsPosition_Seq_out;

            class  EkfGpsPosition_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EkfGpsPosition_TypeSupportInterface_ptr _ptr_type;
                typedef EkfGpsPosition_TypeSupportInterface_var _var_type;

                static EkfGpsPosition_TypeSupportInterface_ptr _duplicate (EkfGpsPosition_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EkfGpsPosition_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EkfGpsPosition_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EkfGpsPosition_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EkfGpsPosition_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EkfGpsPosition_TypeSupportInterface () {};
                ~EkfGpsPosition_TypeSupportInterface () {};
            private:
                EkfGpsPosition_TypeSupportInterface (const EkfGpsPosition_TypeSupportInterface &);
                EkfGpsPosition_TypeSupportInterface & operator = (const EkfGpsPosition_TypeSupportInterface &);
            };

            class  EkfGpsPosition_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EkfGpsPosition_DataWriter_ptr _ptr_type;
                typedef EkfGpsPosition_DataWriter_var _var_type;

                static EkfGpsPosition_DataWriter_ptr _duplicate (EkfGpsPosition_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EkfGpsPosition_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EkfGpsPosition_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EkfGpsPosition_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EkfGpsPosition_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EkfGpsPosition_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EkfGpsPosition_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EkfGpsPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EkfGpsPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EkfGpsPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EkfGpsPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EkfGpsPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EkfGpsPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EkfGpsPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EkfGpsPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EkfGpsPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EkfGpsPosition_& instance_data) = 0;

            protected:
                EkfGpsPosition_DataWriter () {};
                ~EkfGpsPosition_DataWriter () {};
            private:
                EkfGpsPosition_DataWriter (const EkfGpsPosition_DataWriter &);
                EkfGpsPosition_DataWriter & operator = (const EkfGpsPosition_DataWriter &);
            };

            class  EkfGpsPosition_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EkfGpsPosition_DataReader_ptr _ptr_type;
                typedef EkfGpsPosition_DataReader_var _var_type;

                static EkfGpsPosition_DataReader_ptr _duplicate (EkfGpsPosition_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EkfGpsPosition_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EkfGpsPosition_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EkfGpsPosition_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EkfGpsPosition_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EkfGpsPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EkfGpsPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EkfGpsPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EkfGpsPosition_& instance) = 0;

            protected:
                EkfGpsPosition_DataReader () {};
                ~EkfGpsPosition_DataReader () {};
            private:
                EkfGpsPosition_DataReader (const EkfGpsPosition_DataReader &);
                EkfGpsPosition_DataReader & operator = (const EkfGpsPosition_DataReader &);
            };

            class  EkfGpsPosition_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EkfGpsPosition_DataReaderView_ptr _ptr_type;
                typedef EkfGpsPosition_DataReaderView_var _var_type;

                static EkfGpsPosition_DataReaderView_ptr _duplicate (EkfGpsPosition_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EkfGpsPosition_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EkfGpsPosition_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EkfGpsPosition_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EkfGpsPosition_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EkfGpsPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EkfGpsPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EkfGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EkfGpsPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EkfGpsPosition_& instance) = 0;

            protected:
                EkfGpsPosition_DataReaderView () {};
                ~EkfGpsPosition_DataReaderView () {};
            private:
                EkfGpsPosition_DataReaderView (const EkfGpsPosition_DataReaderView &);
                EkfGpsPosition_DataReaderView & operator = (const EkfGpsPosition_DataReaderView &);
            };
        }

    }

}

#endif
