#ifndef _H_3F53D919EAAA28180C99309DCBE185FF_EscStatus_DCPS_H_
#define _H_3F53D919EAAA28180C99309DCBE185FF_EscStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EscStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EscStatus_TypeSupportInterface;

            typedef EscStatus_TypeSupportInterface * EscStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EscStatus_TypeSupportInterface> EscStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EscStatus_TypeSupportInterface> EscStatus_TypeSupportInterface_out;


            class EscStatus_DataWriter;

            typedef EscStatus_DataWriter * EscStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EscStatus_DataWriter> EscStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < EscStatus_DataWriter> EscStatus_DataWriter_out;


            class EscStatus_DataReader;

            typedef EscStatus_DataReader * EscStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EscStatus_DataReader> EscStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < EscStatus_DataReader> EscStatus_DataReader_out;


            class EscStatus_DataReaderView;

            typedef EscStatus_DataReaderView * EscStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EscStatus_DataReaderView> EscStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EscStatus_DataReaderView> EscStatus_DataReaderView_out;

            struct EscStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < EscStatus_, struct EscStatus_Seq_uniq_> EscStatus_Seq;
            typedef DDS_DCPSSequence_var < EscStatus_Seq> EscStatus_Seq_var;
            typedef DDS_DCPSSequence_out < EscStatus_Seq> EscStatus_Seq_out;

            class  EscStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EscStatus_TypeSupportInterface_ptr _ptr_type;
                typedef EscStatus_TypeSupportInterface_var _var_type;

                static EscStatus_TypeSupportInterface_ptr _duplicate (EscStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EscStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EscStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EscStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EscStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EscStatus_TypeSupportInterface () {};
                ~EscStatus_TypeSupportInterface () {};
            private:
                EscStatus_TypeSupportInterface (const EscStatus_TypeSupportInterface &);
                EscStatus_TypeSupportInterface & operator = (const EscStatus_TypeSupportInterface &);
            };

            class  EscStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EscStatus_DataWriter_ptr _ptr_type;
                typedef EscStatus_DataWriter_var _var_type;

                static EscStatus_DataWriter_ptr _duplicate (EscStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EscStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EscStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EscStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EscStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EscStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EscStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EscStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EscStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EscStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EscStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EscStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EscStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EscStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EscStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EscStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EscStatus_& instance_data) = 0;

            protected:
                EscStatus_DataWriter () {};
                ~EscStatus_DataWriter () {};
            private:
                EscStatus_DataWriter (const EscStatus_DataWriter &);
                EscStatus_DataWriter & operator = (const EscStatus_DataWriter &);
            };

            class  EscStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EscStatus_DataReader_ptr _ptr_type;
                typedef EscStatus_DataReader_var _var_type;

                static EscStatus_DataReader_ptr _duplicate (EscStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EscStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EscStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EscStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EscStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EscStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EscStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EscStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EscStatus_& instance) = 0;

            protected:
                EscStatus_DataReader () {};
                ~EscStatus_DataReader () {};
            private:
                EscStatus_DataReader (const EscStatus_DataReader &);
                EscStatus_DataReader & operator = (const EscStatus_DataReader &);
            };

            class  EscStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EscStatus_DataReaderView_ptr _ptr_type;
                typedef EscStatus_DataReaderView_var _var_type;

                static EscStatus_DataReaderView_ptr _duplicate (EscStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EscStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EscStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EscStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EscStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EscStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EscStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EscStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EscStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EscStatus_& instance) = 0;

            protected:
                EscStatus_DataReaderView () {};
                ~EscStatus_DataReaderView () {};
            private:
                EscStatus_DataReaderView (const EscStatus_DataReaderView &);
                EscStatus_DataReaderView & operator = (const EscStatus_DataReaderView &);
            };
        }

    }

}

#endif
