#ifndef _H_FE5DC893AC867640F44DE3C32AAFE1A7_FollowTarget_DCPS_H_
#define _H_FE5DC893AC867640F44DE3C32AAFE1A7_FollowTarget_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FollowTarget_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class FollowTarget_TypeSupportInterface;

            typedef FollowTarget_TypeSupportInterface * FollowTarget_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowTarget_TypeSupportInterface> FollowTarget_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowTarget_TypeSupportInterface> FollowTarget_TypeSupportInterface_out;


            class FollowTarget_DataWriter;

            typedef FollowTarget_DataWriter * FollowTarget_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowTarget_DataWriter> FollowTarget_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowTarget_DataWriter> FollowTarget_DataWriter_out;


            class FollowTarget_DataReader;

            typedef FollowTarget_DataReader * FollowTarget_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowTarget_DataReader> FollowTarget_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowTarget_DataReader> FollowTarget_DataReader_out;


            class FollowTarget_DataReaderView;

            typedef FollowTarget_DataReaderView * FollowTarget_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowTarget_DataReaderView> FollowTarget_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowTarget_DataReaderView> FollowTarget_DataReaderView_out;

            struct FollowTarget_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < FollowTarget_, struct FollowTarget_Seq_uniq_> FollowTarget_Seq;
            typedef DDS_DCPSSequence_var < FollowTarget_Seq> FollowTarget_Seq_var;
            typedef DDS_DCPSSequence_out < FollowTarget_Seq> FollowTarget_Seq_out;

            class  FollowTarget_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowTarget_TypeSupportInterface_ptr _ptr_type;
                typedef FollowTarget_TypeSupportInterface_var _var_type;

                static FollowTarget_TypeSupportInterface_ptr _duplicate (FollowTarget_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowTarget_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowTarget_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowTarget_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowTarget_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowTarget_TypeSupportInterface () {};
                ~FollowTarget_TypeSupportInterface () {};
            private:
                FollowTarget_TypeSupportInterface (const FollowTarget_TypeSupportInterface &);
                FollowTarget_TypeSupportInterface & operator = (const FollowTarget_TypeSupportInterface &);
            };

            class  FollowTarget_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowTarget_DataWriter_ptr _ptr_type;
                typedef FollowTarget_DataWriter_var _var_type;

                static FollowTarget_DataWriter_ptr _duplicate (FollowTarget_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowTarget_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowTarget_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowTarget_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowTarget_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowTarget_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowTarget_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowTarget_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowTarget_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowTarget_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowTarget_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowTarget_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowTarget_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowTarget_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowTarget_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowTarget_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowTarget_& instance_data) = 0;

            protected:
                FollowTarget_DataWriter () {};
                ~FollowTarget_DataWriter () {};
            private:
                FollowTarget_DataWriter (const FollowTarget_DataWriter &);
                FollowTarget_DataWriter & operator = (const FollowTarget_DataWriter &);
            };

            class  FollowTarget_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowTarget_DataReader_ptr _ptr_type;
                typedef FollowTarget_DataReader_var _var_type;

                static FollowTarget_DataReader_ptr _duplicate (FollowTarget_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowTarget_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowTarget_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowTarget_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowTarget_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowTarget_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowTarget_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowTarget_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowTarget_& instance) = 0;

            protected:
                FollowTarget_DataReader () {};
                ~FollowTarget_DataReader () {};
            private:
                FollowTarget_DataReader (const FollowTarget_DataReader &);
                FollowTarget_DataReader & operator = (const FollowTarget_DataReader &);
            };

            class  FollowTarget_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowTarget_DataReaderView_ptr _ptr_type;
                typedef FollowTarget_DataReaderView_var _var_type;

                static FollowTarget_DataReaderView_ptr _duplicate (FollowTarget_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowTarget_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowTarget_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowTarget_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowTarget_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowTarget_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowTarget_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowTarget_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowTarget_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowTarget_& instance) = 0;

            protected:
                FollowTarget_DataReaderView () {};
                ~FollowTarget_DataReaderView () {};
            private:
                FollowTarget_DataReaderView (const FollowTarget_DataReaderView &);
                FollowTarget_DataReaderView & operator = (const FollowTarget_DataReaderView &);
            };
        }

    }

}

#endif
