#ifndef _H_24B85D4400D2E031529299DC982FB0A7_FwVirtualAttitudeSetpoint_DCPS_H_
#define _H_24B85D4400D2E031529299DC982FB0A7_FwVirtualAttitudeSetpoint_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FwVirtualAttitudeSetpoint_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class FwVirtualAttitudeSetpoint_TypeSupportInterface;

            typedef FwVirtualAttitudeSetpoint_TypeSupportInterface * FwVirtualAttitudeSetpoint_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FwVirtualAttitudeSetpoint_TypeSupportInterface> FwVirtualAttitudeSetpoint_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FwVirtualAttitudeSetpoint_TypeSupportInterface> FwVirtualAttitudeSetpoint_TypeSupportInterface_out;


            class FwVirtualAttitudeSetpoint_DataWriter;

            typedef FwVirtualAttitudeSetpoint_DataWriter * FwVirtualAttitudeSetpoint_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FwVirtualAttitudeSetpoint_DataWriter> FwVirtualAttitudeSetpoint_DataWriter_var;
            typedef DDS_DCPSInterface_out < FwVirtualAttitudeSetpoint_DataWriter> FwVirtualAttitudeSetpoint_DataWriter_out;


            class FwVirtualAttitudeSetpoint_DataReader;

            typedef FwVirtualAttitudeSetpoint_DataReader * FwVirtualAttitudeSetpoint_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FwVirtualAttitudeSetpoint_DataReader> FwVirtualAttitudeSetpoint_DataReader_var;
            typedef DDS_DCPSInterface_out < FwVirtualAttitudeSetpoint_DataReader> FwVirtualAttitudeSetpoint_DataReader_out;


            class FwVirtualAttitudeSetpoint_DataReaderView;

            typedef FwVirtualAttitudeSetpoint_DataReaderView * FwVirtualAttitudeSetpoint_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FwVirtualAttitudeSetpoint_DataReaderView> FwVirtualAttitudeSetpoint_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FwVirtualAttitudeSetpoint_DataReaderView> FwVirtualAttitudeSetpoint_DataReaderView_out;

            struct FwVirtualAttitudeSetpoint_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < FwVirtualAttitudeSetpoint_, struct FwVirtualAttitudeSetpoint_Seq_uniq_> FwVirtualAttitudeSetpoint_Seq;
            typedef DDS_DCPSSequence_var < FwVirtualAttitudeSetpoint_Seq> FwVirtualAttitudeSetpoint_Seq_var;
            typedef DDS_DCPSSequence_out < FwVirtualAttitudeSetpoint_Seq> FwVirtualAttitudeSetpoint_Seq_out;

            class  FwVirtualAttitudeSetpoint_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FwVirtualAttitudeSetpoint_TypeSupportInterface_ptr _ptr_type;
                typedef FwVirtualAttitudeSetpoint_TypeSupportInterface_var _var_type;

                static FwVirtualAttitudeSetpoint_TypeSupportInterface_ptr _duplicate (FwVirtualAttitudeSetpoint_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FwVirtualAttitudeSetpoint_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FwVirtualAttitudeSetpoint_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FwVirtualAttitudeSetpoint_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FwVirtualAttitudeSetpoint_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FwVirtualAttitudeSetpoint_TypeSupportInterface () {};
                ~FwVirtualAttitudeSetpoint_TypeSupportInterface () {};
            private:
                FwVirtualAttitudeSetpoint_TypeSupportInterface (const FwVirtualAttitudeSetpoint_TypeSupportInterface &);
                FwVirtualAttitudeSetpoint_TypeSupportInterface & operator = (const FwVirtualAttitudeSetpoint_TypeSupportInterface &);
            };

            class  FwVirtualAttitudeSetpoint_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FwVirtualAttitudeSetpoint_DataWriter_ptr _ptr_type;
                typedef FwVirtualAttitudeSetpoint_DataWriter_var _var_type;

                static FwVirtualAttitudeSetpoint_DataWriter_ptr _duplicate (FwVirtualAttitudeSetpoint_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FwVirtualAttitudeSetpoint_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FwVirtualAttitudeSetpoint_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FwVirtualAttitudeSetpoint_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FwVirtualAttitudeSetpoint_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FwVirtualAttitudeSetpoint_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FwVirtualAttitudeSetpoint_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FwVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FwVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FwVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FwVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FwVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FwVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FwVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FwVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FwVirtualAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FwVirtualAttitudeSetpoint_& instance_data) = 0;

            protected:
                FwVirtualAttitudeSetpoint_DataWriter () {};
                ~FwVirtualAttitudeSetpoint_DataWriter () {};
            private:
                FwVirtualAttitudeSetpoint_DataWriter (const FwVirtualAttitudeSetpoint_DataWriter &);
                FwVirtualAttitudeSetpoint_DataWriter & operator = (const FwVirtualAttitudeSetpoint_DataWriter &);
            };

            class  FwVirtualAttitudeSetpoint_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FwVirtualAttitudeSetpoint_DataReader_ptr _ptr_type;
                typedef FwVirtualAttitudeSetpoint_DataReader_var _var_type;

                static FwVirtualAttitudeSetpoint_DataReader_ptr _duplicate (FwVirtualAttitudeSetpoint_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FwVirtualAttitudeSetpoint_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FwVirtualAttitudeSetpoint_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FwVirtualAttitudeSetpoint_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FwVirtualAttitudeSetpoint_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FwVirtualAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FwVirtualAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FwVirtualAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FwVirtualAttitudeSetpoint_& instance) = 0;

            protected:
                FwVirtualAttitudeSetpoint_DataReader () {};
                ~FwVirtualAttitudeSetpoint_DataReader () {};
            private:
                FwVirtualAttitudeSetpoint_DataReader (const FwVirtualAttitudeSetpoint_DataReader &);
                FwVirtualAttitudeSetpoint_DataReader & operator = (const FwVirtualAttitudeSetpoint_DataReader &);
            };

            class  FwVirtualAttitudeSetpoint_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FwVirtualAttitudeSetpoint_DataReaderView_ptr _ptr_type;
                typedef FwVirtualAttitudeSetpoint_DataReaderView_var _var_type;

                static FwVirtualAttitudeSetpoint_DataReaderView_ptr _duplicate (FwVirtualAttitudeSetpoint_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FwVirtualAttitudeSetpoint_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FwVirtualAttitudeSetpoint_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FwVirtualAttitudeSetpoint_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FwVirtualAttitudeSetpoint_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FwVirtualAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FwVirtualAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FwVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FwVirtualAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FwVirtualAttitudeSetpoint_& instance) = 0;

            protected:
                FwVirtualAttitudeSetpoint_DataReaderView () {};
                ~FwVirtualAttitudeSetpoint_DataReaderView () {};
            private:
                FwVirtualAttitudeSetpoint_DataReaderView (const FwVirtualAttitudeSetpoint_DataReaderView &);
                FwVirtualAttitudeSetpoint_DataReaderView & operator = (const FwVirtualAttitudeSetpoint_DataReaderView &);
            };
        }

    }

}

#endif
