#ifndef _H_6752679FB217016B0FA0F2906C663C27_GeofenceResult__H_
#define _H_6752679FB217016B0FA0F2906C663C27_GeofenceResult__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace GeofenceResult_Constants
            {
                const ::DDS::Octet GF_ACTION_NONE_ = 0;

                const ::DDS::Octet GF_ACTION_WARN_ = 1;

                const ::DDS::Octet GF_ACTION_LOITER_ = 2;

                const ::DDS::Octet GF_ACTION_RTL_ = 3;

                const ::DDS::Octet GF_ACTION_TERMINATE_ = 4;

            }

            struct  GeofenceResult_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Boolean geofence_violated_;
                ::DDS::Octet geofence_action_;
                ::DDS::Boolean home_required_;
            };

            typedef DDS_DCPSStruct_var<GeofenceResult_> GeofenceResult__var;
            typedef GeofenceResult_& GeofenceResult__out;

        }

    }

}

#endif /* _H_6752679FB217016B0FA0F2906C663C27_GeofenceResult__H_ */
