#ifndef _H_1B853E8967F465F61276C9721A9DB8A5_GpsDump_DCPS_H_
#define _H_1B853E8967F465F61276C9721A9DB8A5_GpsDump_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GpsDump_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GpsDump_TypeSupportInterface;

            typedef GpsDump_TypeSupportInterface * GpsDump_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GpsDump_TypeSupportInterface> GpsDump_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GpsDump_TypeSupportInterface> GpsDump_TypeSupportInterface_out;


            class GpsDump_DataWriter;

            typedef GpsDump_DataWriter * GpsDump_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GpsDump_DataWriter> GpsDump_DataWriter_var;
            typedef DDS_DCPSInterface_out < GpsDump_DataWriter> GpsDump_DataWriter_out;


            class GpsDump_DataReader;

            typedef GpsDump_DataReader * GpsDump_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GpsDump_DataReader> GpsDump_DataReader_var;
            typedef DDS_DCPSInterface_out < GpsDump_DataReader> GpsDump_DataReader_out;


            class GpsDump_DataReaderView;

            typedef GpsDump_DataReaderView * GpsDump_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GpsDump_DataReaderView> GpsDump_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GpsDump_DataReaderView> GpsDump_DataReaderView_out;

            struct GpsDump_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GpsDump_, struct GpsDump_Seq_uniq_> GpsDump_Seq;
            typedef DDS_DCPSSequence_var < GpsDump_Seq> GpsDump_Seq_var;
            typedef DDS_DCPSSequence_out < GpsDump_Seq> GpsDump_Seq_out;

            class  GpsDump_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GpsDump_TypeSupportInterface_ptr _ptr_type;
                typedef GpsDump_TypeSupportInterface_var _var_type;

                static GpsDump_TypeSupportInterface_ptr _duplicate (GpsDump_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsDump_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GpsDump_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsDump_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsDump_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GpsDump_TypeSupportInterface () {};
                ~GpsDump_TypeSupportInterface () {};
            private:
                GpsDump_TypeSupportInterface (const GpsDump_TypeSupportInterface &);
                GpsDump_TypeSupportInterface & operator = (const GpsDump_TypeSupportInterface &);
            };

            class  GpsDump_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GpsDump_DataWriter_ptr _ptr_type;
                typedef GpsDump_DataWriter_var _var_type;

                static GpsDump_DataWriter_ptr _duplicate (GpsDump_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsDump_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GpsDump_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsDump_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsDump_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GpsDump_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GpsDump_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GpsDump_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GpsDump_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GpsDump_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GpsDump_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GpsDump_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GpsDump_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GpsDump_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GpsDump_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GpsDump_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsDump_& instance_data) = 0;

            protected:
                GpsDump_DataWriter () {};
                ~GpsDump_DataWriter () {};
            private:
                GpsDump_DataWriter (const GpsDump_DataWriter &);
                GpsDump_DataWriter & operator = (const GpsDump_DataWriter &);
            };

            class  GpsDump_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GpsDump_DataReader_ptr _ptr_type;
                typedef GpsDump_DataReader_var _var_type;

                static GpsDump_DataReader_ptr _duplicate (GpsDump_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsDump_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GpsDump_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsDump_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsDump_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpsDump_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpsDump_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpsDump_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsDump_& instance) = 0;

            protected:
                GpsDump_DataReader () {};
                ~GpsDump_DataReader () {};
            private:
                GpsDump_DataReader (const GpsDump_DataReader &);
                GpsDump_DataReader & operator = (const GpsDump_DataReader &);
            };

            class  GpsDump_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GpsDump_DataReaderView_ptr _ptr_type;
                typedef GpsDump_DataReaderView_var _var_type;

                static GpsDump_DataReaderView_ptr _duplicate (GpsDump_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsDump_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GpsDump_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsDump_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsDump_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpsDump_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpsDump_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpsDump_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpsDump_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsDump_& instance) = 0;

            protected:
                GpsDump_DataReaderView () {};
                ~GpsDump_DataReaderView () {};
            private:
                GpsDump_DataReaderView (const GpsDump_DataReaderView &);
                GpsDump_DataReaderView & operator = (const GpsDump_DataReaderView &);
            };
        }

    }

}

#endif
