#ifndef _H_C44140A5A6B8192E6A5413CF1D285AEE_GpsInjectData_DCPS_H_
#define _H_C44140A5A6B8192E6A5413CF1D285AEE_GpsInjectData_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GpsInjectData_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GpsInjectData_TypeSupportInterface;

            typedef GpsInjectData_TypeSupportInterface * GpsInjectData_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GpsInjectData_TypeSupportInterface> GpsInjectData_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GpsInjectData_TypeSupportInterface> GpsInjectData_TypeSupportInterface_out;


            class GpsInjectData_DataWriter;

            typedef GpsInjectData_DataWriter * GpsInjectData_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GpsInjectData_DataWriter> GpsInjectData_DataWriter_var;
            typedef DDS_DCPSInterface_out < GpsInjectData_DataWriter> GpsInjectData_DataWriter_out;


            class GpsInjectData_DataReader;

            typedef GpsInjectData_DataReader * GpsInjectData_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GpsInjectData_DataReader> GpsInjectData_DataReader_var;
            typedef DDS_DCPSInterface_out < GpsInjectData_DataReader> GpsInjectData_DataReader_out;


            class GpsInjectData_DataReaderView;

            typedef GpsInjectData_DataReaderView * GpsInjectData_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GpsInjectData_DataReaderView> GpsInjectData_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GpsInjectData_DataReaderView> GpsInjectData_DataReaderView_out;

            struct GpsInjectData_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GpsInjectData_, struct GpsInjectData_Seq_uniq_> GpsInjectData_Seq;
            typedef DDS_DCPSSequence_var < GpsInjectData_Seq> GpsInjectData_Seq_var;
            typedef DDS_DCPSSequence_out < GpsInjectData_Seq> GpsInjectData_Seq_out;

            class  GpsInjectData_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GpsInjectData_TypeSupportInterface_ptr _ptr_type;
                typedef GpsInjectData_TypeSupportInterface_var _var_type;

                static GpsInjectData_TypeSupportInterface_ptr _duplicate (GpsInjectData_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsInjectData_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GpsInjectData_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsInjectData_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsInjectData_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GpsInjectData_TypeSupportInterface () {};
                ~GpsInjectData_TypeSupportInterface () {};
            private:
                GpsInjectData_TypeSupportInterface (const GpsInjectData_TypeSupportInterface &);
                GpsInjectData_TypeSupportInterface & operator = (const GpsInjectData_TypeSupportInterface &);
            };

            class  GpsInjectData_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GpsInjectData_DataWriter_ptr _ptr_type;
                typedef GpsInjectData_DataWriter_var _var_type;

                static GpsInjectData_DataWriter_ptr _duplicate (GpsInjectData_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsInjectData_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GpsInjectData_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsInjectData_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsInjectData_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GpsInjectData_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GpsInjectData_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GpsInjectData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GpsInjectData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GpsInjectData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GpsInjectData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GpsInjectData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GpsInjectData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GpsInjectData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GpsInjectData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GpsInjectData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsInjectData_& instance_data) = 0;

            protected:
                GpsInjectData_DataWriter () {};
                ~GpsInjectData_DataWriter () {};
            private:
                GpsInjectData_DataWriter (const GpsInjectData_DataWriter &);
                GpsInjectData_DataWriter & operator = (const GpsInjectData_DataWriter &);
            };

            class  GpsInjectData_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GpsInjectData_DataReader_ptr _ptr_type;
                typedef GpsInjectData_DataReader_var _var_type;

                static GpsInjectData_DataReader_ptr _duplicate (GpsInjectData_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsInjectData_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GpsInjectData_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsInjectData_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsInjectData_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpsInjectData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpsInjectData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpsInjectData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsInjectData_& instance) = 0;

            protected:
                GpsInjectData_DataReader () {};
                ~GpsInjectData_DataReader () {};
            private:
                GpsInjectData_DataReader (const GpsInjectData_DataReader &);
                GpsInjectData_DataReader & operator = (const GpsInjectData_DataReader &);
            };

            class  GpsInjectData_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GpsInjectData_DataReaderView_ptr _ptr_type;
                typedef GpsInjectData_DataReaderView_var _var_type;

                static GpsInjectData_DataReaderView_ptr _duplicate (GpsInjectData_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsInjectData_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GpsInjectData_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsInjectData_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsInjectData_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpsInjectData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpsInjectData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpsInjectData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpsInjectData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsInjectData_& instance) = 0;

            protected:
                GpsInjectData_DataReaderView () {};
                ~GpsInjectData_DataReaderView () {};
            private:
                GpsInjectData_DataReaderView (const GpsInjectData_DataReaderView &);
                GpsInjectData_DataReaderView & operator = (const GpsInjectData_DataReaderView &);
            };
        }

    }

}

#endif
