#ifndef _H_9B6032E94FDD6ADFE2013FBA558CB1B0_InputRc__H_
#define _H_9B6032E94FDD6ADFE2013FBA558CB1B0_InputRc__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace InputRc_Constants
            {
                const ::DDS::Octet RC_INPUT_SOURCE_UNKNOWN_ = 0;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4FMU_PPM_ = 1;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4IO_PPM_ = 2;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4IO_SPEKTRUM_ = 3;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4IO_SBUS_ = 4;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4IO_ST24_ = 5;

                const ::DDS::Octet RC_INPUT_SOURCE_MAVLINK_ = 6;

                const ::DDS::Octet RC_INPUT_SOURCE_QURT_ = 7;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4FMU_SPEKTRUM_ = 8;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4FMU_SBUS_ = 9;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4FMU_ST24_ = 10;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4FMU_SUMD_ = 11;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4FMU_DSM_ = 12;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4IO_SUMD_ = 13;

                const ::DDS::Octet RC_INPUT_SOURCE_PX4FMU_CRSF_ = 14;

                const ::DDS::Octet RC_INPUT_MAX_CHANNELS_ = 18;

            }

            struct  InputRc_
            {
                struct _values__uniq_{};
                typedef ::DDS::UShort _values__slice;
                typedef ::DDS::UShort _values_[18];
                typedef DDS_DCPS_FArray_var< _values_, _values__slice, struct _values__uniq_ > _values__var;
                typedef _values_ _values__out;
                typedef DDS_DCPS_Array_forany< _values_, _values__slice, struct _values__uniq_ > _values__forany;
                static _values__slice *_values__alloc();
                static void _values__free(_values__slice *);
                static void _values__copy(_values__slice *to, const _values__slice *from);
                static _values__slice *_values__dup(const _values__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::ULongLong timestamp_last_signal_;
                ::DDS::ULong channel_count_;
                ::DDS::Long rssi_;
                ::DDS::Boolean rc_failsafe_;
                ::DDS::Boolean rc_lost_;
                ::DDS::UShort rc_lost_frame_count_;
                ::DDS::UShort rc_total_frame_count_;
                ::DDS::UShort rc_ppm_frame_length_;
                ::DDS::Octet input_source_;
                _values_ values_;
            };

            typedef DDS_DCPSStruct_var<InputRc_> InputRc__var;
            typedef InputRc_& InputRc__out;

        }

    }

}

#endif /* _H_9B6032E94FDD6ADFE2013FBA558CB1B0_InputRc__H_ */
