#ifndef _H_9B6032E94FDD6ADFE2013FBA558CB1B0_InputRc_DCPS_H_
#define _H_9B6032E94FDD6ADFE2013FBA558CB1B0_InputRc_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "InputRc_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class InputRc_TypeSupportInterface;

            typedef InputRc_TypeSupportInterface * InputRc_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < InputRc_TypeSupportInterface> InputRc_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < InputRc_TypeSupportInterface> InputRc_TypeSupportInterface_out;


            class InputRc_DataWriter;

            typedef InputRc_DataWriter * InputRc_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < InputRc_DataWriter> InputRc_DataWriter_var;
            typedef DDS_DCPSInterface_out < InputRc_DataWriter> InputRc_DataWriter_out;


            class InputRc_DataReader;

            typedef InputRc_DataReader * InputRc_DataReader_ptr;
            typedef DDS_DCPSInterface_var < InputRc_DataReader> InputRc_DataReader_var;
            typedef DDS_DCPSInterface_out < InputRc_DataReader> InputRc_DataReader_out;


            class InputRc_DataReaderView;

            typedef InputRc_DataReaderView * InputRc_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < InputRc_DataReaderView> InputRc_DataReaderView_var;
            typedef DDS_DCPSInterface_out < InputRc_DataReaderView> InputRc_DataReaderView_out;

            struct InputRc_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < InputRc_, struct InputRc_Seq_uniq_> InputRc_Seq;
            typedef DDS_DCPSSequence_var < InputRc_Seq> InputRc_Seq_var;
            typedef DDS_DCPSSequence_out < InputRc_Seq> InputRc_Seq_out;

            class  InputRc_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef InputRc_TypeSupportInterface_ptr _ptr_type;
                typedef InputRc_TypeSupportInterface_var _var_type;

                static InputRc_TypeSupportInterface_ptr _duplicate (InputRc_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static InputRc_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static InputRc_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static InputRc_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                InputRc_TypeSupportInterface_ptr _this () { return this; }


            protected:
                InputRc_TypeSupportInterface () {};
                ~InputRc_TypeSupportInterface () {};
            private:
                InputRc_TypeSupportInterface (const InputRc_TypeSupportInterface &);
                InputRc_TypeSupportInterface & operator = (const InputRc_TypeSupportInterface &);
            };

            class  InputRc_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef InputRc_DataWriter_ptr _ptr_type;
                typedef InputRc_DataWriter_var _var_type;

                static InputRc_DataWriter_ptr _duplicate (InputRc_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static InputRc_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static InputRc_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static InputRc_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                InputRc_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const InputRc_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const InputRc_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const InputRc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const InputRc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const InputRc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const InputRc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const InputRc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const InputRc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const InputRc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const InputRc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (InputRc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const InputRc_& instance_data) = 0;

            protected:
                InputRc_DataWriter () {};
                ~InputRc_DataWriter () {};
            private:
                InputRc_DataWriter (const InputRc_DataWriter &);
                InputRc_DataWriter & operator = (const InputRc_DataWriter &);
            };

            class  InputRc_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef InputRc_DataReader_ptr _ptr_type;
                typedef InputRc_DataReader_var _var_type;

                static InputRc_DataReader_ptr _duplicate (InputRc_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static InputRc_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static InputRc_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static InputRc_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                InputRc_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (InputRc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (InputRc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (InputRc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const InputRc_& instance) = 0;

            protected:
                InputRc_DataReader () {};
                ~InputRc_DataReader () {};
            private:
                InputRc_DataReader (const InputRc_DataReader &);
                InputRc_DataReader & operator = (const InputRc_DataReader &);
            };

            class  InputRc_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef InputRc_DataReaderView_ptr _ptr_type;
                typedef InputRc_DataReaderView_var _var_type;

                static InputRc_DataReaderView_ptr _duplicate (InputRc_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static InputRc_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static InputRc_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static InputRc_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                InputRc_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (InputRc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (InputRc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (InputRc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (InputRc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const InputRc_& instance) = 0;

            protected:
                InputRc_DataReaderView () {};
                ~InputRc_DataReaderView () {};
            private:
                InputRc_DataReaderView (const InputRc_DataReaderView &);
                InputRc_DataReaderView & operator = (const InputRc_DataReaderView &);
            };
        }

    }

}

#endif
