#ifndef _H_8487552C92778AC9E0A1B2FFF19A5E39_IridiumsbdStatus__H_
#define _H_8487552C92778AC9E0A1B2FFF19A5E39_IridiumsbdStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  IridiumsbdStatus_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::ULongLong last_heartbeat_;
                ::DDS::UShort tx_buf_write_index_;
                ::DDS::UShort rx_buf_read_index_;
                ::DDS::UShort rx_buf_end_index_;
                ::DDS::UShort failed_sbd_sessions_;
                ::DDS::UShort successful_sbd_sessions_;
                ::DDS::UShort num_tx_buf_reset_;
                ::DDS::Octet signal_quality_;
                ::DDS::Octet state_;
                ::DDS::Boolean ring_pending_;
                ::DDS::Boolean tx_buf_write_pending_;
                ::DDS::Boolean tx_session_pending_;
                ::DDS::Boolean rx_read_pending_;
                ::DDS::Boolean rx_session_pending_;
            };

            typedef DDS_DCPSStruct_var<IridiumsbdStatus_> IridiumsbdStatus__var;
            typedef IridiumsbdStatus_& IridiumsbdStatus__out;

        }

    }

}

#endif /* _H_8487552C92778AC9E0A1B2FFF19A5E39_IridiumsbdStatus__H_ */
