#ifndef _H_69467860CFF8ECF13DA9F37A42719A82_LandingTargetInnovations_DCPS_H_
#define _H_69467860CFF8ECF13DA9F37A42719A82_LandingTargetInnovations_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LandingTargetInnovations_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LandingTargetInnovations_TypeSupportInterface;

            typedef LandingTargetInnovations_TypeSupportInterface * LandingTargetInnovations_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LandingTargetInnovations_TypeSupportInterface> LandingTargetInnovations_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LandingTargetInnovations_TypeSupportInterface> LandingTargetInnovations_TypeSupportInterface_out;


            class LandingTargetInnovations_DataWriter;

            typedef LandingTargetInnovations_DataWriter * LandingTargetInnovations_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LandingTargetInnovations_DataWriter> LandingTargetInnovations_DataWriter_var;
            typedef DDS_DCPSInterface_out < LandingTargetInnovations_DataWriter> LandingTargetInnovations_DataWriter_out;


            class LandingTargetInnovations_DataReader;

            typedef LandingTargetInnovations_DataReader * LandingTargetInnovations_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LandingTargetInnovations_DataReader> LandingTargetInnovations_DataReader_var;
            typedef DDS_DCPSInterface_out < LandingTargetInnovations_DataReader> LandingTargetInnovations_DataReader_out;


            class LandingTargetInnovations_DataReaderView;

            typedef LandingTargetInnovations_DataReaderView * LandingTargetInnovations_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LandingTargetInnovations_DataReaderView> LandingTargetInnovations_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LandingTargetInnovations_DataReaderView> LandingTargetInnovations_DataReaderView_out;

            struct LandingTargetInnovations_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LandingTargetInnovations_, struct LandingTargetInnovations_Seq_uniq_> LandingTargetInnovations_Seq;
            typedef DDS_DCPSSequence_var < LandingTargetInnovations_Seq> LandingTargetInnovations_Seq_var;
            typedef DDS_DCPSSequence_out < LandingTargetInnovations_Seq> LandingTargetInnovations_Seq_out;

            class  LandingTargetInnovations_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LandingTargetInnovations_TypeSupportInterface_ptr _ptr_type;
                typedef LandingTargetInnovations_TypeSupportInterface_var _var_type;

                static LandingTargetInnovations_TypeSupportInterface_ptr _duplicate (LandingTargetInnovations_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingTargetInnovations_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LandingTargetInnovations_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingTargetInnovations_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingTargetInnovations_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LandingTargetInnovations_TypeSupportInterface () {};
                ~LandingTargetInnovations_TypeSupportInterface () {};
            private:
                LandingTargetInnovations_TypeSupportInterface (const LandingTargetInnovations_TypeSupportInterface &);
                LandingTargetInnovations_TypeSupportInterface & operator = (const LandingTargetInnovations_TypeSupportInterface &);
            };

            class  LandingTargetInnovations_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LandingTargetInnovations_DataWriter_ptr _ptr_type;
                typedef LandingTargetInnovations_DataWriter_var _var_type;

                static LandingTargetInnovations_DataWriter_ptr _duplicate (LandingTargetInnovations_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingTargetInnovations_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LandingTargetInnovations_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingTargetInnovations_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingTargetInnovations_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LandingTargetInnovations_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LandingTargetInnovations_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LandingTargetInnovations_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LandingTargetInnovations_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LandingTargetInnovations_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LandingTargetInnovations_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LandingTargetInnovations_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LandingTargetInnovations_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LandingTargetInnovations_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LandingTargetInnovations_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LandingTargetInnovations_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingTargetInnovations_& instance_data) = 0;

            protected:
                LandingTargetInnovations_DataWriter () {};
                ~LandingTargetInnovations_DataWriter () {};
            private:
                LandingTargetInnovations_DataWriter (const LandingTargetInnovations_DataWriter &);
                LandingTargetInnovations_DataWriter & operator = (const LandingTargetInnovations_DataWriter &);
            };

            class  LandingTargetInnovations_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LandingTargetInnovations_DataReader_ptr _ptr_type;
                typedef LandingTargetInnovations_DataReader_var _var_type;

                static LandingTargetInnovations_DataReader_ptr _duplicate (LandingTargetInnovations_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingTargetInnovations_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LandingTargetInnovations_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingTargetInnovations_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingTargetInnovations_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LandingTargetInnovations_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LandingTargetInnovations_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LandingTargetInnovations_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingTargetInnovations_& instance) = 0;

            protected:
                LandingTargetInnovations_DataReader () {};
                ~LandingTargetInnovations_DataReader () {};
            private:
                LandingTargetInnovations_DataReader (const LandingTargetInnovations_DataReader &);
                LandingTargetInnovations_DataReader & operator = (const LandingTargetInnovations_DataReader &);
            };

            class  LandingTargetInnovations_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LandingTargetInnovations_DataReaderView_ptr _ptr_type;
                typedef LandingTargetInnovations_DataReaderView_var _var_type;

                static LandingTargetInnovations_DataReaderView_ptr _duplicate (LandingTargetInnovations_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingTargetInnovations_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LandingTargetInnovations_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingTargetInnovations_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingTargetInnovations_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LandingTargetInnovations_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LandingTargetInnovations_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LandingTargetInnovations_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LandingTargetInnovations_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingTargetInnovations_& instance) = 0;

            protected:
                LandingTargetInnovations_DataReaderView () {};
                ~LandingTargetInnovations_DataReaderView () {};
            private:
                LandingTargetInnovations_DataReaderView (const LandingTargetInnovations_DataReaderView &);
                LandingTargetInnovations_DataReaderView & operator = (const LandingTargetInnovations_DataReaderView &);
            };
        }

    }

}

#endif
