#ifndef _H_D660B2777FB95D27747EF1D15CA354D9_LandingTargetPose__H_
#define _H_D660B2777FB95D27747EF1D15CA354D9_LandingTargetPose__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  LandingTargetPose_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Boolean is_static_;
                ::DDS::Boolean rel_pos_valid_;
                ::DDS::Boolean rel_vel_valid_;
                ::DDS::Float x_rel_;
                ::DDS::Float y_rel_;
                ::DDS::Float z_rel_;
                ::DDS::Float vx_rel_;
                ::DDS::Float vy_rel_;
                ::DDS::Float cov_x_rel_;
                ::DDS::Float cov_y_rel_;
                ::DDS::Float cov_vx_rel_;
                ::DDS::Float cov_vy_rel_;
                ::DDS::Boolean abs_pos_valid_;
                ::DDS::Float x_abs_;
                ::DDS::Float y_abs_;
                ::DDS::Float z_abs_;
            };

            typedef DDS_DCPSStruct_var<LandingTargetPose_> LandingTargetPose__var;
            typedef LandingTargetPose_& LandingTargetPose__out;

        }

    }

}

#endif /* _H_D660B2777FB95D27747EF1D15CA354D9_LandingTargetPose__H_ */
