#ifndef _H_D660B2777FB95D27747EF1D15CA354D9_LandingTargetPose_DCPS_H_
#define _H_D660B2777FB95D27747EF1D15CA354D9_LandingTargetPose_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LandingTargetPose_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LandingTargetPose_TypeSupportInterface;

            typedef LandingTargetPose_TypeSupportInterface * LandingTargetPose_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LandingTargetPose_TypeSupportInterface> LandingTargetPose_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LandingTargetPose_TypeSupportInterface> LandingTargetPose_TypeSupportInterface_out;


            class LandingTargetPose_DataWriter;

            typedef LandingTargetPose_DataWriter * LandingTargetPose_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LandingTargetPose_DataWriter> LandingTargetPose_DataWriter_var;
            typedef DDS_DCPSInterface_out < LandingTargetPose_DataWriter> LandingTargetPose_DataWriter_out;


            class LandingTargetPose_DataReader;

            typedef LandingTargetPose_DataReader * LandingTargetPose_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LandingTargetPose_DataReader> LandingTargetPose_DataReader_var;
            typedef DDS_DCPSInterface_out < LandingTargetPose_DataReader> LandingTargetPose_DataReader_out;


            class LandingTargetPose_DataReaderView;

            typedef LandingTargetPose_DataReaderView * LandingTargetPose_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LandingTargetPose_DataReaderView> LandingTargetPose_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LandingTargetPose_DataReaderView> LandingTargetPose_DataReaderView_out;

            struct LandingTargetPose_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LandingTargetPose_, struct LandingTargetPose_Seq_uniq_> LandingTargetPose_Seq;
            typedef DDS_DCPSSequence_var < LandingTargetPose_Seq> LandingTargetPose_Seq_var;
            typedef DDS_DCPSSequence_out < LandingTargetPose_Seq> LandingTargetPose_Seq_out;

            class  LandingTargetPose_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LandingTargetPose_TypeSupportInterface_ptr _ptr_type;
                typedef LandingTargetPose_TypeSupportInterface_var _var_type;

                static LandingTargetPose_TypeSupportInterface_ptr _duplicate (LandingTargetPose_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingTargetPose_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LandingTargetPose_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingTargetPose_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingTargetPose_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LandingTargetPose_TypeSupportInterface () {};
                ~LandingTargetPose_TypeSupportInterface () {};
            private:
                LandingTargetPose_TypeSupportInterface (const LandingTargetPose_TypeSupportInterface &);
                LandingTargetPose_TypeSupportInterface & operator = (const LandingTargetPose_TypeSupportInterface &);
            };

            class  LandingTargetPose_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LandingTargetPose_DataWriter_ptr _ptr_type;
                typedef LandingTargetPose_DataWriter_var _var_type;

                static LandingTargetPose_DataWriter_ptr _duplicate (LandingTargetPose_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingTargetPose_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LandingTargetPose_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingTargetPose_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingTargetPose_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LandingTargetPose_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LandingTargetPose_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LandingTargetPose_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LandingTargetPose_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LandingTargetPose_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LandingTargetPose_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LandingTargetPose_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LandingTargetPose_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LandingTargetPose_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LandingTargetPose_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LandingTargetPose_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingTargetPose_& instance_data) = 0;

            protected:
                LandingTargetPose_DataWriter () {};
                ~LandingTargetPose_DataWriter () {};
            private:
                LandingTargetPose_DataWriter (const LandingTargetPose_DataWriter &);
                LandingTargetPose_DataWriter & operator = (const LandingTargetPose_DataWriter &);
            };

            class  LandingTargetPose_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LandingTargetPose_DataReader_ptr _ptr_type;
                typedef LandingTargetPose_DataReader_var _var_type;

                static LandingTargetPose_DataReader_ptr _duplicate (LandingTargetPose_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingTargetPose_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LandingTargetPose_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingTargetPose_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingTargetPose_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LandingTargetPose_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LandingTargetPose_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LandingTargetPose_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingTargetPose_& instance) = 0;

            protected:
                LandingTargetPose_DataReader () {};
                ~LandingTargetPose_DataReader () {};
            private:
                LandingTargetPose_DataReader (const LandingTargetPose_DataReader &);
                LandingTargetPose_DataReader & operator = (const LandingTargetPose_DataReader &);
            };

            class  LandingTargetPose_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LandingTargetPose_DataReaderView_ptr _ptr_type;
                typedef LandingTargetPose_DataReaderView_var _var_type;

                static LandingTargetPose_DataReaderView_ptr _duplicate (LandingTargetPose_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingTargetPose_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LandingTargetPose_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingTargetPose_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingTargetPose_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LandingTargetPose_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LandingTargetPose_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LandingTargetPose_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LandingTargetPose_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingTargetPose_& instance) = 0;

            protected:
                LandingTargetPose_DataReaderView () {};
                ~LandingTargetPose_DataReaderView () {};
            private:
                LandingTargetPose_DataReaderView (const LandingTargetPose_DataReaderView &);
                LandingTargetPose_DataReaderView & operator = (const LandingTargetPose_DataReaderView &);
            };
        }

    }

}

#endif
