#ifndef _H_B7DE6CF52E251A955A0445FB77986713_ManualControlSetpoint__H_
#define _H_B7DE6CF52E251A955A0445FB77986713_ManualControlSetpoint__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ManualControlSetpoint_Constants
            {
                const ::DDS::Octet SWITCH_POS_NONE_ = 0;

                const ::DDS::Octet SWITCH_POS_ON_ = 1;

                const ::DDS::Octet SWITCH_POS_MIDDLE_ = 2;

                const ::DDS::Octet SWITCH_POS_OFF_ = 3;

                const ::DDS::Octet MODE_SLOT_NONE_ = 0;

                const ::DDS::Octet MODE_SLOT_1_ = 1;

                const ::DDS::Octet MODE_SLOT_2_ = 2;

                const ::DDS::Octet MODE_SLOT_3_ = 3;

                const ::DDS::Octet MODE_SLOT_4_ = 4;

                const ::DDS::Octet MODE_SLOT_5_ = 5;

                const ::DDS::Octet MODE_SLOT_6_ = 6;

                const ::DDS::Octet MODE_SLOT_NUM_ = 6;

                const ::DDS::Octet SOURCE_RC_ = 1;

                const ::DDS::Octet SOURCE_MAVLINK_0_ = 2;

                const ::DDS::Octet SOURCE_MAVLINK_1_ = 3;

                const ::DDS::Octet SOURCE_MAVLINK_2_ = 4;

                const ::DDS::Octet SOURCE_MAVLINK_3_ = 5;

            }

            struct  ManualControlSetpoint_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Float x_;
                ::DDS::Float y_;
                ::DDS::Float z_;
                ::DDS::Float r_;
                ::DDS::Float flaps_;
                ::DDS::Float aux1_;
                ::DDS::Float aux2_;
                ::DDS::Float aux3_;
                ::DDS::Float aux4_;
                ::DDS::Float aux5_;
                ::DDS::Float aux6_;
                ::DDS::Octet mode_switch_;
                ::DDS::Octet return_switch_;
                ::DDS::Octet rattitude_switch_;
                ::DDS::Octet posctl_switch_;
                ::DDS::Octet loiter_switch_;
                ::DDS::Octet acro_switch_;
                ::DDS::Octet offboard_switch_;
                ::DDS::Octet kill_switch_;
                ::DDS::Octet arm_switch_;
                ::DDS::Octet transition_switch_;
                ::DDS::Octet gear_switch_;
                ::DDS::Octet mode_slot_;
                ::DDS::Octet data_source_;
                ::DDS::Octet stab_switch_;
                ::DDS::Octet man_switch_;
            };

            typedef DDS_DCPSStruct_var<ManualControlSetpoint_> ManualControlSetpoint__var;
            typedef ManualControlSetpoint_& ManualControlSetpoint__out;

        }

    }

}

#endif /* _H_B7DE6CF52E251A955A0445FB77986713_ManualControlSetpoint__H_ */
