#ifndef _H_95C83623DE3A81805F34029B12026B5F_MavlinkLog_DCPS_H_
#define _H_95C83623DE3A81805F34029B12026B5F_MavlinkLog_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MavlinkLog_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MavlinkLog_TypeSupportInterface;

            typedef MavlinkLog_TypeSupportInterface * MavlinkLog_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MavlinkLog_TypeSupportInterface> MavlinkLog_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MavlinkLog_TypeSupportInterface> MavlinkLog_TypeSupportInterface_out;


            class MavlinkLog_DataWriter;

            typedef MavlinkLog_DataWriter * MavlinkLog_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MavlinkLog_DataWriter> MavlinkLog_DataWriter_var;
            typedef DDS_DCPSInterface_out < MavlinkLog_DataWriter> MavlinkLog_DataWriter_out;


            class MavlinkLog_DataReader;

            typedef MavlinkLog_DataReader * MavlinkLog_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MavlinkLog_DataReader> MavlinkLog_DataReader_var;
            typedef DDS_DCPSInterface_out < MavlinkLog_DataReader> MavlinkLog_DataReader_out;


            class MavlinkLog_DataReaderView;

            typedef MavlinkLog_DataReaderView * MavlinkLog_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MavlinkLog_DataReaderView> MavlinkLog_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MavlinkLog_DataReaderView> MavlinkLog_DataReaderView_out;

            struct MavlinkLog_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < MavlinkLog_, struct MavlinkLog_Seq_uniq_> MavlinkLog_Seq;
            typedef DDS_DCPSSequence_var < MavlinkLog_Seq> MavlinkLog_Seq_var;
            typedef DDS_DCPSSequence_out < MavlinkLog_Seq> MavlinkLog_Seq_out;

            class  MavlinkLog_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MavlinkLog_TypeSupportInterface_ptr _ptr_type;
                typedef MavlinkLog_TypeSupportInterface_var _var_type;

                static MavlinkLog_TypeSupportInterface_ptr _duplicate (MavlinkLog_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MavlinkLog_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MavlinkLog_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MavlinkLog_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MavlinkLog_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MavlinkLog_TypeSupportInterface () {};
                ~MavlinkLog_TypeSupportInterface () {};
            private:
                MavlinkLog_TypeSupportInterface (const MavlinkLog_TypeSupportInterface &);
                MavlinkLog_TypeSupportInterface & operator = (const MavlinkLog_TypeSupportInterface &);
            };

            class  MavlinkLog_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MavlinkLog_DataWriter_ptr _ptr_type;
                typedef MavlinkLog_DataWriter_var _var_type;

                static MavlinkLog_DataWriter_ptr _duplicate (MavlinkLog_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MavlinkLog_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MavlinkLog_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MavlinkLog_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MavlinkLog_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MavlinkLog_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MavlinkLog_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MavlinkLog_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MavlinkLog_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MavlinkLog_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MavlinkLog_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MavlinkLog_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MavlinkLog_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MavlinkLog_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MavlinkLog_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MavlinkLog_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MavlinkLog_& instance_data) = 0;

            protected:
                MavlinkLog_DataWriter () {};
                ~MavlinkLog_DataWriter () {};
            private:
                MavlinkLog_DataWriter (const MavlinkLog_DataWriter &);
                MavlinkLog_DataWriter & operator = (const MavlinkLog_DataWriter &);
            };

            class  MavlinkLog_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MavlinkLog_DataReader_ptr _ptr_type;
                typedef MavlinkLog_DataReader_var _var_type;

                static MavlinkLog_DataReader_ptr _duplicate (MavlinkLog_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MavlinkLog_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MavlinkLog_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MavlinkLog_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MavlinkLog_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MavlinkLog_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MavlinkLog_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MavlinkLog_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MavlinkLog_& instance) = 0;

            protected:
                MavlinkLog_DataReader () {};
                ~MavlinkLog_DataReader () {};
            private:
                MavlinkLog_DataReader (const MavlinkLog_DataReader &);
                MavlinkLog_DataReader & operator = (const MavlinkLog_DataReader &);
            };

            class  MavlinkLog_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MavlinkLog_DataReaderView_ptr _ptr_type;
                typedef MavlinkLog_DataReaderView_var _var_type;

                static MavlinkLog_DataReaderView_ptr _duplicate (MavlinkLog_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MavlinkLog_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MavlinkLog_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MavlinkLog_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MavlinkLog_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MavlinkLog_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MavlinkLog_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MavlinkLog_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MavlinkLog_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MavlinkLog_& instance) = 0;

            protected:
                MavlinkLog_DataReaderView () {};
                ~MavlinkLog_DataReaderView () {};
            private:
                MavlinkLog_DataReaderView (const MavlinkLog_DataReaderView &);
                MavlinkLog_DataReaderView & operator = (const MavlinkLog_DataReaderView &);
            };
        }

    }

}

#endif
