#ifndef _H_8F224EF25A60A1EE1E46D679FFEEB2DC_McVirtualAttitudeSetpoint_DCPS_H_
#define _H_8F224EF25A60A1EE1E46D679FFEEB2DC_McVirtualAttitudeSetpoint_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "McVirtualAttitudeSetpoint_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class McVirtualAttitudeSetpoint_TypeSupportInterface;

            typedef McVirtualAttitudeSetpoint_TypeSupportInterface * McVirtualAttitudeSetpoint_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < McVirtualAttitudeSetpoint_TypeSupportInterface> McVirtualAttitudeSetpoint_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < McVirtualAttitudeSetpoint_TypeSupportInterface> McVirtualAttitudeSetpoint_TypeSupportInterface_out;


            class McVirtualAttitudeSetpoint_DataWriter;

            typedef McVirtualAttitudeSetpoint_DataWriter * McVirtualAttitudeSetpoint_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < McVirtualAttitudeSetpoint_DataWriter> McVirtualAttitudeSetpoint_DataWriter_var;
            typedef DDS_DCPSInterface_out < McVirtualAttitudeSetpoint_DataWriter> McVirtualAttitudeSetpoint_DataWriter_out;


            class McVirtualAttitudeSetpoint_DataReader;

            typedef McVirtualAttitudeSetpoint_DataReader * McVirtualAttitudeSetpoint_DataReader_ptr;
            typedef DDS_DCPSInterface_var < McVirtualAttitudeSetpoint_DataReader> McVirtualAttitudeSetpoint_DataReader_var;
            typedef DDS_DCPSInterface_out < McVirtualAttitudeSetpoint_DataReader> McVirtualAttitudeSetpoint_DataReader_out;


            class McVirtualAttitudeSetpoint_DataReaderView;

            typedef McVirtualAttitudeSetpoint_DataReaderView * McVirtualAttitudeSetpoint_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < McVirtualAttitudeSetpoint_DataReaderView> McVirtualAttitudeSetpoint_DataReaderView_var;
            typedef DDS_DCPSInterface_out < McVirtualAttitudeSetpoint_DataReaderView> McVirtualAttitudeSetpoint_DataReaderView_out;

            struct McVirtualAttitudeSetpoint_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < McVirtualAttitudeSetpoint_, struct McVirtualAttitudeSetpoint_Seq_uniq_> McVirtualAttitudeSetpoint_Seq;
            typedef DDS_DCPSSequence_var < McVirtualAttitudeSetpoint_Seq> McVirtualAttitudeSetpoint_Seq_var;
            typedef DDS_DCPSSequence_out < McVirtualAttitudeSetpoint_Seq> McVirtualAttitudeSetpoint_Seq_out;

            class  McVirtualAttitudeSetpoint_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef McVirtualAttitudeSetpoint_TypeSupportInterface_ptr _ptr_type;
                typedef McVirtualAttitudeSetpoint_TypeSupportInterface_var _var_type;

                static McVirtualAttitudeSetpoint_TypeSupportInterface_ptr _duplicate (McVirtualAttitudeSetpoint_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static McVirtualAttitudeSetpoint_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static McVirtualAttitudeSetpoint_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static McVirtualAttitudeSetpoint_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                McVirtualAttitudeSetpoint_TypeSupportInterface_ptr _this () { return this; }


            protected:
                McVirtualAttitudeSetpoint_TypeSupportInterface () {};
                ~McVirtualAttitudeSetpoint_TypeSupportInterface () {};
            private:
                McVirtualAttitudeSetpoint_TypeSupportInterface (const McVirtualAttitudeSetpoint_TypeSupportInterface &);
                McVirtualAttitudeSetpoint_TypeSupportInterface & operator = (const McVirtualAttitudeSetpoint_TypeSupportInterface &);
            };

            class  McVirtualAttitudeSetpoint_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef McVirtualAttitudeSetpoint_DataWriter_ptr _ptr_type;
                typedef McVirtualAttitudeSetpoint_DataWriter_var _var_type;

                static McVirtualAttitudeSetpoint_DataWriter_ptr _duplicate (McVirtualAttitudeSetpoint_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static McVirtualAttitudeSetpoint_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static McVirtualAttitudeSetpoint_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static McVirtualAttitudeSetpoint_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                McVirtualAttitudeSetpoint_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const McVirtualAttitudeSetpoint_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const McVirtualAttitudeSetpoint_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const McVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const McVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const McVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const McVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const McVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const McVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const McVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const McVirtualAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (McVirtualAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const McVirtualAttitudeSetpoint_& instance_data) = 0;

            protected:
                McVirtualAttitudeSetpoint_DataWriter () {};
                ~McVirtualAttitudeSetpoint_DataWriter () {};
            private:
                McVirtualAttitudeSetpoint_DataWriter (const McVirtualAttitudeSetpoint_DataWriter &);
                McVirtualAttitudeSetpoint_DataWriter & operator = (const McVirtualAttitudeSetpoint_DataWriter &);
            };

            class  McVirtualAttitudeSetpoint_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef McVirtualAttitudeSetpoint_DataReader_ptr _ptr_type;
                typedef McVirtualAttitudeSetpoint_DataReader_var _var_type;

                static McVirtualAttitudeSetpoint_DataReader_ptr _duplicate (McVirtualAttitudeSetpoint_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static McVirtualAttitudeSetpoint_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static McVirtualAttitudeSetpoint_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static McVirtualAttitudeSetpoint_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                McVirtualAttitudeSetpoint_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (McVirtualAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (McVirtualAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (McVirtualAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const McVirtualAttitudeSetpoint_& instance) = 0;

            protected:
                McVirtualAttitudeSetpoint_DataReader () {};
                ~McVirtualAttitudeSetpoint_DataReader () {};
            private:
                McVirtualAttitudeSetpoint_DataReader (const McVirtualAttitudeSetpoint_DataReader &);
                McVirtualAttitudeSetpoint_DataReader & operator = (const McVirtualAttitudeSetpoint_DataReader &);
            };

            class  McVirtualAttitudeSetpoint_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef McVirtualAttitudeSetpoint_DataReaderView_ptr _ptr_type;
                typedef McVirtualAttitudeSetpoint_DataReaderView_var _var_type;

                static McVirtualAttitudeSetpoint_DataReaderView_ptr _duplicate (McVirtualAttitudeSetpoint_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static McVirtualAttitudeSetpoint_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static McVirtualAttitudeSetpoint_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static McVirtualAttitudeSetpoint_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                McVirtualAttitudeSetpoint_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (McVirtualAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (McVirtualAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (McVirtualAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (McVirtualAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const McVirtualAttitudeSetpoint_& instance) = 0;

            protected:
                McVirtualAttitudeSetpoint_DataReaderView () {};
                ~McVirtualAttitudeSetpoint_DataReaderView () {};
            private:
                McVirtualAttitudeSetpoint_DataReaderView (const McVirtualAttitudeSetpoint_DataReaderView &);
                McVirtualAttitudeSetpoint_DataReaderView & operator = (const McVirtualAttitudeSetpoint_DataReaderView &);
            };
        }

    }

}

#endif
