#ifndef _H_C8F0D28BF80CFF44042FF909FAE3A47F_MissionResult__H_
#define _H_C8F0D28BF80CFF44042FF909FAE3A47F_MissionResult__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace MissionResult_Constants
            {
                const ::DDS::Octet MISSION_EXECUTION_MODE_NORMAL_ = 0;

                const ::DDS::Octet MISSION_EXECUTION_MODE_REVERSE_ = 1;

                const ::DDS::Octet MISSION_EXECUTION_MODE_FAST_FORWARD_ = 2;

            }

            struct  MissionResult_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::ULong instance_count_;
                ::DDS::Long seq_reached_;
                ::DDS::UShort seq_current_;
                ::DDS::UShort seq_total_;
                ::DDS::Boolean valid_;
                ::DDS::Boolean warning_;
                ::DDS::Boolean finished_;
                ::DDS::Boolean failure_;
                ::DDS::Boolean stay_in_failsafe_;
                ::DDS::Boolean flight_termination_;
                ::DDS::Boolean item_do_jump_changed_;
                ::DDS::UShort item_changed_index_;
                ::DDS::UShort item_do_jump_remaining_;
                ::DDS::Octet execution_mode_;
            };

            typedef DDS_DCPSStruct_var<MissionResult_> MissionResult__var;
            typedef MissionResult_& MissionResult__out;

        }

    }

}

#endif /* _H_C8F0D28BF80CFF44042FF909FAE3A47F_MissionResult__H_ */
