#ifndef _H_C8F0D28BF80CFF44042FF909FAE3A47F_MissionResult_DCPS_H_
#define _H_C8F0D28BF80CFF44042FF909FAE3A47F_MissionResult_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MissionResult_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MissionResult_TypeSupportInterface;

            typedef MissionResult_TypeSupportInterface * MissionResult_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MissionResult_TypeSupportInterface> MissionResult_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MissionResult_TypeSupportInterface> MissionResult_TypeSupportInterface_out;


            class MissionResult_DataWriter;

            typedef MissionResult_DataWriter * MissionResult_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MissionResult_DataWriter> MissionResult_DataWriter_var;
            typedef DDS_DCPSInterface_out < MissionResult_DataWriter> MissionResult_DataWriter_out;


            class MissionResult_DataReader;

            typedef MissionResult_DataReader * MissionResult_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MissionResult_DataReader> MissionResult_DataReader_var;
            typedef DDS_DCPSInterface_out < MissionResult_DataReader> MissionResult_DataReader_out;


            class MissionResult_DataReaderView;

            typedef MissionResult_DataReaderView * MissionResult_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MissionResult_DataReaderView> MissionResult_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MissionResult_DataReaderView> MissionResult_DataReaderView_out;

            struct MissionResult_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < MissionResult_, struct MissionResult_Seq_uniq_> MissionResult_Seq;
            typedef DDS_DCPSSequence_var < MissionResult_Seq> MissionResult_Seq_var;
            typedef DDS_DCPSSequence_out < MissionResult_Seq> MissionResult_Seq_out;

            class  MissionResult_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MissionResult_TypeSupportInterface_ptr _ptr_type;
                typedef MissionResult_TypeSupportInterface_var _var_type;

                static MissionResult_TypeSupportInterface_ptr _duplicate (MissionResult_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MissionResult_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MissionResult_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MissionResult_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MissionResult_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MissionResult_TypeSupportInterface () {};
                ~MissionResult_TypeSupportInterface () {};
            private:
                MissionResult_TypeSupportInterface (const MissionResult_TypeSupportInterface &);
                MissionResult_TypeSupportInterface & operator = (const MissionResult_TypeSupportInterface &);
            };

            class  MissionResult_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MissionResult_DataWriter_ptr _ptr_type;
                typedef MissionResult_DataWriter_var _var_type;

                static MissionResult_DataWriter_ptr _duplicate (MissionResult_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MissionResult_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MissionResult_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MissionResult_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MissionResult_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MissionResult_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MissionResult_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MissionResult_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MissionResult_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MissionResult_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MissionResult_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MissionResult_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MissionResult_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MissionResult_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MissionResult_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MissionResult_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MissionResult_& instance_data) = 0;

            protected:
                MissionResult_DataWriter () {};
                ~MissionResult_DataWriter () {};
            private:
                MissionResult_DataWriter (const MissionResult_DataWriter &);
                MissionResult_DataWriter & operator = (const MissionResult_DataWriter &);
            };

            class  MissionResult_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MissionResult_DataReader_ptr _ptr_type;
                typedef MissionResult_DataReader_var _var_type;

                static MissionResult_DataReader_ptr _duplicate (MissionResult_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MissionResult_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MissionResult_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MissionResult_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MissionResult_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MissionResult_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MissionResult_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MissionResult_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MissionResult_& instance) = 0;

            protected:
                MissionResult_DataReader () {};
                ~MissionResult_DataReader () {};
            private:
                MissionResult_DataReader (const MissionResult_DataReader &);
                MissionResult_DataReader & operator = (const MissionResult_DataReader &);
            };

            class  MissionResult_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MissionResult_DataReaderView_ptr _ptr_type;
                typedef MissionResult_DataReaderView_var _var_type;

                static MissionResult_DataReaderView_ptr _duplicate (MissionResult_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MissionResult_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MissionResult_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MissionResult_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MissionResult_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MissionResult_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MissionResult_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MissionResult_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MissionResult_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MissionResult_& instance) = 0;

            protected:
                MissionResult_DataReaderView () {};
                ~MissionResult_DataReaderView () {};
            private:
                MissionResult_DataReaderView (const MissionResult_DataReaderView &);
                MissionResult_DataReaderView & operator = (const MissionResult_DataReaderView &);
            };
        }

    }

}

#endif
