#ifndef _H_80AC5CC88B4B88940BDD3575AA8B48ED_MountOrientation_DCPS_H_
#define _H_80AC5CC88B4B88940BDD3575AA8B48ED_MountOrientation_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MountOrientation_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MountOrientation_TypeSupportInterface;

            typedef MountOrientation_TypeSupportInterface * MountOrientation_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MountOrientation_TypeSupportInterface> MountOrientation_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MountOrientation_TypeSupportInterface> MountOrientation_TypeSupportInterface_out;


            class MountOrientation_DataWriter;

            typedef MountOrientation_DataWriter * MountOrientation_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MountOrientation_DataWriter> MountOrientation_DataWriter_var;
            typedef DDS_DCPSInterface_out < MountOrientation_DataWriter> MountOrientation_DataWriter_out;


            class MountOrientation_DataReader;

            typedef MountOrientation_DataReader * MountOrientation_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MountOrientation_DataReader> MountOrientation_DataReader_var;
            typedef DDS_DCPSInterface_out < MountOrientation_DataReader> MountOrientation_DataReader_out;


            class MountOrientation_DataReaderView;

            typedef MountOrientation_DataReaderView * MountOrientation_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MountOrientation_DataReaderView> MountOrientation_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MountOrientation_DataReaderView> MountOrientation_DataReaderView_out;

            struct MountOrientation_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < MountOrientation_, struct MountOrientation_Seq_uniq_> MountOrientation_Seq;
            typedef DDS_DCPSSequence_var < MountOrientation_Seq> MountOrientation_Seq_var;
            typedef DDS_DCPSSequence_out < MountOrientation_Seq> MountOrientation_Seq_out;

            class  MountOrientation_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MountOrientation_TypeSupportInterface_ptr _ptr_type;
                typedef MountOrientation_TypeSupportInterface_var _var_type;

                static MountOrientation_TypeSupportInterface_ptr _duplicate (MountOrientation_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MountOrientation_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MountOrientation_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MountOrientation_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MountOrientation_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MountOrientation_TypeSupportInterface () {};
                ~MountOrientation_TypeSupportInterface () {};
            private:
                MountOrientation_TypeSupportInterface (const MountOrientation_TypeSupportInterface &);
                MountOrientation_TypeSupportInterface & operator = (const MountOrientation_TypeSupportInterface &);
            };

            class  MountOrientation_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MountOrientation_DataWriter_ptr _ptr_type;
                typedef MountOrientation_DataWriter_var _var_type;

                static MountOrientation_DataWriter_ptr _duplicate (MountOrientation_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MountOrientation_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MountOrientation_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MountOrientation_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MountOrientation_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MountOrientation_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MountOrientation_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MountOrientation_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MountOrientation_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MountOrientation_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MountOrientation_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MountOrientation_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MountOrientation_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MountOrientation_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MountOrientation_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MountOrientation_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MountOrientation_& instance_data) = 0;

            protected:
                MountOrientation_DataWriter () {};
                ~MountOrientation_DataWriter () {};
            private:
                MountOrientation_DataWriter (const MountOrientation_DataWriter &);
                MountOrientation_DataWriter & operator = (const MountOrientation_DataWriter &);
            };

            class  MountOrientation_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MountOrientation_DataReader_ptr _ptr_type;
                typedef MountOrientation_DataReader_var _var_type;

                static MountOrientation_DataReader_ptr _duplicate (MountOrientation_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MountOrientation_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MountOrientation_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MountOrientation_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MountOrientation_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MountOrientation_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MountOrientation_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MountOrientation_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MountOrientation_& instance) = 0;

            protected:
                MountOrientation_DataReader () {};
                ~MountOrientation_DataReader () {};
            private:
                MountOrientation_DataReader (const MountOrientation_DataReader &);
                MountOrientation_DataReader & operator = (const MountOrientation_DataReader &);
            };

            class  MountOrientation_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MountOrientation_DataReaderView_ptr _ptr_type;
                typedef MountOrientation_DataReaderView_var _var_type;

                static MountOrientation_DataReaderView_ptr _duplicate (MountOrientation_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MountOrientation_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MountOrientation_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MountOrientation_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MountOrientation_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MountOrientation_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MountOrientation_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MountOrientation_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MountOrientation_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MountOrientation_& instance) = 0;

            protected:
                MountOrientation_DataReaderView () {};
                ~MountOrientation_DataReaderView () {};
            private:
                MountOrientation_DataReaderView (const MountOrientation_DataReaderView &);
                MountOrientation_DataReaderView & operator = (const MountOrientation_DataReaderView &);
            };
        }

    }

}

#endif
