#ifndef _H_12DA4C7DC17C020399DDE038C5FEB9B8_MultirotorMotorLimits_DCPS_H_
#define _H_12DA4C7DC17C020399DDE038C5FEB9B8_MultirotorMotorLimits_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MultirotorMotorLimits_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MultirotorMotorLimits_TypeSupportInterface;

            typedef MultirotorMotorLimits_TypeSupportInterface * MultirotorMotorLimits_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MultirotorMotorLimits_TypeSupportInterface> MultirotorMotorLimits_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MultirotorMotorLimits_TypeSupportInterface> MultirotorMotorLimits_TypeSupportInterface_out;


            class MultirotorMotorLimits_DataWriter;

            typedef MultirotorMotorLimits_DataWriter * MultirotorMotorLimits_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MultirotorMotorLimits_DataWriter> MultirotorMotorLimits_DataWriter_var;
            typedef DDS_DCPSInterface_out < MultirotorMotorLimits_DataWriter> MultirotorMotorLimits_DataWriter_out;


            class MultirotorMotorLimits_DataReader;

            typedef MultirotorMotorLimits_DataReader * MultirotorMotorLimits_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MultirotorMotorLimits_DataReader> MultirotorMotorLimits_DataReader_var;
            typedef DDS_DCPSInterface_out < MultirotorMotorLimits_DataReader> MultirotorMotorLimits_DataReader_out;


            class MultirotorMotorLimits_DataReaderView;

            typedef MultirotorMotorLimits_DataReaderView * MultirotorMotorLimits_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MultirotorMotorLimits_DataReaderView> MultirotorMotorLimits_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MultirotorMotorLimits_DataReaderView> MultirotorMotorLimits_DataReaderView_out;

            struct MultirotorMotorLimits_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < MultirotorMotorLimits_, struct MultirotorMotorLimits_Seq_uniq_> MultirotorMotorLimits_Seq;
            typedef DDS_DCPSSequence_var < MultirotorMotorLimits_Seq> MultirotorMotorLimits_Seq_var;
            typedef DDS_DCPSSequence_out < MultirotorMotorLimits_Seq> MultirotorMotorLimits_Seq_out;

            class  MultirotorMotorLimits_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MultirotorMotorLimits_TypeSupportInterface_ptr _ptr_type;
                typedef MultirotorMotorLimits_TypeSupportInterface_var _var_type;

                static MultirotorMotorLimits_TypeSupportInterface_ptr _duplicate (MultirotorMotorLimits_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MultirotorMotorLimits_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MultirotorMotorLimits_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MultirotorMotorLimits_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MultirotorMotorLimits_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MultirotorMotorLimits_TypeSupportInterface () {};
                ~MultirotorMotorLimits_TypeSupportInterface () {};
            private:
                MultirotorMotorLimits_TypeSupportInterface (const MultirotorMotorLimits_TypeSupportInterface &);
                MultirotorMotorLimits_TypeSupportInterface & operator = (const MultirotorMotorLimits_TypeSupportInterface &);
            };

            class  MultirotorMotorLimits_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MultirotorMotorLimits_DataWriter_ptr _ptr_type;
                typedef MultirotorMotorLimits_DataWriter_var _var_type;

                static MultirotorMotorLimits_DataWriter_ptr _duplicate (MultirotorMotorLimits_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MultirotorMotorLimits_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MultirotorMotorLimits_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MultirotorMotorLimits_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MultirotorMotorLimits_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MultirotorMotorLimits_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MultirotorMotorLimits_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MultirotorMotorLimits_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MultirotorMotorLimits_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MultirotorMotorLimits_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MultirotorMotorLimits_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MultirotorMotorLimits_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MultirotorMotorLimits_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MultirotorMotorLimits_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MultirotorMotorLimits_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MultirotorMotorLimits_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MultirotorMotorLimits_& instance_data) = 0;

            protected:
                MultirotorMotorLimits_DataWriter () {};
                ~MultirotorMotorLimits_DataWriter () {};
            private:
                MultirotorMotorLimits_DataWriter (const MultirotorMotorLimits_DataWriter &);
                MultirotorMotorLimits_DataWriter & operator = (const MultirotorMotorLimits_DataWriter &);
            };

            class  MultirotorMotorLimits_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MultirotorMotorLimits_DataReader_ptr _ptr_type;
                typedef MultirotorMotorLimits_DataReader_var _var_type;

                static MultirotorMotorLimits_DataReader_ptr _duplicate (MultirotorMotorLimits_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MultirotorMotorLimits_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MultirotorMotorLimits_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MultirotorMotorLimits_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MultirotorMotorLimits_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MultirotorMotorLimits_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MultirotorMotorLimits_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MultirotorMotorLimits_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MultirotorMotorLimits_& instance) = 0;

            protected:
                MultirotorMotorLimits_DataReader () {};
                ~MultirotorMotorLimits_DataReader () {};
            private:
                MultirotorMotorLimits_DataReader (const MultirotorMotorLimits_DataReader &);
                MultirotorMotorLimits_DataReader & operator = (const MultirotorMotorLimits_DataReader &);
            };

            class  MultirotorMotorLimits_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MultirotorMotorLimits_DataReaderView_ptr _ptr_type;
                typedef MultirotorMotorLimits_DataReaderView_var _var_type;

                static MultirotorMotorLimits_DataReaderView_ptr _duplicate (MultirotorMotorLimits_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MultirotorMotorLimits_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MultirotorMotorLimits_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MultirotorMotorLimits_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MultirotorMotorLimits_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MultirotorMotorLimits_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MultirotorMotorLimits_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MultirotorMotorLimits_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MultirotorMotorLimits_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MultirotorMotorLimits_& instance) = 0;

            protected:
                MultirotorMotorLimits_DataReaderView () {};
                ~MultirotorMotorLimits_DataReaderView () {};
            private:
                MultirotorMotorLimits_DataReaderView (const MultirotorMotorLimits_DataReaderView &);
                MultirotorMotorLimits_DataReaderView & operator = (const MultirotorMotorLimits_DataReaderView &);
            };
        }

    }

}

#endif
