#ifndef _H_CA95F2F26E18E43733CABE3621E851EC_ObstacleDistance_DCPS_H_
#define _H_CA95F2F26E18E43733CABE3621E851EC_ObstacleDistance_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObstacleDistance_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObstacleDistance_TypeSupportInterface;

            typedef ObstacleDistance_TypeSupportInterface * ObstacleDistance_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObstacleDistance_TypeSupportInterface> ObstacleDistance_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObstacleDistance_TypeSupportInterface> ObstacleDistance_TypeSupportInterface_out;


            class ObstacleDistance_DataWriter;

            typedef ObstacleDistance_DataWriter * ObstacleDistance_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObstacleDistance_DataWriter> ObstacleDistance_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObstacleDistance_DataWriter> ObstacleDistance_DataWriter_out;


            class ObstacleDistance_DataReader;

            typedef ObstacleDistance_DataReader * ObstacleDistance_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObstacleDistance_DataReader> ObstacleDistance_DataReader_var;
            typedef DDS_DCPSInterface_out < ObstacleDistance_DataReader> ObstacleDistance_DataReader_out;


            class ObstacleDistance_DataReaderView;

            typedef ObstacleDistance_DataReaderView * ObstacleDistance_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObstacleDistance_DataReaderView> ObstacleDistance_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObstacleDistance_DataReaderView> ObstacleDistance_DataReaderView_out;

            struct ObstacleDistance_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ObstacleDistance_, struct ObstacleDistance_Seq_uniq_> ObstacleDistance_Seq;
            typedef DDS_DCPSSequence_var < ObstacleDistance_Seq> ObstacleDistance_Seq_var;
            typedef DDS_DCPSSequence_out < ObstacleDistance_Seq> ObstacleDistance_Seq_out;

            class  ObstacleDistance_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObstacleDistance_TypeSupportInterface_ptr _ptr_type;
                typedef ObstacleDistance_TypeSupportInterface_var _var_type;

                static ObstacleDistance_TypeSupportInterface_ptr _duplicate (ObstacleDistance_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleDistance_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleDistance_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleDistance_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleDistance_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObstacleDistance_TypeSupportInterface () {};
                ~ObstacleDistance_TypeSupportInterface () {};
            private:
                ObstacleDistance_TypeSupportInterface (const ObstacleDistance_TypeSupportInterface &);
                ObstacleDistance_TypeSupportInterface & operator = (const ObstacleDistance_TypeSupportInterface &);
            };

            class  ObstacleDistance_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObstacleDistance_DataWriter_ptr _ptr_type;
                typedef ObstacleDistance_DataWriter_var _var_type;

                static ObstacleDistance_DataWriter_ptr _duplicate (ObstacleDistance_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleDistance_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleDistance_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleDistance_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleDistance_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObstacleDistance_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObstacleDistance_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObstacleDistance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObstacleDistance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObstacleDistance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObstacleDistance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObstacleDistance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObstacleDistance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObstacleDistance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObstacleDistance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObstacleDistance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleDistance_& instance_data) = 0;

            protected:
                ObstacleDistance_DataWriter () {};
                ~ObstacleDistance_DataWriter () {};
            private:
                ObstacleDistance_DataWriter (const ObstacleDistance_DataWriter &);
                ObstacleDistance_DataWriter & operator = (const ObstacleDistance_DataWriter &);
            };

            class  ObstacleDistance_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObstacleDistance_DataReader_ptr _ptr_type;
                typedef ObstacleDistance_DataReader_var _var_type;

                static ObstacleDistance_DataReader_ptr _duplicate (ObstacleDistance_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleDistance_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleDistance_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleDistance_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleDistance_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleDistance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleDistance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleDistance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleDistance_& instance) = 0;

            protected:
                ObstacleDistance_DataReader () {};
                ~ObstacleDistance_DataReader () {};
            private:
                ObstacleDistance_DataReader (const ObstacleDistance_DataReader &);
                ObstacleDistance_DataReader & operator = (const ObstacleDistance_DataReader &);
            };

            class  ObstacleDistance_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObstacleDistance_DataReaderView_ptr _ptr_type;
                typedef ObstacleDistance_DataReaderView_var _var_type;

                static ObstacleDistance_DataReaderView_ptr _duplicate (ObstacleDistance_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleDistance_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleDistance_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleDistance_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleDistance_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleDistance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleDistance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleDistance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleDistance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleDistance_& instance) = 0;

            protected:
                ObstacleDistance_DataReaderView () {};
                ~ObstacleDistance_DataReaderView () {};
            private:
                ObstacleDistance_DataReaderView (const ObstacleDistance_DataReaderView &);
                ObstacleDistance_DataReaderView & operator = (const ObstacleDistance_DataReaderView &);
            };
        }

    }

}

#endif
