#ifndef _H_D688FD539B09B4626C8E2EA786097FAB_OnboardComputerStatus__H_
#define _H_D688FD539B09B4626C8E2EA786097FAB_OnboardComputerStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  OnboardComputerStatus_
            {
                struct _cpu_cores__uniq_{};
                typedef ::DDS::Octet _cpu_cores__slice;
                typedef ::DDS::Octet _cpu_cores_[8];
                typedef DDS_DCPS_FArray_var< _cpu_cores_, _cpu_cores__slice, struct _cpu_cores__uniq_ > _cpu_cores__var;
                typedef _cpu_cores_ _cpu_cores__out;
                typedef DDS_DCPS_Array_forany< _cpu_cores_, _cpu_cores__slice, struct _cpu_cores__uniq_ > _cpu_cores__forany;
                static _cpu_cores__slice *_cpu_cores__alloc();
                static void _cpu_cores__free(_cpu_cores__slice *);
                static void _cpu_cores__copy(_cpu_cores__slice *to, const _cpu_cores__slice *from);
                static _cpu_cores__slice *_cpu_cores__dup(const _cpu_cores__slice *from);
                struct _cpu_combined__uniq_{};
                typedef ::DDS::Octet _cpu_combined__slice;
                typedef ::DDS::Octet _cpu_combined_[10];
                typedef DDS_DCPS_FArray_var< _cpu_combined_, _cpu_combined__slice, struct _cpu_combined__uniq_ > _cpu_combined__var;
                typedef _cpu_combined_ _cpu_combined__out;
                typedef DDS_DCPS_Array_forany< _cpu_combined_, _cpu_combined__slice, struct _cpu_combined__uniq_ > _cpu_combined__forany;
                static _cpu_combined__slice *_cpu_combined__alloc();
                static void _cpu_combined__free(_cpu_combined__slice *);
                static void _cpu_combined__copy(_cpu_combined__slice *to, const _cpu_combined__slice *from);
                static _cpu_combined__slice *_cpu_combined__dup(const _cpu_combined__slice *from);
                struct _gpu_cores__uniq_{};
                typedef ::DDS::Octet _gpu_cores__slice;
                typedef ::DDS::Octet _gpu_cores_[4];
                typedef DDS_DCPS_FArray_var< _gpu_cores_, _gpu_cores__slice, struct _gpu_cores__uniq_ > _gpu_cores__var;
                typedef _gpu_cores_ _gpu_cores__out;
                typedef DDS_DCPS_Array_forany< _gpu_cores_, _gpu_cores__slice, struct _gpu_cores__uniq_ > _gpu_cores__forany;
                static _gpu_cores__slice *_gpu_cores__alloc();
                static void _gpu_cores__free(_gpu_cores__slice *);
                static void _gpu_cores__copy(_gpu_cores__slice *to, const _gpu_cores__slice *from);
                static _gpu_cores__slice *_gpu_cores__dup(const _gpu_cores__slice *from);
                struct _gpu_combined__uniq_{};
                typedef ::DDS::Octet _gpu_combined__slice;
                typedef ::DDS::Octet _gpu_combined_[10];
                typedef DDS_DCPS_FArray_var< _gpu_combined_, _gpu_combined__slice, struct _gpu_combined__uniq_ > _gpu_combined__var;
                typedef _gpu_combined_ _gpu_combined__out;
                typedef DDS_DCPS_Array_forany< _gpu_combined_, _gpu_combined__slice, struct _gpu_combined__uniq_ > _gpu_combined__forany;
                static _gpu_combined__slice *_gpu_combined__alloc();
                static void _gpu_combined__free(_gpu_combined__slice *);
                static void _gpu_combined__copy(_gpu_combined__slice *to, const _gpu_combined__slice *from);
                static _gpu_combined__slice *_gpu_combined__dup(const _gpu_combined__slice *from);
                struct _temperature_core__uniq_{};
                typedef ::DDS::Octet _temperature_core__slice;
                typedef ::DDS::Octet _temperature_core_[8];
                typedef DDS_DCPS_FArray_var< _temperature_core_, _temperature_core__slice, struct _temperature_core__uniq_ > _temperature_core__var;
                typedef _temperature_core_ _temperature_core__out;
                typedef DDS_DCPS_Array_forany< _temperature_core_, _temperature_core__slice, struct _temperature_core__uniq_ > _temperature_core__forany;
                static _temperature_core__slice *_temperature_core__alloc();
                static void _temperature_core__free(_temperature_core__slice *);
                static void _temperature_core__copy(_temperature_core__slice *to, const _temperature_core__slice *from);
                static _temperature_core__slice *_temperature_core__dup(const _temperature_core__slice *from);
                struct _fan_speed__uniq_{};
                typedef ::DDS::Short _fan_speed__slice;
                typedef ::DDS::Short _fan_speed_[4];
                typedef DDS_DCPS_FArray_var< _fan_speed_, _fan_speed__slice, struct _fan_speed__uniq_ > _fan_speed__var;
                typedef _fan_speed_ _fan_speed__out;
                typedef DDS_DCPS_Array_forany< _fan_speed_, _fan_speed__slice, struct _fan_speed__uniq_ > _fan_speed__forany;
                static _fan_speed__slice *_fan_speed__alloc();
                static void _fan_speed__free(_fan_speed__slice *);
                static void _fan_speed__copy(_fan_speed__slice *to, const _fan_speed__slice *from);
                static _fan_speed__slice *_fan_speed__dup(const _fan_speed__slice *from);
                struct _storage_type__uniq_{};
                typedef ::DDS::ULong _storage_type__slice;
                typedef ::DDS::ULong _storage_type_[4];
                typedef DDS_DCPS_FArray_var< _storage_type_, _storage_type__slice, struct _storage_type__uniq_ > _storage_type__var;
                typedef _storage_type_ _storage_type__out;
                typedef DDS_DCPS_Array_forany< _storage_type_, _storage_type__slice, struct _storage_type__uniq_ > _storage_type__forany;
                static _storage_type__slice *_storage_type__alloc();
                static void _storage_type__free(_storage_type__slice *);
                static void _storage_type__copy(_storage_type__slice *to, const _storage_type__slice *from);
                static _storage_type__slice *_storage_type__dup(const _storage_type__slice *from);
                struct _storage_usage__uniq_{};
                typedef ::DDS::ULong _storage_usage__slice;
                typedef ::DDS::ULong _storage_usage_[4];
                typedef DDS_DCPS_FArray_var< _storage_usage_, _storage_usage__slice, struct _storage_usage__uniq_ > _storage_usage__var;
                typedef _storage_usage_ _storage_usage__out;
                typedef DDS_DCPS_Array_forany< _storage_usage_, _storage_usage__slice, struct _storage_usage__uniq_ > _storage_usage__forany;
                static _storage_usage__slice *_storage_usage__alloc();
                static void _storage_usage__free(_storage_usage__slice *);
                static void _storage_usage__copy(_storage_usage__slice *to, const _storage_usage__slice *from);
                static _storage_usage__slice *_storage_usage__dup(const _storage_usage__slice *from);
                struct _storage_total__uniq_{};
                typedef ::DDS::ULong _storage_total__slice;
                typedef ::DDS::ULong _storage_total_[4];
                typedef DDS_DCPS_FArray_var< _storage_total_, _storage_total__slice, struct _storage_total__uniq_ > _storage_total__var;
                typedef _storage_total_ _storage_total__out;
                typedef DDS_DCPS_Array_forany< _storage_total_, _storage_total__slice, struct _storage_total__uniq_ > _storage_total__forany;
                static _storage_total__slice *_storage_total__alloc();
                static void _storage_total__free(_storage_total__slice *);
                static void _storage_total__copy(_storage_total__slice *to, const _storage_total__slice *from);
                static _storage_total__slice *_storage_total__dup(const _storage_total__slice *from);
                struct _link_type__uniq_{};
                typedef ::DDS::ULong _link_type__slice;
                typedef ::DDS::ULong _link_type_[6];
                typedef DDS_DCPS_FArray_var< _link_type_, _link_type__slice, struct _link_type__uniq_ > _link_type__var;
                typedef _link_type_ _link_type__out;
                typedef DDS_DCPS_Array_forany< _link_type_, _link_type__slice, struct _link_type__uniq_ > _link_type__forany;
                static _link_type__slice *_link_type__alloc();
                static void _link_type__free(_link_type__slice *);
                static void _link_type__copy(_link_type__slice *to, const _link_type__slice *from);
                static _link_type__slice *_link_type__dup(const _link_type__slice *from);
                struct _link_tx_rate__uniq_{};
                typedef ::DDS::ULong _link_tx_rate__slice;
                typedef ::DDS::ULong _link_tx_rate_[6];
                typedef DDS_DCPS_FArray_var< _link_tx_rate_, _link_tx_rate__slice, struct _link_tx_rate__uniq_ > _link_tx_rate__var;
                typedef _link_tx_rate_ _link_tx_rate__out;
                typedef DDS_DCPS_Array_forany< _link_tx_rate_, _link_tx_rate__slice, struct _link_tx_rate__uniq_ > _link_tx_rate__forany;
                static _link_tx_rate__slice *_link_tx_rate__alloc();
                static void _link_tx_rate__free(_link_tx_rate__slice *);
                static void _link_tx_rate__copy(_link_tx_rate__slice *to, const _link_tx_rate__slice *from);
                static _link_tx_rate__slice *_link_tx_rate__dup(const _link_tx_rate__slice *from);
                struct _link_rx_rate__uniq_{};
                typedef ::DDS::ULong _link_rx_rate__slice;
                typedef ::DDS::ULong _link_rx_rate_[6];
                typedef DDS_DCPS_FArray_var< _link_rx_rate_, _link_rx_rate__slice, struct _link_rx_rate__uniq_ > _link_rx_rate__var;
                typedef _link_rx_rate_ _link_rx_rate__out;
                typedef DDS_DCPS_Array_forany< _link_rx_rate_, _link_rx_rate__slice, struct _link_rx_rate__uniq_ > _link_rx_rate__forany;
                static _link_rx_rate__slice *_link_rx_rate__alloc();
                static void _link_rx_rate__free(_link_rx_rate__slice *);
                static void _link_rx_rate__copy(_link_rx_rate__slice *to, const _link_rx_rate__slice *from);
                static _link_rx_rate__slice *_link_rx_rate__dup(const _link_rx_rate__slice *from);
                struct _link_tx_max__uniq_{};
                typedef ::DDS::ULong _link_tx_max__slice;
                typedef ::DDS::ULong _link_tx_max_[6];
                typedef DDS_DCPS_FArray_var< _link_tx_max_, _link_tx_max__slice, struct _link_tx_max__uniq_ > _link_tx_max__var;
                typedef _link_tx_max_ _link_tx_max__out;
                typedef DDS_DCPS_Array_forany< _link_tx_max_, _link_tx_max__slice, struct _link_tx_max__uniq_ > _link_tx_max__forany;
                static _link_tx_max__slice *_link_tx_max__alloc();
                static void _link_tx_max__free(_link_tx_max__slice *);
                static void _link_tx_max__copy(_link_tx_max__slice *to, const _link_tx_max__slice *from);
                static _link_tx_max__slice *_link_tx_max__dup(const _link_tx_max__slice *from);
                struct _link_rx_max__uniq_{};
                typedef ::DDS::ULong _link_rx_max__slice;
                typedef ::DDS::ULong _link_rx_max_[6];
                typedef DDS_DCPS_FArray_var< _link_rx_max_, _link_rx_max__slice, struct _link_rx_max__uniq_ > _link_rx_max__var;
                typedef _link_rx_max_ _link_rx_max__out;
                typedef DDS_DCPS_Array_forany< _link_rx_max_, _link_rx_max__slice, struct _link_rx_max__uniq_ > _link_rx_max__forany;
                static _link_rx_max__slice *_link_rx_max__alloc();
                static void _link_rx_max__free(_link_rx_max__slice *);
                static void _link_rx_max__copy(_link_rx_max__slice *to, const _link_rx_max__slice *from);
                static _link_rx_max__slice *_link_rx_max__dup(const _link_rx_max__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::ULong uptime_;
                ::DDS::Octet type_;
                _cpu_cores_ cpu_cores_;
                _cpu_combined_ cpu_combined_;
                _gpu_cores_ gpu_cores_;
                _gpu_combined_ gpu_combined_;
                ::DDS::Octet temperature_board_;
                _temperature_core_ temperature_core_;
                _fan_speed_ fan_speed_;
                ::DDS::ULong ram_usage_;
                ::DDS::ULong ram_total_;
                _storage_type_ storage_type_;
                _storage_usage_ storage_usage_;
                _storage_total_ storage_total_;
                _link_type_ link_type_;
                _link_tx_rate_ link_tx_rate_;
                _link_rx_rate_ link_rx_rate_;
                _link_tx_max_ link_tx_max_;
                _link_rx_max_ link_rx_max_;
            };

            typedef DDS_DCPSStruct_var<OnboardComputerStatus_> OnboardComputerStatus__var;
            typedef OnboardComputerStatus_& OnboardComputerStatus__out;

        }

    }

}

#endif /* _H_D688FD539B09B4626C8E2EA786097FAB_OnboardComputerStatus__H_ */
