#ifndef _H_0A3AE56086736EE95BFE1CA48B410F53_OrbitStatus_DCPS_H_
#define _H_0A3AE56086736EE95BFE1CA48B410F53_OrbitStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "OrbitStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class OrbitStatus_TypeSupportInterface;

            typedef OrbitStatus_TypeSupportInterface * OrbitStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OrbitStatus_TypeSupportInterface> OrbitStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OrbitStatus_TypeSupportInterface> OrbitStatus_TypeSupportInterface_out;


            class OrbitStatus_DataWriter;

            typedef OrbitStatus_DataWriter * OrbitStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OrbitStatus_DataWriter> OrbitStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < OrbitStatus_DataWriter> OrbitStatus_DataWriter_out;


            class OrbitStatus_DataReader;

            typedef OrbitStatus_DataReader * OrbitStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OrbitStatus_DataReader> OrbitStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < OrbitStatus_DataReader> OrbitStatus_DataReader_out;


            class OrbitStatus_DataReaderView;

            typedef OrbitStatus_DataReaderView * OrbitStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OrbitStatus_DataReaderView> OrbitStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OrbitStatus_DataReaderView> OrbitStatus_DataReaderView_out;

            struct OrbitStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < OrbitStatus_, struct OrbitStatus_Seq_uniq_> OrbitStatus_Seq;
            typedef DDS_DCPSSequence_var < OrbitStatus_Seq> OrbitStatus_Seq_var;
            typedef DDS_DCPSSequence_out < OrbitStatus_Seq> OrbitStatus_Seq_out;

            class  OrbitStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OrbitStatus_TypeSupportInterface_ptr _ptr_type;
                typedef OrbitStatus_TypeSupportInterface_var _var_type;

                static OrbitStatus_TypeSupportInterface_ptr _duplicate (OrbitStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OrbitStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OrbitStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OrbitStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OrbitStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OrbitStatus_TypeSupportInterface () {};
                ~OrbitStatus_TypeSupportInterface () {};
            private:
                OrbitStatus_TypeSupportInterface (const OrbitStatus_TypeSupportInterface &);
                OrbitStatus_TypeSupportInterface & operator = (const OrbitStatus_TypeSupportInterface &);
            };

            class  OrbitStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OrbitStatus_DataWriter_ptr _ptr_type;
                typedef OrbitStatus_DataWriter_var _var_type;

                static OrbitStatus_DataWriter_ptr _duplicate (OrbitStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OrbitStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OrbitStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OrbitStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OrbitStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OrbitStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OrbitStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OrbitStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OrbitStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OrbitStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OrbitStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OrbitStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OrbitStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OrbitStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OrbitStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OrbitStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OrbitStatus_& instance_data) = 0;

            protected:
                OrbitStatus_DataWriter () {};
                ~OrbitStatus_DataWriter () {};
            private:
                OrbitStatus_DataWriter (const OrbitStatus_DataWriter &);
                OrbitStatus_DataWriter & operator = (const OrbitStatus_DataWriter &);
            };

            class  OrbitStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OrbitStatus_DataReader_ptr _ptr_type;
                typedef OrbitStatus_DataReader_var _var_type;

                static OrbitStatus_DataReader_ptr _duplicate (OrbitStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OrbitStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OrbitStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OrbitStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OrbitStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OrbitStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OrbitStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OrbitStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OrbitStatus_& instance) = 0;

            protected:
                OrbitStatus_DataReader () {};
                ~OrbitStatus_DataReader () {};
            private:
                OrbitStatus_DataReader (const OrbitStatus_DataReader &);
                OrbitStatus_DataReader & operator = (const OrbitStatus_DataReader &);
            };

            class  OrbitStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OrbitStatus_DataReaderView_ptr _ptr_type;
                typedef OrbitStatus_DataReaderView_var _var_type;

                static OrbitStatus_DataReaderView_ptr _duplicate (OrbitStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OrbitStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OrbitStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OrbitStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OrbitStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OrbitStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OrbitStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OrbitStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OrbitStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OrbitStatus_& instance) = 0;

            protected:
                OrbitStatus_DataReaderView () {};
                ~OrbitStatus_DataReaderView () {};
            private:
                OrbitStatus_DataReaderView (const OrbitStatus_DataReaderView &);
                OrbitStatus_DataReaderView & operator = (const OrbitStatus_DataReaderView &);
            };
        }

    }

}

#endif
