#ifndef _H_CFED8611E6B5395D44BE4965B8E98EC3_PositionControllerLandingStatus_DCPS_H_
#define _H_CFED8611E6B5395D44BE4965B8E98EC3_PositionControllerLandingStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionControllerLandingStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionControllerLandingStatus_TypeSupportInterface;

            typedef PositionControllerLandingStatus_TypeSupportInterface * PositionControllerLandingStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionControllerLandingStatus_TypeSupportInterface> PositionControllerLandingStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionControllerLandingStatus_TypeSupportInterface> PositionControllerLandingStatus_TypeSupportInterface_out;


            class PositionControllerLandingStatus_DataWriter;

            typedef PositionControllerLandingStatus_DataWriter * PositionControllerLandingStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionControllerLandingStatus_DataWriter> PositionControllerLandingStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionControllerLandingStatus_DataWriter> PositionControllerLandingStatus_DataWriter_out;


            class PositionControllerLandingStatus_DataReader;

            typedef PositionControllerLandingStatus_DataReader * PositionControllerLandingStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionControllerLandingStatus_DataReader> PositionControllerLandingStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionControllerLandingStatus_DataReader> PositionControllerLandingStatus_DataReader_out;


            class PositionControllerLandingStatus_DataReaderView;

            typedef PositionControllerLandingStatus_DataReaderView * PositionControllerLandingStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionControllerLandingStatus_DataReaderView> PositionControllerLandingStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionControllerLandingStatus_DataReaderView> PositionControllerLandingStatus_DataReaderView_out;

            struct PositionControllerLandingStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PositionControllerLandingStatus_, struct PositionControllerLandingStatus_Seq_uniq_> PositionControllerLandingStatus_Seq;
            typedef DDS_DCPSSequence_var < PositionControllerLandingStatus_Seq> PositionControllerLandingStatus_Seq_var;
            typedef DDS_DCPSSequence_out < PositionControllerLandingStatus_Seq> PositionControllerLandingStatus_Seq_out;

            class  PositionControllerLandingStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionControllerLandingStatus_TypeSupportInterface_ptr _ptr_type;
                typedef PositionControllerLandingStatus_TypeSupportInterface_var _var_type;

                static PositionControllerLandingStatus_TypeSupportInterface_ptr _duplicate (PositionControllerLandingStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionControllerLandingStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionControllerLandingStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionControllerLandingStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionControllerLandingStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionControllerLandingStatus_TypeSupportInterface () {};
                ~PositionControllerLandingStatus_TypeSupportInterface () {};
            private:
                PositionControllerLandingStatus_TypeSupportInterface (const PositionControllerLandingStatus_TypeSupportInterface &);
                PositionControllerLandingStatus_TypeSupportInterface & operator = (const PositionControllerLandingStatus_TypeSupportInterface &);
            };

            class  PositionControllerLandingStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionControllerLandingStatus_DataWriter_ptr _ptr_type;
                typedef PositionControllerLandingStatus_DataWriter_var _var_type;

                static PositionControllerLandingStatus_DataWriter_ptr _duplicate (PositionControllerLandingStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionControllerLandingStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionControllerLandingStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionControllerLandingStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionControllerLandingStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionControllerLandingStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionControllerLandingStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionControllerLandingStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionControllerLandingStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionControllerLandingStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionControllerLandingStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionControllerLandingStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionControllerLandingStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionControllerLandingStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionControllerLandingStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionControllerLandingStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionControllerLandingStatus_& instance_data) = 0;

            protected:
                PositionControllerLandingStatus_DataWriter () {};
                ~PositionControllerLandingStatus_DataWriter () {};
            private:
                PositionControllerLandingStatus_DataWriter (const PositionControllerLandingStatus_DataWriter &);
                PositionControllerLandingStatus_DataWriter & operator = (const PositionControllerLandingStatus_DataWriter &);
            };

            class  PositionControllerLandingStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionControllerLandingStatus_DataReader_ptr _ptr_type;
                typedef PositionControllerLandingStatus_DataReader_var _var_type;

                static PositionControllerLandingStatus_DataReader_ptr _duplicate (PositionControllerLandingStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionControllerLandingStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionControllerLandingStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionControllerLandingStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionControllerLandingStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionControllerLandingStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionControllerLandingStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionControllerLandingStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionControllerLandingStatus_& instance) = 0;

            protected:
                PositionControllerLandingStatus_DataReader () {};
                ~PositionControllerLandingStatus_DataReader () {};
            private:
                PositionControllerLandingStatus_DataReader (const PositionControllerLandingStatus_DataReader &);
                PositionControllerLandingStatus_DataReader & operator = (const PositionControllerLandingStatus_DataReader &);
            };

            class  PositionControllerLandingStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionControllerLandingStatus_DataReaderView_ptr _ptr_type;
                typedef PositionControllerLandingStatus_DataReaderView_var _var_type;

                static PositionControllerLandingStatus_DataReaderView_ptr _duplicate (PositionControllerLandingStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionControllerLandingStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionControllerLandingStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionControllerLandingStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionControllerLandingStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionControllerLandingStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionControllerLandingStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionControllerLandingStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionControllerLandingStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionControllerLandingStatus_& instance) = 0;

            protected:
                PositionControllerLandingStatus_DataReaderView () {};
                ~PositionControllerLandingStatus_DataReaderView () {};
            private:
                PositionControllerLandingStatus_DataReaderView (const PositionControllerLandingStatus_DataReaderView &);
                PositionControllerLandingStatus_DataReaderView & operator = (const PositionControllerLandingStatus_DataReaderView &);
            };
        }

    }

}

#endif
