#ifndef _H_18953F1F51A2D931FCD305A8D6038F98_PositionSetpoint_DCPS_H_
#define _H_18953F1F51A2D931FCD305A8D6038F98_PositionSetpoint_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionSetpoint_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionSetpoint_TypeSupportInterface;

            typedef PositionSetpoint_TypeSupportInterface * PositionSetpoint_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionSetpoint_TypeSupportInterface> PositionSetpoint_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionSetpoint_TypeSupportInterface> PositionSetpoint_TypeSupportInterface_out;


            class PositionSetpoint_DataWriter;

            typedef PositionSetpoint_DataWriter * PositionSetpoint_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionSetpoint_DataWriter> PositionSetpoint_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionSetpoint_DataWriter> PositionSetpoint_DataWriter_out;


            class PositionSetpoint_DataReader;

            typedef PositionSetpoint_DataReader * PositionSetpoint_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionSetpoint_DataReader> PositionSetpoint_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionSetpoint_DataReader> PositionSetpoint_DataReader_out;


            class PositionSetpoint_DataReaderView;

            typedef PositionSetpoint_DataReaderView * PositionSetpoint_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionSetpoint_DataReaderView> PositionSetpoint_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionSetpoint_DataReaderView> PositionSetpoint_DataReaderView_out;

            struct PositionSetpoint_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PositionSetpoint_, struct PositionSetpoint_Seq_uniq_> PositionSetpoint_Seq;
            typedef DDS_DCPSSequence_var < PositionSetpoint_Seq> PositionSetpoint_Seq_var;
            typedef DDS_DCPSSequence_out < PositionSetpoint_Seq> PositionSetpoint_Seq_out;

            class  PositionSetpoint_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionSetpoint_TypeSupportInterface_ptr _ptr_type;
                typedef PositionSetpoint_TypeSupportInterface_var _var_type;

                static PositionSetpoint_TypeSupportInterface_ptr _duplicate (PositionSetpoint_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionSetpoint_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionSetpoint_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionSetpoint_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionSetpoint_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionSetpoint_TypeSupportInterface () {};
                ~PositionSetpoint_TypeSupportInterface () {};
            private:
                PositionSetpoint_TypeSupportInterface (const PositionSetpoint_TypeSupportInterface &);
                PositionSetpoint_TypeSupportInterface & operator = (const PositionSetpoint_TypeSupportInterface &);
            };

            class  PositionSetpoint_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionSetpoint_DataWriter_ptr _ptr_type;
                typedef PositionSetpoint_DataWriter_var _var_type;

                static PositionSetpoint_DataWriter_ptr _duplicate (PositionSetpoint_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionSetpoint_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionSetpoint_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionSetpoint_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionSetpoint_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionSetpoint_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionSetpoint_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionSetpoint_& instance_data) = 0;

            protected:
                PositionSetpoint_DataWriter () {};
                ~PositionSetpoint_DataWriter () {};
            private:
                PositionSetpoint_DataWriter (const PositionSetpoint_DataWriter &);
                PositionSetpoint_DataWriter & operator = (const PositionSetpoint_DataWriter &);
            };

            class  PositionSetpoint_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionSetpoint_DataReader_ptr _ptr_type;
                typedef PositionSetpoint_DataReader_var _var_type;

                static PositionSetpoint_DataReader_ptr _duplicate (PositionSetpoint_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionSetpoint_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionSetpoint_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionSetpoint_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionSetpoint_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionSetpoint_& instance) = 0;

            protected:
                PositionSetpoint_DataReader () {};
                ~PositionSetpoint_DataReader () {};
            private:
                PositionSetpoint_DataReader (const PositionSetpoint_DataReader &);
                PositionSetpoint_DataReader & operator = (const PositionSetpoint_DataReader &);
            };

            class  PositionSetpoint_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionSetpoint_DataReaderView_ptr _ptr_type;
                typedef PositionSetpoint_DataReaderView_var _var_type;

                static PositionSetpoint_DataReaderView_ptr _duplicate (PositionSetpoint_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionSetpoint_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionSetpoint_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionSetpoint_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionSetpoint_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionSetpoint_& instance) = 0;

            protected:
                PositionSetpoint_DataReaderView () {};
                ~PositionSetpoint_DataReaderView () {};
            private:
                PositionSetpoint_DataReaderView (const PositionSetpoint_DataReaderView &);
                PositionSetpoint_DataReaderView & operator = (const PositionSetpoint_DataReaderView &);
            };
        }

    }

}

#endif
