#ifndef _H_FBC187E5ECD81D96E155EBF8320DD6EF_PowerButtonState__H_
#define _H_FBC187E5ECD81D96E155EBF8320DD6EF_PowerButtonState__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace PowerButtonState_Constants
            {
                const ::DDS::Octet PWR_BUTTON_STATE_IDEL_ = 0;

                const ::DDS::Octet PWR_BUTTON_STATE_DOWN_ = 1;

                const ::DDS::Octet PWR_BUTTON_STATE_UP_ = 2;

                const ::DDS::Octet PWR_BUTTON_STATE_REQUEST_SHUTDOWN_ = 3;

            }

            struct  PowerButtonState_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet event_;
            };

            typedef DDS_DCPSStruct_var<PowerButtonState_> PowerButtonState__var;
            typedef PowerButtonState_& PowerButtonState__out;

        }

    }

}

#endif /* _H_FBC187E5ECD81D96E155EBF8320DD6EF_PowerButtonState__H_ */
