#ifndef _H_CD83CE5364F458621B5219CD8B49D424_PowerMonitor_DCPS_H_
#define _H_CD83CE5364F458621B5219CD8B49D424_PowerMonitor_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PowerMonitor_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PowerMonitor_TypeSupportInterface;

            typedef PowerMonitor_TypeSupportInterface * PowerMonitor_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PowerMonitor_TypeSupportInterface> PowerMonitor_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PowerMonitor_TypeSupportInterface> PowerMonitor_TypeSupportInterface_out;


            class PowerMonitor_DataWriter;

            typedef PowerMonitor_DataWriter * PowerMonitor_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PowerMonitor_DataWriter> PowerMonitor_DataWriter_var;
            typedef DDS_DCPSInterface_out < PowerMonitor_DataWriter> PowerMonitor_DataWriter_out;


            class PowerMonitor_DataReader;

            typedef PowerMonitor_DataReader * PowerMonitor_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PowerMonitor_DataReader> PowerMonitor_DataReader_var;
            typedef DDS_DCPSInterface_out < PowerMonitor_DataReader> PowerMonitor_DataReader_out;


            class PowerMonitor_DataReaderView;

            typedef PowerMonitor_DataReaderView * PowerMonitor_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PowerMonitor_DataReaderView> PowerMonitor_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PowerMonitor_DataReaderView> PowerMonitor_DataReaderView_out;

            struct PowerMonitor_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PowerMonitor_, struct PowerMonitor_Seq_uniq_> PowerMonitor_Seq;
            typedef DDS_DCPSSequence_var < PowerMonitor_Seq> PowerMonitor_Seq_var;
            typedef DDS_DCPSSequence_out < PowerMonitor_Seq> PowerMonitor_Seq_out;

            class  PowerMonitor_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PowerMonitor_TypeSupportInterface_ptr _ptr_type;
                typedef PowerMonitor_TypeSupportInterface_var _var_type;

                static PowerMonitor_TypeSupportInterface_ptr _duplicate (PowerMonitor_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerMonitor_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PowerMonitor_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerMonitor_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerMonitor_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PowerMonitor_TypeSupportInterface () {};
                ~PowerMonitor_TypeSupportInterface () {};
            private:
                PowerMonitor_TypeSupportInterface (const PowerMonitor_TypeSupportInterface &);
                PowerMonitor_TypeSupportInterface & operator = (const PowerMonitor_TypeSupportInterface &);
            };

            class  PowerMonitor_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PowerMonitor_DataWriter_ptr _ptr_type;
                typedef PowerMonitor_DataWriter_var _var_type;

                static PowerMonitor_DataWriter_ptr _duplicate (PowerMonitor_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerMonitor_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PowerMonitor_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerMonitor_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerMonitor_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PowerMonitor_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PowerMonitor_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PowerMonitor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PowerMonitor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PowerMonitor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PowerMonitor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PowerMonitor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PowerMonitor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PowerMonitor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PowerMonitor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PowerMonitor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerMonitor_& instance_data) = 0;

            protected:
                PowerMonitor_DataWriter () {};
                ~PowerMonitor_DataWriter () {};
            private:
                PowerMonitor_DataWriter (const PowerMonitor_DataWriter &);
                PowerMonitor_DataWriter & operator = (const PowerMonitor_DataWriter &);
            };

            class  PowerMonitor_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PowerMonitor_DataReader_ptr _ptr_type;
                typedef PowerMonitor_DataReader_var _var_type;

                static PowerMonitor_DataReader_ptr _duplicate (PowerMonitor_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerMonitor_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PowerMonitor_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerMonitor_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerMonitor_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PowerMonitor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PowerMonitor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PowerMonitor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerMonitor_& instance) = 0;

            protected:
                PowerMonitor_DataReader () {};
                ~PowerMonitor_DataReader () {};
            private:
                PowerMonitor_DataReader (const PowerMonitor_DataReader &);
                PowerMonitor_DataReader & operator = (const PowerMonitor_DataReader &);
            };

            class  PowerMonitor_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PowerMonitor_DataReaderView_ptr _ptr_type;
                typedef PowerMonitor_DataReaderView_var _var_type;

                static PowerMonitor_DataReaderView_ptr _duplicate (PowerMonitor_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerMonitor_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PowerMonitor_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerMonitor_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerMonitor_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PowerMonitor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PowerMonitor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PowerMonitor_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PowerMonitor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerMonitor_& instance) = 0;

            protected:
                PowerMonitor_DataReaderView () {};
                ~PowerMonitor_DataReaderView () {};
            private:
                PowerMonitor_DataReaderView (const PowerMonitor_DataReaderView &);
                PowerMonitor_DataReaderView & operator = (const PowerMonitor_DataReaderView &);
            };
        }

    }

}

#endif
