#ifndef _H_66CFE4E0F10E380F60F2907AE487C7E5_PwmInput_DCPS_H_
#define _H_66CFE4E0F10E380F60F2907AE487C7E5_PwmInput_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PwmInput_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PwmInput_TypeSupportInterface;

            typedef PwmInput_TypeSupportInterface * PwmInput_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PwmInput_TypeSupportInterface> PwmInput_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PwmInput_TypeSupportInterface> PwmInput_TypeSupportInterface_out;


            class PwmInput_DataWriter;

            typedef PwmInput_DataWriter * PwmInput_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PwmInput_DataWriter> PwmInput_DataWriter_var;
            typedef DDS_DCPSInterface_out < PwmInput_DataWriter> PwmInput_DataWriter_out;


            class PwmInput_DataReader;

            typedef PwmInput_DataReader * PwmInput_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PwmInput_DataReader> PwmInput_DataReader_var;
            typedef DDS_DCPSInterface_out < PwmInput_DataReader> PwmInput_DataReader_out;


            class PwmInput_DataReaderView;

            typedef PwmInput_DataReaderView * PwmInput_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PwmInput_DataReaderView> PwmInput_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PwmInput_DataReaderView> PwmInput_DataReaderView_out;

            struct PwmInput_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PwmInput_, struct PwmInput_Seq_uniq_> PwmInput_Seq;
            typedef DDS_DCPSSequence_var < PwmInput_Seq> PwmInput_Seq_var;
            typedef DDS_DCPSSequence_out < PwmInput_Seq> PwmInput_Seq_out;

            class  PwmInput_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PwmInput_TypeSupportInterface_ptr _ptr_type;
                typedef PwmInput_TypeSupportInterface_var _var_type;

                static PwmInput_TypeSupportInterface_ptr _duplicate (PwmInput_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PwmInput_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PwmInput_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PwmInput_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PwmInput_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PwmInput_TypeSupportInterface () {};
                ~PwmInput_TypeSupportInterface () {};
            private:
                PwmInput_TypeSupportInterface (const PwmInput_TypeSupportInterface &);
                PwmInput_TypeSupportInterface & operator = (const PwmInput_TypeSupportInterface &);
            };

            class  PwmInput_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PwmInput_DataWriter_ptr _ptr_type;
                typedef PwmInput_DataWriter_var _var_type;

                static PwmInput_DataWriter_ptr _duplicate (PwmInput_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PwmInput_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PwmInput_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PwmInput_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PwmInput_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PwmInput_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PwmInput_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PwmInput_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PwmInput_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PwmInput_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PwmInput_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PwmInput_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PwmInput_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PwmInput_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PwmInput_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PwmInput_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PwmInput_& instance_data) = 0;

            protected:
                PwmInput_DataWriter () {};
                ~PwmInput_DataWriter () {};
            private:
                PwmInput_DataWriter (const PwmInput_DataWriter &);
                PwmInput_DataWriter & operator = (const PwmInput_DataWriter &);
            };

            class  PwmInput_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PwmInput_DataReader_ptr _ptr_type;
                typedef PwmInput_DataReader_var _var_type;

                static PwmInput_DataReader_ptr _duplicate (PwmInput_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PwmInput_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PwmInput_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PwmInput_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PwmInput_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PwmInput_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PwmInput_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PwmInput_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PwmInput_& instance) = 0;

            protected:
                PwmInput_DataReader () {};
                ~PwmInput_DataReader () {};
            private:
                PwmInput_DataReader (const PwmInput_DataReader &);
                PwmInput_DataReader & operator = (const PwmInput_DataReader &);
            };

            class  PwmInput_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PwmInput_DataReaderView_ptr _ptr_type;
                typedef PwmInput_DataReaderView_var _var_type;

                static PwmInput_DataReaderView_ptr _duplicate (PwmInput_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PwmInput_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PwmInput_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PwmInput_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PwmInput_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PwmInput_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PwmInput_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PwmInput_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PwmInput_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PwmInput_& instance) = 0;

            protected:
                PwmInput_DataReaderView () {};
                ~PwmInput_DataReaderView () {};
            private:
                PwmInput_DataReaderView (const PwmInput_DataReaderView &);
                PwmInput_DataReaderView & operator = (const PwmInput_DataReaderView &);
            };
        }

    }

}

#endif
