#ifndef _H_D7C0A5F6DF48B4E13D648C4FA1ABA21B_QshellReq_DCPS_H_
#define _H_D7C0A5F6DF48B4E13D648C4FA1ABA21B_QshellReq_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "QshellReq_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class QshellReq_TypeSupportInterface;

            typedef QshellReq_TypeSupportInterface * QshellReq_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < QshellReq_TypeSupportInterface> QshellReq_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < QshellReq_TypeSupportInterface> QshellReq_TypeSupportInterface_out;


            class QshellReq_DataWriter;

            typedef QshellReq_DataWriter * QshellReq_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < QshellReq_DataWriter> QshellReq_DataWriter_var;
            typedef DDS_DCPSInterface_out < QshellReq_DataWriter> QshellReq_DataWriter_out;


            class QshellReq_DataReader;

            typedef QshellReq_DataReader * QshellReq_DataReader_ptr;
            typedef DDS_DCPSInterface_var < QshellReq_DataReader> QshellReq_DataReader_var;
            typedef DDS_DCPSInterface_out < QshellReq_DataReader> QshellReq_DataReader_out;


            class QshellReq_DataReaderView;

            typedef QshellReq_DataReaderView * QshellReq_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < QshellReq_DataReaderView> QshellReq_DataReaderView_var;
            typedef DDS_DCPSInterface_out < QshellReq_DataReaderView> QshellReq_DataReaderView_out;

            struct QshellReq_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < QshellReq_, struct QshellReq_Seq_uniq_> QshellReq_Seq;
            typedef DDS_DCPSSequence_var < QshellReq_Seq> QshellReq_Seq_var;
            typedef DDS_DCPSSequence_out < QshellReq_Seq> QshellReq_Seq_out;

            class  QshellReq_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef QshellReq_TypeSupportInterface_ptr _ptr_type;
                typedef QshellReq_TypeSupportInterface_var _var_type;

                static QshellReq_TypeSupportInterface_ptr _duplicate (QshellReq_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QshellReq_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static QshellReq_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QshellReq_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                QshellReq_TypeSupportInterface_ptr _this () { return this; }


            protected:
                QshellReq_TypeSupportInterface () {};
                ~QshellReq_TypeSupportInterface () {};
            private:
                QshellReq_TypeSupportInterface (const QshellReq_TypeSupportInterface &);
                QshellReq_TypeSupportInterface & operator = (const QshellReq_TypeSupportInterface &);
            };

            class  QshellReq_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef QshellReq_DataWriter_ptr _ptr_type;
                typedef QshellReq_DataWriter_var _var_type;

                static QshellReq_DataWriter_ptr _duplicate (QshellReq_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QshellReq_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static QshellReq_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QshellReq_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                QshellReq_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const QshellReq_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const QshellReq_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const QshellReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const QshellReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const QshellReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const QshellReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const QshellReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const QshellReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const QshellReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const QshellReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (QshellReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QshellReq_& instance_data) = 0;

            protected:
                QshellReq_DataWriter () {};
                ~QshellReq_DataWriter () {};
            private:
                QshellReq_DataWriter (const QshellReq_DataWriter &);
                QshellReq_DataWriter & operator = (const QshellReq_DataWriter &);
            };

            class  QshellReq_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef QshellReq_DataReader_ptr _ptr_type;
                typedef QshellReq_DataReader_var _var_type;

                static QshellReq_DataReader_ptr _duplicate (QshellReq_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QshellReq_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static QshellReq_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QshellReq_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                QshellReq_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (QshellReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (QshellReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (QshellReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QshellReq_& instance) = 0;

            protected:
                QshellReq_DataReader () {};
                ~QshellReq_DataReader () {};
            private:
                QshellReq_DataReader (const QshellReq_DataReader &);
                QshellReq_DataReader & operator = (const QshellReq_DataReader &);
            };

            class  QshellReq_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef QshellReq_DataReaderView_ptr _ptr_type;
                typedef QshellReq_DataReaderView_var _var_type;

                static QshellReq_DataReaderView_ptr _duplicate (QshellReq_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QshellReq_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static QshellReq_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QshellReq_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                QshellReq_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (QshellReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (QshellReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (QshellReq_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (QshellReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QshellReq_& instance) = 0;

            protected:
                QshellReq_DataReaderView () {};
                ~QshellReq_DataReaderView () {};
            private:
                QshellReq_DataReaderView (const QshellReq_DataReaderView &);
                QshellReq_DataReaderView & operator = (const QshellReq_DataReaderView &);
            };
        }

    }

}

#endif
