#ifndef _H_B74A5EF1128E15B43A51F0B6F221B2E6_QshellRetval_DCPS_H_
#define _H_B74A5EF1128E15B43A51F0B6F221B2E6_QshellRetval_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "QshellRetval_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class QshellRetval_TypeSupportInterface;

            typedef QshellRetval_TypeSupportInterface * QshellRetval_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < QshellRetval_TypeSupportInterface> QshellRetval_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < QshellRetval_TypeSupportInterface> QshellRetval_TypeSupportInterface_out;


            class QshellRetval_DataWriter;

            typedef QshellRetval_DataWriter * QshellRetval_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < QshellRetval_DataWriter> QshellRetval_DataWriter_var;
            typedef DDS_DCPSInterface_out < QshellRetval_DataWriter> QshellRetval_DataWriter_out;


            class QshellRetval_DataReader;

            typedef QshellRetval_DataReader * QshellRetval_DataReader_ptr;
            typedef DDS_DCPSInterface_var < QshellRetval_DataReader> QshellRetval_DataReader_var;
            typedef DDS_DCPSInterface_out < QshellRetval_DataReader> QshellRetval_DataReader_out;


            class QshellRetval_DataReaderView;

            typedef QshellRetval_DataReaderView * QshellRetval_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < QshellRetval_DataReaderView> QshellRetval_DataReaderView_var;
            typedef DDS_DCPSInterface_out < QshellRetval_DataReaderView> QshellRetval_DataReaderView_out;

            struct QshellRetval_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < QshellRetval_, struct QshellRetval_Seq_uniq_> QshellRetval_Seq;
            typedef DDS_DCPSSequence_var < QshellRetval_Seq> QshellRetval_Seq_var;
            typedef DDS_DCPSSequence_out < QshellRetval_Seq> QshellRetval_Seq_out;

            class  QshellRetval_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef QshellRetval_TypeSupportInterface_ptr _ptr_type;
                typedef QshellRetval_TypeSupportInterface_var _var_type;

                static QshellRetval_TypeSupportInterface_ptr _duplicate (QshellRetval_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QshellRetval_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static QshellRetval_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QshellRetval_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                QshellRetval_TypeSupportInterface_ptr _this () { return this; }


            protected:
                QshellRetval_TypeSupportInterface () {};
                ~QshellRetval_TypeSupportInterface () {};
            private:
                QshellRetval_TypeSupportInterface (const QshellRetval_TypeSupportInterface &);
                QshellRetval_TypeSupportInterface & operator = (const QshellRetval_TypeSupportInterface &);
            };

            class  QshellRetval_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef QshellRetval_DataWriter_ptr _ptr_type;
                typedef QshellRetval_DataWriter_var _var_type;

                static QshellRetval_DataWriter_ptr _duplicate (QshellRetval_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QshellRetval_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static QshellRetval_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QshellRetval_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                QshellRetval_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const QshellRetval_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const QshellRetval_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const QshellRetval_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const QshellRetval_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const QshellRetval_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const QshellRetval_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const QshellRetval_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const QshellRetval_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const QshellRetval_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const QshellRetval_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (QshellRetval_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QshellRetval_& instance_data) = 0;

            protected:
                QshellRetval_DataWriter () {};
                ~QshellRetval_DataWriter () {};
            private:
                QshellRetval_DataWriter (const QshellRetval_DataWriter &);
                QshellRetval_DataWriter & operator = (const QshellRetval_DataWriter &);
            };

            class  QshellRetval_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef QshellRetval_DataReader_ptr _ptr_type;
                typedef QshellRetval_DataReader_var _var_type;

                static QshellRetval_DataReader_ptr _duplicate (QshellRetval_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QshellRetval_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static QshellRetval_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QshellRetval_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                QshellRetval_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (QshellRetval_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (QshellRetval_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (QshellRetval_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QshellRetval_& instance) = 0;

            protected:
                QshellRetval_DataReader () {};
                ~QshellRetval_DataReader () {};
            private:
                QshellRetval_DataReader (const QshellRetval_DataReader &);
                QshellRetval_DataReader & operator = (const QshellRetval_DataReader &);
            };

            class  QshellRetval_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef QshellRetval_DataReaderView_ptr _ptr_type;
                typedef QshellRetval_DataReaderView_var _var_type;

                static QshellRetval_DataReaderView_ptr _duplicate (QshellRetval_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QshellRetval_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static QshellRetval_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QshellRetval_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                QshellRetval_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (QshellRetval_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (QshellRetval_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (QshellRetval_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (QshellRetval_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QshellRetval_& instance) = 0;

            protected:
                QshellRetval_DataReaderView () {};
                ~QshellRetval_DataReaderView () {};
            private:
                QshellRetval_DataReaderView (const QshellRetval_DataReaderView &);
                QshellRetval_DataReaderView & operator = (const QshellRetval_DataReaderView &);
            };
        }

    }

}

#endif
