#ifndef _H_2A829DC8E8B390E27741679E635E7167_RateCtrlStatus_DCPS_H_
#define _H_2A829DC8E8B390E27741679E635E7167_RateCtrlStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RateCtrlStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RateCtrlStatus_TypeSupportInterface;

            typedef RateCtrlStatus_TypeSupportInterface * RateCtrlStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RateCtrlStatus_TypeSupportInterface> RateCtrlStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RateCtrlStatus_TypeSupportInterface> RateCtrlStatus_TypeSupportInterface_out;


            class RateCtrlStatus_DataWriter;

            typedef RateCtrlStatus_DataWriter * RateCtrlStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RateCtrlStatus_DataWriter> RateCtrlStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < RateCtrlStatus_DataWriter> RateCtrlStatus_DataWriter_out;


            class RateCtrlStatus_DataReader;

            typedef RateCtrlStatus_DataReader * RateCtrlStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RateCtrlStatus_DataReader> RateCtrlStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < RateCtrlStatus_DataReader> RateCtrlStatus_DataReader_out;


            class RateCtrlStatus_DataReaderView;

            typedef RateCtrlStatus_DataReaderView * RateCtrlStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RateCtrlStatus_DataReaderView> RateCtrlStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RateCtrlStatus_DataReaderView> RateCtrlStatus_DataReaderView_out;

            struct RateCtrlStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RateCtrlStatus_, struct RateCtrlStatus_Seq_uniq_> RateCtrlStatus_Seq;
            typedef DDS_DCPSSequence_var < RateCtrlStatus_Seq> RateCtrlStatus_Seq_var;
            typedef DDS_DCPSSequence_out < RateCtrlStatus_Seq> RateCtrlStatus_Seq_out;

            class  RateCtrlStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RateCtrlStatus_TypeSupportInterface_ptr _ptr_type;
                typedef RateCtrlStatus_TypeSupportInterface_var _var_type;

                static RateCtrlStatus_TypeSupportInterface_ptr _duplicate (RateCtrlStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RateCtrlStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RateCtrlStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RateCtrlStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RateCtrlStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RateCtrlStatus_TypeSupportInterface () {};
                ~RateCtrlStatus_TypeSupportInterface () {};
            private:
                RateCtrlStatus_TypeSupportInterface (const RateCtrlStatus_TypeSupportInterface &);
                RateCtrlStatus_TypeSupportInterface & operator = (const RateCtrlStatus_TypeSupportInterface &);
            };

            class  RateCtrlStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RateCtrlStatus_DataWriter_ptr _ptr_type;
                typedef RateCtrlStatus_DataWriter_var _var_type;

                static RateCtrlStatus_DataWriter_ptr _duplicate (RateCtrlStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RateCtrlStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RateCtrlStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RateCtrlStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RateCtrlStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RateCtrlStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RateCtrlStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RateCtrlStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RateCtrlStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RateCtrlStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RateCtrlStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RateCtrlStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RateCtrlStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RateCtrlStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RateCtrlStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RateCtrlStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RateCtrlStatus_& instance_data) = 0;

            protected:
                RateCtrlStatus_DataWriter () {};
                ~RateCtrlStatus_DataWriter () {};
            private:
                RateCtrlStatus_DataWriter (const RateCtrlStatus_DataWriter &);
                RateCtrlStatus_DataWriter & operator = (const RateCtrlStatus_DataWriter &);
            };

            class  RateCtrlStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RateCtrlStatus_DataReader_ptr _ptr_type;
                typedef RateCtrlStatus_DataReader_var _var_type;

                static RateCtrlStatus_DataReader_ptr _duplicate (RateCtrlStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RateCtrlStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RateCtrlStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RateCtrlStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RateCtrlStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RateCtrlStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RateCtrlStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RateCtrlStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RateCtrlStatus_& instance) = 0;

            protected:
                RateCtrlStatus_DataReader () {};
                ~RateCtrlStatus_DataReader () {};
            private:
                RateCtrlStatus_DataReader (const RateCtrlStatus_DataReader &);
                RateCtrlStatus_DataReader & operator = (const RateCtrlStatus_DataReader &);
            };

            class  RateCtrlStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RateCtrlStatus_DataReaderView_ptr _ptr_type;
                typedef RateCtrlStatus_DataReaderView_var _var_type;

                static RateCtrlStatus_DataReaderView_ptr _duplicate (RateCtrlStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RateCtrlStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RateCtrlStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RateCtrlStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RateCtrlStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RateCtrlStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RateCtrlStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RateCtrlStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RateCtrlStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RateCtrlStatus_& instance) = 0;

            protected:
                RateCtrlStatus_DataReaderView () {};
                ~RateCtrlStatus_DataReaderView () {};
            private:
                RateCtrlStatus_DataReaderView (const RateCtrlStatus_DataReaderView &);
                RateCtrlStatus_DataReaderView & operator = (const RateCtrlStatus_DataReaderView &);
            };
        }

    }

}

#endif
