#ifndef _H_5F75662095ED7D7A1AAC1AF186CB6211_RcParameterMap__H_
#define _H_5F75662095ED7D7A1AAC1AF186CB6211_RcParameterMap__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace RcParameterMap_Constants
            {
                const ::DDS::Octet RC_PARAM_MAP_NCHAN_ = 3;

                const ::DDS::Octet PARAM_ID_LEN_ = 16;

            }

            struct  RcParameterMap_
            {
                struct _valid__uniq_{};
                typedef ::DDS::Boolean _valid__slice;
                typedef ::DDS::Boolean _valid_[3];
                typedef DDS_DCPS_FArray_var< _valid_, _valid__slice, struct _valid__uniq_ > _valid__var;
                typedef _valid_ _valid__out;
                typedef DDS_DCPS_Array_forany< _valid_, _valid__slice, struct _valid__uniq_ > _valid__forany;
                static _valid__slice *_valid__alloc();
                static void _valid__free(_valid__slice *);
                static void _valid__copy(_valid__slice *to, const _valid__slice *from);
                static _valid__slice *_valid__dup(const _valid__slice *from);
                struct _param_index__uniq_{};
                typedef ::DDS::Long _param_index__slice;
                typedef ::DDS::Long _param_index_[3];
                typedef DDS_DCPS_FArray_var< _param_index_, _param_index__slice, struct _param_index__uniq_ > _param_index__var;
                typedef _param_index_ _param_index__out;
                typedef DDS_DCPS_Array_forany< _param_index_, _param_index__slice, struct _param_index__uniq_ > _param_index__forany;
                static _param_index__slice *_param_index__alloc();
                static void _param_index__free(_param_index__slice *);
                static void _param_index__copy(_param_index__slice *to, const _param_index__slice *from);
                static _param_index__slice *_param_index__dup(const _param_index__slice *from);
                struct _param_id__uniq_{};
                typedef ::DDS::Octet _param_id__slice;
                typedef ::DDS::Octet _param_id_[51];
                typedef DDS_DCPS_FArray_var< _param_id_, _param_id__slice, struct _param_id__uniq_ > _param_id__var;
                typedef _param_id_ _param_id__out;
                typedef DDS_DCPS_Array_forany< _param_id_, _param_id__slice, struct _param_id__uniq_ > _param_id__forany;
                static _param_id__slice *_param_id__alloc();
                static void _param_id__free(_param_id__slice *);
                static void _param_id__copy(_param_id__slice *to, const _param_id__slice *from);
                static _param_id__slice *_param_id__dup(const _param_id__slice *from);
                struct _scale__uniq_{};
                typedef ::DDS::Float _scale__slice;
                typedef ::DDS::Float _scale_[3];
                typedef DDS_DCPS_FArray_var< _scale_, _scale__slice, struct _scale__uniq_ > _scale__var;
                typedef _scale_ _scale__out;
                typedef DDS_DCPS_Array_forany< _scale_, _scale__slice, struct _scale__uniq_ > _scale__forany;
                static _scale__slice *_scale__alloc();
                static void _scale__free(_scale__slice *);
                static void _scale__copy(_scale__slice *to, const _scale__slice *from);
                static _scale__slice *_scale__dup(const _scale__slice *from);
                struct _value0__uniq_{};
                typedef ::DDS::Float _value0__slice;
                typedef ::DDS::Float _value0_[3];
                typedef DDS_DCPS_FArray_var< _value0_, _value0__slice, struct _value0__uniq_ > _value0__var;
                typedef _value0_ _value0__out;
                typedef DDS_DCPS_Array_forany< _value0_, _value0__slice, struct _value0__uniq_ > _value0__forany;
                static _value0__slice *_value0__alloc();
                static void _value0__free(_value0__slice *);
                static void _value0__copy(_value0__slice *to, const _value0__slice *from);
                static _value0__slice *_value0__dup(const _value0__slice *from);
                struct _value_min__uniq_{};
                typedef ::DDS::Float _value_min__slice;
                typedef ::DDS::Float _value_min_[3];
                typedef DDS_DCPS_FArray_var< _value_min_, _value_min__slice, struct _value_min__uniq_ > _value_min__var;
                typedef _value_min_ _value_min__out;
                typedef DDS_DCPS_Array_forany< _value_min_, _value_min__slice, struct _value_min__uniq_ > _value_min__forany;
                static _value_min__slice *_value_min__alloc();
                static void _value_min__free(_value_min__slice *);
                static void _value_min__copy(_value_min__slice *to, const _value_min__slice *from);
                static _value_min__slice *_value_min__dup(const _value_min__slice *from);
                struct _value_max__uniq_{};
                typedef ::DDS::Float _value_max__slice;
                typedef ::DDS::Float _value_max_[3];
                typedef DDS_DCPS_FArray_var< _value_max_, _value_max__slice, struct _value_max__uniq_ > _value_max__var;
                typedef _value_max_ _value_max__out;
                typedef DDS_DCPS_Array_forany< _value_max_, _value_max__slice, struct _value_max__uniq_ > _value_max__forany;
                static _value_max__slice *_value_max__alloc();
                static void _value_max__free(_value_max__slice *);
                static void _value_max__copy(_value_max__slice *to, const _value_max__slice *from);
                static _value_max__slice *_value_max__dup(const _value_max__slice *from);
                ::DDS::ULongLong timestamp_;
                _valid_ valid_;
                _param_index_ param_index_;
                _param_id_ param_id_;
                _scale_ scale_;
                _value0_ value0_;
                _value_min_ value_min_;
                _value_max_ value_max_;
            };

            typedef DDS_DCPSStruct_var<RcParameterMap_> RcParameterMap__var;
            typedef RcParameterMap_& RcParameterMap__out;

        }

    }

}

#endif /* _H_5F75662095ED7D7A1AAC1AF186CB6211_RcParameterMap__H_ */
