#ifndef _H_5F75662095ED7D7A1AAC1AF186CB6211_RcParameterMap_DCPS_H_
#define _H_5F75662095ED7D7A1AAC1AF186CB6211_RcParameterMap_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RcParameterMap_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RcParameterMap_TypeSupportInterface;

            typedef RcParameterMap_TypeSupportInterface * RcParameterMap_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RcParameterMap_TypeSupportInterface> RcParameterMap_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RcParameterMap_TypeSupportInterface> RcParameterMap_TypeSupportInterface_out;


            class RcParameterMap_DataWriter;

            typedef RcParameterMap_DataWriter * RcParameterMap_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RcParameterMap_DataWriter> RcParameterMap_DataWriter_var;
            typedef DDS_DCPSInterface_out < RcParameterMap_DataWriter> RcParameterMap_DataWriter_out;


            class RcParameterMap_DataReader;

            typedef RcParameterMap_DataReader * RcParameterMap_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RcParameterMap_DataReader> RcParameterMap_DataReader_var;
            typedef DDS_DCPSInterface_out < RcParameterMap_DataReader> RcParameterMap_DataReader_out;


            class RcParameterMap_DataReaderView;

            typedef RcParameterMap_DataReaderView * RcParameterMap_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RcParameterMap_DataReaderView> RcParameterMap_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RcParameterMap_DataReaderView> RcParameterMap_DataReaderView_out;

            struct RcParameterMap_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RcParameterMap_, struct RcParameterMap_Seq_uniq_> RcParameterMap_Seq;
            typedef DDS_DCPSSequence_var < RcParameterMap_Seq> RcParameterMap_Seq_var;
            typedef DDS_DCPSSequence_out < RcParameterMap_Seq> RcParameterMap_Seq_out;

            class  RcParameterMap_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RcParameterMap_TypeSupportInterface_ptr _ptr_type;
                typedef RcParameterMap_TypeSupportInterface_var _var_type;

                static RcParameterMap_TypeSupportInterface_ptr _duplicate (RcParameterMap_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RcParameterMap_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RcParameterMap_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RcParameterMap_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RcParameterMap_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RcParameterMap_TypeSupportInterface () {};
                ~RcParameterMap_TypeSupportInterface () {};
            private:
                RcParameterMap_TypeSupportInterface (const RcParameterMap_TypeSupportInterface &);
                RcParameterMap_TypeSupportInterface & operator = (const RcParameterMap_TypeSupportInterface &);
            };

            class  RcParameterMap_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RcParameterMap_DataWriter_ptr _ptr_type;
                typedef RcParameterMap_DataWriter_var _var_type;

                static RcParameterMap_DataWriter_ptr _duplicate (RcParameterMap_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RcParameterMap_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RcParameterMap_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RcParameterMap_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RcParameterMap_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RcParameterMap_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RcParameterMap_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RcParameterMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RcParameterMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RcParameterMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RcParameterMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RcParameterMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RcParameterMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RcParameterMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RcParameterMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RcParameterMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RcParameterMap_& instance_data) = 0;

            protected:
                RcParameterMap_DataWriter () {};
                ~RcParameterMap_DataWriter () {};
            private:
                RcParameterMap_DataWriter (const RcParameterMap_DataWriter &);
                RcParameterMap_DataWriter & operator = (const RcParameterMap_DataWriter &);
            };

            class  RcParameterMap_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RcParameterMap_DataReader_ptr _ptr_type;
                typedef RcParameterMap_DataReader_var _var_type;

                static RcParameterMap_DataReader_ptr _duplicate (RcParameterMap_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RcParameterMap_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RcParameterMap_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RcParameterMap_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RcParameterMap_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RcParameterMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RcParameterMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RcParameterMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RcParameterMap_& instance) = 0;

            protected:
                RcParameterMap_DataReader () {};
                ~RcParameterMap_DataReader () {};
            private:
                RcParameterMap_DataReader (const RcParameterMap_DataReader &);
                RcParameterMap_DataReader & operator = (const RcParameterMap_DataReader &);
            };

            class  RcParameterMap_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RcParameterMap_DataReaderView_ptr _ptr_type;
                typedef RcParameterMap_DataReaderView_var _var_type;

                static RcParameterMap_DataReaderView_ptr _duplicate (RcParameterMap_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RcParameterMap_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RcParameterMap_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RcParameterMap_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RcParameterMap_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RcParameterMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RcParameterMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RcParameterMap_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RcParameterMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RcParameterMap_& instance) = 0;

            protected:
                RcParameterMap_DataReaderView () {};
                ~RcParameterMap_DataReaderView () {};
            private:
                RcParameterMap_DataReaderView (const RcParameterMap_DataReaderView &);
                RcParameterMap_DataReaderView & operator = (const RcParameterMap_DataReaderView &);
            };
        }

    }

}

#endif
