#ifndef _H_A74203456CA33BAA5F27795989EB74CE_SatelliteInfo_DCPS_H_
#define _H_A74203456CA33BAA5F27795989EB74CE_SatelliteInfo_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SatelliteInfo_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SatelliteInfo_TypeSupportInterface;

            typedef SatelliteInfo_TypeSupportInterface * SatelliteInfo_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SatelliteInfo_TypeSupportInterface> SatelliteInfo_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SatelliteInfo_TypeSupportInterface> SatelliteInfo_TypeSupportInterface_out;


            class SatelliteInfo_DataWriter;

            typedef SatelliteInfo_DataWriter * SatelliteInfo_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SatelliteInfo_DataWriter> SatelliteInfo_DataWriter_var;
            typedef DDS_DCPSInterface_out < SatelliteInfo_DataWriter> SatelliteInfo_DataWriter_out;


            class SatelliteInfo_DataReader;

            typedef SatelliteInfo_DataReader * SatelliteInfo_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SatelliteInfo_DataReader> SatelliteInfo_DataReader_var;
            typedef DDS_DCPSInterface_out < SatelliteInfo_DataReader> SatelliteInfo_DataReader_out;


            class SatelliteInfo_DataReaderView;

            typedef SatelliteInfo_DataReaderView * SatelliteInfo_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SatelliteInfo_DataReaderView> SatelliteInfo_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SatelliteInfo_DataReaderView> SatelliteInfo_DataReaderView_out;

            struct SatelliteInfo_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SatelliteInfo_, struct SatelliteInfo_Seq_uniq_> SatelliteInfo_Seq;
            typedef DDS_DCPSSequence_var < SatelliteInfo_Seq> SatelliteInfo_Seq_var;
            typedef DDS_DCPSSequence_out < SatelliteInfo_Seq> SatelliteInfo_Seq_out;

            class  SatelliteInfo_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SatelliteInfo_TypeSupportInterface_ptr _ptr_type;
                typedef SatelliteInfo_TypeSupportInterface_var _var_type;

                static SatelliteInfo_TypeSupportInterface_ptr _duplicate (SatelliteInfo_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SatelliteInfo_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SatelliteInfo_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SatelliteInfo_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SatelliteInfo_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SatelliteInfo_TypeSupportInterface () {};
                ~SatelliteInfo_TypeSupportInterface () {};
            private:
                SatelliteInfo_TypeSupportInterface (const SatelliteInfo_TypeSupportInterface &);
                SatelliteInfo_TypeSupportInterface & operator = (const SatelliteInfo_TypeSupportInterface &);
            };

            class  SatelliteInfo_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SatelliteInfo_DataWriter_ptr _ptr_type;
                typedef SatelliteInfo_DataWriter_var _var_type;

                static SatelliteInfo_DataWriter_ptr _duplicate (SatelliteInfo_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SatelliteInfo_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SatelliteInfo_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SatelliteInfo_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SatelliteInfo_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SatelliteInfo_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SatelliteInfo_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SatelliteInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SatelliteInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SatelliteInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SatelliteInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SatelliteInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SatelliteInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SatelliteInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SatelliteInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SatelliteInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SatelliteInfo_& instance_data) = 0;

            protected:
                SatelliteInfo_DataWriter () {};
                ~SatelliteInfo_DataWriter () {};
            private:
                SatelliteInfo_DataWriter (const SatelliteInfo_DataWriter &);
                SatelliteInfo_DataWriter & operator = (const SatelliteInfo_DataWriter &);
            };

            class  SatelliteInfo_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SatelliteInfo_DataReader_ptr _ptr_type;
                typedef SatelliteInfo_DataReader_var _var_type;

                static SatelliteInfo_DataReader_ptr _duplicate (SatelliteInfo_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SatelliteInfo_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SatelliteInfo_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SatelliteInfo_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SatelliteInfo_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SatelliteInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SatelliteInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SatelliteInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SatelliteInfo_& instance) = 0;

            protected:
                SatelliteInfo_DataReader () {};
                ~SatelliteInfo_DataReader () {};
            private:
                SatelliteInfo_DataReader (const SatelliteInfo_DataReader &);
                SatelliteInfo_DataReader & operator = (const SatelliteInfo_DataReader &);
            };

            class  SatelliteInfo_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SatelliteInfo_DataReaderView_ptr _ptr_type;
                typedef SatelliteInfo_DataReaderView_var _var_type;

                static SatelliteInfo_DataReaderView_ptr _duplicate (SatelliteInfo_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SatelliteInfo_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SatelliteInfo_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SatelliteInfo_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SatelliteInfo_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SatelliteInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SatelliteInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SatelliteInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SatelliteInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SatelliteInfo_& instance) = 0;

            protected:
                SatelliteInfo_DataReaderView () {};
                ~SatelliteInfo_DataReaderView () {};
            private:
                SatelliteInfo_DataReaderView (const SatelliteInfo_DataReaderView &);
                SatelliteInfo_DataReaderView & operator = (const SatelliteInfo_DataReaderView &);
            };
        }

    }

}

#endif
