#ifndef _H_F21BF179C04C13ADED27196AFA3CB373_SensorBias__H_
#define _H_F21BF179C04C13ADED27196AFA3CB373_SensorBias__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SensorBias_
            {
                struct _gyro_bias__uniq_{};
                typedef ::DDS::Float _gyro_bias__slice;
                typedef ::DDS::Float _gyro_bias_[3];
                typedef DDS_DCPS_FArray_var< _gyro_bias_, _gyro_bias__slice, struct _gyro_bias__uniq_ > _gyro_bias__var;
                typedef _gyro_bias_ _gyro_bias__out;
                typedef DDS_DCPS_Array_forany< _gyro_bias_, _gyro_bias__slice, struct _gyro_bias__uniq_ > _gyro_bias__forany;
                static _gyro_bias__slice *_gyro_bias__alloc();
                static void _gyro_bias__free(_gyro_bias__slice *);
                static void _gyro_bias__copy(_gyro_bias__slice *to, const _gyro_bias__slice *from);
                static _gyro_bias__slice *_gyro_bias__dup(const _gyro_bias__slice *from);
                struct _accel_bias__uniq_{};
                typedef ::DDS::Float _accel_bias__slice;
                typedef ::DDS::Float _accel_bias_[3];
                typedef DDS_DCPS_FArray_var< _accel_bias_, _accel_bias__slice, struct _accel_bias__uniq_ > _accel_bias__var;
                typedef _accel_bias_ _accel_bias__out;
                typedef DDS_DCPS_Array_forany< _accel_bias_, _accel_bias__slice, struct _accel_bias__uniq_ > _accel_bias__forany;
                static _accel_bias__slice *_accel_bias__alloc();
                static void _accel_bias__free(_accel_bias__slice *);
                static void _accel_bias__copy(_accel_bias__slice *to, const _accel_bias__slice *from);
                static _accel_bias__slice *_accel_bias__dup(const _accel_bias__slice *from);
                struct _mag_bias__uniq_{};
                typedef ::DDS::Float _mag_bias__slice;
                typedef ::DDS::Float _mag_bias_[3];
                typedef DDS_DCPS_FArray_var< _mag_bias_, _mag_bias__slice, struct _mag_bias__uniq_ > _mag_bias__var;
                typedef _mag_bias_ _mag_bias__out;
                typedef DDS_DCPS_Array_forany< _mag_bias_, _mag_bias__slice, struct _mag_bias__uniq_ > _mag_bias__forany;
                static _mag_bias__slice *_mag_bias__alloc();
                static void _mag_bias__free(_mag_bias__slice *);
                static void _mag_bias__copy(_mag_bias__slice *to, const _mag_bias__slice *from);
                static _mag_bias__slice *_mag_bias__dup(const _mag_bias__slice *from);
                ::DDS::ULongLong timestamp_;
                _gyro_bias_ gyro_bias_;
                _accel_bias_ accel_bias_;
                _mag_bias_ mag_bias_;
            };

            typedef DDS_DCPSStruct_var<SensorBias_> SensorBias__var;
            typedef SensorBias_& SensorBias__out;

        }

    }

}

#endif /* _H_F21BF179C04C13ADED27196AFA3CB373_SensorBias__H_ */
