#ifndef _H_970A994B270E16A063C183425ADF933F_SensorCorrection_DCPS_H_
#define _H_970A994B270E16A063C183425ADF933F_SensorCorrection_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorCorrection_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorCorrection_TypeSupportInterface;

            typedef SensorCorrection_TypeSupportInterface * SensorCorrection_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorCorrection_TypeSupportInterface> SensorCorrection_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorCorrection_TypeSupportInterface> SensorCorrection_TypeSupportInterface_out;


            class SensorCorrection_DataWriter;

            typedef SensorCorrection_DataWriter * SensorCorrection_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorCorrection_DataWriter> SensorCorrection_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorCorrection_DataWriter> SensorCorrection_DataWriter_out;


            class SensorCorrection_DataReader;

            typedef SensorCorrection_DataReader * SensorCorrection_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorCorrection_DataReader> SensorCorrection_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorCorrection_DataReader> SensorCorrection_DataReader_out;


            class SensorCorrection_DataReaderView;

            typedef SensorCorrection_DataReaderView * SensorCorrection_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorCorrection_DataReaderView> SensorCorrection_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorCorrection_DataReaderView> SensorCorrection_DataReaderView_out;

            struct SensorCorrection_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorCorrection_, struct SensorCorrection_Seq_uniq_> SensorCorrection_Seq;
            typedef DDS_DCPSSequence_var < SensorCorrection_Seq> SensorCorrection_Seq_var;
            typedef DDS_DCPSSequence_out < SensorCorrection_Seq> SensorCorrection_Seq_out;

            class  SensorCorrection_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorCorrection_TypeSupportInterface_ptr _ptr_type;
                typedef SensorCorrection_TypeSupportInterface_var _var_type;

                static SensorCorrection_TypeSupportInterface_ptr _duplicate (SensorCorrection_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorCorrection_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorCorrection_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorCorrection_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorCorrection_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorCorrection_TypeSupportInterface () {};
                ~SensorCorrection_TypeSupportInterface () {};
            private:
                SensorCorrection_TypeSupportInterface (const SensorCorrection_TypeSupportInterface &);
                SensorCorrection_TypeSupportInterface & operator = (const SensorCorrection_TypeSupportInterface &);
            };

            class  SensorCorrection_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorCorrection_DataWriter_ptr _ptr_type;
                typedef SensorCorrection_DataWriter_var _var_type;

                static SensorCorrection_DataWriter_ptr _duplicate (SensorCorrection_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorCorrection_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorCorrection_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorCorrection_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorCorrection_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorCorrection_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorCorrection_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorCorrection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorCorrection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorCorrection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorCorrection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorCorrection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorCorrection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorCorrection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorCorrection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorCorrection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorCorrection_& instance_data) = 0;

            protected:
                SensorCorrection_DataWriter () {};
                ~SensorCorrection_DataWriter () {};
            private:
                SensorCorrection_DataWriter (const SensorCorrection_DataWriter &);
                SensorCorrection_DataWriter & operator = (const SensorCorrection_DataWriter &);
            };

            class  SensorCorrection_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorCorrection_DataReader_ptr _ptr_type;
                typedef SensorCorrection_DataReader_var _var_type;

                static SensorCorrection_DataReader_ptr _duplicate (SensorCorrection_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorCorrection_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorCorrection_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorCorrection_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorCorrection_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorCorrection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorCorrection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorCorrection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorCorrection_& instance) = 0;

            protected:
                SensorCorrection_DataReader () {};
                ~SensorCorrection_DataReader () {};
            private:
                SensorCorrection_DataReader (const SensorCorrection_DataReader &);
                SensorCorrection_DataReader & operator = (const SensorCorrection_DataReader &);
            };

            class  SensorCorrection_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorCorrection_DataReaderView_ptr _ptr_type;
                typedef SensorCorrection_DataReaderView_var _var_type;

                static SensorCorrection_DataReaderView_ptr _duplicate (SensorCorrection_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorCorrection_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorCorrection_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorCorrection_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorCorrection_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorCorrection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorCorrection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorCorrection_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorCorrection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorCorrection_& instance) = 0;

            protected:
                SensorCorrection_DataReaderView () {};
                ~SensorCorrection_DataReaderView () {};
            private:
                SensorCorrection_DataReaderView (const SensorCorrection_DataReaderView &);
                SensorCorrection_DataReaderView & operator = (const SensorCorrection_DataReaderView &);
            };
        }

    }

}

#endif
