#ifndef _H_B94EE4B0E1CA94BD37CDCA640991BE5B_SensorGyro__H_
#define _H_B94EE4B0E1CA94BD37CDCA640991BE5B_SensorGyro__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SensorGyro_
            {
                ::DDS::ULong device_id_;
                ::DDS::ULongLong timestamp_;
                ::DDS::ULongLong error_count_;
                ::DDS::Float x_;
                ::DDS::Float y_;
                ::DDS::Float z_;
                ::DDS::ULong integral_dt_;
                ::DDS::Float x_integral_;
                ::DDS::Float y_integral_;
                ::DDS::Float z_integral_;
                ::DDS::Float temperature_;
                ::DDS::Float scaling_;
                ::DDS::Short x_raw_;
                ::DDS::Short y_raw_;
                ::DDS::Short z_raw_;
            };

            typedef DDS_DCPSStruct_var<SensorGyro_> SensorGyro__var;
            typedef SensorGyro_& SensorGyro__out;

        }

    }

}

#endif /* _H_B94EE4B0E1CA94BD37CDCA640991BE5B_SensorGyro__H_ */
