#ifndef _H_B94EE4B0E1CA94BD37CDCA640991BE5B_SensorGyro_DCPS_H_
#define _H_B94EE4B0E1CA94BD37CDCA640991BE5B_SensorGyro_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorGyro_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorGyro_TypeSupportInterface;

            typedef SensorGyro_TypeSupportInterface * SensorGyro_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorGyro_TypeSupportInterface> SensorGyro_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorGyro_TypeSupportInterface> SensorGyro_TypeSupportInterface_out;


            class SensorGyro_DataWriter;

            typedef SensorGyro_DataWriter * SensorGyro_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorGyro_DataWriter> SensorGyro_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorGyro_DataWriter> SensorGyro_DataWriter_out;


            class SensorGyro_DataReader;

            typedef SensorGyro_DataReader * SensorGyro_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorGyro_DataReader> SensorGyro_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorGyro_DataReader> SensorGyro_DataReader_out;


            class SensorGyro_DataReaderView;

            typedef SensorGyro_DataReaderView * SensorGyro_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorGyro_DataReaderView> SensorGyro_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorGyro_DataReaderView> SensorGyro_DataReaderView_out;

            struct SensorGyro_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorGyro_, struct SensorGyro_Seq_uniq_> SensorGyro_Seq;
            typedef DDS_DCPSSequence_var < SensorGyro_Seq> SensorGyro_Seq_var;
            typedef DDS_DCPSSequence_out < SensorGyro_Seq> SensorGyro_Seq_out;

            class  SensorGyro_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorGyro_TypeSupportInterface_ptr _ptr_type;
                typedef SensorGyro_TypeSupportInterface_var _var_type;

                static SensorGyro_TypeSupportInterface_ptr _duplicate (SensorGyro_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorGyro_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorGyro_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorGyro_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorGyro_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorGyro_TypeSupportInterface () {};
                ~SensorGyro_TypeSupportInterface () {};
            private:
                SensorGyro_TypeSupportInterface (const SensorGyro_TypeSupportInterface &);
                SensorGyro_TypeSupportInterface & operator = (const SensorGyro_TypeSupportInterface &);
            };

            class  SensorGyro_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorGyro_DataWriter_ptr _ptr_type;
                typedef SensorGyro_DataWriter_var _var_type;

                static SensorGyro_DataWriter_ptr _duplicate (SensorGyro_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorGyro_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorGyro_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorGyro_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorGyro_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorGyro_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorGyro_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorGyro_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorGyro_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorGyro_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorGyro_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorGyro_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorGyro_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorGyro_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorGyro_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorGyro_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorGyro_& instance_data) = 0;

            protected:
                SensorGyro_DataWriter () {};
                ~SensorGyro_DataWriter () {};
            private:
                SensorGyro_DataWriter (const SensorGyro_DataWriter &);
                SensorGyro_DataWriter & operator = (const SensorGyro_DataWriter &);
            };

            class  SensorGyro_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorGyro_DataReader_ptr _ptr_type;
                typedef SensorGyro_DataReader_var _var_type;

                static SensorGyro_DataReader_ptr _duplicate (SensorGyro_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorGyro_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorGyro_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorGyro_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorGyro_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorGyro_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorGyro_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorGyro_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorGyro_& instance) = 0;

            protected:
                SensorGyro_DataReader () {};
                ~SensorGyro_DataReader () {};
            private:
                SensorGyro_DataReader (const SensorGyro_DataReader &);
                SensorGyro_DataReader & operator = (const SensorGyro_DataReader &);
            };

            class  SensorGyro_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorGyro_DataReaderView_ptr _ptr_type;
                typedef SensorGyro_DataReaderView_var _var_type;

                static SensorGyro_DataReaderView_ptr _duplicate (SensorGyro_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorGyro_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorGyro_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorGyro_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorGyro_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorGyro_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorGyro_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorGyro_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorGyro_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorGyro_& instance) = 0;

            protected:
                SensorGyro_DataReaderView () {};
                ~SensorGyro_DataReaderView () {};
            private:
                SensorGyro_DataReaderView (const SensorGyro_DataReaderView &);
                SensorGyro_DataReaderView & operator = (const SensorGyro_DataReaderView &);
            };
        }

    }

}

#endif
