#ifndef _H_A76F57F6642C623283BFCB511D8CE6D8_SensorPreflight_DCPS_H_
#define _H_A76F57F6642C623283BFCB511D8CE6D8_SensorPreflight_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorPreflight_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorPreflight_TypeSupportInterface;

            typedef SensorPreflight_TypeSupportInterface * SensorPreflight_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorPreflight_TypeSupportInterface> SensorPreflight_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorPreflight_TypeSupportInterface> SensorPreflight_TypeSupportInterface_out;


            class SensorPreflight_DataWriter;

            typedef SensorPreflight_DataWriter * SensorPreflight_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorPreflight_DataWriter> SensorPreflight_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorPreflight_DataWriter> SensorPreflight_DataWriter_out;


            class SensorPreflight_DataReader;

            typedef SensorPreflight_DataReader * SensorPreflight_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorPreflight_DataReader> SensorPreflight_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorPreflight_DataReader> SensorPreflight_DataReader_out;


            class SensorPreflight_DataReaderView;

            typedef SensorPreflight_DataReaderView * SensorPreflight_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorPreflight_DataReaderView> SensorPreflight_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorPreflight_DataReaderView> SensorPreflight_DataReaderView_out;

            struct SensorPreflight_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorPreflight_, struct SensorPreflight_Seq_uniq_> SensorPreflight_Seq;
            typedef DDS_DCPSSequence_var < SensorPreflight_Seq> SensorPreflight_Seq_var;
            typedef DDS_DCPSSequence_out < SensorPreflight_Seq> SensorPreflight_Seq_out;

            class  SensorPreflight_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorPreflight_TypeSupportInterface_ptr _ptr_type;
                typedef SensorPreflight_TypeSupportInterface_var _var_type;

                static SensorPreflight_TypeSupportInterface_ptr _duplicate (SensorPreflight_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorPreflight_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorPreflight_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorPreflight_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorPreflight_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorPreflight_TypeSupportInterface () {};
                ~SensorPreflight_TypeSupportInterface () {};
            private:
                SensorPreflight_TypeSupportInterface (const SensorPreflight_TypeSupportInterface &);
                SensorPreflight_TypeSupportInterface & operator = (const SensorPreflight_TypeSupportInterface &);
            };

            class  SensorPreflight_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorPreflight_DataWriter_ptr _ptr_type;
                typedef SensorPreflight_DataWriter_var _var_type;

                static SensorPreflight_DataWriter_ptr _duplicate (SensorPreflight_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorPreflight_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorPreflight_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorPreflight_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorPreflight_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorPreflight_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorPreflight_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorPreflight_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorPreflight_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorPreflight_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorPreflight_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorPreflight_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorPreflight_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorPreflight_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorPreflight_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorPreflight_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorPreflight_& instance_data) = 0;

            protected:
                SensorPreflight_DataWriter () {};
                ~SensorPreflight_DataWriter () {};
            private:
                SensorPreflight_DataWriter (const SensorPreflight_DataWriter &);
                SensorPreflight_DataWriter & operator = (const SensorPreflight_DataWriter &);
            };

            class  SensorPreflight_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorPreflight_DataReader_ptr _ptr_type;
                typedef SensorPreflight_DataReader_var _var_type;

                static SensorPreflight_DataReader_ptr _duplicate (SensorPreflight_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorPreflight_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorPreflight_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorPreflight_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorPreflight_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorPreflight_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorPreflight_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorPreflight_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorPreflight_& instance) = 0;

            protected:
                SensorPreflight_DataReader () {};
                ~SensorPreflight_DataReader () {};
            private:
                SensorPreflight_DataReader (const SensorPreflight_DataReader &);
                SensorPreflight_DataReader & operator = (const SensorPreflight_DataReader &);
            };

            class  SensorPreflight_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorPreflight_DataReaderView_ptr _ptr_type;
                typedef SensorPreflight_DataReaderView_var _var_type;

                static SensorPreflight_DataReaderView_ptr _duplicate (SensorPreflight_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorPreflight_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorPreflight_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorPreflight_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorPreflight_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorPreflight_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorPreflight_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorPreflight_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorPreflight_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorPreflight_& instance) = 0;

            protected:
                SensorPreflight_DataReaderView () {};
                ~SensorPreflight_DataReaderView () {};
            private:
                SensorPreflight_DataReaderView (const SensorPreflight_DataReaderView &);
                SensorPreflight_DataReaderView & operator = (const SensorPreflight_DataReaderView &);
            };
        }

    }

}

#endif
