#ifndef _H_02895694F5A2EEE4D974996EE8449E0C_SensorSelection_DCPS_H_
#define _H_02895694F5A2EEE4D974996EE8449E0C_SensorSelection_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorSelection_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorSelection_TypeSupportInterface;

            typedef SensorSelection_TypeSupportInterface * SensorSelection_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorSelection_TypeSupportInterface> SensorSelection_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorSelection_TypeSupportInterface> SensorSelection_TypeSupportInterface_out;


            class SensorSelection_DataWriter;

            typedef SensorSelection_DataWriter * SensorSelection_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorSelection_DataWriter> SensorSelection_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorSelection_DataWriter> SensorSelection_DataWriter_out;


            class SensorSelection_DataReader;

            typedef SensorSelection_DataReader * SensorSelection_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorSelection_DataReader> SensorSelection_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorSelection_DataReader> SensorSelection_DataReader_out;


            class SensorSelection_DataReaderView;

            typedef SensorSelection_DataReaderView * SensorSelection_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorSelection_DataReaderView> SensorSelection_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorSelection_DataReaderView> SensorSelection_DataReaderView_out;

            struct SensorSelection_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorSelection_, struct SensorSelection_Seq_uniq_> SensorSelection_Seq;
            typedef DDS_DCPSSequence_var < SensorSelection_Seq> SensorSelection_Seq_var;
            typedef DDS_DCPSSequence_out < SensorSelection_Seq> SensorSelection_Seq_out;

            class  SensorSelection_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorSelection_TypeSupportInterface_ptr _ptr_type;
                typedef SensorSelection_TypeSupportInterface_var _var_type;

                static SensorSelection_TypeSupportInterface_ptr _duplicate (SensorSelection_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorSelection_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorSelection_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorSelection_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorSelection_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorSelection_TypeSupportInterface () {};
                ~SensorSelection_TypeSupportInterface () {};
            private:
                SensorSelection_TypeSupportInterface (const SensorSelection_TypeSupportInterface &);
                SensorSelection_TypeSupportInterface & operator = (const SensorSelection_TypeSupportInterface &);
            };

            class  SensorSelection_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorSelection_DataWriter_ptr _ptr_type;
                typedef SensorSelection_DataWriter_var _var_type;

                static SensorSelection_DataWriter_ptr _duplicate (SensorSelection_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorSelection_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorSelection_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorSelection_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorSelection_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorSelection_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorSelection_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorSelection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorSelection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorSelection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorSelection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorSelection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorSelection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorSelection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorSelection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorSelection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorSelection_& instance_data) = 0;

            protected:
                SensorSelection_DataWriter () {};
                ~SensorSelection_DataWriter () {};
            private:
                SensorSelection_DataWriter (const SensorSelection_DataWriter &);
                SensorSelection_DataWriter & operator = (const SensorSelection_DataWriter &);
            };

            class  SensorSelection_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorSelection_DataReader_ptr _ptr_type;
                typedef SensorSelection_DataReader_var _var_type;

                static SensorSelection_DataReader_ptr _duplicate (SensorSelection_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorSelection_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorSelection_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorSelection_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorSelection_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorSelection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorSelection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorSelection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorSelection_& instance) = 0;

            protected:
                SensorSelection_DataReader () {};
                ~SensorSelection_DataReader () {};
            private:
                SensorSelection_DataReader (const SensorSelection_DataReader &);
                SensorSelection_DataReader & operator = (const SensorSelection_DataReader &);
            };

            class  SensorSelection_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorSelection_DataReaderView_ptr _ptr_type;
                typedef SensorSelection_DataReaderView_var _var_type;

                static SensorSelection_DataReaderView_ptr _duplicate (SensorSelection_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorSelection_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorSelection_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorSelection_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorSelection_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorSelection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorSelection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorSelection_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorSelection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorSelection_& instance) = 0;

            protected:
                SensorSelection_DataReaderView () {};
                ~SensorSelection_DataReaderView () {};
            private:
                SensorSelection_DataReaderView (const SensorSelection_DataReaderView &);
                SensorSelection_DataReaderView & operator = (const SensorSelection_DataReaderView &);
            };
        }

    }

}

#endif
