#ifndef _H_8CD5522E8D37E8B30ADE55FCA050AEFE_SubsystemInfo_DCPS_H_
#define _H_8CD5522E8D37E8B30ADE55FCA050AEFE_SubsystemInfo_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SubsystemInfo_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SubsystemInfo_TypeSupportInterface;

            typedef SubsystemInfo_TypeSupportInterface * SubsystemInfo_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SubsystemInfo_TypeSupportInterface> SubsystemInfo_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SubsystemInfo_TypeSupportInterface> SubsystemInfo_TypeSupportInterface_out;


            class SubsystemInfo_DataWriter;

            typedef SubsystemInfo_DataWriter * SubsystemInfo_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SubsystemInfo_DataWriter> SubsystemInfo_DataWriter_var;
            typedef DDS_DCPSInterface_out < SubsystemInfo_DataWriter> SubsystemInfo_DataWriter_out;


            class SubsystemInfo_DataReader;

            typedef SubsystemInfo_DataReader * SubsystemInfo_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SubsystemInfo_DataReader> SubsystemInfo_DataReader_var;
            typedef DDS_DCPSInterface_out < SubsystemInfo_DataReader> SubsystemInfo_DataReader_out;


            class SubsystemInfo_DataReaderView;

            typedef SubsystemInfo_DataReaderView * SubsystemInfo_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SubsystemInfo_DataReaderView> SubsystemInfo_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SubsystemInfo_DataReaderView> SubsystemInfo_DataReaderView_out;

            struct SubsystemInfo_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SubsystemInfo_, struct SubsystemInfo_Seq_uniq_> SubsystemInfo_Seq;
            typedef DDS_DCPSSequence_var < SubsystemInfo_Seq> SubsystemInfo_Seq_var;
            typedef DDS_DCPSSequence_out < SubsystemInfo_Seq> SubsystemInfo_Seq_out;

            class  SubsystemInfo_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SubsystemInfo_TypeSupportInterface_ptr _ptr_type;
                typedef SubsystemInfo_TypeSupportInterface_var _var_type;

                static SubsystemInfo_TypeSupportInterface_ptr _duplicate (SubsystemInfo_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SubsystemInfo_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SubsystemInfo_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SubsystemInfo_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SubsystemInfo_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SubsystemInfo_TypeSupportInterface () {};
                ~SubsystemInfo_TypeSupportInterface () {};
            private:
                SubsystemInfo_TypeSupportInterface (const SubsystemInfo_TypeSupportInterface &);
                SubsystemInfo_TypeSupportInterface & operator = (const SubsystemInfo_TypeSupportInterface &);
            };

            class  SubsystemInfo_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SubsystemInfo_DataWriter_ptr _ptr_type;
                typedef SubsystemInfo_DataWriter_var _var_type;

                static SubsystemInfo_DataWriter_ptr _duplicate (SubsystemInfo_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SubsystemInfo_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SubsystemInfo_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SubsystemInfo_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SubsystemInfo_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SubsystemInfo_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SubsystemInfo_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SubsystemInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SubsystemInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SubsystemInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SubsystemInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SubsystemInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SubsystemInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SubsystemInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SubsystemInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SubsystemInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SubsystemInfo_& instance_data) = 0;

            protected:
                SubsystemInfo_DataWriter () {};
                ~SubsystemInfo_DataWriter () {};
            private:
                SubsystemInfo_DataWriter (const SubsystemInfo_DataWriter &);
                SubsystemInfo_DataWriter & operator = (const SubsystemInfo_DataWriter &);
            };

            class  SubsystemInfo_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SubsystemInfo_DataReader_ptr _ptr_type;
                typedef SubsystemInfo_DataReader_var _var_type;

                static SubsystemInfo_DataReader_ptr _duplicate (SubsystemInfo_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SubsystemInfo_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SubsystemInfo_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SubsystemInfo_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SubsystemInfo_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SubsystemInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SubsystemInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SubsystemInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SubsystemInfo_& instance) = 0;

            protected:
                SubsystemInfo_DataReader () {};
                ~SubsystemInfo_DataReader () {};
            private:
                SubsystemInfo_DataReader (const SubsystemInfo_DataReader &);
                SubsystemInfo_DataReader & operator = (const SubsystemInfo_DataReader &);
            };

            class  SubsystemInfo_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SubsystemInfo_DataReaderView_ptr _ptr_type;
                typedef SubsystemInfo_DataReaderView_var _var_type;

                static SubsystemInfo_DataReaderView_ptr _duplicate (SubsystemInfo_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SubsystemInfo_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SubsystemInfo_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SubsystemInfo_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SubsystemInfo_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SubsystemInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SubsystemInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SubsystemInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SubsystemInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SubsystemInfo_& instance) = 0;

            protected:
                SubsystemInfo_DataReaderView () {};
                ~SubsystemInfo_DataReaderView () {};
            private:
                SubsystemInfo_DataReaderView (const SubsystemInfo_DataReaderView &);
                SubsystemInfo_DataReaderView & operator = (const SubsystemInfo_DataReaderView &);
            };
        }

    }

}

#endif
