#ifndef _H_1279EF6679C3B4773551265C82088D75_TaskStackInfo_DCPS_H_
#define _H_1279EF6679C3B4773551265C82088D75_TaskStackInfo_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TaskStackInfo_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TaskStackInfo_TypeSupportInterface;

            typedef TaskStackInfo_TypeSupportInterface * TaskStackInfo_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TaskStackInfo_TypeSupportInterface> TaskStackInfo_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TaskStackInfo_TypeSupportInterface> TaskStackInfo_TypeSupportInterface_out;


            class TaskStackInfo_DataWriter;

            typedef TaskStackInfo_DataWriter * TaskStackInfo_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TaskStackInfo_DataWriter> TaskStackInfo_DataWriter_var;
            typedef DDS_DCPSInterface_out < TaskStackInfo_DataWriter> TaskStackInfo_DataWriter_out;


            class TaskStackInfo_DataReader;

            typedef TaskStackInfo_DataReader * TaskStackInfo_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TaskStackInfo_DataReader> TaskStackInfo_DataReader_var;
            typedef DDS_DCPSInterface_out < TaskStackInfo_DataReader> TaskStackInfo_DataReader_out;


            class TaskStackInfo_DataReaderView;

            typedef TaskStackInfo_DataReaderView * TaskStackInfo_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TaskStackInfo_DataReaderView> TaskStackInfo_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TaskStackInfo_DataReaderView> TaskStackInfo_DataReaderView_out;

            struct TaskStackInfo_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TaskStackInfo_, struct TaskStackInfo_Seq_uniq_> TaskStackInfo_Seq;
            typedef DDS_DCPSSequence_var < TaskStackInfo_Seq> TaskStackInfo_Seq_var;
            typedef DDS_DCPSSequence_out < TaskStackInfo_Seq> TaskStackInfo_Seq_out;

            class  TaskStackInfo_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TaskStackInfo_TypeSupportInterface_ptr _ptr_type;
                typedef TaskStackInfo_TypeSupportInterface_var _var_type;

                static TaskStackInfo_TypeSupportInterface_ptr _duplicate (TaskStackInfo_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TaskStackInfo_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TaskStackInfo_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TaskStackInfo_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TaskStackInfo_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TaskStackInfo_TypeSupportInterface () {};
                ~TaskStackInfo_TypeSupportInterface () {};
            private:
                TaskStackInfo_TypeSupportInterface (const TaskStackInfo_TypeSupportInterface &);
                TaskStackInfo_TypeSupportInterface & operator = (const TaskStackInfo_TypeSupportInterface &);
            };

            class  TaskStackInfo_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TaskStackInfo_DataWriter_ptr _ptr_type;
                typedef TaskStackInfo_DataWriter_var _var_type;

                static TaskStackInfo_DataWriter_ptr _duplicate (TaskStackInfo_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TaskStackInfo_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TaskStackInfo_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TaskStackInfo_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TaskStackInfo_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TaskStackInfo_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TaskStackInfo_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TaskStackInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TaskStackInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TaskStackInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TaskStackInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TaskStackInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TaskStackInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TaskStackInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TaskStackInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TaskStackInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TaskStackInfo_& instance_data) = 0;

            protected:
                TaskStackInfo_DataWriter () {};
                ~TaskStackInfo_DataWriter () {};
            private:
                TaskStackInfo_DataWriter (const TaskStackInfo_DataWriter &);
                TaskStackInfo_DataWriter & operator = (const TaskStackInfo_DataWriter &);
            };

            class  TaskStackInfo_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TaskStackInfo_DataReader_ptr _ptr_type;
                typedef TaskStackInfo_DataReader_var _var_type;

                static TaskStackInfo_DataReader_ptr _duplicate (TaskStackInfo_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TaskStackInfo_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TaskStackInfo_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TaskStackInfo_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TaskStackInfo_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TaskStackInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TaskStackInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TaskStackInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TaskStackInfo_& instance) = 0;

            protected:
                TaskStackInfo_DataReader () {};
                ~TaskStackInfo_DataReader () {};
            private:
                TaskStackInfo_DataReader (const TaskStackInfo_DataReader &);
                TaskStackInfo_DataReader & operator = (const TaskStackInfo_DataReader &);
            };

            class  TaskStackInfo_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TaskStackInfo_DataReaderView_ptr _ptr_type;
                typedef TaskStackInfo_DataReaderView_var _var_type;

                static TaskStackInfo_DataReaderView_ptr _duplicate (TaskStackInfo_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TaskStackInfo_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TaskStackInfo_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TaskStackInfo_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TaskStackInfo_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TaskStackInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TaskStackInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TaskStackInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TaskStackInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TaskStackInfo_& instance) = 0;

            protected:
                TaskStackInfo_DataReaderView () {};
                ~TaskStackInfo_DataReaderView () {};
            private:
                TaskStackInfo_DataReaderView (const TaskStackInfo_DataReaderView &);
                TaskStackInfo_DataReaderView & operator = (const TaskStackInfo_DataReaderView &);
            };
        }

    }

}

#endif
