#ifndef _H_D7109767968BF8897382BFF080E1C6D8_TelemetryStatus_DCPS_H_
#define _H_D7109767968BF8897382BFF080E1C6D8_TelemetryStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TelemetryStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TelemetryStatus_TypeSupportInterface;

            typedef TelemetryStatus_TypeSupportInterface * TelemetryStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TelemetryStatus_TypeSupportInterface> TelemetryStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TelemetryStatus_TypeSupportInterface> TelemetryStatus_TypeSupportInterface_out;


            class TelemetryStatus_DataWriter;

            typedef TelemetryStatus_DataWriter * TelemetryStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TelemetryStatus_DataWriter> TelemetryStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < TelemetryStatus_DataWriter> TelemetryStatus_DataWriter_out;


            class TelemetryStatus_DataReader;

            typedef TelemetryStatus_DataReader * TelemetryStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TelemetryStatus_DataReader> TelemetryStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < TelemetryStatus_DataReader> TelemetryStatus_DataReader_out;


            class TelemetryStatus_DataReaderView;

            typedef TelemetryStatus_DataReaderView * TelemetryStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TelemetryStatus_DataReaderView> TelemetryStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TelemetryStatus_DataReaderView> TelemetryStatus_DataReaderView_out;

            struct TelemetryStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TelemetryStatus_, struct TelemetryStatus_Seq_uniq_> TelemetryStatus_Seq;
            typedef DDS_DCPSSequence_var < TelemetryStatus_Seq> TelemetryStatus_Seq_var;
            typedef DDS_DCPSSequence_out < TelemetryStatus_Seq> TelemetryStatus_Seq_out;

            class  TelemetryStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TelemetryStatus_TypeSupportInterface_ptr _ptr_type;
                typedef TelemetryStatus_TypeSupportInterface_var _var_type;

                static TelemetryStatus_TypeSupportInterface_ptr _duplicate (TelemetryStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TelemetryStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TelemetryStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TelemetryStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TelemetryStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TelemetryStatus_TypeSupportInterface () {};
                ~TelemetryStatus_TypeSupportInterface () {};
            private:
                TelemetryStatus_TypeSupportInterface (const TelemetryStatus_TypeSupportInterface &);
                TelemetryStatus_TypeSupportInterface & operator = (const TelemetryStatus_TypeSupportInterface &);
            };

            class  TelemetryStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TelemetryStatus_DataWriter_ptr _ptr_type;
                typedef TelemetryStatus_DataWriter_var _var_type;

                static TelemetryStatus_DataWriter_ptr _duplicate (TelemetryStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TelemetryStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TelemetryStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TelemetryStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TelemetryStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TelemetryStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TelemetryStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TelemetryStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TelemetryStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TelemetryStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TelemetryStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TelemetryStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TelemetryStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TelemetryStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TelemetryStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TelemetryStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TelemetryStatus_& instance_data) = 0;

            protected:
                TelemetryStatus_DataWriter () {};
                ~TelemetryStatus_DataWriter () {};
            private:
                TelemetryStatus_DataWriter (const TelemetryStatus_DataWriter &);
                TelemetryStatus_DataWriter & operator = (const TelemetryStatus_DataWriter &);
            };

            class  TelemetryStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TelemetryStatus_DataReader_ptr _ptr_type;
                typedef TelemetryStatus_DataReader_var _var_type;

                static TelemetryStatus_DataReader_ptr _duplicate (TelemetryStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TelemetryStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TelemetryStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TelemetryStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TelemetryStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TelemetryStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TelemetryStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TelemetryStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TelemetryStatus_& instance) = 0;

            protected:
                TelemetryStatus_DataReader () {};
                ~TelemetryStatus_DataReader () {};
            private:
                TelemetryStatus_DataReader (const TelemetryStatus_DataReader &);
                TelemetryStatus_DataReader & operator = (const TelemetryStatus_DataReader &);
            };

            class  TelemetryStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TelemetryStatus_DataReaderView_ptr _ptr_type;
                typedef TelemetryStatus_DataReaderView_var _var_type;

                static TelemetryStatus_DataReaderView_ptr _duplicate (TelemetryStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TelemetryStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TelemetryStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TelemetryStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TelemetryStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TelemetryStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TelemetryStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TelemetryStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TelemetryStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TelemetryStatus_& instance) = 0;

            protected:
                TelemetryStatus_DataReaderView () {};
                ~TelemetryStatus_DataReaderView () {};
            private:
                TelemetryStatus_DataReaderView (const TelemetryStatus_DataReaderView &);
                TelemetryStatus_DataReaderView & operator = (const TelemetryStatus_DataReaderView &);
            };
        }

    }

}

#endif
