#ifndef _H_9708638BA8D4290A9BF937136B6463A7_TimesyncStatus_DCPS_H_
#define _H_9708638BA8D4290A9BF937136B6463A7_TimesyncStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TimesyncStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TimesyncStatus_TypeSupportInterface;

            typedef TimesyncStatus_TypeSupportInterface * TimesyncStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TimesyncStatus_TypeSupportInterface> TimesyncStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TimesyncStatus_TypeSupportInterface> TimesyncStatus_TypeSupportInterface_out;


            class TimesyncStatus_DataWriter;

            typedef TimesyncStatus_DataWriter * TimesyncStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TimesyncStatus_DataWriter> TimesyncStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < TimesyncStatus_DataWriter> TimesyncStatus_DataWriter_out;


            class TimesyncStatus_DataReader;

            typedef TimesyncStatus_DataReader * TimesyncStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TimesyncStatus_DataReader> TimesyncStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < TimesyncStatus_DataReader> TimesyncStatus_DataReader_out;


            class TimesyncStatus_DataReaderView;

            typedef TimesyncStatus_DataReaderView * TimesyncStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TimesyncStatus_DataReaderView> TimesyncStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TimesyncStatus_DataReaderView> TimesyncStatus_DataReaderView_out;

            struct TimesyncStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TimesyncStatus_, struct TimesyncStatus_Seq_uniq_> TimesyncStatus_Seq;
            typedef DDS_DCPSSequence_var < TimesyncStatus_Seq> TimesyncStatus_Seq_var;
            typedef DDS_DCPSSequence_out < TimesyncStatus_Seq> TimesyncStatus_Seq_out;

            class  TimesyncStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TimesyncStatus_TypeSupportInterface_ptr _ptr_type;
                typedef TimesyncStatus_TypeSupportInterface_var _var_type;

                static TimesyncStatus_TypeSupportInterface_ptr _duplicate (TimesyncStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TimesyncStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TimesyncStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TimesyncStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TimesyncStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TimesyncStatus_TypeSupportInterface () {};
                ~TimesyncStatus_TypeSupportInterface () {};
            private:
                TimesyncStatus_TypeSupportInterface (const TimesyncStatus_TypeSupportInterface &);
                TimesyncStatus_TypeSupportInterface & operator = (const TimesyncStatus_TypeSupportInterface &);
            };

            class  TimesyncStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TimesyncStatus_DataWriter_ptr _ptr_type;
                typedef TimesyncStatus_DataWriter_var _var_type;

                static TimesyncStatus_DataWriter_ptr _duplicate (TimesyncStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TimesyncStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TimesyncStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TimesyncStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TimesyncStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TimesyncStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TimesyncStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TimesyncStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TimesyncStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TimesyncStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TimesyncStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TimesyncStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TimesyncStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TimesyncStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TimesyncStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TimesyncStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TimesyncStatus_& instance_data) = 0;

            protected:
                TimesyncStatus_DataWriter () {};
                ~TimesyncStatus_DataWriter () {};
            private:
                TimesyncStatus_DataWriter (const TimesyncStatus_DataWriter &);
                TimesyncStatus_DataWriter & operator = (const TimesyncStatus_DataWriter &);
            };

            class  TimesyncStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TimesyncStatus_DataReader_ptr _ptr_type;
                typedef TimesyncStatus_DataReader_var _var_type;

                static TimesyncStatus_DataReader_ptr _duplicate (TimesyncStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TimesyncStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TimesyncStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TimesyncStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TimesyncStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TimesyncStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TimesyncStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TimesyncStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TimesyncStatus_& instance) = 0;

            protected:
                TimesyncStatus_DataReader () {};
                ~TimesyncStatus_DataReader () {};
            private:
                TimesyncStatus_DataReader (const TimesyncStatus_DataReader &);
                TimesyncStatus_DataReader & operator = (const TimesyncStatus_DataReader &);
            };

            class  TimesyncStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TimesyncStatus_DataReaderView_ptr _ptr_type;
                typedef TimesyncStatus_DataReaderView_var _var_type;

                static TimesyncStatus_DataReaderView_ptr _duplicate (TimesyncStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TimesyncStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TimesyncStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TimesyncStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TimesyncStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TimesyncStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TimesyncStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TimesyncStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TimesyncStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TimesyncStatus_& instance) = 0;

            protected:
                TimesyncStatus_DataReaderView () {};
                ~TimesyncStatus_DataReaderView () {};
            private:
                TimesyncStatus_DataReaderView (const TimesyncStatus_DataReaderView &);
                TimesyncStatus_DataReaderView & operator = (const TimesyncStatus_DataReaderView &);
            };
        }

    }

}

#endif
