#ifndef _H_9F42E50B207A1DAC54A2F56B0D56A444_TransponderReport_DCPS_H_
#define _H_9F42E50B207A1DAC54A2F56B0D56A444_TransponderReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TransponderReport_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TransponderReport_TypeSupportInterface;

            typedef TransponderReport_TypeSupportInterface * TransponderReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TransponderReport_TypeSupportInterface> TransponderReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TransponderReport_TypeSupportInterface> TransponderReport_TypeSupportInterface_out;


            class TransponderReport_DataWriter;

            typedef TransponderReport_DataWriter * TransponderReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TransponderReport_DataWriter> TransponderReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < TransponderReport_DataWriter> TransponderReport_DataWriter_out;


            class TransponderReport_DataReader;

            typedef TransponderReport_DataReader * TransponderReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TransponderReport_DataReader> TransponderReport_DataReader_var;
            typedef DDS_DCPSInterface_out < TransponderReport_DataReader> TransponderReport_DataReader_out;


            class TransponderReport_DataReaderView;

            typedef TransponderReport_DataReaderView * TransponderReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TransponderReport_DataReaderView> TransponderReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TransponderReport_DataReaderView> TransponderReport_DataReaderView_out;

            struct TransponderReport_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TransponderReport_, struct TransponderReport_Seq_uniq_> TransponderReport_Seq;
            typedef DDS_DCPSSequence_var < TransponderReport_Seq> TransponderReport_Seq_var;
            typedef DDS_DCPSSequence_out < TransponderReport_Seq> TransponderReport_Seq_out;

            class  TransponderReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TransponderReport_TypeSupportInterface_ptr _ptr_type;
                typedef TransponderReport_TypeSupportInterface_var _var_type;

                static TransponderReport_TypeSupportInterface_ptr _duplicate (TransponderReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TransponderReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TransponderReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TransponderReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TransponderReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TransponderReport_TypeSupportInterface () {};
                ~TransponderReport_TypeSupportInterface () {};
            private:
                TransponderReport_TypeSupportInterface (const TransponderReport_TypeSupportInterface &);
                TransponderReport_TypeSupportInterface & operator = (const TransponderReport_TypeSupportInterface &);
            };

            class  TransponderReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TransponderReport_DataWriter_ptr _ptr_type;
                typedef TransponderReport_DataWriter_var _var_type;

                static TransponderReport_DataWriter_ptr _duplicate (TransponderReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TransponderReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TransponderReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TransponderReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TransponderReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TransponderReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TransponderReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TransponderReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TransponderReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TransponderReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TransponderReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TransponderReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TransponderReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TransponderReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TransponderReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TransponderReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TransponderReport_& instance_data) = 0;

            protected:
                TransponderReport_DataWriter () {};
                ~TransponderReport_DataWriter () {};
            private:
                TransponderReport_DataWriter (const TransponderReport_DataWriter &);
                TransponderReport_DataWriter & operator = (const TransponderReport_DataWriter &);
            };

            class  TransponderReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TransponderReport_DataReader_ptr _ptr_type;
                typedef TransponderReport_DataReader_var _var_type;

                static TransponderReport_DataReader_ptr _duplicate (TransponderReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TransponderReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TransponderReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TransponderReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TransponderReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TransponderReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TransponderReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TransponderReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TransponderReport_& instance) = 0;

            protected:
                TransponderReport_DataReader () {};
                ~TransponderReport_DataReader () {};
            private:
                TransponderReport_DataReader (const TransponderReport_DataReader &);
                TransponderReport_DataReader & operator = (const TransponderReport_DataReader &);
            };

            class  TransponderReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TransponderReport_DataReaderView_ptr _ptr_type;
                typedef TransponderReport_DataReaderView_var _var_type;

                static TransponderReport_DataReaderView_ptr _duplicate (TransponderReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TransponderReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TransponderReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TransponderReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TransponderReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TransponderReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TransponderReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TransponderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TransponderReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TransponderReport_& instance) = 0;

            protected:
                TransponderReport_DataReaderView () {};
                ~TransponderReport_DataReaderView () {};
            private:
                TransponderReport_DataReaderView (const TransponderReport_DataReaderView &);
                TransponderReport_DataReaderView & operator = (const TransponderReport_DataReaderView &);
            };
        }

    }

}

#endif
