#ifndef _H_AFBDF991994FE6A75D9C7533C7576283_TuneControl__H_
#define _H_AFBDF991994FE6A75D9C7533C7576283_TuneControl__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace TuneControl_Constants
            {
                const ::DDS::Octet VOLUME_LEVEL_MIN_ = 0;

                const ::DDS::Octet VOLUME_LEVEL_DEFAULT_ = 40;

                const ::DDS::Octet VOLUME_LEVEL_MAX_ = 100;

                const ::DDS::Octet ORB_QUEUE_LENGTH_ = 3;

            }

            struct  TuneControl_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet tune_id_;
                ::DDS::Octet tune_override_;
                ::DDS::UShort frequency_;
                ::DDS::ULong duration_;
                ::DDS::ULong silence_;
                ::DDS::Octet volume_;
            };

            typedef DDS_DCPSStruct_var<TuneControl_> TuneControl__var;
            typedef TuneControl_& TuneControl__out;

        }

    }

}

#endif /* _H_AFBDF991994FE6A75D9C7533C7576283_TuneControl__H_ */
