#ifndef _H_AFBDF991994FE6A75D9C7533C7576283_TuneControl_DCPS_H_
#define _H_AFBDF991994FE6A75D9C7533C7576283_TuneControl_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TuneControl_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TuneControl_TypeSupportInterface;

            typedef TuneControl_TypeSupportInterface * TuneControl_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TuneControl_TypeSupportInterface> TuneControl_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TuneControl_TypeSupportInterface> TuneControl_TypeSupportInterface_out;


            class TuneControl_DataWriter;

            typedef TuneControl_DataWriter * TuneControl_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TuneControl_DataWriter> TuneControl_DataWriter_var;
            typedef DDS_DCPSInterface_out < TuneControl_DataWriter> TuneControl_DataWriter_out;


            class TuneControl_DataReader;

            typedef TuneControl_DataReader * TuneControl_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TuneControl_DataReader> TuneControl_DataReader_var;
            typedef DDS_DCPSInterface_out < TuneControl_DataReader> TuneControl_DataReader_out;


            class TuneControl_DataReaderView;

            typedef TuneControl_DataReaderView * TuneControl_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TuneControl_DataReaderView> TuneControl_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TuneControl_DataReaderView> TuneControl_DataReaderView_out;

            struct TuneControl_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TuneControl_, struct TuneControl_Seq_uniq_> TuneControl_Seq;
            typedef DDS_DCPSSequence_var < TuneControl_Seq> TuneControl_Seq_var;
            typedef DDS_DCPSSequence_out < TuneControl_Seq> TuneControl_Seq_out;

            class  TuneControl_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TuneControl_TypeSupportInterface_ptr _ptr_type;
                typedef TuneControl_TypeSupportInterface_var _var_type;

                static TuneControl_TypeSupportInterface_ptr _duplicate (TuneControl_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TuneControl_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TuneControl_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TuneControl_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TuneControl_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TuneControl_TypeSupportInterface () {};
                ~TuneControl_TypeSupportInterface () {};
            private:
                TuneControl_TypeSupportInterface (const TuneControl_TypeSupportInterface &);
                TuneControl_TypeSupportInterface & operator = (const TuneControl_TypeSupportInterface &);
            };

            class  TuneControl_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TuneControl_DataWriter_ptr _ptr_type;
                typedef TuneControl_DataWriter_var _var_type;

                static TuneControl_DataWriter_ptr _duplicate (TuneControl_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TuneControl_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TuneControl_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TuneControl_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TuneControl_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TuneControl_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TuneControl_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TuneControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TuneControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TuneControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TuneControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TuneControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TuneControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TuneControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TuneControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TuneControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TuneControl_& instance_data) = 0;

            protected:
                TuneControl_DataWriter () {};
                ~TuneControl_DataWriter () {};
            private:
                TuneControl_DataWriter (const TuneControl_DataWriter &);
                TuneControl_DataWriter & operator = (const TuneControl_DataWriter &);
            };

            class  TuneControl_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TuneControl_DataReader_ptr _ptr_type;
                typedef TuneControl_DataReader_var _var_type;

                static TuneControl_DataReader_ptr _duplicate (TuneControl_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TuneControl_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TuneControl_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TuneControl_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TuneControl_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TuneControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TuneControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TuneControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TuneControl_& instance) = 0;

            protected:
                TuneControl_DataReader () {};
                ~TuneControl_DataReader () {};
            private:
                TuneControl_DataReader (const TuneControl_DataReader &);
                TuneControl_DataReader & operator = (const TuneControl_DataReader &);
            };

            class  TuneControl_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TuneControl_DataReaderView_ptr _ptr_type;
                typedef TuneControl_DataReaderView_var _var_type;

                static TuneControl_DataReaderView_ptr _duplicate (TuneControl_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TuneControl_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TuneControl_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TuneControl_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TuneControl_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TuneControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TuneControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TuneControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TuneControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TuneControl_& instance) = 0;

            protected:
                TuneControl_DataReaderView () {};
                ~TuneControl_DataReaderView () {};
            private:
                TuneControl_DataReaderView (const TuneControl_DataReaderView &);
                TuneControl_DataReaderView & operator = (const TuneControl_DataReaderView &);
            };
        }

    }

}

#endif
