#ifndef _H_9391B9123B0896E13AD85A07AB5F801B_UavcanParameterRequest__H_
#define _H_9391B9123B0896E13AD85A07AB5F801B_UavcanParameterRequest__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace UavcanParameterRequest_Constants
            {
                const ::DDS::Octet ORB_QUEUE_LENGTH_ = 3;

            }

            struct  UavcanParameterRequest_
            {
                struct _param_id__uniq_{};
                typedef ::DDS::Octet _param_id__slice;
                typedef ::DDS::Octet _param_id_[17];
                typedef DDS_DCPS_FArray_var< _param_id_, _param_id__slice, struct _param_id__uniq_ > _param_id__var;
                typedef _param_id_ _param_id__out;
                typedef DDS_DCPS_Array_forany< _param_id_, _param_id__slice, struct _param_id__uniq_ > _param_id__forany;
                static _param_id__slice *_param_id__alloc();
                static void _param_id__free(_param_id__slice *);
                static void _param_id__copy(_param_id__slice *to, const _param_id__slice *from);
                static _param_id__slice *_param_id__dup(const _param_id__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet message_type_;
                ::DDS::Octet node_id_;
                _param_id_ param_id_;
                ::DDS::Short param_index_;
                ::DDS::Octet param_type_;
                ::DDS::LongLong int_value_;
                ::DDS::Float real_value_;
            };

            typedef DDS_DCPSStruct_var<UavcanParameterRequest_> UavcanParameterRequest__var;
            typedef UavcanParameterRequest_& UavcanParameterRequest__out;

        }

    }

}

#endif /* _H_9391B9123B0896E13AD85A07AB5F801B_UavcanParameterRequest__H_ */
