#ifndef _H_BDA3542980432D825B40718F4F293945_UavcanParameterValue_DCPS_H_
#define _H_BDA3542980432D825B40718F4F293945_UavcanParameterValue_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UavcanParameterValue_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UavcanParameterValue_TypeSupportInterface;

            typedef UavcanParameterValue_TypeSupportInterface * UavcanParameterValue_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UavcanParameterValue_TypeSupportInterface> UavcanParameterValue_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UavcanParameterValue_TypeSupportInterface> UavcanParameterValue_TypeSupportInterface_out;


            class UavcanParameterValue_DataWriter;

            typedef UavcanParameterValue_DataWriter * UavcanParameterValue_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UavcanParameterValue_DataWriter> UavcanParameterValue_DataWriter_var;
            typedef DDS_DCPSInterface_out < UavcanParameterValue_DataWriter> UavcanParameterValue_DataWriter_out;


            class UavcanParameterValue_DataReader;

            typedef UavcanParameterValue_DataReader * UavcanParameterValue_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UavcanParameterValue_DataReader> UavcanParameterValue_DataReader_var;
            typedef DDS_DCPSInterface_out < UavcanParameterValue_DataReader> UavcanParameterValue_DataReader_out;


            class UavcanParameterValue_DataReaderView;

            typedef UavcanParameterValue_DataReaderView * UavcanParameterValue_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UavcanParameterValue_DataReaderView> UavcanParameterValue_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UavcanParameterValue_DataReaderView> UavcanParameterValue_DataReaderView_out;

            struct UavcanParameterValue_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < UavcanParameterValue_, struct UavcanParameterValue_Seq_uniq_> UavcanParameterValue_Seq;
            typedef DDS_DCPSSequence_var < UavcanParameterValue_Seq> UavcanParameterValue_Seq_var;
            typedef DDS_DCPSSequence_out < UavcanParameterValue_Seq> UavcanParameterValue_Seq_out;

            class  UavcanParameterValue_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UavcanParameterValue_TypeSupportInterface_ptr _ptr_type;
                typedef UavcanParameterValue_TypeSupportInterface_var _var_type;

                static UavcanParameterValue_TypeSupportInterface_ptr _duplicate (UavcanParameterValue_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UavcanParameterValue_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UavcanParameterValue_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UavcanParameterValue_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UavcanParameterValue_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UavcanParameterValue_TypeSupportInterface () {};
                ~UavcanParameterValue_TypeSupportInterface () {};
            private:
                UavcanParameterValue_TypeSupportInterface (const UavcanParameterValue_TypeSupportInterface &);
                UavcanParameterValue_TypeSupportInterface & operator = (const UavcanParameterValue_TypeSupportInterface &);
            };

            class  UavcanParameterValue_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UavcanParameterValue_DataWriter_ptr _ptr_type;
                typedef UavcanParameterValue_DataWriter_var _var_type;

                static UavcanParameterValue_DataWriter_ptr _duplicate (UavcanParameterValue_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UavcanParameterValue_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UavcanParameterValue_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UavcanParameterValue_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UavcanParameterValue_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UavcanParameterValue_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UavcanParameterValue_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UavcanParameterValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UavcanParameterValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UavcanParameterValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UavcanParameterValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UavcanParameterValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UavcanParameterValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UavcanParameterValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UavcanParameterValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UavcanParameterValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UavcanParameterValue_& instance_data) = 0;

            protected:
                UavcanParameterValue_DataWriter () {};
                ~UavcanParameterValue_DataWriter () {};
            private:
                UavcanParameterValue_DataWriter (const UavcanParameterValue_DataWriter &);
                UavcanParameterValue_DataWriter & operator = (const UavcanParameterValue_DataWriter &);
            };

            class  UavcanParameterValue_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UavcanParameterValue_DataReader_ptr _ptr_type;
                typedef UavcanParameterValue_DataReader_var _var_type;

                static UavcanParameterValue_DataReader_ptr _duplicate (UavcanParameterValue_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UavcanParameterValue_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UavcanParameterValue_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UavcanParameterValue_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UavcanParameterValue_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UavcanParameterValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UavcanParameterValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UavcanParameterValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UavcanParameterValue_& instance) = 0;

            protected:
                UavcanParameterValue_DataReader () {};
                ~UavcanParameterValue_DataReader () {};
            private:
                UavcanParameterValue_DataReader (const UavcanParameterValue_DataReader &);
                UavcanParameterValue_DataReader & operator = (const UavcanParameterValue_DataReader &);
            };

            class  UavcanParameterValue_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UavcanParameterValue_DataReaderView_ptr _ptr_type;
                typedef UavcanParameterValue_DataReaderView_var _var_type;

                static UavcanParameterValue_DataReaderView_ptr _duplicate (UavcanParameterValue_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UavcanParameterValue_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UavcanParameterValue_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UavcanParameterValue_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UavcanParameterValue_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UavcanParameterValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UavcanParameterValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UavcanParameterValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UavcanParameterValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UavcanParameterValue_& instance) = 0;

            protected:
                UavcanParameterValue_DataReaderView () {};
                ~UavcanParameterValue_DataReaderView () {};
            private:
                UavcanParameterValue_DataReaderView (const UavcanParameterValue_DataReaderView &);
                UavcanParameterValue_DataReaderView & operator = (const UavcanParameterValue_DataReaderView &);
            };
        }

    }

}

#endif
