#ifndef _H_CA9F93307CE4695B9282B8AAC08EB256_UlogStreamAck_DCPS_H_
#define _H_CA9F93307CE4695B9282B8AAC08EB256_UlogStreamAck_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UlogStreamAck_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UlogStreamAck_TypeSupportInterface;

            typedef UlogStreamAck_TypeSupportInterface * UlogStreamAck_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UlogStreamAck_TypeSupportInterface> UlogStreamAck_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UlogStreamAck_TypeSupportInterface> UlogStreamAck_TypeSupportInterface_out;


            class UlogStreamAck_DataWriter;

            typedef UlogStreamAck_DataWriter * UlogStreamAck_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UlogStreamAck_DataWriter> UlogStreamAck_DataWriter_var;
            typedef DDS_DCPSInterface_out < UlogStreamAck_DataWriter> UlogStreamAck_DataWriter_out;


            class UlogStreamAck_DataReader;

            typedef UlogStreamAck_DataReader * UlogStreamAck_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UlogStreamAck_DataReader> UlogStreamAck_DataReader_var;
            typedef DDS_DCPSInterface_out < UlogStreamAck_DataReader> UlogStreamAck_DataReader_out;


            class UlogStreamAck_DataReaderView;

            typedef UlogStreamAck_DataReaderView * UlogStreamAck_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UlogStreamAck_DataReaderView> UlogStreamAck_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UlogStreamAck_DataReaderView> UlogStreamAck_DataReaderView_out;

            struct UlogStreamAck_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < UlogStreamAck_, struct UlogStreamAck_Seq_uniq_> UlogStreamAck_Seq;
            typedef DDS_DCPSSequence_var < UlogStreamAck_Seq> UlogStreamAck_Seq_var;
            typedef DDS_DCPSSequence_out < UlogStreamAck_Seq> UlogStreamAck_Seq_out;

            class  UlogStreamAck_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UlogStreamAck_TypeSupportInterface_ptr _ptr_type;
                typedef UlogStreamAck_TypeSupportInterface_var _var_type;

                static UlogStreamAck_TypeSupportInterface_ptr _duplicate (UlogStreamAck_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UlogStreamAck_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UlogStreamAck_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UlogStreamAck_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UlogStreamAck_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UlogStreamAck_TypeSupportInterface () {};
                ~UlogStreamAck_TypeSupportInterface () {};
            private:
                UlogStreamAck_TypeSupportInterface (const UlogStreamAck_TypeSupportInterface &);
                UlogStreamAck_TypeSupportInterface & operator = (const UlogStreamAck_TypeSupportInterface &);
            };

            class  UlogStreamAck_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UlogStreamAck_DataWriter_ptr _ptr_type;
                typedef UlogStreamAck_DataWriter_var _var_type;

                static UlogStreamAck_DataWriter_ptr _duplicate (UlogStreamAck_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UlogStreamAck_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UlogStreamAck_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UlogStreamAck_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UlogStreamAck_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UlogStreamAck_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UlogStreamAck_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UlogStreamAck_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UlogStreamAck_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UlogStreamAck_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UlogStreamAck_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UlogStreamAck_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UlogStreamAck_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UlogStreamAck_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UlogStreamAck_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UlogStreamAck_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UlogStreamAck_& instance_data) = 0;

            protected:
                UlogStreamAck_DataWriter () {};
                ~UlogStreamAck_DataWriter () {};
            private:
                UlogStreamAck_DataWriter (const UlogStreamAck_DataWriter &);
                UlogStreamAck_DataWriter & operator = (const UlogStreamAck_DataWriter &);
            };

            class  UlogStreamAck_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UlogStreamAck_DataReader_ptr _ptr_type;
                typedef UlogStreamAck_DataReader_var _var_type;

                static UlogStreamAck_DataReader_ptr _duplicate (UlogStreamAck_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UlogStreamAck_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UlogStreamAck_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UlogStreamAck_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UlogStreamAck_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UlogStreamAck_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UlogStreamAck_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UlogStreamAck_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UlogStreamAck_& instance) = 0;

            protected:
                UlogStreamAck_DataReader () {};
                ~UlogStreamAck_DataReader () {};
            private:
                UlogStreamAck_DataReader (const UlogStreamAck_DataReader &);
                UlogStreamAck_DataReader & operator = (const UlogStreamAck_DataReader &);
            };

            class  UlogStreamAck_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UlogStreamAck_DataReaderView_ptr _ptr_type;
                typedef UlogStreamAck_DataReaderView_var _var_type;

                static UlogStreamAck_DataReaderView_ptr _duplicate (UlogStreamAck_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UlogStreamAck_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UlogStreamAck_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UlogStreamAck_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UlogStreamAck_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UlogStreamAck_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UlogStreamAck_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UlogStreamAck_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UlogStreamAck_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UlogStreamAck_& instance) = 0;

            protected:
                UlogStreamAck_DataReaderView () {};
                ~UlogStreamAck_DataReaderView () {};
            private:
                UlogStreamAck_DataReaderView (const UlogStreamAck_DataReaderView &);
                UlogStreamAck_DataReaderView & operator = (const UlogStreamAck_DataReaderView &);
            };
        }

    }

}

#endif
