#ifndef _H_5F77D1CCE758A615B594EF9AD51F21C1_VehicleAcceleration_DCPS_H_
#define _H_5F77D1CCE758A615B594EF9AD51F21C1_VehicleAcceleration_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleAcceleration_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleAcceleration_TypeSupportInterface;

            typedef VehicleAcceleration_TypeSupportInterface * VehicleAcceleration_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleAcceleration_TypeSupportInterface> VehicleAcceleration_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleAcceleration_TypeSupportInterface> VehicleAcceleration_TypeSupportInterface_out;


            class VehicleAcceleration_DataWriter;

            typedef VehicleAcceleration_DataWriter * VehicleAcceleration_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleAcceleration_DataWriter> VehicleAcceleration_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleAcceleration_DataWriter> VehicleAcceleration_DataWriter_out;


            class VehicleAcceleration_DataReader;

            typedef VehicleAcceleration_DataReader * VehicleAcceleration_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleAcceleration_DataReader> VehicleAcceleration_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleAcceleration_DataReader> VehicleAcceleration_DataReader_out;


            class VehicleAcceleration_DataReaderView;

            typedef VehicleAcceleration_DataReaderView * VehicleAcceleration_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleAcceleration_DataReaderView> VehicleAcceleration_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleAcceleration_DataReaderView> VehicleAcceleration_DataReaderView_out;

            struct VehicleAcceleration_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleAcceleration_, struct VehicleAcceleration_Seq_uniq_> VehicleAcceleration_Seq;
            typedef DDS_DCPSSequence_var < VehicleAcceleration_Seq> VehicleAcceleration_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleAcceleration_Seq> VehicleAcceleration_Seq_out;

            class  VehicleAcceleration_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleAcceleration_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleAcceleration_TypeSupportInterface_var _var_type;

                static VehicleAcceleration_TypeSupportInterface_ptr _duplicate (VehicleAcceleration_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAcceleration_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAcceleration_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAcceleration_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAcceleration_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleAcceleration_TypeSupportInterface () {};
                ~VehicleAcceleration_TypeSupportInterface () {};
            private:
                VehicleAcceleration_TypeSupportInterface (const VehicleAcceleration_TypeSupportInterface &);
                VehicleAcceleration_TypeSupportInterface & operator = (const VehicleAcceleration_TypeSupportInterface &);
            };

            class  VehicleAcceleration_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleAcceleration_DataWriter_ptr _ptr_type;
                typedef VehicleAcceleration_DataWriter_var _var_type;

                static VehicleAcceleration_DataWriter_ptr _duplicate (VehicleAcceleration_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAcceleration_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAcceleration_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAcceleration_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAcceleration_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleAcceleration_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleAcceleration_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleAcceleration_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleAcceleration_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleAcceleration_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleAcceleration_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleAcceleration_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleAcceleration_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleAcceleration_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleAcceleration_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleAcceleration_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAcceleration_& instance_data) = 0;

            protected:
                VehicleAcceleration_DataWriter () {};
                ~VehicleAcceleration_DataWriter () {};
            private:
                VehicleAcceleration_DataWriter (const VehicleAcceleration_DataWriter &);
                VehicleAcceleration_DataWriter & operator = (const VehicleAcceleration_DataWriter &);
            };

            class  VehicleAcceleration_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleAcceleration_DataReader_ptr _ptr_type;
                typedef VehicleAcceleration_DataReader_var _var_type;

                static VehicleAcceleration_DataReader_ptr _duplicate (VehicleAcceleration_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAcceleration_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAcceleration_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAcceleration_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAcceleration_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAcceleration_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAcceleration_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAcceleration_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAcceleration_& instance) = 0;

            protected:
                VehicleAcceleration_DataReader () {};
                ~VehicleAcceleration_DataReader () {};
            private:
                VehicleAcceleration_DataReader (const VehicleAcceleration_DataReader &);
                VehicleAcceleration_DataReader & operator = (const VehicleAcceleration_DataReader &);
            };

            class  VehicleAcceleration_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleAcceleration_DataReaderView_ptr _ptr_type;
                typedef VehicleAcceleration_DataReaderView_var _var_type;

                static VehicleAcceleration_DataReaderView_ptr _duplicate (VehicleAcceleration_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAcceleration_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAcceleration_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAcceleration_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAcceleration_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAcceleration_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAcceleration_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAcceleration_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAcceleration_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAcceleration_& instance) = 0;

            protected:
                VehicleAcceleration_DataReaderView () {};
                ~VehicleAcceleration_DataReaderView () {};
            private:
                VehicleAcceleration_DataReaderView (const VehicleAcceleration_DataReaderView &);
                VehicleAcceleration_DataReaderView & operator = (const VehicleAcceleration_DataReaderView &);
            };
        }

    }

}

#endif
