#ifndef _H_9F387E2424DE440F29DE84CA44E79960_VehicleAngularVelocityGroundtruth_DCPS_H_
#define _H_9F387E2424DE440F29DE84CA44E79960_VehicleAngularVelocityGroundtruth_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleAngularVelocityGroundtruth_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleAngularVelocityGroundtruth_TypeSupportInterface;

            typedef VehicleAngularVelocityGroundtruth_TypeSupportInterface * VehicleAngularVelocityGroundtruth_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleAngularVelocityGroundtruth_TypeSupportInterface> VehicleAngularVelocityGroundtruth_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleAngularVelocityGroundtruth_TypeSupportInterface> VehicleAngularVelocityGroundtruth_TypeSupportInterface_out;


            class VehicleAngularVelocityGroundtruth_DataWriter;

            typedef VehicleAngularVelocityGroundtruth_DataWriter * VehicleAngularVelocityGroundtruth_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleAngularVelocityGroundtruth_DataWriter> VehicleAngularVelocityGroundtruth_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleAngularVelocityGroundtruth_DataWriter> VehicleAngularVelocityGroundtruth_DataWriter_out;


            class VehicleAngularVelocityGroundtruth_DataReader;

            typedef VehicleAngularVelocityGroundtruth_DataReader * VehicleAngularVelocityGroundtruth_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleAngularVelocityGroundtruth_DataReader> VehicleAngularVelocityGroundtruth_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleAngularVelocityGroundtruth_DataReader> VehicleAngularVelocityGroundtruth_DataReader_out;


            class VehicleAngularVelocityGroundtruth_DataReaderView;

            typedef VehicleAngularVelocityGroundtruth_DataReaderView * VehicleAngularVelocityGroundtruth_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleAngularVelocityGroundtruth_DataReaderView> VehicleAngularVelocityGroundtruth_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleAngularVelocityGroundtruth_DataReaderView> VehicleAngularVelocityGroundtruth_DataReaderView_out;

            struct VehicleAngularVelocityGroundtruth_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleAngularVelocityGroundtruth_, struct VehicleAngularVelocityGroundtruth_Seq_uniq_> VehicleAngularVelocityGroundtruth_Seq;
            typedef DDS_DCPSSequence_var < VehicleAngularVelocityGroundtruth_Seq> VehicleAngularVelocityGroundtruth_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleAngularVelocityGroundtruth_Seq> VehicleAngularVelocityGroundtruth_Seq_out;

            class  VehicleAngularVelocityGroundtruth_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleAngularVelocityGroundtruth_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleAngularVelocityGroundtruth_TypeSupportInterface_var _var_type;

                static VehicleAngularVelocityGroundtruth_TypeSupportInterface_ptr _duplicate (VehicleAngularVelocityGroundtruth_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAngularVelocityGroundtruth_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocityGroundtruth_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocityGroundtruth_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAngularVelocityGroundtruth_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleAngularVelocityGroundtruth_TypeSupportInterface () {};
                ~VehicleAngularVelocityGroundtruth_TypeSupportInterface () {};
            private:
                VehicleAngularVelocityGroundtruth_TypeSupportInterface (const VehicleAngularVelocityGroundtruth_TypeSupportInterface &);
                VehicleAngularVelocityGroundtruth_TypeSupportInterface & operator = (const VehicleAngularVelocityGroundtruth_TypeSupportInterface &);
            };

            class  VehicleAngularVelocityGroundtruth_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleAngularVelocityGroundtruth_DataWriter_ptr _ptr_type;
                typedef VehicleAngularVelocityGroundtruth_DataWriter_var _var_type;

                static VehicleAngularVelocityGroundtruth_DataWriter_ptr _duplicate (VehicleAngularVelocityGroundtruth_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAngularVelocityGroundtruth_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocityGroundtruth_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocityGroundtruth_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAngularVelocityGroundtruth_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleAngularVelocityGroundtruth_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleAngularVelocityGroundtruth_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleAngularVelocityGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleAngularVelocityGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleAngularVelocityGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleAngularVelocityGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleAngularVelocityGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleAngularVelocityGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleAngularVelocityGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleAngularVelocityGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleAngularVelocityGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAngularVelocityGroundtruth_& instance_data) = 0;

            protected:
                VehicleAngularVelocityGroundtruth_DataWriter () {};
                ~VehicleAngularVelocityGroundtruth_DataWriter () {};
            private:
                VehicleAngularVelocityGroundtruth_DataWriter (const VehicleAngularVelocityGroundtruth_DataWriter &);
                VehicleAngularVelocityGroundtruth_DataWriter & operator = (const VehicleAngularVelocityGroundtruth_DataWriter &);
            };

            class  VehicleAngularVelocityGroundtruth_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleAngularVelocityGroundtruth_DataReader_ptr _ptr_type;
                typedef VehicleAngularVelocityGroundtruth_DataReader_var _var_type;

                static VehicleAngularVelocityGroundtruth_DataReader_ptr _duplicate (VehicleAngularVelocityGroundtruth_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAngularVelocityGroundtruth_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocityGroundtruth_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocityGroundtruth_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAngularVelocityGroundtruth_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAngularVelocityGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAngularVelocityGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAngularVelocityGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAngularVelocityGroundtruth_& instance) = 0;

            protected:
                VehicleAngularVelocityGroundtruth_DataReader () {};
                ~VehicleAngularVelocityGroundtruth_DataReader () {};
            private:
                VehicleAngularVelocityGroundtruth_DataReader (const VehicleAngularVelocityGroundtruth_DataReader &);
                VehicleAngularVelocityGroundtruth_DataReader & operator = (const VehicleAngularVelocityGroundtruth_DataReader &);
            };

            class  VehicleAngularVelocityGroundtruth_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleAngularVelocityGroundtruth_DataReaderView_ptr _ptr_type;
                typedef VehicleAngularVelocityGroundtruth_DataReaderView_var _var_type;

                static VehicleAngularVelocityGroundtruth_DataReaderView_ptr _duplicate (VehicleAngularVelocityGroundtruth_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAngularVelocityGroundtruth_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocityGroundtruth_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocityGroundtruth_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAngularVelocityGroundtruth_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAngularVelocityGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAngularVelocityGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAngularVelocityGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAngularVelocityGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAngularVelocityGroundtruth_& instance) = 0;

            protected:
                VehicleAngularVelocityGroundtruth_DataReaderView () {};
                ~VehicleAngularVelocityGroundtruth_DataReaderView () {};
            private:
                VehicleAngularVelocityGroundtruth_DataReaderView (const VehicleAngularVelocityGroundtruth_DataReaderView &);
                VehicleAngularVelocityGroundtruth_DataReaderView & operator = (const VehicleAngularVelocityGroundtruth_DataReaderView &);
            };
        }

    }

}

#endif
