#ifndef _H_39A1E5629D52EB3658B556DB40EC2D6C_VehicleAngularVelocity_DCPS_H_
#define _H_39A1E5629D52EB3658B556DB40EC2D6C_VehicleAngularVelocity_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleAngularVelocity_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleAngularVelocity_TypeSupportInterface;

            typedef VehicleAngularVelocity_TypeSupportInterface * VehicleAngularVelocity_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleAngularVelocity_TypeSupportInterface> VehicleAngularVelocity_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleAngularVelocity_TypeSupportInterface> VehicleAngularVelocity_TypeSupportInterface_out;


            class VehicleAngularVelocity_DataWriter;

            typedef VehicleAngularVelocity_DataWriter * VehicleAngularVelocity_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleAngularVelocity_DataWriter> VehicleAngularVelocity_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleAngularVelocity_DataWriter> VehicleAngularVelocity_DataWriter_out;


            class VehicleAngularVelocity_DataReader;

            typedef VehicleAngularVelocity_DataReader * VehicleAngularVelocity_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleAngularVelocity_DataReader> VehicleAngularVelocity_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleAngularVelocity_DataReader> VehicleAngularVelocity_DataReader_out;


            class VehicleAngularVelocity_DataReaderView;

            typedef VehicleAngularVelocity_DataReaderView * VehicleAngularVelocity_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleAngularVelocity_DataReaderView> VehicleAngularVelocity_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleAngularVelocity_DataReaderView> VehicleAngularVelocity_DataReaderView_out;

            struct VehicleAngularVelocity_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleAngularVelocity_, struct VehicleAngularVelocity_Seq_uniq_> VehicleAngularVelocity_Seq;
            typedef DDS_DCPSSequence_var < VehicleAngularVelocity_Seq> VehicleAngularVelocity_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleAngularVelocity_Seq> VehicleAngularVelocity_Seq_out;

            class  VehicleAngularVelocity_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleAngularVelocity_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleAngularVelocity_TypeSupportInterface_var _var_type;

                static VehicleAngularVelocity_TypeSupportInterface_ptr _duplicate (VehicleAngularVelocity_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAngularVelocity_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocity_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocity_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAngularVelocity_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleAngularVelocity_TypeSupportInterface () {};
                ~VehicleAngularVelocity_TypeSupportInterface () {};
            private:
                VehicleAngularVelocity_TypeSupportInterface (const VehicleAngularVelocity_TypeSupportInterface &);
                VehicleAngularVelocity_TypeSupportInterface & operator = (const VehicleAngularVelocity_TypeSupportInterface &);
            };

            class  VehicleAngularVelocity_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleAngularVelocity_DataWriter_ptr _ptr_type;
                typedef VehicleAngularVelocity_DataWriter_var _var_type;

                static VehicleAngularVelocity_DataWriter_ptr _duplicate (VehicleAngularVelocity_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAngularVelocity_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocity_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocity_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAngularVelocity_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleAngularVelocity_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleAngularVelocity_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleAngularVelocity_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleAngularVelocity_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleAngularVelocity_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleAngularVelocity_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleAngularVelocity_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleAngularVelocity_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleAngularVelocity_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleAngularVelocity_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleAngularVelocity_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAngularVelocity_& instance_data) = 0;

            protected:
                VehicleAngularVelocity_DataWriter () {};
                ~VehicleAngularVelocity_DataWriter () {};
            private:
                VehicleAngularVelocity_DataWriter (const VehicleAngularVelocity_DataWriter &);
                VehicleAngularVelocity_DataWriter & operator = (const VehicleAngularVelocity_DataWriter &);
            };

            class  VehicleAngularVelocity_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleAngularVelocity_DataReader_ptr _ptr_type;
                typedef VehicleAngularVelocity_DataReader_var _var_type;

                static VehicleAngularVelocity_DataReader_ptr _duplicate (VehicleAngularVelocity_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAngularVelocity_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocity_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocity_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAngularVelocity_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAngularVelocity_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAngularVelocity_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAngularVelocity_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAngularVelocity_& instance) = 0;

            protected:
                VehicleAngularVelocity_DataReader () {};
                ~VehicleAngularVelocity_DataReader () {};
            private:
                VehicleAngularVelocity_DataReader (const VehicleAngularVelocity_DataReader &);
                VehicleAngularVelocity_DataReader & operator = (const VehicleAngularVelocity_DataReader &);
            };

            class  VehicleAngularVelocity_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleAngularVelocity_DataReaderView_ptr _ptr_type;
                typedef VehicleAngularVelocity_DataReaderView_var _var_type;

                static VehicleAngularVelocity_DataReaderView_ptr _duplicate (VehicleAngularVelocity_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAngularVelocity_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocity_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAngularVelocity_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAngularVelocity_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAngularVelocity_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAngularVelocity_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAngularVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAngularVelocity_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAngularVelocity_& instance) = 0;

            protected:
                VehicleAngularVelocity_DataReaderView () {};
                ~VehicleAngularVelocity_DataReaderView () {};
            private:
                VehicleAngularVelocity_DataReaderView (const VehicleAngularVelocity_DataReaderView &);
                VehicleAngularVelocity_DataReaderView & operator = (const VehicleAngularVelocity_DataReaderView &);
            };
        }

    }

}

#endif
