#ifndef _H_0D6A74E2704A23C3BFD06B9969AACD61_VehicleCommandAck__H_
#define _H_0D6A74E2704A23C3BFD06B9969AACD61_VehicleCommandAck__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace VehicleCommandAck_Constants
            {
                const ::DDS::Octet VEHICLE_RESULT_ACCEPTED_ = 0;

                const ::DDS::Octet VEHICLE_RESULT_TEMPORARILY_REJECTED_ = 1;

                const ::DDS::Octet VEHICLE_RESULT_DENIED_ = 2;

                const ::DDS::Octet VEHICLE_RESULT_UNSUPPORTED_ = 3;

                const ::DDS::Octet VEHICLE_RESULT_FAILED_ = 4;

                const ::DDS::Octet VEHICLE_RESULT_IN_PROGRESS_ = 5;

                const ::DDS::UShort ARM_AUTH_DENIED_REASON_GENERIC_ = 0U;

                const ::DDS::UShort ARM_AUTH_DENIED_REASON_NONE_ = 1U;

                const ::DDS::UShort ARM_AUTH_DENIED_REASON_INVALID_WAYPOINT_ = 2U;

                const ::DDS::UShort ARM_AUTH_DENIED_REASON_TIMEOUT_ = 3U;

                const ::DDS::UShort ARM_AUTH_DENIED_REASON_AIRSPACE_IN_USE_ = 4U;

                const ::DDS::UShort ARM_AUTH_DENIED_REASON_BAD_WEATHER_ = 5U;

                const ::DDS::Octet ORB_QUEUE_LENGTH_ = 3;

            }

            struct  VehicleCommandAck_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::UShort command_;
                ::DDS::Octet result_;
                ::DDS::Boolean from_external_;
                ::DDS::Octet result_param1_;
                ::DDS::Long result_param2_;
                ::DDS::Octet target_system_;
                ::DDS::Octet target_component_;
            };

            typedef DDS_DCPSStruct_var<VehicleCommandAck_> VehicleCommandAck__var;
            typedef VehicleCommandAck_& VehicleCommandAck__out;

        }

    }

}

#endif /* _H_0D6A74E2704A23C3BFD06B9969AACD61_VehicleCommandAck__H_ */
