#ifndef _H_08D7877141F3C6D05A2D42E8B514DDF1_VehicleCommand_DCPS_H_
#define _H_08D7877141F3C6D05A2D42E8B514DDF1_VehicleCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleCommand_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleCommand_TypeSupportInterface;

            typedef VehicleCommand_TypeSupportInterface * VehicleCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleCommand_TypeSupportInterface> VehicleCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleCommand_TypeSupportInterface> VehicleCommand_TypeSupportInterface_out;


            class VehicleCommand_DataWriter;

            typedef VehicleCommand_DataWriter * VehicleCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleCommand_DataWriter> VehicleCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleCommand_DataWriter> VehicleCommand_DataWriter_out;


            class VehicleCommand_DataReader;

            typedef VehicleCommand_DataReader * VehicleCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleCommand_DataReader> VehicleCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleCommand_DataReader> VehicleCommand_DataReader_out;


            class VehicleCommand_DataReaderView;

            typedef VehicleCommand_DataReaderView * VehicleCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleCommand_DataReaderView> VehicleCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleCommand_DataReaderView> VehicleCommand_DataReaderView_out;

            struct VehicleCommand_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleCommand_, struct VehicleCommand_Seq_uniq_> VehicleCommand_Seq;
            typedef DDS_DCPSSequence_var < VehicleCommand_Seq> VehicleCommand_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleCommand_Seq> VehicleCommand_Seq_out;

            class  VehicleCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleCommand_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleCommand_TypeSupportInterface_var _var_type;

                static VehicleCommand_TypeSupportInterface_ptr _duplicate (VehicleCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleCommand_TypeSupportInterface () {};
                ~VehicleCommand_TypeSupportInterface () {};
            private:
                VehicleCommand_TypeSupportInterface (const VehicleCommand_TypeSupportInterface &);
                VehicleCommand_TypeSupportInterface & operator = (const VehicleCommand_TypeSupportInterface &);
            };

            class  VehicleCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleCommand_DataWriter_ptr _ptr_type;
                typedef VehicleCommand_DataWriter_var _var_type;

                static VehicleCommand_DataWriter_ptr _duplicate (VehicleCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleCommand_& instance_data) = 0;

            protected:
                VehicleCommand_DataWriter () {};
                ~VehicleCommand_DataWriter () {};
            private:
                VehicleCommand_DataWriter (const VehicleCommand_DataWriter &);
                VehicleCommand_DataWriter & operator = (const VehicleCommand_DataWriter &);
            };

            class  VehicleCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleCommand_DataReader_ptr _ptr_type;
                typedef VehicleCommand_DataReader_var _var_type;

                static VehicleCommand_DataReader_ptr _duplicate (VehicleCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleCommand_& instance) = 0;

            protected:
                VehicleCommand_DataReader () {};
                ~VehicleCommand_DataReader () {};
            private:
                VehicleCommand_DataReader (const VehicleCommand_DataReader &);
                VehicleCommand_DataReader & operator = (const VehicleCommand_DataReader &);
            };

            class  VehicleCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleCommand_DataReaderView_ptr _ptr_type;
                typedef VehicleCommand_DataReaderView_var _var_type;

                static VehicleCommand_DataReaderView_ptr _duplicate (VehicleCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleCommand_& instance) = 0;

            protected:
                VehicleCommand_DataReaderView () {};
                ~VehicleCommand_DataReaderView () {};
            private:
                VehicleCommand_DataReaderView (const VehicleCommand_DataReaderView &);
                VehicleCommand_DataReaderView & operator = (const VehicleCommand_DataReaderView &);
            };
        }

    }

}

#endif
