#ifndef _H_55F039F3DD10D21A8B8681CEADB28A8A_VehicleConstraints__H_
#define _H_55F039F3DD10D21A8B8681CEADB28A8A_VehicleConstraints__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleConstraints_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Float yawspeed_;
                ::DDS::Float speed_xy_;
                ::DDS::Float speed_up_;
                ::DDS::Float speed_down_;
                ::DDS::Float tilt_;
                ::DDS::Float min_distance_to_ground_;
                ::DDS::Float max_distance_to_ground_;
                ::DDS::Boolean want_takeoff_;
            };

            typedef DDS_DCPSStruct_var<VehicleConstraints_> VehicleConstraints__var;
            typedef VehicleConstraints_& VehicleConstraints__out;

        }

    }

}

#endif /* _H_55F039F3DD10D21A8B8681CEADB28A8A_VehicleConstraints__H_ */
