#ifndef _H_6C6372090655E7CED94C31E026639042_VehicleGlobalPosition_DCPS_H_
#define _H_6C6372090655E7CED94C31E026639042_VehicleGlobalPosition_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleGlobalPosition_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleGlobalPosition_TypeSupportInterface;

            typedef VehicleGlobalPosition_TypeSupportInterface * VehicleGlobalPosition_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleGlobalPosition_TypeSupportInterface> VehicleGlobalPosition_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleGlobalPosition_TypeSupportInterface> VehicleGlobalPosition_TypeSupportInterface_out;


            class VehicleGlobalPosition_DataWriter;

            typedef VehicleGlobalPosition_DataWriter * VehicleGlobalPosition_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleGlobalPosition_DataWriter> VehicleGlobalPosition_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleGlobalPosition_DataWriter> VehicleGlobalPosition_DataWriter_out;


            class VehicleGlobalPosition_DataReader;

            typedef VehicleGlobalPosition_DataReader * VehicleGlobalPosition_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleGlobalPosition_DataReader> VehicleGlobalPosition_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleGlobalPosition_DataReader> VehicleGlobalPosition_DataReader_out;


            class VehicleGlobalPosition_DataReaderView;

            typedef VehicleGlobalPosition_DataReaderView * VehicleGlobalPosition_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleGlobalPosition_DataReaderView> VehicleGlobalPosition_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleGlobalPosition_DataReaderView> VehicleGlobalPosition_DataReaderView_out;

            struct VehicleGlobalPosition_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleGlobalPosition_, struct VehicleGlobalPosition_Seq_uniq_> VehicleGlobalPosition_Seq;
            typedef DDS_DCPSSequence_var < VehicleGlobalPosition_Seq> VehicleGlobalPosition_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleGlobalPosition_Seq> VehicleGlobalPosition_Seq_out;

            class  VehicleGlobalPosition_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleGlobalPosition_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleGlobalPosition_TypeSupportInterface_var _var_type;

                static VehicleGlobalPosition_TypeSupportInterface_ptr _duplicate (VehicleGlobalPosition_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGlobalPosition_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGlobalPosition_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGlobalPosition_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGlobalPosition_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleGlobalPosition_TypeSupportInterface () {};
                ~VehicleGlobalPosition_TypeSupportInterface () {};
            private:
                VehicleGlobalPosition_TypeSupportInterface (const VehicleGlobalPosition_TypeSupportInterface &);
                VehicleGlobalPosition_TypeSupportInterface & operator = (const VehicleGlobalPosition_TypeSupportInterface &);
            };

            class  VehicleGlobalPosition_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleGlobalPosition_DataWriter_ptr _ptr_type;
                typedef VehicleGlobalPosition_DataWriter_var _var_type;

                static VehicleGlobalPosition_DataWriter_ptr _duplicate (VehicleGlobalPosition_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGlobalPosition_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGlobalPosition_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGlobalPosition_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGlobalPosition_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleGlobalPosition_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleGlobalPosition_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleGlobalPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleGlobalPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleGlobalPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleGlobalPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleGlobalPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleGlobalPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleGlobalPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleGlobalPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleGlobalPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGlobalPosition_& instance_data) = 0;

            protected:
                VehicleGlobalPosition_DataWriter () {};
                ~VehicleGlobalPosition_DataWriter () {};
            private:
                VehicleGlobalPosition_DataWriter (const VehicleGlobalPosition_DataWriter &);
                VehicleGlobalPosition_DataWriter & operator = (const VehicleGlobalPosition_DataWriter &);
            };

            class  VehicleGlobalPosition_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleGlobalPosition_DataReader_ptr _ptr_type;
                typedef VehicleGlobalPosition_DataReader_var _var_type;

                static VehicleGlobalPosition_DataReader_ptr _duplicate (VehicleGlobalPosition_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGlobalPosition_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGlobalPosition_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGlobalPosition_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGlobalPosition_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleGlobalPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleGlobalPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleGlobalPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGlobalPosition_& instance) = 0;

            protected:
                VehicleGlobalPosition_DataReader () {};
                ~VehicleGlobalPosition_DataReader () {};
            private:
                VehicleGlobalPosition_DataReader (const VehicleGlobalPosition_DataReader &);
                VehicleGlobalPosition_DataReader & operator = (const VehicleGlobalPosition_DataReader &);
            };

            class  VehicleGlobalPosition_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleGlobalPosition_DataReaderView_ptr _ptr_type;
                typedef VehicleGlobalPosition_DataReaderView_var _var_type;

                static VehicleGlobalPosition_DataReaderView_ptr _duplicate (VehicleGlobalPosition_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGlobalPosition_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGlobalPosition_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGlobalPosition_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGlobalPosition_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleGlobalPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleGlobalPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleGlobalPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleGlobalPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGlobalPosition_& instance) = 0;

            protected:
                VehicleGlobalPosition_DataReaderView () {};
                ~VehicleGlobalPosition_DataReaderView () {};
            private:
                VehicleGlobalPosition_DataReaderView (const VehicleGlobalPosition_DataReaderView &);
                VehicleGlobalPosition_DataReaderView & operator = (const VehicleGlobalPosition_DataReaderView &);
            };
        }

    }

}

#endif
