#ifndef _H_52A8ADF71669655F95956FDBDCDDFE57_VehicleGpsPosition__H_
#define _H_52A8ADF71669655F95956FDBDCDDFE57_VehicleGpsPosition__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleGpsPosition_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Long lat_;
                ::DDS::Long lon_;
                ::DDS::Long alt_;
                ::DDS::Long alt_ellipsoid_;
                ::DDS::Float s_variance_m_s_;
                ::DDS::Float c_variance_rad_;
                ::DDS::Octet fix_type_;
                ::DDS::Float eph_;
                ::DDS::Float epv_;
                ::DDS::Float hdop_;
                ::DDS::Float vdop_;
                ::DDS::Long noise_per_ms_;
                ::DDS::Long jamming_indicator_;
                ::DDS::Float vel_m_s_;
                ::DDS::Float vel_n_m_s_;
                ::DDS::Float vel_e_m_s_;
                ::DDS::Float vel_d_m_s_;
                ::DDS::Float cog_rad_;
                ::DDS::Boolean vel_ned_valid_;
                ::DDS::Long timestamp_time_relative_;
                ::DDS::ULongLong time_utc_usec_;
                ::DDS::Octet satellites_used_;
                ::DDS::Float heading_;
                ::DDS::Float heading_offset_;
            };

            typedef DDS_DCPSStruct_var<VehicleGpsPosition_> VehicleGpsPosition__var;
            typedef VehicleGpsPosition_& VehicleGpsPosition__out;

        }

    }

}

#endif /* _H_52A8ADF71669655F95956FDBDCDDFE57_VehicleGpsPosition__H_ */
