#ifndef _H_70D138EF2B3370BBF0E26A3917EA8C1E_VehicleLandDetected_DCPS_H_
#define _H_70D138EF2B3370BBF0E26A3917EA8C1E_VehicleLandDetected_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleLandDetected_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleLandDetected_TypeSupportInterface;

            typedef VehicleLandDetected_TypeSupportInterface * VehicleLandDetected_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleLandDetected_TypeSupportInterface> VehicleLandDetected_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleLandDetected_TypeSupportInterface> VehicleLandDetected_TypeSupportInterface_out;


            class VehicleLandDetected_DataWriter;

            typedef VehicleLandDetected_DataWriter * VehicleLandDetected_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleLandDetected_DataWriter> VehicleLandDetected_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleLandDetected_DataWriter> VehicleLandDetected_DataWriter_out;


            class VehicleLandDetected_DataReader;

            typedef VehicleLandDetected_DataReader * VehicleLandDetected_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleLandDetected_DataReader> VehicleLandDetected_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleLandDetected_DataReader> VehicleLandDetected_DataReader_out;


            class VehicleLandDetected_DataReaderView;

            typedef VehicleLandDetected_DataReaderView * VehicleLandDetected_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleLandDetected_DataReaderView> VehicleLandDetected_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleLandDetected_DataReaderView> VehicleLandDetected_DataReaderView_out;

            struct VehicleLandDetected_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleLandDetected_, struct VehicleLandDetected_Seq_uniq_> VehicleLandDetected_Seq;
            typedef DDS_DCPSSequence_var < VehicleLandDetected_Seq> VehicleLandDetected_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleLandDetected_Seq> VehicleLandDetected_Seq_out;

            class  VehicleLandDetected_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleLandDetected_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleLandDetected_TypeSupportInterface_var _var_type;

                static VehicleLandDetected_TypeSupportInterface_ptr _duplicate (VehicleLandDetected_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLandDetected_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLandDetected_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLandDetected_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLandDetected_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleLandDetected_TypeSupportInterface () {};
                ~VehicleLandDetected_TypeSupportInterface () {};
            private:
                VehicleLandDetected_TypeSupportInterface (const VehicleLandDetected_TypeSupportInterface &);
                VehicleLandDetected_TypeSupportInterface & operator = (const VehicleLandDetected_TypeSupportInterface &);
            };

            class  VehicleLandDetected_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleLandDetected_DataWriter_ptr _ptr_type;
                typedef VehicleLandDetected_DataWriter_var _var_type;

                static VehicleLandDetected_DataWriter_ptr _duplicate (VehicleLandDetected_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLandDetected_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLandDetected_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLandDetected_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLandDetected_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleLandDetected_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleLandDetected_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleLandDetected_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleLandDetected_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleLandDetected_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleLandDetected_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleLandDetected_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleLandDetected_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleLandDetected_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleLandDetected_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleLandDetected_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLandDetected_& instance_data) = 0;

            protected:
                VehicleLandDetected_DataWriter () {};
                ~VehicleLandDetected_DataWriter () {};
            private:
                VehicleLandDetected_DataWriter (const VehicleLandDetected_DataWriter &);
                VehicleLandDetected_DataWriter & operator = (const VehicleLandDetected_DataWriter &);
            };

            class  VehicleLandDetected_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleLandDetected_DataReader_ptr _ptr_type;
                typedef VehicleLandDetected_DataReader_var _var_type;

                static VehicleLandDetected_DataReader_ptr _duplicate (VehicleLandDetected_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLandDetected_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLandDetected_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLandDetected_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLandDetected_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleLandDetected_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleLandDetected_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleLandDetected_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLandDetected_& instance) = 0;

            protected:
                VehicleLandDetected_DataReader () {};
                ~VehicleLandDetected_DataReader () {};
            private:
                VehicleLandDetected_DataReader (const VehicleLandDetected_DataReader &);
                VehicleLandDetected_DataReader & operator = (const VehicleLandDetected_DataReader &);
            };

            class  VehicleLandDetected_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleLandDetected_DataReaderView_ptr _ptr_type;
                typedef VehicleLandDetected_DataReaderView_var _var_type;

                static VehicleLandDetected_DataReaderView_ptr _duplicate (VehicleLandDetected_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLandDetected_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLandDetected_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLandDetected_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLandDetected_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleLandDetected_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleLandDetected_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleLandDetected_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleLandDetected_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLandDetected_& instance) = 0;

            protected:
                VehicleLandDetected_DataReaderView () {};
                ~VehicleLandDetected_DataReaderView () {};
            private:
                VehicleLandDetected_DataReaderView (const VehicleLandDetected_DataReaderView &);
                VehicleLandDetected_DataReaderView & operator = (const VehicleLandDetected_DataReaderView &);
            };
        }

    }

}

#endif
