#ifndef _H_DE4688BFD780F47DFE9EB117A01E6DC2_VehicleLocalPositionGroundtruth__H_
#define _H_DE4688BFD780F47DFE9EB117A01E6DC2_VehicleLocalPositionGroundtruth__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleLocalPositionGroundtruth_
            {
                struct _delta_xy__uniq_{};
                typedef ::DDS::Float _delta_xy__slice;
                typedef ::DDS::Float _delta_xy_[2];
                typedef DDS_DCPS_FArray_var< _delta_xy_, _delta_xy__slice, struct _delta_xy__uniq_ > _delta_xy__var;
                typedef _delta_xy_ _delta_xy__out;
                typedef DDS_DCPS_Array_forany< _delta_xy_, _delta_xy__slice, struct _delta_xy__uniq_ > _delta_xy__forany;
                static _delta_xy__slice *_delta_xy__alloc();
                static void _delta_xy__free(_delta_xy__slice *);
                static void _delta_xy__copy(_delta_xy__slice *to, const _delta_xy__slice *from);
                static _delta_xy__slice *_delta_xy__dup(const _delta_xy__slice *from);
                struct _delta_vxy__uniq_{};
                typedef ::DDS::Float _delta_vxy__slice;
                typedef ::DDS::Float _delta_vxy_[2];
                typedef DDS_DCPS_FArray_var< _delta_vxy_, _delta_vxy__slice, struct _delta_vxy__uniq_ > _delta_vxy__var;
                typedef _delta_vxy_ _delta_vxy__out;
                typedef DDS_DCPS_Array_forany< _delta_vxy_, _delta_vxy__slice, struct _delta_vxy__uniq_ > _delta_vxy__forany;
                static _delta_vxy__slice *_delta_vxy__alloc();
                static void _delta_vxy__free(_delta_vxy__slice *);
                static void _delta_vxy__copy(_delta_vxy__slice *to, const _delta_vxy__slice *from);
                static _delta_vxy__slice *_delta_vxy__dup(const _delta_vxy__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::Boolean xy_valid_;
                ::DDS::Boolean z_valid_;
                ::DDS::Boolean v_xy_valid_;
                ::DDS::Boolean v_z_valid_;
                ::DDS::Float x_;
                ::DDS::Float y_;
                ::DDS::Float z_;
                _delta_xy_ delta_xy_;
                ::DDS::Octet xy_reset_counter_;
                ::DDS::Float delta_z_;
                ::DDS::Octet z_reset_counter_;
                ::DDS::Float vx_;
                ::DDS::Float vy_;
                ::DDS::Float vz_;
                ::DDS::Float z_deriv_;
                _delta_vxy_ delta_vxy_;
                ::DDS::Octet vxy_reset_counter_;
                ::DDS::Float delta_vz_;
                ::DDS::Octet vz_reset_counter_;
                ::DDS::Float ax_;
                ::DDS::Float ay_;
                ::DDS::Float az_;
                ::DDS::Float yaw_;
                ::DDS::Boolean xy_global_;
                ::DDS::Boolean z_global_;
                ::DDS::ULongLong ref_timestamp_;
                ::DDS::Double ref_lat_;
                ::DDS::Double ref_lon_;
                ::DDS::Float ref_alt_;
                ::DDS::Float dist_bottom_;
                ::DDS::Float dist_bottom_rate_;
                ::DDS::Boolean dist_bottom_valid_;
                ::DDS::Float eph_;
                ::DDS::Float epv_;
                ::DDS::Float evh_;
                ::DDS::Float evv_;
                ::DDS::Float vxy_max_;
                ::DDS::Float vz_max_;
                ::DDS::Float hagl_min_;
                ::DDS::Float hagl_max_;
            };

            typedef DDS_DCPSStruct_var<VehicleLocalPositionGroundtruth_> VehicleLocalPositionGroundtruth__var;
            typedef VehicleLocalPositionGroundtruth_& VehicleLocalPositionGroundtruth__out;

        }

    }

}

#endif /* _H_DE4688BFD780F47DFE9EB117A01E6DC2_VehicleLocalPositionGroundtruth__H_ */
