#ifndef _H_395BCB6720A13D6EE76B9C74F10A766A_VehicleLocalPositionSetpoint_DCPS_H_
#define _H_395BCB6720A13D6EE76B9C74F10A766A_VehicleLocalPositionSetpoint_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleLocalPositionSetpoint_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleLocalPositionSetpoint_TypeSupportInterface;

            typedef VehicleLocalPositionSetpoint_TypeSupportInterface * VehicleLocalPositionSetpoint_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleLocalPositionSetpoint_TypeSupportInterface> VehicleLocalPositionSetpoint_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleLocalPositionSetpoint_TypeSupportInterface> VehicleLocalPositionSetpoint_TypeSupportInterface_out;


            class VehicleLocalPositionSetpoint_DataWriter;

            typedef VehicleLocalPositionSetpoint_DataWriter * VehicleLocalPositionSetpoint_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleLocalPositionSetpoint_DataWriter> VehicleLocalPositionSetpoint_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleLocalPositionSetpoint_DataWriter> VehicleLocalPositionSetpoint_DataWriter_out;


            class VehicleLocalPositionSetpoint_DataReader;

            typedef VehicleLocalPositionSetpoint_DataReader * VehicleLocalPositionSetpoint_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleLocalPositionSetpoint_DataReader> VehicleLocalPositionSetpoint_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleLocalPositionSetpoint_DataReader> VehicleLocalPositionSetpoint_DataReader_out;


            class VehicleLocalPositionSetpoint_DataReaderView;

            typedef VehicleLocalPositionSetpoint_DataReaderView * VehicleLocalPositionSetpoint_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleLocalPositionSetpoint_DataReaderView> VehicleLocalPositionSetpoint_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleLocalPositionSetpoint_DataReaderView> VehicleLocalPositionSetpoint_DataReaderView_out;

            struct VehicleLocalPositionSetpoint_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleLocalPositionSetpoint_, struct VehicleLocalPositionSetpoint_Seq_uniq_> VehicleLocalPositionSetpoint_Seq;
            typedef DDS_DCPSSequence_var < VehicleLocalPositionSetpoint_Seq> VehicleLocalPositionSetpoint_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleLocalPositionSetpoint_Seq> VehicleLocalPositionSetpoint_Seq_out;

            class  VehicleLocalPositionSetpoint_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleLocalPositionSetpoint_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleLocalPositionSetpoint_TypeSupportInterface_var _var_type;

                static VehicleLocalPositionSetpoint_TypeSupportInterface_ptr _duplicate (VehicleLocalPositionSetpoint_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLocalPositionSetpoint_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionSetpoint_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionSetpoint_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLocalPositionSetpoint_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleLocalPositionSetpoint_TypeSupportInterface () {};
                ~VehicleLocalPositionSetpoint_TypeSupportInterface () {};
            private:
                VehicleLocalPositionSetpoint_TypeSupportInterface (const VehicleLocalPositionSetpoint_TypeSupportInterface &);
                VehicleLocalPositionSetpoint_TypeSupportInterface & operator = (const VehicleLocalPositionSetpoint_TypeSupportInterface &);
            };

            class  VehicleLocalPositionSetpoint_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleLocalPositionSetpoint_DataWriter_ptr _ptr_type;
                typedef VehicleLocalPositionSetpoint_DataWriter_var _var_type;

                static VehicleLocalPositionSetpoint_DataWriter_ptr _duplicate (VehicleLocalPositionSetpoint_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLocalPositionSetpoint_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionSetpoint_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionSetpoint_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLocalPositionSetpoint_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleLocalPositionSetpoint_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleLocalPositionSetpoint_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleLocalPositionSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleLocalPositionSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleLocalPositionSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleLocalPositionSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleLocalPositionSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleLocalPositionSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleLocalPositionSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleLocalPositionSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleLocalPositionSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLocalPositionSetpoint_& instance_data) = 0;

            protected:
                VehicleLocalPositionSetpoint_DataWriter () {};
                ~VehicleLocalPositionSetpoint_DataWriter () {};
            private:
                VehicleLocalPositionSetpoint_DataWriter (const VehicleLocalPositionSetpoint_DataWriter &);
                VehicleLocalPositionSetpoint_DataWriter & operator = (const VehicleLocalPositionSetpoint_DataWriter &);
            };

            class  VehicleLocalPositionSetpoint_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleLocalPositionSetpoint_DataReader_ptr _ptr_type;
                typedef VehicleLocalPositionSetpoint_DataReader_var _var_type;

                static VehicleLocalPositionSetpoint_DataReader_ptr _duplicate (VehicleLocalPositionSetpoint_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLocalPositionSetpoint_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionSetpoint_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionSetpoint_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLocalPositionSetpoint_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleLocalPositionSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleLocalPositionSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleLocalPositionSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLocalPositionSetpoint_& instance) = 0;

            protected:
                VehicleLocalPositionSetpoint_DataReader () {};
                ~VehicleLocalPositionSetpoint_DataReader () {};
            private:
                VehicleLocalPositionSetpoint_DataReader (const VehicleLocalPositionSetpoint_DataReader &);
                VehicleLocalPositionSetpoint_DataReader & operator = (const VehicleLocalPositionSetpoint_DataReader &);
            };

            class  VehicleLocalPositionSetpoint_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleLocalPositionSetpoint_DataReaderView_ptr _ptr_type;
                typedef VehicleLocalPositionSetpoint_DataReaderView_var _var_type;

                static VehicleLocalPositionSetpoint_DataReaderView_ptr _duplicate (VehicleLocalPositionSetpoint_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLocalPositionSetpoint_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionSetpoint_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionSetpoint_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLocalPositionSetpoint_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleLocalPositionSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleLocalPositionSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleLocalPositionSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleLocalPositionSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLocalPositionSetpoint_& instance) = 0;

            protected:
                VehicleLocalPositionSetpoint_DataReaderView () {};
                ~VehicleLocalPositionSetpoint_DataReaderView () {};
            private:
                VehicleLocalPositionSetpoint_DataReaderView (const VehicleLocalPositionSetpoint_DataReaderView &);
                VehicleLocalPositionSetpoint_DataReaderView & operator = (const VehicleLocalPositionSetpoint_DataReaderView &);
            };
        }

    }

}

#endif
