#ifndef _H_3217975644AAECA1ECF0CC6B1D0492D8_VehicleMocapOdometry_DCPS_H_
#define _H_3217975644AAECA1ECF0CC6B1D0492D8_VehicleMocapOdometry_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleMocapOdometry_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleMocapOdometry_TypeSupportInterface;

            typedef VehicleMocapOdometry_TypeSupportInterface * VehicleMocapOdometry_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleMocapOdometry_TypeSupportInterface> VehicleMocapOdometry_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleMocapOdometry_TypeSupportInterface> VehicleMocapOdometry_TypeSupportInterface_out;


            class VehicleMocapOdometry_DataWriter;

            typedef VehicleMocapOdometry_DataWriter * VehicleMocapOdometry_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleMocapOdometry_DataWriter> VehicleMocapOdometry_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleMocapOdometry_DataWriter> VehicleMocapOdometry_DataWriter_out;


            class VehicleMocapOdometry_DataReader;

            typedef VehicleMocapOdometry_DataReader * VehicleMocapOdometry_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleMocapOdometry_DataReader> VehicleMocapOdometry_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleMocapOdometry_DataReader> VehicleMocapOdometry_DataReader_out;


            class VehicleMocapOdometry_DataReaderView;

            typedef VehicleMocapOdometry_DataReaderView * VehicleMocapOdometry_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleMocapOdometry_DataReaderView> VehicleMocapOdometry_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleMocapOdometry_DataReaderView> VehicleMocapOdometry_DataReaderView_out;

            struct VehicleMocapOdometry_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleMocapOdometry_, struct VehicleMocapOdometry_Seq_uniq_> VehicleMocapOdometry_Seq;
            typedef DDS_DCPSSequence_var < VehicleMocapOdometry_Seq> VehicleMocapOdometry_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleMocapOdometry_Seq> VehicleMocapOdometry_Seq_out;

            class  VehicleMocapOdometry_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleMocapOdometry_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleMocapOdometry_TypeSupportInterface_var _var_type;

                static VehicleMocapOdometry_TypeSupportInterface_ptr _duplicate (VehicleMocapOdometry_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleMocapOdometry_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleMocapOdometry_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleMocapOdometry_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleMocapOdometry_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleMocapOdometry_TypeSupportInterface () {};
                ~VehicleMocapOdometry_TypeSupportInterface () {};
            private:
                VehicleMocapOdometry_TypeSupportInterface (const VehicleMocapOdometry_TypeSupportInterface &);
                VehicleMocapOdometry_TypeSupportInterface & operator = (const VehicleMocapOdometry_TypeSupportInterface &);
            };

            class  VehicleMocapOdometry_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleMocapOdometry_DataWriter_ptr _ptr_type;
                typedef VehicleMocapOdometry_DataWriter_var _var_type;

                static VehicleMocapOdometry_DataWriter_ptr _duplicate (VehicleMocapOdometry_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleMocapOdometry_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleMocapOdometry_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleMocapOdometry_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleMocapOdometry_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleMocapOdometry_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleMocapOdometry_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleMocapOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleMocapOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleMocapOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleMocapOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleMocapOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleMocapOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleMocapOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleMocapOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleMocapOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleMocapOdometry_& instance_data) = 0;

            protected:
                VehicleMocapOdometry_DataWriter () {};
                ~VehicleMocapOdometry_DataWriter () {};
            private:
                VehicleMocapOdometry_DataWriter (const VehicleMocapOdometry_DataWriter &);
                VehicleMocapOdometry_DataWriter & operator = (const VehicleMocapOdometry_DataWriter &);
            };

            class  VehicleMocapOdometry_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleMocapOdometry_DataReader_ptr _ptr_type;
                typedef VehicleMocapOdometry_DataReader_var _var_type;

                static VehicleMocapOdometry_DataReader_ptr _duplicate (VehicleMocapOdometry_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleMocapOdometry_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleMocapOdometry_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleMocapOdometry_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleMocapOdometry_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleMocapOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleMocapOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleMocapOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleMocapOdometry_& instance) = 0;

            protected:
                VehicleMocapOdometry_DataReader () {};
                ~VehicleMocapOdometry_DataReader () {};
            private:
                VehicleMocapOdometry_DataReader (const VehicleMocapOdometry_DataReader &);
                VehicleMocapOdometry_DataReader & operator = (const VehicleMocapOdometry_DataReader &);
            };

            class  VehicleMocapOdometry_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleMocapOdometry_DataReaderView_ptr _ptr_type;
                typedef VehicleMocapOdometry_DataReaderView_var _var_type;

                static VehicleMocapOdometry_DataReaderView_ptr _duplicate (VehicleMocapOdometry_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleMocapOdometry_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleMocapOdometry_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleMocapOdometry_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleMocapOdometry_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleMocapOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleMocapOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleMocapOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleMocapOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleMocapOdometry_& instance) = 0;

            protected:
                VehicleMocapOdometry_DataReaderView () {};
                ~VehicleMocapOdometry_DataReaderView () {};
            private:
                VehicleMocapOdometry_DataReaderView (const VehicleMocapOdometry_DataReaderView &);
                VehicleMocapOdometry_DataReaderView & operator = (const VehicleMocapOdometry_DataReaderView &);
            };
        }

    }

}

#endif
