#ifndef _H_9FBC318E0FDAA884310A0A48C7C05D16_VehicleStatusFlags_DCPS_H_
#define _H_9FBC318E0FDAA884310A0A48C7C05D16_VehicleStatusFlags_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleStatusFlags_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleStatusFlags_TypeSupportInterface;

            typedef VehicleStatusFlags_TypeSupportInterface * VehicleStatusFlags_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleStatusFlags_TypeSupportInterface> VehicleStatusFlags_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleStatusFlags_TypeSupportInterface> VehicleStatusFlags_TypeSupportInterface_out;


            class VehicleStatusFlags_DataWriter;

            typedef VehicleStatusFlags_DataWriter * VehicleStatusFlags_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleStatusFlags_DataWriter> VehicleStatusFlags_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleStatusFlags_DataWriter> VehicleStatusFlags_DataWriter_out;


            class VehicleStatusFlags_DataReader;

            typedef VehicleStatusFlags_DataReader * VehicleStatusFlags_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleStatusFlags_DataReader> VehicleStatusFlags_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleStatusFlags_DataReader> VehicleStatusFlags_DataReader_out;


            class VehicleStatusFlags_DataReaderView;

            typedef VehicleStatusFlags_DataReaderView * VehicleStatusFlags_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleStatusFlags_DataReaderView> VehicleStatusFlags_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleStatusFlags_DataReaderView> VehicleStatusFlags_DataReaderView_out;

            struct VehicleStatusFlags_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleStatusFlags_, struct VehicleStatusFlags_Seq_uniq_> VehicleStatusFlags_Seq;
            typedef DDS_DCPSSequence_var < VehicleStatusFlags_Seq> VehicleStatusFlags_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleStatusFlags_Seq> VehicleStatusFlags_Seq_out;

            class  VehicleStatusFlags_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleStatusFlags_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleStatusFlags_TypeSupportInterface_var _var_type;

                static VehicleStatusFlags_TypeSupportInterface_ptr _duplicate (VehicleStatusFlags_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStatusFlags_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStatusFlags_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStatusFlags_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStatusFlags_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleStatusFlags_TypeSupportInterface () {};
                ~VehicleStatusFlags_TypeSupportInterface () {};
            private:
                VehicleStatusFlags_TypeSupportInterface (const VehicleStatusFlags_TypeSupportInterface &);
                VehicleStatusFlags_TypeSupportInterface & operator = (const VehicleStatusFlags_TypeSupportInterface &);
            };

            class  VehicleStatusFlags_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleStatusFlags_DataWriter_ptr _ptr_type;
                typedef VehicleStatusFlags_DataWriter_var _var_type;

                static VehicleStatusFlags_DataWriter_ptr _duplicate (VehicleStatusFlags_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStatusFlags_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStatusFlags_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStatusFlags_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStatusFlags_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleStatusFlags_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleStatusFlags_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleStatusFlags_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleStatusFlags_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleStatusFlags_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleStatusFlags_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleStatusFlags_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleStatusFlags_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleStatusFlags_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleStatusFlags_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleStatusFlags_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStatusFlags_& instance_data) = 0;

            protected:
                VehicleStatusFlags_DataWriter () {};
                ~VehicleStatusFlags_DataWriter () {};
            private:
                VehicleStatusFlags_DataWriter (const VehicleStatusFlags_DataWriter &);
                VehicleStatusFlags_DataWriter & operator = (const VehicleStatusFlags_DataWriter &);
            };

            class  VehicleStatusFlags_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleStatusFlags_DataReader_ptr _ptr_type;
                typedef VehicleStatusFlags_DataReader_var _var_type;

                static VehicleStatusFlags_DataReader_ptr _duplicate (VehicleStatusFlags_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStatusFlags_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStatusFlags_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStatusFlags_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStatusFlags_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStatusFlags_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStatusFlags_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStatusFlags_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStatusFlags_& instance) = 0;

            protected:
                VehicleStatusFlags_DataReader () {};
                ~VehicleStatusFlags_DataReader () {};
            private:
                VehicleStatusFlags_DataReader (const VehicleStatusFlags_DataReader &);
                VehicleStatusFlags_DataReader & operator = (const VehicleStatusFlags_DataReader &);
            };

            class  VehicleStatusFlags_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleStatusFlags_DataReaderView_ptr _ptr_type;
                typedef VehicleStatusFlags_DataReaderView_var _var_type;

                static VehicleStatusFlags_DataReaderView_ptr _duplicate (VehicleStatusFlags_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStatusFlags_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStatusFlags_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStatusFlags_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStatusFlags_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStatusFlags_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStatusFlags_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStatusFlags_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStatusFlags_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStatusFlags_& instance) = 0;

            protected:
                VehicleStatusFlags_DataReaderView () {};
                ~VehicleStatusFlags_DataReaderView () {};
            private:
                VehicleStatusFlags_DataReaderView (const VehicleStatusFlags_DataReaderView &);
                VehicleStatusFlags_DataReaderView & operator = (const VehicleStatusFlags_DataReaderView &);
            };
        }

    }

}

#endif
