#ifndef _H_32515AED4BDB67E56C33CE21D6B01DCB_VehicleStatus_DCPS_H_
#define _H_32515AED4BDB67E56C33CE21D6B01DCB_VehicleStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleStatus_TypeSupportInterface;

            typedef VehicleStatus_TypeSupportInterface * VehicleStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleStatus_TypeSupportInterface> VehicleStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleStatus_TypeSupportInterface> VehicleStatus_TypeSupportInterface_out;


            class VehicleStatus_DataWriter;

            typedef VehicleStatus_DataWriter * VehicleStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleStatus_DataWriter> VehicleStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleStatus_DataWriter> VehicleStatus_DataWriter_out;


            class VehicleStatus_DataReader;

            typedef VehicleStatus_DataReader * VehicleStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleStatus_DataReader> VehicleStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleStatus_DataReader> VehicleStatus_DataReader_out;


            class VehicleStatus_DataReaderView;

            typedef VehicleStatus_DataReaderView * VehicleStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleStatus_DataReaderView> VehicleStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleStatus_DataReaderView> VehicleStatus_DataReaderView_out;

            struct VehicleStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleStatus_, struct VehicleStatus_Seq_uniq_> VehicleStatus_Seq;
            typedef DDS_DCPSSequence_var < VehicleStatus_Seq> VehicleStatus_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleStatus_Seq> VehicleStatus_Seq_out;

            class  VehicleStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleStatus_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleStatus_TypeSupportInterface_var _var_type;

                static VehicleStatus_TypeSupportInterface_ptr _duplicate (VehicleStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleStatus_TypeSupportInterface () {};
                ~VehicleStatus_TypeSupportInterface () {};
            private:
                VehicleStatus_TypeSupportInterface (const VehicleStatus_TypeSupportInterface &);
                VehicleStatus_TypeSupportInterface & operator = (const VehicleStatus_TypeSupportInterface &);
            };

            class  VehicleStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleStatus_DataWriter_ptr _ptr_type;
                typedef VehicleStatus_DataWriter_var _var_type;

                static VehicleStatus_DataWriter_ptr _duplicate (VehicleStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStatus_& instance_data) = 0;

            protected:
                VehicleStatus_DataWriter () {};
                ~VehicleStatus_DataWriter () {};
            private:
                VehicleStatus_DataWriter (const VehicleStatus_DataWriter &);
                VehicleStatus_DataWriter & operator = (const VehicleStatus_DataWriter &);
            };

            class  VehicleStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleStatus_DataReader_ptr _ptr_type;
                typedef VehicleStatus_DataReader_var _var_type;

                static VehicleStatus_DataReader_ptr _duplicate (VehicleStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStatus_& instance) = 0;

            protected:
                VehicleStatus_DataReader () {};
                ~VehicleStatus_DataReader () {};
            private:
                VehicleStatus_DataReader (const VehicleStatus_DataReader &);
                VehicleStatus_DataReader & operator = (const VehicleStatus_DataReader &);
            };

            class  VehicleStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleStatus_DataReaderView_ptr _ptr_type;
                typedef VehicleStatus_DataReaderView_var _var_type;

                static VehicleStatus_DataReaderView_ptr _duplicate (VehicleStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStatus_& instance) = 0;

            protected:
                VehicleStatus_DataReaderView () {};
                ~VehicleStatus_DataReaderView () {};
            private:
                VehicleStatus_DataReaderView (const VehicleStatus_DataReaderView &);
                VehicleStatus_DataReaderView & operator = (const VehicleStatus_DataReaderView &);
            };
        }

    }

}

#endif
