#ifndef H_32515AED4BDB67E56C33CE21D6B01DCB_VehicleStatus_SPLTYPES_H
#define H_32515AED4BDB67E56C33CE21D6B01DCB_VehicleStatus_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_VehicleStatus_.h"


extern c_metaObject __VehicleStatus__px4_msgs__load (c_base base);

extern c_metaObject __VehicleStatus__px4_msgs_msg__load (c_base base);

extern c_metaObject __VehicleStatus__px4_msgs_msg_dds___load (c_base base);

extern c_metaObject __VehicleStatus__px4_msgs_msg_dds__VehicleStatus_Constants__load (c_base base);

extern const char *px4_msgs_msg_dds__VehicleStatus__metaDescriptor[];
extern const int px4_msgs_msg_dds__VehicleStatus__metaDescriptorArrLength;
extern const int px4_msgs_msg_dds__VehicleStatus__metaDescriptorLength;
extern c_metaObject __px4_msgs_msg_dds__VehicleStatus___load (c_base base);
struct _px4_msgs_msg_dds__VehicleStatus_ ;
extern  v_copyin_result __px4_msgs_msg_dds__VehicleStatus___copyIn(c_base base, const struct px4_msgs::msg::dds_::VehicleStatus_ *from, struct _px4_msgs_msg_dds__VehicleStatus_ *to);
extern  void __px4_msgs_msg_dds__VehicleStatus___copyOut(const void *_from, void *_to);
struct _px4_msgs_msg_dds__VehicleStatus_ {
    c_ulonglong timestamp_;
    c_octet nav_state_;
    c_octet arming_state_;
    c_octet hil_state_;
    c_bool failsafe_;
    c_octet system_type_;
    c_octet system_id_;
    c_octet component_id_;
    c_octet vehicle_type_;
    c_bool is_vtol_;
    c_bool vtol_fw_permanent_stab_;
    c_bool in_transition_mode_;
    c_bool in_transition_to_fw_;
    c_bool rc_signal_lost_;
    c_octet rc_input_mode_;
    c_bool data_link_lost_;
    c_octet data_link_lost_counter_;
    c_bool high_latency_data_link_lost_;
    c_bool engine_failure_;
    c_bool mission_failure_;
    c_octet failure_detector_status_;
    c_ulong onboard_control_sensors_present_;
    c_ulong onboard_control_sensors_enabled_;
    c_ulong onboard_control_sensors_health_;
    c_float arspd_check_level_;
    c_bool aspd_check_failing_;
    c_bool aspd_fault_declared_;
    c_bool aspd_use_inhibit_;
    c_bool aspd_fail_rtl_;
    c_float load_factor_ratio_;
};

#undef OS_API
#endif
