#ifndef _H_C90E2F08ED7456519E21A392F2ECC975_VehicleVisionAttitude_DCPS_H_
#define _H_C90E2F08ED7456519E21A392F2ECC975_VehicleVisionAttitude_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleVisionAttitude_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleVisionAttitude_TypeSupportInterface;

            typedef VehicleVisionAttitude_TypeSupportInterface * VehicleVisionAttitude_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisionAttitude_TypeSupportInterface> VehicleVisionAttitude_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleVisionAttitude_TypeSupportInterface> VehicleVisionAttitude_TypeSupportInterface_out;


            class VehicleVisionAttitude_DataWriter;

            typedef VehicleVisionAttitude_DataWriter * VehicleVisionAttitude_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisionAttitude_DataWriter> VehicleVisionAttitude_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleVisionAttitude_DataWriter> VehicleVisionAttitude_DataWriter_out;


            class VehicleVisionAttitude_DataReader;

            typedef VehicleVisionAttitude_DataReader * VehicleVisionAttitude_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisionAttitude_DataReader> VehicleVisionAttitude_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleVisionAttitude_DataReader> VehicleVisionAttitude_DataReader_out;


            class VehicleVisionAttitude_DataReaderView;

            typedef VehicleVisionAttitude_DataReaderView * VehicleVisionAttitude_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisionAttitude_DataReaderView> VehicleVisionAttitude_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleVisionAttitude_DataReaderView> VehicleVisionAttitude_DataReaderView_out;

            struct VehicleVisionAttitude_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleVisionAttitude_, struct VehicleVisionAttitude_Seq_uniq_> VehicleVisionAttitude_Seq;
            typedef DDS_DCPSSequence_var < VehicleVisionAttitude_Seq> VehicleVisionAttitude_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleVisionAttitude_Seq> VehicleVisionAttitude_Seq_out;

            class  VehicleVisionAttitude_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleVisionAttitude_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleVisionAttitude_TypeSupportInterface_var _var_type;

                static VehicleVisionAttitude_TypeSupportInterface_ptr _duplicate (VehicleVisionAttitude_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisionAttitude_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisionAttitude_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisionAttitude_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisionAttitude_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleVisionAttitude_TypeSupportInterface () {};
                ~VehicleVisionAttitude_TypeSupportInterface () {};
            private:
                VehicleVisionAttitude_TypeSupportInterface (const VehicleVisionAttitude_TypeSupportInterface &);
                VehicleVisionAttitude_TypeSupportInterface & operator = (const VehicleVisionAttitude_TypeSupportInterface &);
            };

            class  VehicleVisionAttitude_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleVisionAttitude_DataWriter_ptr _ptr_type;
                typedef VehicleVisionAttitude_DataWriter_var _var_type;

                static VehicleVisionAttitude_DataWriter_ptr _duplicate (VehicleVisionAttitude_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisionAttitude_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisionAttitude_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisionAttitude_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisionAttitude_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleVisionAttitude_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleVisionAttitude_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleVisionAttitude_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleVisionAttitude_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleVisionAttitude_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleVisionAttitude_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleVisionAttitude_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleVisionAttitude_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleVisionAttitude_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleVisionAttitude_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleVisionAttitude_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisionAttitude_& instance_data) = 0;

            protected:
                VehicleVisionAttitude_DataWriter () {};
                ~VehicleVisionAttitude_DataWriter () {};
            private:
                VehicleVisionAttitude_DataWriter (const VehicleVisionAttitude_DataWriter &);
                VehicleVisionAttitude_DataWriter & operator = (const VehicleVisionAttitude_DataWriter &);
            };

            class  VehicleVisionAttitude_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleVisionAttitude_DataReader_ptr _ptr_type;
                typedef VehicleVisionAttitude_DataReader_var _var_type;

                static VehicleVisionAttitude_DataReader_ptr _duplicate (VehicleVisionAttitude_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisionAttitude_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisionAttitude_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisionAttitude_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisionAttitude_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleVisionAttitude_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleVisionAttitude_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleVisionAttitude_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisionAttitude_& instance) = 0;

            protected:
                VehicleVisionAttitude_DataReader () {};
                ~VehicleVisionAttitude_DataReader () {};
            private:
                VehicleVisionAttitude_DataReader (const VehicleVisionAttitude_DataReader &);
                VehicleVisionAttitude_DataReader & operator = (const VehicleVisionAttitude_DataReader &);
            };

            class  VehicleVisionAttitude_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleVisionAttitude_DataReaderView_ptr _ptr_type;
                typedef VehicleVisionAttitude_DataReaderView_var _var_type;

                static VehicleVisionAttitude_DataReaderView_ptr _duplicate (VehicleVisionAttitude_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisionAttitude_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisionAttitude_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisionAttitude_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisionAttitude_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleVisionAttitude_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleVisionAttitude_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleVisionAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleVisionAttitude_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisionAttitude_& instance) = 0;

            protected:
                VehicleVisionAttitude_DataReaderView () {};
                ~VehicleVisionAttitude_DataReaderView () {};
            private:
                VehicleVisionAttitude_DataReaderView (const VehicleVisionAttitude_DataReaderView &);
                VehicleVisionAttitude_DataReaderView & operator = (const VehicleVisionAttitude_DataReaderView &);
            };
        }

    }

}

#endif
