#ifndef _H_BED7E7A8E96033FFF62981517D925FBB_VehicleVisualOdometryAligned_DCPS_H_
#define _H_BED7E7A8E96033FFF62981517D925FBB_VehicleVisualOdometryAligned_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleVisualOdometryAligned_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleVisualOdometryAligned_TypeSupportInterface;

            typedef VehicleVisualOdometryAligned_TypeSupportInterface * VehicleVisualOdometryAligned_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisualOdometryAligned_TypeSupportInterface> VehicleVisualOdometryAligned_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleVisualOdometryAligned_TypeSupportInterface> VehicleVisualOdometryAligned_TypeSupportInterface_out;


            class VehicleVisualOdometryAligned_DataWriter;

            typedef VehicleVisualOdometryAligned_DataWriter * VehicleVisualOdometryAligned_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisualOdometryAligned_DataWriter> VehicleVisualOdometryAligned_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleVisualOdometryAligned_DataWriter> VehicleVisualOdometryAligned_DataWriter_out;


            class VehicleVisualOdometryAligned_DataReader;

            typedef VehicleVisualOdometryAligned_DataReader * VehicleVisualOdometryAligned_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisualOdometryAligned_DataReader> VehicleVisualOdometryAligned_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleVisualOdometryAligned_DataReader> VehicleVisualOdometryAligned_DataReader_out;


            class VehicleVisualOdometryAligned_DataReaderView;

            typedef VehicleVisualOdometryAligned_DataReaderView * VehicleVisualOdometryAligned_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisualOdometryAligned_DataReaderView> VehicleVisualOdometryAligned_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleVisualOdometryAligned_DataReaderView> VehicleVisualOdometryAligned_DataReaderView_out;

            struct VehicleVisualOdometryAligned_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleVisualOdometryAligned_, struct VehicleVisualOdometryAligned_Seq_uniq_> VehicleVisualOdometryAligned_Seq;
            typedef DDS_DCPSSequence_var < VehicleVisualOdometryAligned_Seq> VehicleVisualOdometryAligned_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleVisualOdometryAligned_Seq> VehicleVisualOdometryAligned_Seq_out;

            class  VehicleVisualOdometryAligned_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleVisualOdometryAligned_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleVisualOdometryAligned_TypeSupportInterface_var _var_type;

                static VehicleVisualOdometryAligned_TypeSupportInterface_ptr _duplicate (VehicleVisualOdometryAligned_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisualOdometryAligned_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometryAligned_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometryAligned_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisualOdometryAligned_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleVisualOdometryAligned_TypeSupportInterface () {};
                ~VehicleVisualOdometryAligned_TypeSupportInterface () {};
            private:
                VehicleVisualOdometryAligned_TypeSupportInterface (const VehicleVisualOdometryAligned_TypeSupportInterface &);
                VehicleVisualOdometryAligned_TypeSupportInterface & operator = (const VehicleVisualOdometryAligned_TypeSupportInterface &);
            };

            class  VehicleVisualOdometryAligned_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleVisualOdometryAligned_DataWriter_ptr _ptr_type;
                typedef VehicleVisualOdometryAligned_DataWriter_var _var_type;

                static VehicleVisualOdometryAligned_DataWriter_ptr _duplicate (VehicleVisualOdometryAligned_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisualOdometryAligned_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometryAligned_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometryAligned_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisualOdometryAligned_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleVisualOdometryAligned_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleVisualOdometryAligned_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleVisualOdometryAligned_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleVisualOdometryAligned_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleVisualOdometryAligned_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleVisualOdometryAligned_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleVisualOdometryAligned_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleVisualOdometryAligned_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleVisualOdometryAligned_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleVisualOdometryAligned_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleVisualOdometryAligned_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisualOdometryAligned_& instance_data) = 0;

            protected:
                VehicleVisualOdometryAligned_DataWriter () {};
                ~VehicleVisualOdometryAligned_DataWriter () {};
            private:
                VehicleVisualOdometryAligned_DataWriter (const VehicleVisualOdometryAligned_DataWriter &);
                VehicleVisualOdometryAligned_DataWriter & operator = (const VehicleVisualOdometryAligned_DataWriter &);
            };

            class  VehicleVisualOdometryAligned_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleVisualOdometryAligned_DataReader_ptr _ptr_type;
                typedef VehicleVisualOdometryAligned_DataReader_var _var_type;

                static VehicleVisualOdometryAligned_DataReader_ptr _duplicate (VehicleVisualOdometryAligned_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisualOdometryAligned_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometryAligned_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometryAligned_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisualOdometryAligned_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleVisualOdometryAligned_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleVisualOdometryAligned_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleVisualOdometryAligned_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisualOdometryAligned_& instance) = 0;

            protected:
                VehicleVisualOdometryAligned_DataReader () {};
                ~VehicleVisualOdometryAligned_DataReader () {};
            private:
                VehicleVisualOdometryAligned_DataReader (const VehicleVisualOdometryAligned_DataReader &);
                VehicleVisualOdometryAligned_DataReader & operator = (const VehicleVisualOdometryAligned_DataReader &);
            };

            class  VehicleVisualOdometryAligned_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleVisualOdometryAligned_DataReaderView_ptr _ptr_type;
                typedef VehicleVisualOdometryAligned_DataReaderView_var _var_type;

                static VehicleVisualOdometryAligned_DataReaderView_ptr _duplicate (VehicleVisualOdometryAligned_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisualOdometryAligned_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometryAligned_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometryAligned_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisualOdometryAligned_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleVisualOdometryAligned_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleVisualOdometryAligned_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleVisualOdometryAligned_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleVisualOdometryAligned_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisualOdometryAligned_& instance) = 0;

            protected:
                VehicleVisualOdometryAligned_DataReaderView () {};
                ~VehicleVisualOdometryAligned_DataReaderView () {};
            private:
                VehicleVisualOdometryAligned_DataReaderView (const VehicleVisualOdometryAligned_DataReaderView &);
                VehicleVisualOdometryAligned_DataReaderView & operator = (const VehicleVisualOdometryAligned_DataReaderView &);
            };
        }

    }

}

#endif
