#ifndef _H_805EDE33480F45E1860BA993B19248B5_VtolVehicleStatus__H_
#define _H_805EDE33480F45E1860BA993B19248B5_VtolVehicleStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace VtolVehicleStatus_Constants
            {
                const ::DDS::Octet VEHICLE_VTOL_STATE_UNDEFINED_ = 0;

                const ::DDS::Octet VEHICLE_VTOL_STATE_TRANSITION_TO_FW_ = 1;

                const ::DDS::Octet VEHICLE_VTOL_STATE_TRANSITION_TO_MC_ = 2;

                const ::DDS::Octet VEHICLE_VTOL_STATE_MC_ = 3;

                const ::DDS::Octet VEHICLE_VTOL_STATE_FW_ = 4;

            }

            struct  VtolVehicleStatus_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Boolean vtol_in_rw_mode_;
                ::DDS::Boolean vtol_in_trans_mode_;
                ::DDS::Boolean in_transition_to_fw_;
                ::DDS::Boolean vtol_transition_failsafe_;
                ::DDS::Boolean fw_permanent_stab_;
            };

            typedef DDS_DCPSStruct_var<VtolVehicleStatus_> VtolVehicleStatus__var;
            typedef VtolVehicleStatus_& VtolVehicleStatus__out;

        }

    }

}

#endif /* _H_805EDE33480F45E1860BA993B19248B5_VtolVehicleStatus__H_ */
