#ifndef _H_0EC979730CEF451D3A4300C54BAB391D_WindEstimate__H_
#define _H_0EC979730CEF451D3A4300C54BAB391D_WindEstimate__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  WindEstimate_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Float windspeed_north_;
                ::DDS::Float windspeed_east_;
                ::DDS::Float variance_north_;
                ::DDS::Float variance_east_;
                ::DDS::Float tas_innov_;
                ::DDS::Float tas_innov_var_;
                ::DDS::Float tas_scale_;
                ::DDS::Float beta_innov_;
                ::DDS::Float beta_innov_var_;
            };

            typedef DDS_DCPSStruct_var<WindEstimate_> WindEstimate__var;
            typedef WindEstimate_& WindEstimate__out;

        }

    }

}

#endif /* _H_0EC979730CEF451D3A4300C54BAB391D_WindEstimate__H_ */
