// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/OffboardControlMode.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__OFFBOARD_CONTROL_MODE__STRUCT_HPP_
#define PX4_MSGS__MSG__OFFBOARD_CONTROL_MODE__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__OffboardControlMode __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__OffboardControlMode __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct OffboardControlMode_
{
  using Type = OffboardControlMode_<ContainerAllocator>;

  explicit OffboardControlMode_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->ignore_thrust = false;
      this->ignore_attitude = false;
      this->ignore_bodyrate_x = false;
      this->ignore_bodyrate_y = false;
      this->ignore_bodyrate_z = false;
      this->ignore_position = false;
      this->ignore_velocity = false;
      this->ignore_acceleration_force = false;
      this->ignore_alt_hold = false;
    }
  }

  explicit OffboardControlMode_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->ignore_thrust = false;
      this->ignore_attitude = false;
      this->ignore_bodyrate_x = false;
      this->ignore_bodyrate_y = false;
      this->ignore_bodyrate_z = false;
      this->ignore_position = false;
      this->ignore_velocity = false;
      this->ignore_acceleration_force = false;
      this->ignore_alt_hold = false;
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _ignore_thrust_type =
    bool;
  _ignore_thrust_type ignore_thrust;
  using _ignore_attitude_type =
    bool;
  _ignore_attitude_type ignore_attitude;
  using _ignore_bodyrate_x_type =
    bool;
  _ignore_bodyrate_x_type ignore_bodyrate_x;
  using _ignore_bodyrate_y_type =
    bool;
  _ignore_bodyrate_y_type ignore_bodyrate_y;
  using _ignore_bodyrate_z_type =
    bool;
  _ignore_bodyrate_z_type ignore_bodyrate_z;
  using _ignore_position_type =
    bool;
  _ignore_position_type ignore_position;
  using _ignore_velocity_type =
    bool;
  _ignore_velocity_type ignore_velocity;
  using _ignore_acceleration_force_type =
    bool;
  _ignore_acceleration_force_type ignore_acceleration_force;
  using _ignore_alt_hold_type =
    bool;
  _ignore_alt_hold_type ignore_alt_hold;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__ignore_thrust(
    const bool & _arg)
  {
    this->ignore_thrust = _arg;
    return *this;
  }
  Type & set__ignore_attitude(
    const bool & _arg)
  {
    this->ignore_attitude = _arg;
    return *this;
  }
  Type & set__ignore_bodyrate_x(
    const bool & _arg)
  {
    this->ignore_bodyrate_x = _arg;
    return *this;
  }
  Type & set__ignore_bodyrate_y(
    const bool & _arg)
  {
    this->ignore_bodyrate_y = _arg;
    return *this;
  }
  Type & set__ignore_bodyrate_z(
    const bool & _arg)
  {
    this->ignore_bodyrate_z = _arg;
    return *this;
  }
  Type & set__ignore_position(
    const bool & _arg)
  {
    this->ignore_position = _arg;
    return *this;
  }
  Type & set__ignore_velocity(
    const bool & _arg)
  {
    this->ignore_velocity = _arg;
    return *this;
  }
  Type & set__ignore_acceleration_force(
    const bool & _arg)
  {
    this->ignore_acceleration_force = _arg;
    return *this;
  }
  Type & set__ignore_alt_hold(
    const bool & _arg)
  {
    this->ignore_alt_hold = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    px4_msgs::msg::OffboardControlMode_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::OffboardControlMode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::OffboardControlMode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::OffboardControlMode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::OffboardControlMode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::OffboardControlMode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::OffboardControlMode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::OffboardControlMode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::OffboardControlMode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::OffboardControlMode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__OffboardControlMode
    std::shared_ptr<px4_msgs::msg::OffboardControlMode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__OffboardControlMode
    std::shared_ptr<px4_msgs::msg::OffboardControlMode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const OffboardControlMode_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->ignore_thrust != other.ignore_thrust) {
      return false;
    }
    if (this->ignore_attitude != other.ignore_attitude) {
      return false;
    }
    if (this->ignore_bodyrate_x != other.ignore_bodyrate_x) {
      return false;
    }
    if (this->ignore_bodyrate_y != other.ignore_bodyrate_y) {
      return false;
    }
    if (this->ignore_bodyrate_z != other.ignore_bodyrate_z) {
      return false;
    }
    if (this->ignore_position != other.ignore_position) {
      return false;
    }
    if (this->ignore_velocity != other.ignore_velocity) {
      return false;
    }
    if (this->ignore_acceleration_force != other.ignore_acceleration_force) {
      return false;
    }
    if (this->ignore_alt_hold != other.ignore_alt_hold) {
      return false;
    }
    return true;
  }
  bool operator!=(const OffboardControlMode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct OffboardControlMode_

// alias to use template instance with default allocator
using OffboardControlMode =
  px4_msgs::msg::OffboardControlMode_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__OFFBOARD_CONTROL_MODE__STRUCT_HPP_
