// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/SensorBias.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__SENSOR_BIAS__STRUCT_HPP_
#define PX4_MSGS__MSG__SENSOR_BIAS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__SensorBias __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__SensorBias __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorBias_
{
  using Type = SensorBias_<ContainerAllocator>;

  explicit SensorBias_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_bias.begin(), this->gyro_bias.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_bias.begin(), this->accel_bias.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->mag_bias.begin(), this->mag_bias.end(), 0.0f);
    }
  }

  explicit SensorBias_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : gyro_bias(_alloc),
    accel_bias(_alloc),
    mag_bias(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_bias.begin(), this->gyro_bias.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_bias.begin(), this->accel_bias.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->mag_bias.begin(), this->mag_bias.end(), 0.0f);
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _gyro_bias_type =
    std::array<float, 3>;
  _gyro_bias_type gyro_bias;
  using _accel_bias_type =
    std::array<float, 3>;
  _accel_bias_type accel_bias;
  using _mag_bias_type =
    std::array<float, 3>;
  _mag_bias_type mag_bias;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__gyro_bias(
    const std::array<float, 3> & _arg)
  {
    this->gyro_bias = _arg;
    return *this;
  }
  Type & set__accel_bias(
    const std::array<float, 3> & _arg)
  {
    this->accel_bias = _arg;
    return *this;
  }
  Type & set__mag_bias(
    const std::array<float, 3> & _arg)
  {
    this->mag_bias = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    px4_msgs::msg::SensorBias_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::SensorBias_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorBias_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorBias_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorBias_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorBias_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorBias_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorBias_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorBias_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorBias_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__SensorBias
    std::shared_ptr<px4_msgs::msg::SensorBias_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__SensorBias
    std::shared_ptr<px4_msgs::msg::SensorBias_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorBias_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->gyro_bias != other.gyro_bias) {
      return false;
    }
    if (this->accel_bias != other.accel_bias) {
      return false;
    }
    if (this->mag_bias != other.mag_bias) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorBias_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorBias_

// alias to use template instance with default allocator
using SensorBias =
  px4_msgs::msg::SensorBias_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__SENSOR_BIAS__STRUCT_HPP_
