// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/SensorCorrection.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__SENSOR_CORRECTION__STRUCT_HPP_
#define PX4_MSGS__MSG__SENSOR_CORRECTION__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__SensorCorrection __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__SensorCorrection __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorCorrection_
{
  using Type = SensorCorrection_<ContainerAllocator>;

  explicit SensorCorrection_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_offset_0.begin(), this->gyro_offset_0.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_scale_0.begin(), this->gyro_scale_0.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_offset_1.begin(), this->gyro_offset_1.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_scale_1.begin(), this->gyro_scale_1.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_offset_2.begin(), this->gyro_offset_2.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_scale_2.begin(), this->gyro_scale_2.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_offset_0.begin(), this->accel_offset_0.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_scale_0.begin(), this->accel_scale_0.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_offset_1.begin(), this->accel_offset_1.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_scale_1.begin(), this->accel_scale_1.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_offset_2.begin(), this->accel_offset_2.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_scale_2.begin(), this->accel_scale_2.end(), 0.0f);
      this->baro_offset_0 = 0.0f;
      this->baro_scale_0 = 0.0f;
      this->baro_offset_1 = 0.0f;
      this->baro_scale_1 = 0.0f;
      this->baro_offset_2 = 0.0f;
      this->baro_scale_2 = 0.0f;
      this->selected_gyro_instance = 0;
      this->selected_accel_instance = 0;
      this->selected_baro_instance = 0;
      std::fill<typename std::array<uint8_t, 3>::iterator, uint8_t>(this->gyro_mapping.begin(), this->gyro_mapping.end(), 0);
      std::fill<typename std::array<uint8_t, 3>::iterator, uint8_t>(this->accel_mapping.begin(), this->accel_mapping.end(), 0);
      std::fill<typename std::array<uint8_t, 3>::iterator, uint8_t>(this->baro_mapping.begin(), this->baro_mapping.end(), 0);
    }
  }

  explicit SensorCorrection_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : gyro_offset_0(_alloc),
    gyro_scale_0(_alloc),
    gyro_offset_1(_alloc),
    gyro_scale_1(_alloc),
    gyro_offset_2(_alloc),
    gyro_scale_2(_alloc),
    accel_offset_0(_alloc),
    accel_scale_0(_alloc),
    accel_offset_1(_alloc),
    accel_scale_1(_alloc),
    accel_offset_2(_alloc),
    accel_scale_2(_alloc),
    gyro_mapping(_alloc),
    accel_mapping(_alloc),
    baro_mapping(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_offset_0.begin(), this->gyro_offset_0.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_scale_0.begin(), this->gyro_scale_0.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_offset_1.begin(), this->gyro_offset_1.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_scale_1.begin(), this->gyro_scale_1.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_offset_2.begin(), this->gyro_offset_2.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_scale_2.begin(), this->gyro_scale_2.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_offset_0.begin(), this->accel_offset_0.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_scale_0.begin(), this->accel_scale_0.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_offset_1.begin(), this->accel_offset_1.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_scale_1.begin(), this->accel_scale_1.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_offset_2.begin(), this->accel_offset_2.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->accel_scale_2.begin(), this->accel_scale_2.end(), 0.0f);
      this->baro_offset_0 = 0.0f;
      this->baro_scale_0 = 0.0f;
      this->baro_offset_1 = 0.0f;
      this->baro_scale_1 = 0.0f;
      this->baro_offset_2 = 0.0f;
      this->baro_scale_2 = 0.0f;
      this->selected_gyro_instance = 0;
      this->selected_accel_instance = 0;
      this->selected_baro_instance = 0;
      std::fill<typename std::array<uint8_t, 3>::iterator, uint8_t>(this->gyro_mapping.begin(), this->gyro_mapping.end(), 0);
      std::fill<typename std::array<uint8_t, 3>::iterator, uint8_t>(this->accel_mapping.begin(), this->accel_mapping.end(), 0);
      std::fill<typename std::array<uint8_t, 3>::iterator, uint8_t>(this->baro_mapping.begin(), this->baro_mapping.end(), 0);
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _gyro_offset_0_type =
    std::array<float, 3>;
  _gyro_offset_0_type gyro_offset_0;
  using _gyro_scale_0_type =
    std::array<float, 3>;
  _gyro_scale_0_type gyro_scale_0;
  using _gyro_offset_1_type =
    std::array<float, 3>;
  _gyro_offset_1_type gyro_offset_1;
  using _gyro_scale_1_type =
    std::array<float, 3>;
  _gyro_scale_1_type gyro_scale_1;
  using _gyro_offset_2_type =
    std::array<float, 3>;
  _gyro_offset_2_type gyro_offset_2;
  using _gyro_scale_2_type =
    std::array<float, 3>;
  _gyro_scale_2_type gyro_scale_2;
  using _accel_offset_0_type =
    std::array<float, 3>;
  _accel_offset_0_type accel_offset_0;
  using _accel_scale_0_type =
    std::array<float, 3>;
  _accel_scale_0_type accel_scale_0;
  using _accel_offset_1_type =
    std::array<float, 3>;
  _accel_offset_1_type accel_offset_1;
  using _accel_scale_1_type =
    std::array<float, 3>;
  _accel_scale_1_type accel_scale_1;
  using _accel_offset_2_type =
    std::array<float, 3>;
  _accel_offset_2_type accel_offset_2;
  using _accel_scale_2_type =
    std::array<float, 3>;
  _accel_scale_2_type accel_scale_2;
  using _baro_offset_0_type =
    float;
  _baro_offset_0_type baro_offset_0;
  using _baro_scale_0_type =
    float;
  _baro_scale_0_type baro_scale_0;
  using _baro_offset_1_type =
    float;
  _baro_offset_1_type baro_offset_1;
  using _baro_scale_1_type =
    float;
  _baro_scale_1_type baro_scale_1;
  using _baro_offset_2_type =
    float;
  _baro_offset_2_type baro_offset_2;
  using _baro_scale_2_type =
    float;
  _baro_scale_2_type baro_scale_2;
  using _selected_gyro_instance_type =
    uint8_t;
  _selected_gyro_instance_type selected_gyro_instance;
  using _selected_accel_instance_type =
    uint8_t;
  _selected_accel_instance_type selected_accel_instance;
  using _selected_baro_instance_type =
    uint8_t;
  _selected_baro_instance_type selected_baro_instance;
  using _gyro_mapping_type =
    std::array<uint8_t, 3>;
  _gyro_mapping_type gyro_mapping;
  using _accel_mapping_type =
    std::array<uint8_t, 3>;
  _accel_mapping_type accel_mapping;
  using _baro_mapping_type =
    std::array<uint8_t, 3>;
  _baro_mapping_type baro_mapping;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__gyro_offset_0(
    const std::array<float, 3> & _arg)
  {
    this->gyro_offset_0 = _arg;
    return *this;
  }
  Type & set__gyro_scale_0(
    const std::array<float, 3> & _arg)
  {
    this->gyro_scale_0 = _arg;
    return *this;
  }
  Type & set__gyro_offset_1(
    const std::array<float, 3> & _arg)
  {
    this->gyro_offset_1 = _arg;
    return *this;
  }
  Type & set__gyro_scale_1(
    const std::array<float, 3> & _arg)
  {
    this->gyro_scale_1 = _arg;
    return *this;
  }
  Type & set__gyro_offset_2(
    const std::array<float, 3> & _arg)
  {
    this->gyro_offset_2 = _arg;
    return *this;
  }
  Type & set__gyro_scale_2(
    const std::array<float, 3> & _arg)
  {
    this->gyro_scale_2 = _arg;
    return *this;
  }
  Type & set__accel_offset_0(
    const std::array<float, 3> & _arg)
  {
    this->accel_offset_0 = _arg;
    return *this;
  }
  Type & set__accel_scale_0(
    const std::array<float, 3> & _arg)
  {
    this->accel_scale_0 = _arg;
    return *this;
  }
  Type & set__accel_offset_1(
    const std::array<float, 3> & _arg)
  {
    this->accel_offset_1 = _arg;
    return *this;
  }
  Type & set__accel_scale_1(
    const std::array<float, 3> & _arg)
  {
    this->accel_scale_1 = _arg;
    return *this;
  }
  Type & set__accel_offset_2(
    const std::array<float, 3> & _arg)
  {
    this->accel_offset_2 = _arg;
    return *this;
  }
  Type & set__accel_scale_2(
    const std::array<float, 3> & _arg)
  {
    this->accel_scale_2 = _arg;
    return *this;
  }
  Type & set__baro_offset_0(
    const float & _arg)
  {
    this->baro_offset_0 = _arg;
    return *this;
  }
  Type & set__baro_scale_0(
    const float & _arg)
  {
    this->baro_scale_0 = _arg;
    return *this;
  }
  Type & set__baro_offset_1(
    const float & _arg)
  {
    this->baro_offset_1 = _arg;
    return *this;
  }
  Type & set__baro_scale_1(
    const float & _arg)
  {
    this->baro_scale_1 = _arg;
    return *this;
  }
  Type & set__baro_offset_2(
    const float & _arg)
  {
    this->baro_offset_2 = _arg;
    return *this;
  }
  Type & set__baro_scale_2(
    const float & _arg)
  {
    this->baro_scale_2 = _arg;
    return *this;
  }
  Type & set__selected_gyro_instance(
    const uint8_t & _arg)
  {
    this->selected_gyro_instance = _arg;
    return *this;
  }
  Type & set__selected_accel_instance(
    const uint8_t & _arg)
  {
    this->selected_accel_instance = _arg;
    return *this;
  }
  Type & set__selected_baro_instance(
    const uint8_t & _arg)
  {
    this->selected_baro_instance = _arg;
    return *this;
  }
  Type & set__gyro_mapping(
    const std::array<uint8_t, 3> & _arg)
  {
    this->gyro_mapping = _arg;
    return *this;
  }
  Type & set__accel_mapping(
    const std::array<uint8_t, 3> & _arg)
  {
    this->accel_mapping = _arg;
    return *this;
  }
  Type & set__baro_mapping(
    const std::array<uint8_t, 3> & _arg)
  {
    this->baro_mapping = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    px4_msgs::msg::SensorCorrection_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::SensorCorrection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorCorrection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorCorrection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorCorrection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorCorrection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorCorrection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorCorrection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorCorrection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorCorrection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__SensorCorrection
    std::shared_ptr<px4_msgs::msg::SensorCorrection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__SensorCorrection
    std::shared_ptr<px4_msgs::msg::SensorCorrection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorCorrection_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->gyro_offset_0 != other.gyro_offset_0) {
      return false;
    }
    if (this->gyro_scale_0 != other.gyro_scale_0) {
      return false;
    }
    if (this->gyro_offset_1 != other.gyro_offset_1) {
      return false;
    }
    if (this->gyro_scale_1 != other.gyro_scale_1) {
      return false;
    }
    if (this->gyro_offset_2 != other.gyro_offset_2) {
      return false;
    }
    if (this->gyro_scale_2 != other.gyro_scale_2) {
      return false;
    }
    if (this->accel_offset_0 != other.accel_offset_0) {
      return false;
    }
    if (this->accel_scale_0 != other.accel_scale_0) {
      return false;
    }
    if (this->accel_offset_1 != other.accel_offset_1) {
      return false;
    }
    if (this->accel_scale_1 != other.accel_scale_1) {
      return false;
    }
    if (this->accel_offset_2 != other.accel_offset_2) {
      return false;
    }
    if (this->accel_scale_2 != other.accel_scale_2) {
      return false;
    }
    if (this->baro_offset_0 != other.baro_offset_0) {
      return false;
    }
    if (this->baro_scale_0 != other.baro_scale_0) {
      return false;
    }
    if (this->baro_offset_1 != other.baro_offset_1) {
      return false;
    }
    if (this->baro_scale_1 != other.baro_scale_1) {
      return false;
    }
    if (this->baro_offset_2 != other.baro_offset_2) {
      return false;
    }
    if (this->baro_scale_2 != other.baro_scale_2) {
      return false;
    }
    if (this->selected_gyro_instance != other.selected_gyro_instance) {
      return false;
    }
    if (this->selected_accel_instance != other.selected_accel_instance) {
      return false;
    }
    if (this->selected_baro_instance != other.selected_baro_instance) {
      return false;
    }
    if (this->gyro_mapping != other.gyro_mapping) {
      return false;
    }
    if (this->accel_mapping != other.accel_mapping) {
      return false;
    }
    if (this->baro_mapping != other.baro_mapping) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorCorrection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorCorrection_

// alias to use template instance with default allocator
using SensorCorrection =
  px4_msgs::msg::SensorCorrection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__SENSOR_CORRECTION__STRUCT_HPP_
