// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/SubsystemInfo.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__SUBSYSTEM_INFO__STRUCT_HPP_
#define PX4_MSGS__MSG__SUBSYSTEM_INFO__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__SubsystemInfo __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__SubsystemInfo __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SubsystemInfo_
{
  using Type = SubsystemInfo_<ContainerAllocator>;

  explicit SubsystemInfo_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->present = false;
      this->enabled = false;
      this->ok = false;
      this->subsystem_type = 0ull;
    }
  }

  explicit SubsystemInfo_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->present = false;
      this->enabled = false;
      this->ok = false;
      this->subsystem_type = 0ull;
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _present_type =
    bool;
  _present_type present;
  using _enabled_type =
    bool;
  _enabled_type enabled;
  using _ok_type =
    bool;
  _ok_type ok;
  using _subsystem_type_type =
    uint64_t;
  _subsystem_type_type subsystem_type;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__present(
    const bool & _arg)
  {
    this->present = _arg;
    return *this;
  }
  Type & set__enabled(
    const bool & _arg)
  {
    this->enabled = _arg;
    return *this;
  }
  Type & set__ok(
    const bool & _arg)
  {
    this->ok = _arg;
    return *this;
  }
  Type & set__subsystem_type(
    const uint64_t & _arg)
  {
    this->subsystem_type = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint64_t SUBSYSTEM_TYPE_GYRO =
    1u;
  static constexpr uint64_t SUBSYSTEM_TYPE_ACC =
    2u;
  static constexpr uint64_t SUBSYSTEM_TYPE_MAG =
    4u;
  static constexpr uint64_t SUBSYSTEM_TYPE_ABSPRESSURE =
    8u;
  static constexpr uint64_t SUBSYSTEM_TYPE_DIFFPRESSURE =
    16u;
  static constexpr uint64_t SUBSYSTEM_TYPE_GPS =
    32u;
  static constexpr uint64_t SUBSYSTEM_TYPE_OPTICALFLOW =
    64u;
  static constexpr uint64_t SUBSYSTEM_TYPE_CVPOSITION =
    128u;
  static constexpr uint64_t SUBSYSTEM_TYPE_LASERPOSITION =
    256u;
  static constexpr uint64_t SUBSYSTEM_TYPE_EXTERNALGROUNDTRUTH =
    512u;
  static constexpr uint64_t SUBSYSTEM_TYPE_ANGULARRATECONTROL =
    1024u;
  static constexpr uint64_t SUBSYSTEM_TYPE_ATTITUDESTABILIZATION =
    2048u;
  static constexpr uint64_t SUBSYSTEM_TYPE_YAWPOSITION =
    4096u;
  static constexpr uint64_t SUBSYSTEM_TYPE_ALTITUDECONTROL =
    8192u;
  static constexpr uint64_t SUBSYSTEM_TYPE_POSITIONCONTROL =
    16384u;
  static constexpr uint64_t SUBSYSTEM_TYPE_MOTORCONTROL =
    32768u;
  static constexpr uint64_t SUBSYSTEM_TYPE_RCRECEIVER =
    65536u;
  static constexpr uint64_t SUBSYSTEM_TYPE_GYRO2 =
    131072u;
  static constexpr uint64_t SUBSYSTEM_TYPE_ACC2 =
    262144u;
  static constexpr uint64_t SUBSYSTEM_TYPE_MAG2 =
    524288u;
  static constexpr uint64_t SUBSYSTEM_TYPE_GEOFENCE =
    1048576u;
  static constexpr uint64_t SUBSYSTEM_TYPE_AHRS =
    2097152u;
  static constexpr uint64_t SUBSYSTEM_TYPE_TERRAIN =
    4194304u;
  static constexpr uint64_t SUBSYSTEM_TYPE_REVERSEMOTOR =
    8388608u;
  static constexpr uint64_t SUBSYSTEM_TYPE_LOGGING =
    16777216u;
  static constexpr uint64_t SUBSYSTEM_TYPE_SENSORBATTERY =
    33554432u;
  static constexpr uint64_t SUBSYSTEM_TYPE_SENSORPROXIMITY =
    67108864u;
  static constexpr uint64_t SUBSYSTEM_TYPE_SATCOM =
    134217728u;
  static constexpr uint8_t ORB_QUEUE_LENGTH =
    5u;

  // pointer types
  using RawPtr =
    px4_msgs::msg::SubsystemInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::SubsystemInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::SubsystemInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::SubsystemInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SubsystemInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SubsystemInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SubsystemInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SubsystemInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::SubsystemInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::SubsystemInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__SubsystemInfo
    std::shared_ptr<px4_msgs::msg::SubsystemInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__SubsystemInfo
    std::shared_ptr<px4_msgs::msg::SubsystemInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SubsystemInfo_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->present != other.present) {
      return false;
    }
    if (this->enabled != other.enabled) {
      return false;
    }
    if (this->ok != other.ok) {
      return false;
    }
    if (this->subsystem_type != other.subsystem_type) {
      return false;
    }
    return true;
  }
  bool operator!=(const SubsystemInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SubsystemInfo_

// alias to use template instance with default allocator
using SubsystemInfo =
  px4_msgs::msg::SubsystemInfo_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_GYRO;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_ACC;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_MAG;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_ABSPRESSURE;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_DIFFPRESSURE;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_GPS;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_OPTICALFLOW;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_CVPOSITION;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_LASERPOSITION;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_EXTERNALGROUNDTRUTH;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_ANGULARRATECONTROL;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_ATTITUDESTABILIZATION;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_YAWPOSITION;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_ALTITUDECONTROL;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_POSITIONCONTROL;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_MOTORCONTROL;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_RCRECEIVER;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_GYRO2;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_ACC2;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_MAG2;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_GEOFENCE;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_AHRS;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_TERRAIN;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_REVERSEMOTOR;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_LOGGING;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_SENSORBATTERY;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_SENSORPROXIMITY;
template<typename ContainerAllocator>
constexpr uint64_t SubsystemInfo_<ContainerAllocator>::SUBSYSTEM_TYPE_SATCOM;
template<typename ContainerAllocator>
constexpr uint8_t SubsystemInfo_<ContainerAllocator>::ORB_QUEUE_LENGTH;

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__SUBSYSTEM_INFO__STRUCT_HPP_
