// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/TelemetryStatus.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__TELEMETRY_STATUS__STRUCT_HPP_
#define PX4_MSGS__MSG__TELEMETRY_STATUS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__TelemetryStatus __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__TelemetryStatus __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TelemetryStatus_
{
  using Type = TelemetryStatus_<ContainerAllocator>;

  explicit TelemetryStatus_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->heartbeat_time = 0ull;
      this->remote_system_id = 0;
      this->remote_component_id = 0;
      this->remote_type = 0;
      this->remote_system_status = 0;
      this->type = 0;
      this->mode = 0;
      this->flow_control = false;
      this->forwarding = false;
      this->mavlink_v2 = false;
      this->ftp = false;
      this->streams = 0;
      this->data_rate = 0.0f;
      this->rate_multiplier = 0.0f;
      this->rate_rx = 0.0f;
      this->rate_tx = 0.0f;
      this->rate_txerr = 0.0f;
    }
  }

  explicit TelemetryStatus_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->heartbeat_time = 0ull;
      this->remote_system_id = 0;
      this->remote_component_id = 0;
      this->remote_type = 0;
      this->remote_system_status = 0;
      this->type = 0;
      this->mode = 0;
      this->flow_control = false;
      this->forwarding = false;
      this->mavlink_v2 = false;
      this->ftp = false;
      this->streams = 0;
      this->data_rate = 0.0f;
      this->rate_multiplier = 0.0f;
      this->rate_rx = 0.0f;
      this->rate_tx = 0.0f;
      this->rate_txerr = 0.0f;
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _heartbeat_time_type =
    uint64_t;
  _heartbeat_time_type heartbeat_time;
  using _remote_system_id_type =
    uint8_t;
  _remote_system_id_type remote_system_id;
  using _remote_component_id_type =
    uint8_t;
  _remote_component_id_type remote_component_id;
  using _remote_type_type =
    uint8_t;
  _remote_type_type remote_type;
  using _remote_system_status_type =
    uint8_t;
  _remote_system_status_type remote_system_status;
  using _type_type =
    uint8_t;
  _type_type type;
  using _mode_type =
    uint8_t;
  _mode_type mode;
  using _flow_control_type =
    bool;
  _flow_control_type flow_control;
  using _forwarding_type =
    bool;
  _forwarding_type forwarding;
  using _mavlink_v2_type =
    bool;
  _mavlink_v2_type mavlink_v2;
  using _ftp_type =
    bool;
  _ftp_type ftp;
  using _streams_type =
    uint8_t;
  _streams_type streams;
  using _data_rate_type =
    float;
  _data_rate_type data_rate;
  using _rate_multiplier_type =
    float;
  _rate_multiplier_type rate_multiplier;
  using _rate_rx_type =
    float;
  _rate_rx_type rate_rx;
  using _rate_tx_type =
    float;
  _rate_tx_type rate_tx;
  using _rate_txerr_type =
    float;
  _rate_txerr_type rate_txerr;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__heartbeat_time(
    const uint64_t & _arg)
  {
    this->heartbeat_time = _arg;
    return *this;
  }
  Type & set__remote_system_id(
    const uint8_t & _arg)
  {
    this->remote_system_id = _arg;
    return *this;
  }
  Type & set__remote_component_id(
    const uint8_t & _arg)
  {
    this->remote_component_id = _arg;
    return *this;
  }
  Type & set__remote_type(
    const uint8_t & _arg)
  {
    this->remote_type = _arg;
    return *this;
  }
  Type & set__remote_system_status(
    const uint8_t & _arg)
  {
    this->remote_system_status = _arg;
    return *this;
  }
  Type & set__type(
    const uint8_t & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__mode(
    const uint8_t & _arg)
  {
    this->mode = _arg;
    return *this;
  }
  Type & set__flow_control(
    const bool & _arg)
  {
    this->flow_control = _arg;
    return *this;
  }
  Type & set__forwarding(
    const bool & _arg)
  {
    this->forwarding = _arg;
    return *this;
  }
  Type & set__mavlink_v2(
    const bool & _arg)
  {
    this->mavlink_v2 = _arg;
    return *this;
  }
  Type & set__ftp(
    const bool & _arg)
  {
    this->ftp = _arg;
    return *this;
  }
  Type & set__streams(
    const uint8_t & _arg)
  {
    this->streams = _arg;
    return *this;
  }
  Type & set__data_rate(
    const float & _arg)
  {
    this->data_rate = _arg;
    return *this;
  }
  Type & set__rate_multiplier(
    const float & _arg)
  {
    this->rate_multiplier = _arg;
    return *this;
  }
  Type & set__rate_rx(
    const float & _arg)
  {
    this->rate_rx = _arg;
    return *this;
  }
  Type & set__rate_tx(
    const float & _arg)
  {
    this->rate_tx = _arg;
    return *this;
  }
  Type & set__rate_txerr(
    const float & _arg)
  {
    this->rate_txerr = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t LINK_TYPE_GENERIC =
    0u;
  static constexpr uint8_t LINK_TYPE_3DR_RADIO =
    1u;
  static constexpr uint8_t LINK_TYPE_UBIQUITY_BULLET =
    2u;
  static constexpr uint8_t LINK_TYPE_WIRE =
    3u;
  static constexpr uint8_t LINK_TYPE_USB =
    4u;
  static constexpr uint8_t LINK_TYPE_IRIDIUM =
    5u;
  static constexpr uint8_t COMPONENT_ID_ALL =
    0u;
  static constexpr uint8_t COMPONENT_ID_AUTOPILOT1 =
    1u;
  static constexpr uint8_t COMPONENT_ID_CAMERA =
    100u;
  static constexpr uint8_t COMPONENT_ID_OBSTACLE_AVOIDANCE =
    196u;
  static constexpr uint8_t MAV_TYPE_GENERIC =
    0u;
  static constexpr uint8_t MAV_TYPE_GCS =
    6u;
  static constexpr uint8_t MAV_TYPE_ONBOARD_CONTROLLER =
    18u;
  static constexpr uint8_t MAV_STATE_UNINIT =
    0u;
  static constexpr uint8_t MAV_STATE_BOOT =
    1u;
  static constexpr uint8_t MAV_STATE_CALIBRATING =
    2u;
  static constexpr uint8_t MAV_STATE_STANDBY =
    3u;
  static constexpr uint8_t MAV_STATE_ACTIVE =
    4u;
  static constexpr uint8_t MAV_STATE_CRITICAL =
    5u;
  static constexpr uint8_t MAV_STATE_EMERGENCY =
    6u;
  static constexpr uint8_t MAV_STATE_POWEROFF =
    7u;
  static constexpr uint8_t MAV_STATE_FLIGHT_TERMINATION =
    8u;
  static constexpr uint8_t ORB_QUEUE_LENGTH =
    3u;

  // pointer types
  using RawPtr =
    px4_msgs::msg::TelemetryStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::TelemetryStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::TelemetryStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::TelemetryStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::TelemetryStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::TelemetryStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::TelemetryStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::TelemetryStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::TelemetryStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::TelemetryStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__TelemetryStatus
    std::shared_ptr<px4_msgs::msg::TelemetryStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__TelemetryStatus
    std::shared_ptr<px4_msgs::msg::TelemetryStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TelemetryStatus_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->heartbeat_time != other.heartbeat_time) {
      return false;
    }
    if (this->remote_system_id != other.remote_system_id) {
      return false;
    }
    if (this->remote_component_id != other.remote_component_id) {
      return false;
    }
    if (this->remote_type != other.remote_type) {
      return false;
    }
    if (this->remote_system_status != other.remote_system_status) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->mode != other.mode) {
      return false;
    }
    if (this->flow_control != other.flow_control) {
      return false;
    }
    if (this->forwarding != other.forwarding) {
      return false;
    }
    if (this->mavlink_v2 != other.mavlink_v2) {
      return false;
    }
    if (this->ftp != other.ftp) {
      return false;
    }
    if (this->streams != other.streams) {
      return false;
    }
    if (this->data_rate != other.data_rate) {
      return false;
    }
    if (this->rate_multiplier != other.rate_multiplier) {
      return false;
    }
    if (this->rate_rx != other.rate_rx) {
      return false;
    }
    if (this->rate_tx != other.rate_tx) {
      return false;
    }
    if (this->rate_txerr != other.rate_txerr) {
      return false;
    }
    return true;
  }
  bool operator!=(const TelemetryStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TelemetryStatus_

// alias to use template instance with default allocator
using TelemetryStatus =
  px4_msgs::msg::TelemetryStatus_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::LINK_TYPE_GENERIC;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::LINK_TYPE_3DR_RADIO;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::LINK_TYPE_UBIQUITY_BULLET;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::LINK_TYPE_WIRE;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::LINK_TYPE_USB;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::LINK_TYPE_IRIDIUM;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::COMPONENT_ID_ALL;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::COMPONENT_ID_AUTOPILOT1;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::COMPONENT_ID_CAMERA;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::COMPONENT_ID_OBSTACLE_AVOIDANCE;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_TYPE_GENERIC;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_TYPE_GCS;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_TYPE_ONBOARD_CONTROLLER;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_UNINIT;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_BOOT;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_CALIBRATING;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_STANDBY;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_ACTIVE;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_CRITICAL;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_EMERGENCY;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_POWEROFF;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::MAV_STATE_FLIGHT_TERMINATION;
template<typename ContainerAllocator>
constexpr uint8_t TelemetryStatus_<ContainerAllocator>::ORB_QUEUE_LENGTH;

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__TELEMETRY_STATUS__STRUCT_HPP_
