// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from px4_msgs:msg/BatteryStatus.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__BATTERY_STATUS__STRUCT_H_
#define PX4_MSGS__MSG__BATTERY_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'BATTERY_WARNING_NONE'.
enum
{
  px4_msgs__msg__BatteryStatus__BATTERY_WARNING_NONE = 0
};

/// Constant 'BATTERY_WARNING_LOW'.
enum
{
  px4_msgs__msg__BatteryStatus__BATTERY_WARNING_LOW = 1
};

/// Constant 'BATTERY_WARNING_CRITICAL'.
enum
{
  px4_msgs__msg__BatteryStatus__BATTERY_WARNING_CRITICAL = 2
};

/// Constant 'BATTERY_WARNING_EMERGENCY'.
enum
{
  px4_msgs__msg__BatteryStatus__BATTERY_WARNING_EMERGENCY = 3
};

/// Constant 'BATTERY_WARNING_FAILED'.
enum
{
  px4_msgs__msg__BatteryStatus__BATTERY_WARNING_FAILED = 4
};

// Struct defined in msg/BatteryStatus in the package px4_msgs.
typedef struct px4_msgs__msg__BatteryStatus
{
  uint64_t timestamp;
  float voltage_v;
  float voltage_filtered_v;
  float current_a;
  float current_filtered_a;
  float average_current_a;
  float discharged_mah;
  float remaining;
  float scale;
  float temperature;
  int32_t cell_count;
  bool connected;
  bool system_source;
  uint8_t priority;
  uint16_t capacity;
  uint16_t cycle_count;
  uint16_t run_time_to_empty;
  uint16_t average_time_to_empty;
  uint16_t serial_number;
  float voltage_cell_v[4];
  float max_cell_voltage_delta;
  bool is_powering_off;
  uint8_t warning;
} px4_msgs__msg__BatteryStatus;

// Struct for a sequence of px4_msgs__msg__BatteryStatus.
typedef struct px4_msgs__msg__BatteryStatus__Sequence
{
  px4_msgs__msg__BatteryStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} px4_msgs__msg__BatteryStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PX4_MSGS__MSG__BATTERY_STATUS__STRUCT_H_
