#ifndef _H_A930C1803E8758984063561E4FDF8B68_ActuatorArmed__H_
#define _H_A930C1803E8758984063561E4FDF8B68_ActuatorArmed__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  ActuatorArmed_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::ULong armed_time_ms_;
                ::DDS::Boolean armed_;
                ::DDS::Boolean prearmed_;
                ::DDS::Boolean ready_to_arm_;
                ::DDS::Boolean lockdown_;
                ::DDS::Boolean manual_lockdown_;
                ::DDS::Boolean force_failsafe_;
                ::DDS::Boolean in_esc_calibration_mode_;
                ::DDS::Boolean soft_stop_;
            };

            typedef DDS_DCPSStruct_var<ActuatorArmed_> ActuatorArmed__var;
            typedef ActuatorArmed_& ActuatorArmed__out;

        }

    }

}

#endif /* _H_A930C1803E8758984063561E4FDF8B68_ActuatorArmed__H_ */
