#ifndef _H_28195355DB9C8C15703A2E7A4B634619_ActuatorControls1_DCPS_H_
#define _H_28195355DB9C8C15703A2E7A4B634619_ActuatorControls1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorControls1_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorControls1_TypeSupportInterface;

            typedef ActuatorControls1_TypeSupportInterface * ActuatorControls1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls1_TypeSupportInterface> ActuatorControls1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorControls1_TypeSupportInterface> ActuatorControls1_TypeSupportInterface_out;


            class ActuatorControls1_DataWriter;

            typedef ActuatorControls1_DataWriter * ActuatorControls1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls1_DataWriter> ActuatorControls1_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorControls1_DataWriter> ActuatorControls1_DataWriter_out;


            class ActuatorControls1_DataReader;

            typedef ActuatorControls1_DataReader * ActuatorControls1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls1_DataReader> ActuatorControls1_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorControls1_DataReader> ActuatorControls1_DataReader_out;


            class ActuatorControls1_DataReaderView;

            typedef ActuatorControls1_DataReaderView * ActuatorControls1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls1_DataReaderView> ActuatorControls1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorControls1_DataReaderView> ActuatorControls1_DataReaderView_out;

            struct ActuatorControls1_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorControls1_, struct ActuatorControls1_Seq_uniq_> ActuatorControls1_Seq;
            typedef DDS_DCPSSequence_var < ActuatorControls1_Seq> ActuatorControls1_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorControls1_Seq> ActuatorControls1_Seq_out;

            class  ActuatorControls1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorControls1_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorControls1_TypeSupportInterface_var _var_type;

                static ActuatorControls1_TypeSupportInterface_ptr _duplicate (ActuatorControls1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorControls1_TypeSupportInterface () {};
                ~ActuatorControls1_TypeSupportInterface () {};
            private:
                ActuatorControls1_TypeSupportInterface (const ActuatorControls1_TypeSupportInterface &);
                ActuatorControls1_TypeSupportInterface & operator = (const ActuatorControls1_TypeSupportInterface &);
            };

            class  ActuatorControls1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorControls1_DataWriter_ptr _ptr_type;
                typedef ActuatorControls1_DataWriter_var _var_type;

                static ActuatorControls1_DataWriter_ptr _duplicate (ActuatorControls1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorControls1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorControls1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorControls1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorControls1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorControls1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorControls1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorControls1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorControls1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorControls1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorControls1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorControls1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls1_& instance_data) = 0;

            protected:
                ActuatorControls1_DataWriter () {};
                ~ActuatorControls1_DataWriter () {};
            private:
                ActuatorControls1_DataWriter (const ActuatorControls1_DataWriter &);
                ActuatorControls1_DataWriter & operator = (const ActuatorControls1_DataWriter &);
            };

            class  ActuatorControls1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorControls1_DataReader_ptr _ptr_type;
                typedef ActuatorControls1_DataReader_var _var_type;

                static ActuatorControls1_DataReader_ptr _duplicate (ActuatorControls1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls1_& instance) = 0;

            protected:
                ActuatorControls1_DataReader () {};
                ~ActuatorControls1_DataReader () {};
            private:
                ActuatorControls1_DataReader (const ActuatorControls1_DataReader &);
                ActuatorControls1_DataReader & operator = (const ActuatorControls1_DataReader &);
            };

            class  ActuatorControls1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorControls1_DataReaderView_ptr _ptr_type;
                typedef ActuatorControls1_DataReaderView_var _var_type;

                static ActuatorControls1_DataReaderView_ptr _duplicate (ActuatorControls1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls1_& instance) = 0;

            protected:
                ActuatorControls1_DataReaderView () {};
                ~ActuatorControls1_DataReaderView () {};
            private:
                ActuatorControls1_DataReaderView (const ActuatorControls1_DataReaderView &);
                ActuatorControls1_DataReaderView & operator = (const ActuatorControls1_DataReaderView &);
            };
        }

    }

}

#endif
