#ifndef _H_E87352A2C94251E405E09ACA2FAA7457_ActuatorControls3_DCPS_H_
#define _H_E87352A2C94251E405E09ACA2FAA7457_ActuatorControls3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorControls3_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorControls3_TypeSupportInterface;

            typedef ActuatorControls3_TypeSupportInterface * ActuatorControls3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls3_TypeSupportInterface> ActuatorControls3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorControls3_TypeSupportInterface> ActuatorControls3_TypeSupportInterface_out;


            class ActuatorControls3_DataWriter;

            typedef ActuatorControls3_DataWriter * ActuatorControls3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls3_DataWriter> ActuatorControls3_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorControls3_DataWriter> ActuatorControls3_DataWriter_out;


            class ActuatorControls3_DataReader;

            typedef ActuatorControls3_DataReader * ActuatorControls3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls3_DataReader> ActuatorControls3_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorControls3_DataReader> ActuatorControls3_DataReader_out;


            class ActuatorControls3_DataReaderView;

            typedef ActuatorControls3_DataReaderView * ActuatorControls3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControls3_DataReaderView> ActuatorControls3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorControls3_DataReaderView> ActuatorControls3_DataReaderView_out;

            struct ActuatorControls3_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorControls3_, struct ActuatorControls3_Seq_uniq_> ActuatorControls3_Seq;
            typedef DDS_DCPSSequence_var < ActuatorControls3_Seq> ActuatorControls3_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorControls3_Seq> ActuatorControls3_Seq_out;

            class  ActuatorControls3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorControls3_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorControls3_TypeSupportInterface_var _var_type;

                static ActuatorControls3_TypeSupportInterface_ptr _duplicate (ActuatorControls3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorControls3_TypeSupportInterface () {};
                ~ActuatorControls3_TypeSupportInterface () {};
            private:
                ActuatorControls3_TypeSupportInterface (const ActuatorControls3_TypeSupportInterface &);
                ActuatorControls3_TypeSupportInterface & operator = (const ActuatorControls3_TypeSupportInterface &);
            };

            class  ActuatorControls3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorControls3_DataWriter_ptr _ptr_type;
                typedef ActuatorControls3_DataWriter_var _var_type;

                static ActuatorControls3_DataWriter_ptr _duplicate (ActuatorControls3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorControls3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorControls3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorControls3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorControls3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorControls3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorControls3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorControls3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorControls3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorControls3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorControls3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorControls3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls3_& instance_data) = 0;

            protected:
                ActuatorControls3_DataWriter () {};
                ~ActuatorControls3_DataWriter () {};
            private:
                ActuatorControls3_DataWriter (const ActuatorControls3_DataWriter &);
                ActuatorControls3_DataWriter & operator = (const ActuatorControls3_DataWriter &);
            };

            class  ActuatorControls3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorControls3_DataReader_ptr _ptr_type;
                typedef ActuatorControls3_DataReader_var _var_type;

                static ActuatorControls3_DataReader_ptr _duplicate (ActuatorControls3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls3_& instance) = 0;

            protected:
                ActuatorControls3_DataReader () {};
                ~ActuatorControls3_DataReader () {};
            private:
                ActuatorControls3_DataReader (const ActuatorControls3_DataReader &);
                ActuatorControls3_DataReader & operator = (const ActuatorControls3_DataReader &);
            };

            class  ActuatorControls3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorControls3_DataReaderView_ptr _ptr_type;
                typedef ActuatorControls3_DataReaderView_var _var_type;

                static ActuatorControls3_DataReaderView_ptr _duplicate (ActuatorControls3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControls3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControls3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControls3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControls3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControls3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControls3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControls3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControls3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControls3_& instance) = 0;

            protected:
                ActuatorControls3_DataReaderView () {};
                ~ActuatorControls3_DataReaderView () {};
            private:
                ActuatorControls3_DataReaderView (const ActuatorControls3_DataReaderView &);
                ActuatorControls3_DataReaderView & operator = (const ActuatorControls3_DataReaderView &);
            };
        }

    }

}

#endif
