#ifndef _H_F31C61EE0153ACB5A8949F4234C84668_ActuatorControlsVirtualFw_DCPS_H_
#define _H_F31C61EE0153ACB5A8949F4234C84668_ActuatorControlsVirtualFw_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorControlsVirtualFw_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorControlsVirtualFw_TypeSupportInterface;

            typedef ActuatorControlsVirtualFw_TypeSupportInterface * ActuatorControlsVirtualFw_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlsVirtualFw_TypeSupportInterface> ActuatorControlsVirtualFw_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorControlsVirtualFw_TypeSupportInterface> ActuatorControlsVirtualFw_TypeSupportInterface_out;


            class ActuatorControlsVirtualFw_DataWriter;

            typedef ActuatorControlsVirtualFw_DataWriter * ActuatorControlsVirtualFw_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlsVirtualFw_DataWriter> ActuatorControlsVirtualFw_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorControlsVirtualFw_DataWriter> ActuatorControlsVirtualFw_DataWriter_out;


            class ActuatorControlsVirtualFw_DataReader;

            typedef ActuatorControlsVirtualFw_DataReader * ActuatorControlsVirtualFw_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlsVirtualFw_DataReader> ActuatorControlsVirtualFw_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorControlsVirtualFw_DataReader> ActuatorControlsVirtualFw_DataReader_out;


            class ActuatorControlsVirtualFw_DataReaderView;

            typedef ActuatorControlsVirtualFw_DataReaderView * ActuatorControlsVirtualFw_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlsVirtualFw_DataReaderView> ActuatorControlsVirtualFw_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorControlsVirtualFw_DataReaderView> ActuatorControlsVirtualFw_DataReaderView_out;

            struct ActuatorControlsVirtualFw_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorControlsVirtualFw_, struct ActuatorControlsVirtualFw_Seq_uniq_> ActuatorControlsVirtualFw_Seq;
            typedef DDS_DCPSSequence_var < ActuatorControlsVirtualFw_Seq> ActuatorControlsVirtualFw_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorControlsVirtualFw_Seq> ActuatorControlsVirtualFw_Seq_out;

            class  ActuatorControlsVirtualFw_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorControlsVirtualFw_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorControlsVirtualFw_TypeSupportInterface_var _var_type;

                static ActuatorControlsVirtualFw_TypeSupportInterface_ptr _duplicate (ActuatorControlsVirtualFw_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlsVirtualFw_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualFw_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualFw_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlsVirtualFw_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorControlsVirtualFw_TypeSupportInterface () {};
                ~ActuatorControlsVirtualFw_TypeSupportInterface () {};
            private:
                ActuatorControlsVirtualFw_TypeSupportInterface (const ActuatorControlsVirtualFw_TypeSupportInterface &);
                ActuatorControlsVirtualFw_TypeSupportInterface & operator = (const ActuatorControlsVirtualFw_TypeSupportInterface &);
            };

            class  ActuatorControlsVirtualFw_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorControlsVirtualFw_DataWriter_ptr _ptr_type;
                typedef ActuatorControlsVirtualFw_DataWriter_var _var_type;

                static ActuatorControlsVirtualFw_DataWriter_ptr _duplicate (ActuatorControlsVirtualFw_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlsVirtualFw_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualFw_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualFw_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlsVirtualFw_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorControlsVirtualFw_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorControlsVirtualFw_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorControlsVirtualFw_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorControlsVirtualFw_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorControlsVirtualFw_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorControlsVirtualFw_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorControlsVirtualFw_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorControlsVirtualFw_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorControlsVirtualFw_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorControlsVirtualFw_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorControlsVirtualFw_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlsVirtualFw_& instance_data) = 0;

            protected:
                ActuatorControlsVirtualFw_DataWriter () {};
                ~ActuatorControlsVirtualFw_DataWriter () {};
            private:
                ActuatorControlsVirtualFw_DataWriter (const ActuatorControlsVirtualFw_DataWriter &);
                ActuatorControlsVirtualFw_DataWriter & operator = (const ActuatorControlsVirtualFw_DataWriter &);
            };

            class  ActuatorControlsVirtualFw_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorControlsVirtualFw_DataReader_ptr _ptr_type;
                typedef ActuatorControlsVirtualFw_DataReader_var _var_type;

                static ActuatorControlsVirtualFw_DataReader_ptr _duplicate (ActuatorControlsVirtualFw_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlsVirtualFw_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualFw_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualFw_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlsVirtualFw_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControlsVirtualFw_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControlsVirtualFw_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControlsVirtualFw_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlsVirtualFw_& instance) = 0;

            protected:
                ActuatorControlsVirtualFw_DataReader () {};
                ~ActuatorControlsVirtualFw_DataReader () {};
            private:
                ActuatorControlsVirtualFw_DataReader (const ActuatorControlsVirtualFw_DataReader &);
                ActuatorControlsVirtualFw_DataReader & operator = (const ActuatorControlsVirtualFw_DataReader &);
            };

            class  ActuatorControlsVirtualFw_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorControlsVirtualFw_DataReaderView_ptr _ptr_type;
                typedef ActuatorControlsVirtualFw_DataReaderView_var _var_type;

                static ActuatorControlsVirtualFw_DataReaderView_ptr _duplicate (ActuatorControlsVirtualFw_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlsVirtualFw_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualFw_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualFw_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlsVirtualFw_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControlsVirtualFw_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControlsVirtualFw_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControlsVirtualFw_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControlsVirtualFw_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlsVirtualFw_& instance) = 0;

            protected:
                ActuatorControlsVirtualFw_DataReaderView () {};
                ~ActuatorControlsVirtualFw_DataReaderView () {};
            private:
                ActuatorControlsVirtualFw_DataReaderView (const ActuatorControlsVirtualFw_DataReaderView &);
                ActuatorControlsVirtualFw_DataReaderView & operator = (const ActuatorControlsVirtualFw_DataReaderView &);
            };
        }

    }

}

#endif
