#ifndef _H_512CAECECF57244CB5A95188C1765067_ActuatorControlsVirtualMc_DCPS_H_
#define _H_512CAECECF57244CB5A95188C1765067_ActuatorControlsVirtualMc_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorControlsVirtualMc_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorControlsVirtualMc_TypeSupportInterface;

            typedef ActuatorControlsVirtualMc_TypeSupportInterface * ActuatorControlsVirtualMc_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlsVirtualMc_TypeSupportInterface> ActuatorControlsVirtualMc_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorControlsVirtualMc_TypeSupportInterface> ActuatorControlsVirtualMc_TypeSupportInterface_out;


            class ActuatorControlsVirtualMc_DataWriter;

            typedef ActuatorControlsVirtualMc_DataWriter * ActuatorControlsVirtualMc_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlsVirtualMc_DataWriter> ActuatorControlsVirtualMc_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorControlsVirtualMc_DataWriter> ActuatorControlsVirtualMc_DataWriter_out;


            class ActuatorControlsVirtualMc_DataReader;

            typedef ActuatorControlsVirtualMc_DataReader * ActuatorControlsVirtualMc_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlsVirtualMc_DataReader> ActuatorControlsVirtualMc_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorControlsVirtualMc_DataReader> ActuatorControlsVirtualMc_DataReader_out;


            class ActuatorControlsVirtualMc_DataReaderView;

            typedef ActuatorControlsVirtualMc_DataReaderView * ActuatorControlsVirtualMc_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlsVirtualMc_DataReaderView> ActuatorControlsVirtualMc_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorControlsVirtualMc_DataReaderView> ActuatorControlsVirtualMc_DataReaderView_out;

            struct ActuatorControlsVirtualMc_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorControlsVirtualMc_, struct ActuatorControlsVirtualMc_Seq_uniq_> ActuatorControlsVirtualMc_Seq;
            typedef DDS_DCPSSequence_var < ActuatorControlsVirtualMc_Seq> ActuatorControlsVirtualMc_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorControlsVirtualMc_Seq> ActuatorControlsVirtualMc_Seq_out;

            class  ActuatorControlsVirtualMc_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorControlsVirtualMc_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorControlsVirtualMc_TypeSupportInterface_var _var_type;

                static ActuatorControlsVirtualMc_TypeSupportInterface_ptr _duplicate (ActuatorControlsVirtualMc_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlsVirtualMc_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualMc_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualMc_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlsVirtualMc_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorControlsVirtualMc_TypeSupportInterface () {};
                ~ActuatorControlsVirtualMc_TypeSupportInterface () {};
            private:
                ActuatorControlsVirtualMc_TypeSupportInterface (const ActuatorControlsVirtualMc_TypeSupportInterface &);
                ActuatorControlsVirtualMc_TypeSupportInterface & operator = (const ActuatorControlsVirtualMc_TypeSupportInterface &);
            };

            class  ActuatorControlsVirtualMc_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorControlsVirtualMc_DataWriter_ptr _ptr_type;
                typedef ActuatorControlsVirtualMc_DataWriter_var _var_type;

                static ActuatorControlsVirtualMc_DataWriter_ptr _duplicate (ActuatorControlsVirtualMc_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlsVirtualMc_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualMc_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualMc_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlsVirtualMc_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorControlsVirtualMc_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorControlsVirtualMc_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorControlsVirtualMc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorControlsVirtualMc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorControlsVirtualMc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorControlsVirtualMc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorControlsVirtualMc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorControlsVirtualMc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorControlsVirtualMc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorControlsVirtualMc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorControlsVirtualMc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlsVirtualMc_& instance_data) = 0;

            protected:
                ActuatorControlsVirtualMc_DataWriter () {};
                ~ActuatorControlsVirtualMc_DataWriter () {};
            private:
                ActuatorControlsVirtualMc_DataWriter (const ActuatorControlsVirtualMc_DataWriter &);
                ActuatorControlsVirtualMc_DataWriter & operator = (const ActuatorControlsVirtualMc_DataWriter &);
            };

            class  ActuatorControlsVirtualMc_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorControlsVirtualMc_DataReader_ptr _ptr_type;
                typedef ActuatorControlsVirtualMc_DataReader_var _var_type;

                static ActuatorControlsVirtualMc_DataReader_ptr _duplicate (ActuatorControlsVirtualMc_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlsVirtualMc_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualMc_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualMc_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlsVirtualMc_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControlsVirtualMc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControlsVirtualMc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControlsVirtualMc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlsVirtualMc_& instance) = 0;

            protected:
                ActuatorControlsVirtualMc_DataReader () {};
                ~ActuatorControlsVirtualMc_DataReader () {};
            private:
                ActuatorControlsVirtualMc_DataReader (const ActuatorControlsVirtualMc_DataReader &);
                ActuatorControlsVirtualMc_DataReader & operator = (const ActuatorControlsVirtualMc_DataReader &);
            };

            class  ActuatorControlsVirtualMc_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorControlsVirtualMc_DataReaderView_ptr _ptr_type;
                typedef ActuatorControlsVirtualMc_DataReaderView_var _var_type;

                static ActuatorControlsVirtualMc_DataReaderView_ptr _duplicate (ActuatorControlsVirtualMc_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlsVirtualMc_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualMc_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlsVirtualMc_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlsVirtualMc_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControlsVirtualMc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControlsVirtualMc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControlsVirtualMc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControlsVirtualMc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlsVirtualMc_& instance) = 0;

            protected:
                ActuatorControlsVirtualMc_DataReaderView () {};
                ~ActuatorControlsVirtualMc_DataReaderView () {};
            private:
                ActuatorControlsVirtualMc_DataReaderView (const ActuatorControlsVirtualMc_DataReaderView &);
                ActuatorControlsVirtualMc_DataReaderView & operator = (const ActuatorControlsVirtualMc_DataReaderView &);
            };
        }

    }

}

#endif
