#ifndef _H_F3478832D098B2F482EA34742AF61FB2_ActuatorDirect_DCPS_H_
#define _H_F3478832D098B2F482EA34742AF61FB2_ActuatorDirect_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorDirect_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorDirect_TypeSupportInterface;

            typedef ActuatorDirect_TypeSupportInterface * ActuatorDirect_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorDirect_TypeSupportInterface> ActuatorDirect_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorDirect_TypeSupportInterface> ActuatorDirect_TypeSupportInterface_out;


            class ActuatorDirect_DataWriter;

            typedef ActuatorDirect_DataWriter * ActuatorDirect_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorDirect_DataWriter> ActuatorDirect_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorDirect_DataWriter> ActuatorDirect_DataWriter_out;


            class ActuatorDirect_DataReader;

            typedef ActuatorDirect_DataReader * ActuatorDirect_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorDirect_DataReader> ActuatorDirect_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorDirect_DataReader> ActuatorDirect_DataReader_out;


            class ActuatorDirect_DataReaderView;

            typedef ActuatorDirect_DataReaderView * ActuatorDirect_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorDirect_DataReaderView> ActuatorDirect_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorDirect_DataReaderView> ActuatorDirect_DataReaderView_out;

            struct ActuatorDirect_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorDirect_, struct ActuatorDirect_Seq_uniq_> ActuatorDirect_Seq;
            typedef DDS_DCPSSequence_var < ActuatorDirect_Seq> ActuatorDirect_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorDirect_Seq> ActuatorDirect_Seq_out;

            class  ActuatorDirect_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorDirect_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorDirect_TypeSupportInterface_var _var_type;

                static ActuatorDirect_TypeSupportInterface_ptr _duplicate (ActuatorDirect_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorDirect_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorDirect_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorDirect_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorDirect_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorDirect_TypeSupportInterface () {};
                ~ActuatorDirect_TypeSupportInterface () {};
            private:
                ActuatorDirect_TypeSupportInterface (const ActuatorDirect_TypeSupportInterface &);
                ActuatorDirect_TypeSupportInterface & operator = (const ActuatorDirect_TypeSupportInterface &);
            };

            class  ActuatorDirect_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorDirect_DataWriter_ptr _ptr_type;
                typedef ActuatorDirect_DataWriter_var _var_type;

                static ActuatorDirect_DataWriter_ptr _duplicate (ActuatorDirect_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorDirect_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorDirect_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorDirect_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorDirect_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorDirect_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorDirect_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorDirect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorDirect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorDirect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorDirect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorDirect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorDirect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorDirect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorDirect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorDirect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorDirect_& instance_data) = 0;

            protected:
                ActuatorDirect_DataWriter () {};
                ~ActuatorDirect_DataWriter () {};
            private:
                ActuatorDirect_DataWriter (const ActuatorDirect_DataWriter &);
                ActuatorDirect_DataWriter & operator = (const ActuatorDirect_DataWriter &);
            };

            class  ActuatorDirect_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorDirect_DataReader_ptr _ptr_type;
                typedef ActuatorDirect_DataReader_var _var_type;

                static ActuatorDirect_DataReader_ptr _duplicate (ActuatorDirect_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorDirect_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorDirect_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorDirect_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorDirect_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorDirect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorDirect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorDirect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorDirect_& instance) = 0;

            protected:
                ActuatorDirect_DataReader () {};
                ~ActuatorDirect_DataReader () {};
            private:
                ActuatorDirect_DataReader (const ActuatorDirect_DataReader &);
                ActuatorDirect_DataReader & operator = (const ActuatorDirect_DataReader &);
            };

            class  ActuatorDirect_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorDirect_DataReaderView_ptr _ptr_type;
                typedef ActuatorDirect_DataReaderView_var _var_type;

                static ActuatorDirect_DataReaderView_ptr _duplicate (ActuatorDirect_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorDirect_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorDirect_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorDirect_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorDirect_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorDirect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorDirect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorDirect_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorDirect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorDirect_& instance) = 0;

            protected:
                ActuatorDirect_DataReaderView () {};
                ~ActuatorDirect_DataReaderView () {};
            private:
                ActuatorDirect_DataReaderView (const ActuatorDirect_DataReaderView &);
                ActuatorDirect_DataReaderView & operator = (const ActuatorDirect_DataReaderView &);
            };
        }

    }

}

#endif
