#ifndef _H_B8449CF71A8EAD3D9218ECAFEF06747B_ActuatorOutputs_DCPS_H_
#define _H_B8449CF71A8EAD3D9218ECAFEF06747B_ActuatorOutputs_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorOutputs_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorOutputs_TypeSupportInterface;

            typedef ActuatorOutputs_TypeSupportInterface * ActuatorOutputs_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorOutputs_TypeSupportInterface> ActuatorOutputs_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorOutputs_TypeSupportInterface> ActuatorOutputs_TypeSupportInterface_out;


            class ActuatorOutputs_DataWriter;

            typedef ActuatorOutputs_DataWriter * ActuatorOutputs_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorOutputs_DataWriter> ActuatorOutputs_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorOutputs_DataWriter> ActuatorOutputs_DataWriter_out;


            class ActuatorOutputs_DataReader;

            typedef ActuatorOutputs_DataReader * ActuatorOutputs_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorOutputs_DataReader> ActuatorOutputs_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorOutputs_DataReader> ActuatorOutputs_DataReader_out;


            class ActuatorOutputs_DataReaderView;

            typedef ActuatorOutputs_DataReaderView * ActuatorOutputs_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorOutputs_DataReaderView> ActuatorOutputs_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorOutputs_DataReaderView> ActuatorOutputs_DataReaderView_out;

            struct ActuatorOutputs_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorOutputs_, struct ActuatorOutputs_Seq_uniq_> ActuatorOutputs_Seq;
            typedef DDS_DCPSSequence_var < ActuatorOutputs_Seq> ActuatorOutputs_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorOutputs_Seq> ActuatorOutputs_Seq_out;

            class  ActuatorOutputs_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorOutputs_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorOutputs_TypeSupportInterface_var _var_type;

                static ActuatorOutputs_TypeSupportInterface_ptr _duplicate (ActuatorOutputs_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorOutputs_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorOutputs_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorOutputs_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorOutputs_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorOutputs_TypeSupportInterface () {};
                ~ActuatorOutputs_TypeSupportInterface () {};
            private:
                ActuatorOutputs_TypeSupportInterface (const ActuatorOutputs_TypeSupportInterface &);
                ActuatorOutputs_TypeSupportInterface & operator = (const ActuatorOutputs_TypeSupportInterface &);
            };

            class  ActuatorOutputs_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorOutputs_DataWriter_ptr _ptr_type;
                typedef ActuatorOutputs_DataWriter_var _var_type;

                static ActuatorOutputs_DataWriter_ptr _duplicate (ActuatorOutputs_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorOutputs_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorOutputs_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorOutputs_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorOutputs_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorOutputs_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorOutputs_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorOutputs_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorOutputs_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorOutputs_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorOutputs_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorOutputs_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorOutputs_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorOutputs_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorOutputs_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorOutputs_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorOutputs_& instance_data) = 0;

            protected:
                ActuatorOutputs_DataWriter () {};
                ~ActuatorOutputs_DataWriter () {};
            private:
                ActuatorOutputs_DataWriter (const ActuatorOutputs_DataWriter &);
                ActuatorOutputs_DataWriter & operator = (const ActuatorOutputs_DataWriter &);
            };

            class  ActuatorOutputs_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorOutputs_DataReader_ptr _ptr_type;
                typedef ActuatorOutputs_DataReader_var _var_type;

                static ActuatorOutputs_DataReader_ptr _duplicate (ActuatorOutputs_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorOutputs_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorOutputs_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorOutputs_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorOutputs_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorOutputs_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorOutputs_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorOutputs_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorOutputs_& instance) = 0;

            protected:
                ActuatorOutputs_DataReader () {};
                ~ActuatorOutputs_DataReader () {};
            private:
                ActuatorOutputs_DataReader (const ActuatorOutputs_DataReader &);
                ActuatorOutputs_DataReader & operator = (const ActuatorOutputs_DataReader &);
            };

            class  ActuatorOutputs_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorOutputs_DataReaderView_ptr _ptr_type;
                typedef ActuatorOutputs_DataReaderView_var _var_type;

                static ActuatorOutputs_DataReaderView_ptr _duplicate (ActuatorOutputs_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorOutputs_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorOutputs_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorOutputs_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorOutputs_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorOutputs_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorOutputs_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorOutputs_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorOutputs_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorOutputs_& instance) = 0;

            protected:
                ActuatorOutputs_DataReaderView () {};
                ~ActuatorOutputs_DataReaderView () {};
            private:
                ActuatorOutputs_DataReaderView (const ActuatorOutputs_DataReaderView &);
                ActuatorOutputs_DataReaderView & operator = (const ActuatorOutputs_DataReaderView &);
            };
        }

    }

}

#endif
