#ifndef _H_B0EFE84667B371A370513936C979ABD5_CameraTriggerSecondary_DCPS_H_
#define _H_B0EFE84667B371A370513936C979ABD5_CameraTriggerSecondary_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CameraTriggerSecondary_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CameraTriggerSecondary_TypeSupportInterface;

            typedef CameraTriggerSecondary_TypeSupportInterface * CameraTriggerSecondary_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CameraTriggerSecondary_TypeSupportInterface> CameraTriggerSecondary_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CameraTriggerSecondary_TypeSupportInterface> CameraTriggerSecondary_TypeSupportInterface_out;


            class CameraTriggerSecondary_DataWriter;

            typedef CameraTriggerSecondary_DataWriter * CameraTriggerSecondary_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CameraTriggerSecondary_DataWriter> CameraTriggerSecondary_DataWriter_var;
            typedef DDS_DCPSInterface_out < CameraTriggerSecondary_DataWriter> CameraTriggerSecondary_DataWriter_out;


            class CameraTriggerSecondary_DataReader;

            typedef CameraTriggerSecondary_DataReader * CameraTriggerSecondary_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CameraTriggerSecondary_DataReader> CameraTriggerSecondary_DataReader_var;
            typedef DDS_DCPSInterface_out < CameraTriggerSecondary_DataReader> CameraTriggerSecondary_DataReader_out;


            class CameraTriggerSecondary_DataReaderView;

            typedef CameraTriggerSecondary_DataReaderView * CameraTriggerSecondary_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CameraTriggerSecondary_DataReaderView> CameraTriggerSecondary_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CameraTriggerSecondary_DataReaderView> CameraTriggerSecondary_DataReaderView_out;

            struct CameraTriggerSecondary_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CameraTriggerSecondary_, struct CameraTriggerSecondary_Seq_uniq_> CameraTriggerSecondary_Seq;
            typedef DDS_DCPSSequence_var < CameraTriggerSecondary_Seq> CameraTriggerSecondary_Seq_var;
            typedef DDS_DCPSSequence_out < CameraTriggerSecondary_Seq> CameraTriggerSecondary_Seq_out;

            class  CameraTriggerSecondary_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CameraTriggerSecondary_TypeSupportInterface_ptr _ptr_type;
                typedef CameraTriggerSecondary_TypeSupportInterface_var _var_type;

                static CameraTriggerSecondary_TypeSupportInterface_ptr _duplicate (CameraTriggerSecondary_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CameraTriggerSecondary_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CameraTriggerSecondary_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CameraTriggerSecondary_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CameraTriggerSecondary_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CameraTriggerSecondary_TypeSupportInterface () {};
                ~CameraTriggerSecondary_TypeSupportInterface () {};
            private:
                CameraTriggerSecondary_TypeSupportInterface (const CameraTriggerSecondary_TypeSupportInterface &);
                CameraTriggerSecondary_TypeSupportInterface & operator = (const CameraTriggerSecondary_TypeSupportInterface &);
            };

            class  CameraTriggerSecondary_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CameraTriggerSecondary_DataWriter_ptr _ptr_type;
                typedef CameraTriggerSecondary_DataWriter_var _var_type;

                static CameraTriggerSecondary_DataWriter_ptr _duplicate (CameraTriggerSecondary_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CameraTriggerSecondary_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CameraTriggerSecondary_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CameraTriggerSecondary_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CameraTriggerSecondary_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CameraTriggerSecondary_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CameraTriggerSecondary_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CameraTriggerSecondary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CameraTriggerSecondary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CameraTriggerSecondary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CameraTriggerSecondary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CameraTriggerSecondary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CameraTriggerSecondary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CameraTriggerSecondary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CameraTriggerSecondary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CameraTriggerSecondary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CameraTriggerSecondary_& instance_data) = 0;

            protected:
                CameraTriggerSecondary_DataWriter () {};
                ~CameraTriggerSecondary_DataWriter () {};
            private:
                CameraTriggerSecondary_DataWriter (const CameraTriggerSecondary_DataWriter &);
                CameraTriggerSecondary_DataWriter & operator = (const CameraTriggerSecondary_DataWriter &);
            };

            class  CameraTriggerSecondary_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CameraTriggerSecondary_DataReader_ptr _ptr_type;
                typedef CameraTriggerSecondary_DataReader_var _var_type;

                static CameraTriggerSecondary_DataReader_ptr _duplicate (CameraTriggerSecondary_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CameraTriggerSecondary_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CameraTriggerSecondary_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CameraTriggerSecondary_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CameraTriggerSecondary_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CameraTriggerSecondary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CameraTriggerSecondary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CameraTriggerSecondary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CameraTriggerSecondary_& instance) = 0;

            protected:
                CameraTriggerSecondary_DataReader () {};
                ~CameraTriggerSecondary_DataReader () {};
            private:
                CameraTriggerSecondary_DataReader (const CameraTriggerSecondary_DataReader &);
                CameraTriggerSecondary_DataReader & operator = (const CameraTriggerSecondary_DataReader &);
            };

            class  CameraTriggerSecondary_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CameraTriggerSecondary_DataReaderView_ptr _ptr_type;
                typedef CameraTriggerSecondary_DataReaderView_var _var_type;

                static CameraTriggerSecondary_DataReaderView_ptr _duplicate (CameraTriggerSecondary_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CameraTriggerSecondary_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CameraTriggerSecondary_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CameraTriggerSecondary_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CameraTriggerSecondary_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CameraTriggerSecondary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CameraTriggerSecondary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CameraTriggerSecondary_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CameraTriggerSecondary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CameraTriggerSecondary_& instance) = 0;

            protected:
                CameraTriggerSecondary_DataReaderView () {};
                ~CameraTriggerSecondary_DataReaderView () {};
            private:
                CameraTriggerSecondary_DataReaderView (const CameraTriggerSecondary_DataReaderView &);
                CameraTriggerSecondary_DataReaderView & operator = (const CameraTriggerSecondary_DataReaderView &);
            };
        }

    }

}

#endif
