#ifndef _H_E2B20495624BF07723B8B3D00C9471FD_CommanderState__H_
#define _H_E2B20495624BF07723B8B3D00C9471FD_CommanderState__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace CommanderState_Constants
            {
                const ::DDS::Octet MAIN_STATE_MANUAL_ = 0;

                const ::DDS::Octet MAIN_STATE_ALTCTL_ = 1;

                const ::DDS::Octet MAIN_STATE_POSCTL_ = 2;

                const ::DDS::Octet MAIN_STATE_AUTO_MISSION_ = 3;

                const ::DDS::Octet MAIN_STATE_AUTO_LOITER_ = 4;

                const ::DDS::Octet MAIN_STATE_AUTO_RTL_ = 5;

                const ::DDS::Octet MAIN_STATE_ACRO_ = 6;

                const ::DDS::Octet MAIN_STATE_OFFBOARD_ = 7;

                const ::DDS::Octet MAIN_STATE_STAB_ = 8;

                const ::DDS::Octet MAIN_STATE_RATTITUDE_ = 9;

                const ::DDS::Octet MAIN_STATE_AUTO_TAKEOFF_ = 10;

                const ::DDS::Octet MAIN_STATE_AUTO_LAND_ = 11;

                const ::DDS::Octet MAIN_STATE_AUTO_FOLLOW_TARGET_ = 12;

                const ::DDS::Octet MAIN_STATE_AUTO_PRECLAND_ = 13;

                const ::DDS::Octet MAIN_STATE_ORBIT_ = 14;

                const ::DDS::Octet MAIN_STATE_MAX_ = 15;

            }

            struct  CommanderState_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet main_state_;
            };

            typedef DDS_DCPSStruct_var<CommanderState_> CommanderState__var;
            typedef CommanderState_& CommanderState__out;

        }

    }

}

#endif /* _H_E2B20495624BF07723B8B3D00C9471FD_CommanderState__H_ */
