#ifndef _H_E2B20495624BF07723B8B3D00C9471FD_CommanderState_DCPS_H_
#define _H_E2B20495624BF07723B8B3D00C9471FD_CommanderState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CommanderState_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CommanderState_TypeSupportInterface;

            typedef CommanderState_TypeSupportInterface * CommanderState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CommanderState_TypeSupportInterface> CommanderState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CommanderState_TypeSupportInterface> CommanderState_TypeSupportInterface_out;


            class CommanderState_DataWriter;

            typedef CommanderState_DataWriter * CommanderState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CommanderState_DataWriter> CommanderState_DataWriter_var;
            typedef DDS_DCPSInterface_out < CommanderState_DataWriter> CommanderState_DataWriter_out;


            class CommanderState_DataReader;

            typedef CommanderState_DataReader * CommanderState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CommanderState_DataReader> CommanderState_DataReader_var;
            typedef DDS_DCPSInterface_out < CommanderState_DataReader> CommanderState_DataReader_out;


            class CommanderState_DataReaderView;

            typedef CommanderState_DataReaderView * CommanderState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CommanderState_DataReaderView> CommanderState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CommanderState_DataReaderView> CommanderState_DataReaderView_out;

            struct CommanderState_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CommanderState_, struct CommanderState_Seq_uniq_> CommanderState_Seq;
            typedef DDS_DCPSSequence_var < CommanderState_Seq> CommanderState_Seq_var;
            typedef DDS_DCPSSequence_out < CommanderState_Seq> CommanderState_Seq_out;

            class  CommanderState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CommanderState_TypeSupportInterface_ptr _ptr_type;
                typedef CommanderState_TypeSupportInterface_var _var_type;

                static CommanderState_TypeSupportInterface_ptr _duplicate (CommanderState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CommanderState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CommanderState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CommanderState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CommanderState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CommanderState_TypeSupportInterface () {};
                ~CommanderState_TypeSupportInterface () {};
            private:
                CommanderState_TypeSupportInterface (const CommanderState_TypeSupportInterface &);
                CommanderState_TypeSupportInterface & operator = (const CommanderState_TypeSupportInterface &);
            };

            class  CommanderState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CommanderState_DataWriter_ptr _ptr_type;
                typedef CommanderState_DataWriter_var _var_type;

                static CommanderState_DataWriter_ptr _duplicate (CommanderState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CommanderState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CommanderState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CommanderState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CommanderState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CommanderState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CommanderState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CommanderState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CommanderState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CommanderState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CommanderState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CommanderState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CommanderState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CommanderState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CommanderState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CommanderState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CommanderState_& instance_data) = 0;

            protected:
                CommanderState_DataWriter () {};
                ~CommanderState_DataWriter () {};
            private:
                CommanderState_DataWriter (const CommanderState_DataWriter &);
                CommanderState_DataWriter & operator = (const CommanderState_DataWriter &);
            };

            class  CommanderState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CommanderState_DataReader_ptr _ptr_type;
                typedef CommanderState_DataReader_var _var_type;

                static CommanderState_DataReader_ptr _duplicate (CommanderState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CommanderState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CommanderState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CommanderState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CommanderState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CommanderState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CommanderState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CommanderState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CommanderState_& instance) = 0;

            protected:
                CommanderState_DataReader () {};
                ~CommanderState_DataReader () {};
            private:
                CommanderState_DataReader (const CommanderState_DataReader &);
                CommanderState_DataReader & operator = (const CommanderState_DataReader &);
            };

            class  CommanderState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CommanderState_DataReaderView_ptr _ptr_type;
                typedef CommanderState_DataReaderView_var _var_type;

                static CommanderState_DataReaderView_ptr _duplicate (CommanderState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CommanderState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CommanderState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CommanderState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CommanderState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CommanderState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CommanderState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CommanderState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CommanderState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CommanderState_& instance) = 0;

            protected:
                CommanderState_DataReaderView () {};
                ~CommanderState_DataReaderView () {};
            private:
                CommanderState_DataReaderView (const CommanderState_DataReaderView &);
                CommanderState_DataReaderView & operator = (const CommanderState_DataReaderView &);
            };
        }

    }

}

#endif
