#ifndef _H_0275B612A870CE1CD41827686C1FCBDB_DebugKeyValue_DCPS_H_
#define _H_0275B612A870CE1CD41827686C1FCBDB_DebugKeyValue_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DebugKeyValue_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DebugKeyValue_TypeSupportInterface;

            typedef DebugKeyValue_TypeSupportInterface * DebugKeyValue_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DebugKeyValue_TypeSupportInterface> DebugKeyValue_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DebugKeyValue_TypeSupportInterface> DebugKeyValue_TypeSupportInterface_out;


            class DebugKeyValue_DataWriter;

            typedef DebugKeyValue_DataWriter * DebugKeyValue_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DebugKeyValue_DataWriter> DebugKeyValue_DataWriter_var;
            typedef DDS_DCPSInterface_out < DebugKeyValue_DataWriter> DebugKeyValue_DataWriter_out;


            class DebugKeyValue_DataReader;

            typedef DebugKeyValue_DataReader * DebugKeyValue_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DebugKeyValue_DataReader> DebugKeyValue_DataReader_var;
            typedef DDS_DCPSInterface_out < DebugKeyValue_DataReader> DebugKeyValue_DataReader_out;


            class DebugKeyValue_DataReaderView;

            typedef DebugKeyValue_DataReaderView * DebugKeyValue_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DebugKeyValue_DataReaderView> DebugKeyValue_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DebugKeyValue_DataReaderView> DebugKeyValue_DataReaderView_out;

            struct DebugKeyValue_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DebugKeyValue_, struct DebugKeyValue_Seq_uniq_> DebugKeyValue_Seq;
            typedef DDS_DCPSSequence_var < DebugKeyValue_Seq> DebugKeyValue_Seq_var;
            typedef DDS_DCPSSequence_out < DebugKeyValue_Seq> DebugKeyValue_Seq_out;

            class  DebugKeyValue_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DebugKeyValue_TypeSupportInterface_ptr _ptr_type;
                typedef DebugKeyValue_TypeSupportInterface_var _var_type;

                static DebugKeyValue_TypeSupportInterface_ptr _duplicate (DebugKeyValue_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugKeyValue_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DebugKeyValue_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugKeyValue_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugKeyValue_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DebugKeyValue_TypeSupportInterface () {};
                ~DebugKeyValue_TypeSupportInterface () {};
            private:
                DebugKeyValue_TypeSupportInterface (const DebugKeyValue_TypeSupportInterface &);
                DebugKeyValue_TypeSupportInterface & operator = (const DebugKeyValue_TypeSupportInterface &);
            };

            class  DebugKeyValue_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DebugKeyValue_DataWriter_ptr _ptr_type;
                typedef DebugKeyValue_DataWriter_var _var_type;

                static DebugKeyValue_DataWriter_ptr _duplicate (DebugKeyValue_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugKeyValue_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DebugKeyValue_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugKeyValue_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugKeyValue_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DebugKeyValue_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DebugKeyValue_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DebugKeyValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DebugKeyValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DebugKeyValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DebugKeyValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DebugKeyValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DebugKeyValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DebugKeyValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DebugKeyValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DebugKeyValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugKeyValue_& instance_data) = 0;

            protected:
                DebugKeyValue_DataWriter () {};
                ~DebugKeyValue_DataWriter () {};
            private:
                DebugKeyValue_DataWriter (const DebugKeyValue_DataWriter &);
                DebugKeyValue_DataWriter & operator = (const DebugKeyValue_DataWriter &);
            };

            class  DebugKeyValue_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DebugKeyValue_DataReader_ptr _ptr_type;
                typedef DebugKeyValue_DataReader_var _var_type;

                static DebugKeyValue_DataReader_ptr _duplicate (DebugKeyValue_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugKeyValue_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DebugKeyValue_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugKeyValue_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugKeyValue_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DebugKeyValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DebugKeyValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DebugKeyValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugKeyValue_& instance) = 0;

            protected:
                DebugKeyValue_DataReader () {};
                ~DebugKeyValue_DataReader () {};
            private:
                DebugKeyValue_DataReader (const DebugKeyValue_DataReader &);
                DebugKeyValue_DataReader & operator = (const DebugKeyValue_DataReader &);
            };

            class  DebugKeyValue_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DebugKeyValue_DataReaderView_ptr _ptr_type;
                typedef DebugKeyValue_DataReaderView_var _var_type;

                static DebugKeyValue_DataReaderView_ptr _duplicate (DebugKeyValue_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DebugKeyValue_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DebugKeyValue_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DebugKeyValue_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DebugKeyValue_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DebugKeyValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DebugKeyValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DebugKeyValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DebugKeyValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DebugKeyValue_& instance) = 0;

            protected:
                DebugKeyValue_DataReaderView () {};
                ~DebugKeyValue_DataReaderView () {};
            private:
                DebugKeyValue_DataReaderView (const DebugKeyValue_DataReaderView &);
                DebugKeyValue_DataReaderView & operator = (const DebugKeyValue_DataReaderView &);
            };
        }

    }

}

#endif
