#ifndef _H_77F1A9B27BA59598B6BBC6766A4755AB_DistanceSensor_DCPS_H_
#define _H_77F1A9B27BA59598B6BBC6766A4755AB_DistanceSensor_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DistanceSensor_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DistanceSensor_TypeSupportInterface;

            typedef DistanceSensor_TypeSupportInterface * DistanceSensor_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DistanceSensor_TypeSupportInterface> DistanceSensor_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DistanceSensor_TypeSupportInterface> DistanceSensor_TypeSupportInterface_out;


            class DistanceSensor_DataWriter;

            typedef DistanceSensor_DataWriter * DistanceSensor_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DistanceSensor_DataWriter> DistanceSensor_DataWriter_var;
            typedef DDS_DCPSInterface_out < DistanceSensor_DataWriter> DistanceSensor_DataWriter_out;


            class DistanceSensor_DataReader;

            typedef DistanceSensor_DataReader * DistanceSensor_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DistanceSensor_DataReader> DistanceSensor_DataReader_var;
            typedef DDS_DCPSInterface_out < DistanceSensor_DataReader> DistanceSensor_DataReader_out;


            class DistanceSensor_DataReaderView;

            typedef DistanceSensor_DataReaderView * DistanceSensor_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DistanceSensor_DataReaderView> DistanceSensor_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DistanceSensor_DataReaderView> DistanceSensor_DataReaderView_out;

            struct DistanceSensor_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DistanceSensor_, struct DistanceSensor_Seq_uniq_> DistanceSensor_Seq;
            typedef DDS_DCPSSequence_var < DistanceSensor_Seq> DistanceSensor_Seq_var;
            typedef DDS_DCPSSequence_out < DistanceSensor_Seq> DistanceSensor_Seq_out;

            class  DistanceSensor_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DistanceSensor_TypeSupportInterface_ptr _ptr_type;
                typedef DistanceSensor_TypeSupportInterface_var _var_type;

                static DistanceSensor_TypeSupportInterface_ptr _duplicate (DistanceSensor_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DistanceSensor_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DistanceSensor_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DistanceSensor_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DistanceSensor_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DistanceSensor_TypeSupportInterface () {};
                ~DistanceSensor_TypeSupportInterface () {};
            private:
                DistanceSensor_TypeSupportInterface (const DistanceSensor_TypeSupportInterface &);
                DistanceSensor_TypeSupportInterface & operator = (const DistanceSensor_TypeSupportInterface &);
            };

            class  DistanceSensor_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DistanceSensor_DataWriter_ptr _ptr_type;
                typedef DistanceSensor_DataWriter_var _var_type;

                static DistanceSensor_DataWriter_ptr _duplicate (DistanceSensor_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DistanceSensor_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DistanceSensor_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DistanceSensor_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DistanceSensor_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DistanceSensor_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DistanceSensor_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DistanceSensor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DistanceSensor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DistanceSensor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DistanceSensor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DistanceSensor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DistanceSensor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DistanceSensor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DistanceSensor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DistanceSensor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DistanceSensor_& instance_data) = 0;

            protected:
                DistanceSensor_DataWriter () {};
                ~DistanceSensor_DataWriter () {};
            private:
                DistanceSensor_DataWriter (const DistanceSensor_DataWriter &);
                DistanceSensor_DataWriter & operator = (const DistanceSensor_DataWriter &);
            };

            class  DistanceSensor_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DistanceSensor_DataReader_ptr _ptr_type;
                typedef DistanceSensor_DataReader_var _var_type;

                static DistanceSensor_DataReader_ptr _duplicate (DistanceSensor_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DistanceSensor_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DistanceSensor_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DistanceSensor_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DistanceSensor_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DistanceSensor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DistanceSensor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DistanceSensor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DistanceSensor_& instance) = 0;

            protected:
                DistanceSensor_DataReader () {};
                ~DistanceSensor_DataReader () {};
            private:
                DistanceSensor_DataReader (const DistanceSensor_DataReader &);
                DistanceSensor_DataReader & operator = (const DistanceSensor_DataReader &);
            };

            class  DistanceSensor_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DistanceSensor_DataReaderView_ptr _ptr_type;
                typedef DistanceSensor_DataReaderView_var _var_type;

                static DistanceSensor_DataReaderView_ptr _duplicate (DistanceSensor_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DistanceSensor_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DistanceSensor_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DistanceSensor_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DistanceSensor_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DistanceSensor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DistanceSensor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DistanceSensor_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DistanceSensor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DistanceSensor_& instance) = 0;

            protected:
                DistanceSensor_DataReaderView () {};
                ~DistanceSensor_DataReaderView () {};
            private:
                DistanceSensor_DataReaderView (const DistanceSensor_DataReaderView &);
                DistanceSensor_DataReaderView & operator = (const DistanceSensor_DataReaderView &);
            };
        }

    }

}

#endif
