#ifndef _H_92C70656BFD86DA5D1F36B541BB1E368_Ekf2Innovations_DCPS_H_
#define _H_92C70656BFD86DA5D1F36B541BB1E368_Ekf2Innovations_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Ekf2Innovations_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Ekf2Innovations_TypeSupportInterface;

            typedef Ekf2Innovations_TypeSupportInterface * Ekf2Innovations_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Ekf2Innovations_TypeSupportInterface> Ekf2Innovations_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Ekf2Innovations_TypeSupportInterface> Ekf2Innovations_TypeSupportInterface_out;


            class Ekf2Innovations_DataWriter;

            typedef Ekf2Innovations_DataWriter * Ekf2Innovations_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Ekf2Innovations_DataWriter> Ekf2Innovations_DataWriter_var;
            typedef DDS_DCPSInterface_out < Ekf2Innovations_DataWriter> Ekf2Innovations_DataWriter_out;


            class Ekf2Innovations_DataReader;

            typedef Ekf2Innovations_DataReader * Ekf2Innovations_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Ekf2Innovations_DataReader> Ekf2Innovations_DataReader_var;
            typedef DDS_DCPSInterface_out < Ekf2Innovations_DataReader> Ekf2Innovations_DataReader_out;


            class Ekf2Innovations_DataReaderView;

            typedef Ekf2Innovations_DataReaderView * Ekf2Innovations_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Ekf2Innovations_DataReaderView> Ekf2Innovations_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Ekf2Innovations_DataReaderView> Ekf2Innovations_DataReaderView_out;

            struct Ekf2Innovations_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Ekf2Innovations_, struct Ekf2Innovations_Seq_uniq_> Ekf2Innovations_Seq;
            typedef DDS_DCPSSequence_var < Ekf2Innovations_Seq> Ekf2Innovations_Seq_var;
            typedef DDS_DCPSSequence_out < Ekf2Innovations_Seq> Ekf2Innovations_Seq_out;

            class  Ekf2Innovations_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Ekf2Innovations_TypeSupportInterface_ptr _ptr_type;
                typedef Ekf2Innovations_TypeSupportInterface_var _var_type;

                static Ekf2Innovations_TypeSupportInterface_ptr _duplicate (Ekf2Innovations_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ekf2Innovations_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Ekf2Innovations_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ekf2Innovations_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Ekf2Innovations_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Ekf2Innovations_TypeSupportInterface () {};
                ~Ekf2Innovations_TypeSupportInterface () {};
            private:
                Ekf2Innovations_TypeSupportInterface (const Ekf2Innovations_TypeSupportInterface &);
                Ekf2Innovations_TypeSupportInterface & operator = (const Ekf2Innovations_TypeSupportInterface &);
            };

            class  Ekf2Innovations_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Ekf2Innovations_DataWriter_ptr _ptr_type;
                typedef Ekf2Innovations_DataWriter_var _var_type;

                static Ekf2Innovations_DataWriter_ptr _duplicate (Ekf2Innovations_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ekf2Innovations_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Ekf2Innovations_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ekf2Innovations_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Ekf2Innovations_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Ekf2Innovations_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Ekf2Innovations_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Ekf2Innovations_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Ekf2Innovations_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Ekf2Innovations_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Ekf2Innovations_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Ekf2Innovations_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Ekf2Innovations_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Ekf2Innovations_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Ekf2Innovations_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Ekf2Innovations_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ekf2Innovations_& instance_data) = 0;

            protected:
                Ekf2Innovations_DataWriter () {};
                ~Ekf2Innovations_DataWriter () {};
            private:
                Ekf2Innovations_DataWriter (const Ekf2Innovations_DataWriter &);
                Ekf2Innovations_DataWriter & operator = (const Ekf2Innovations_DataWriter &);
            };

            class  Ekf2Innovations_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Ekf2Innovations_DataReader_ptr _ptr_type;
                typedef Ekf2Innovations_DataReader_var _var_type;

                static Ekf2Innovations_DataReader_ptr _duplicate (Ekf2Innovations_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ekf2Innovations_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Ekf2Innovations_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ekf2Innovations_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Ekf2Innovations_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Ekf2Innovations_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Ekf2Innovations_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Ekf2Innovations_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ekf2Innovations_& instance) = 0;

            protected:
                Ekf2Innovations_DataReader () {};
                ~Ekf2Innovations_DataReader () {};
            private:
                Ekf2Innovations_DataReader (const Ekf2Innovations_DataReader &);
                Ekf2Innovations_DataReader & operator = (const Ekf2Innovations_DataReader &);
            };

            class  Ekf2Innovations_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Ekf2Innovations_DataReaderView_ptr _ptr_type;
                typedef Ekf2Innovations_DataReaderView_var _var_type;

                static Ekf2Innovations_DataReaderView_ptr _duplicate (Ekf2Innovations_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ekf2Innovations_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Ekf2Innovations_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ekf2Innovations_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Ekf2Innovations_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Ekf2Innovations_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Ekf2Innovations_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Ekf2Innovations_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Ekf2Innovations_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ekf2Innovations_& instance) = 0;

            protected:
                Ekf2Innovations_DataReaderView () {};
                ~Ekf2Innovations_DataReaderView () {};
            private:
                Ekf2Innovations_DataReaderView (const Ekf2Innovations_DataReaderView &);
                Ekf2Innovations_DataReaderView & operator = (const Ekf2Innovations_DataReaderView &);
            };
        }

    }

}

#endif
