#ifndef _H_00334EB07E8D2F2297BB1C87A3B9139B_EkfGpsDrift_DCPS_H_
#define _H_00334EB07E8D2F2297BB1C87A3B9139B_EkfGpsDrift_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EkfGpsDrift_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EkfGpsDrift_TypeSupportInterface;

            typedef EkfGpsDrift_TypeSupportInterface * EkfGpsDrift_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EkfGpsDrift_TypeSupportInterface> EkfGpsDrift_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EkfGpsDrift_TypeSupportInterface> EkfGpsDrift_TypeSupportInterface_out;


            class EkfGpsDrift_DataWriter;

            typedef EkfGpsDrift_DataWriter * EkfGpsDrift_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EkfGpsDrift_DataWriter> EkfGpsDrift_DataWriter_var;
            typedef DDS_DCPSInterface_out < EkfGpsDrift_DataWriter> EkfGpsDrift_DataWriter_out;


            class EkfGpsDrift_DataReader;

            typedef EkfGpsDrift_DataReader * EkfGpsDrift_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EkfGpsDrift_DataReader> EkfGpsDrift_DataReader_var;
            typedef DDS_DCPSInterface_out < EkfGpsDrift_DataReader> EkfGpsDrift_DataReader_out;


            class EkfGpsDrift_DataReaderView;

            typedef EkfGpsDrift_DataReaderView * EkfGpsDrift_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EkfGpsDrift_DataReaderView> EkfGpsDrift_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EkfGpsDrift_DataReaderView> EkfGpsDrift_DataReaderView_out;

            struct EkfGpsDrift_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < EkfGpsDrift_, struct EkfGpsDrift_Seq_uniq_> EkfGpsDrift_Seq;
            typedef DDS_DCPSSequence_var < EkfGpsDrift_Seq> EkfGpsDrift_Seq_var;
            typedef DDS_DCPSSequence_out < EkfGpsDrift_Seq> EkfGpsDrift_Seq_out;

            class  EkfGpsDrift_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EkfGpsDrift_TypeSupportInterface_ptr _ptr_type;
                typedef EkfGpsDrift_TypeSupportInterface_var _var_type;

                static EkfGpsDrift_TypeSupportInterface_ptr _duplicate (EkfGpsDrift_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EkfGpsDrift_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EkfGpsDrift_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EkfGpsDrift_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EkfGpsDrift_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EkfGpsDrift_TypeSupportInterface () {};
                ~EkfGpsDrift_TypeSupportInterface () {};
            private:
                EkfGpsDrift_TypeSupportInterface (const EkfGpsDrift_TypeSupportInterface &);
                EkfGpsDrift_TypeSupportInterface & operator = (const EkfGpsDrift_TypeSupportInterface &);
            };

            class  EkfGpsDrift_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EkfGpsDrift_DataWriter_ptr _ptr_type;
                typedef EkfGpsDrift_DataWriter_var _var_type;

                static EkfGpsDrift_DataWriter_ptr _duplicate (EkfGpsDrift_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EkfGpsDrift_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EkfGpsDrift_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EkfGpsDrift_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EkfGpsDrift_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EkfGpsDrift_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EkfGpsDrift_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EkfGpsDrift_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EkfGpsDrift_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EkfGpsDrift_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EkfGpsDrift_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EkfGpsDrift_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EkfGpsDrift_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EkfGpsDrift_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EkfGpsDrift_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EkfGpsDrift_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EkfGpsDrift_& instance_data) = 0;

            protected:
                EkfGpsDrift_DataWriter () {};
                ~EkfGpsDrift_DataWriter () {};
            private:
                EkfGpsDrift_DataWriter (const EkfGpsDrift_DataWriter &);
                EkfGpsDrift_DataWriter & operator = (const EkfGpsDrift_DataWriter &);
            };

            class  EkfGpsDrift_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EkfGpsDrift_DataReader_ptr _ptr_type;
                typedef EkfGpsDrift_DataReader_var _var_type;

                static EkfGpsDrift_DataReader_ptr _duplicate (EkfGpsDrift_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EkfGpsDrift_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EkfGpsDrift_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EkfGpsDrift_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EkfGpsDrift_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EkfGpsDrift_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EkfGpsDrift_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EkfGpsDrift_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EkfGpsDrift_& instance) = 0;

            protected:
                EkfGpsDrift_DataReader () {};
                ~EkfGpsDrift_DataReader () {};
            private:
                EkfGpsDrift_DataReader (const EkfGpsDrift_DataReader &);
                EkfGpsDrift_DataReader & operator = (const EkfGpsDrift_DataReader &);
            };

            class  EkfGpsDrift_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EkfGpsDrift_DataReaderView_ptr _ptr_type;
                typedef EkfGpsDrift_DataReaderView_var _var_type;

                static EkfGpsDrift_DataReaderView_ptr _duplicate (EkfGpsDrift_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EkfGpsDrift_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EkfGpsDrift_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EkfGpsDrift_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EkfGpsDrift_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EkfGpsDrift_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EkfGpsDrift_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EkfGpsDrift_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EkfGpsDrift_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EkfGpsDrift_& instance) = 0;

            protected:
                EkfGpsDrift_DataReaderView () {};
                ~EkfGpsDrift_DataReaderView () {};
            private:
                EkfGpsDrift_DataReaderView (const EkfGpsDrift_DataReaderView &);
                EkfGpsDrift_DataReaderView & operator = (const EkfGpsDrift_DataReaderView &);
            };
        }

    }

}

#endif
