#ifndef _H_C9F9565EA78457C1DBBBEE6D4C49E4AA_EscReport_DCPS_H_
#define _H_C9F9565EA78457C1DBBBEE6D4C49E4AA_EscReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EscReport_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EscReport_TypeSupportInterface;

            typedef EscReport_TypeSupportInterface * EscReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EscReport_TypeSupportInterface> EscReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EscReport_TypeSupportInterface> EscReport_TypeSupportInterface_out;


            class EscReport_DataWriter;

            typedef EscReport_DataWriter * EscReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EscReport_DataWriter> EscReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < EscReport_DataWriter> EscReport_DataWriter_out;


            class EscReport_DataReader;

            typedef EscReport_DataReader * EscReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EscReport_DataReader> EscReport_DataReader_var;
            typedef DDS_DCPSInterface_out < EscReport_DataReader> EscReport_DataReader_out;


            class EscReport_DataReaderView;

            typedef EscReport_DataReaderView * EscReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EscReport_DataReaderView> EscReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EscReport_DataReaderView> EscReport_DataReaderView_out;

            struct EscReport_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < EscReport_, struct EscReport_Seq_uniq_> EscReport_Seq;
            typedef DDS_DCPSSequence_var < EscReport_Seq> EscReport_Seq_var;
            typedef DDS_DCPSSequence_out < EscReport_Seq> EscReport_Seq_out;

            class  EscReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EscReport_TypeSupportInterface_ptr _ptr_type;
                typedef EscReport_TypeSupportInterface_var _var_type;

                static EscReport_TypeSupportInterface_ptr _duplicate (EscReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EscReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EscReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EscReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EscReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EscReport_TypeSupportInterface () {};
                ~EscReport_TypeSupportInterface () {};
            private:
                EscReport_TypeSupportInterface (const EscReport_TypeSupportInterface &);
                EscReport_TypeSupportInterface & operator = (const EscReport_TypeSupportInterface &);
            };

            class  EscReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EscReport_DataWriter_ptr _ptr_type;
                typedef EscReport_DataWriter_var _var_type;

                static EscReport_DataWriter_ptr _duplicate (EscReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EscReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EscReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EscReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EscReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EscReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EscReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EscReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EscReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EscReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EscReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EscReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EscReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EscReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EscReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EscReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EscReport_& instance_data) = 0;

            protected:
                EscReport_DataWriter () {};
                ~EscReport_DataWriter () {};
            private:
                EscReport_DataWriter (const EscReport_DataWriter &);
                EscReport_DataWriter & operator = (const EscReport_DataWriter &);
            };

            class  EscReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EscReport_DataReader_ptr _ptr_type;
                typedef EscReport_DataReader_var _var_type;

                static EscReport_DataReader_ptr _duplicate (EscReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EscReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EscReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EscReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EscReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EscReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EscReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EscReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EscReport_& instance) = 0;

            protected:
                EscReport_DataReader () {};
                ~EscReport_DataReader () {};
            private:
                EscReport_DataReader (const EscReport_DataReader &);
                EscReport_DataReader & operator = (const EscReport_DataReader &);
            };

            class  EscReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EscReport_DataReaderView_ptr _ptr_type;
                typedef EscReport_DataReaderView_var _var_type;

                static EscReport_DataReaderView_ptr _duplicate (EscReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EscReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EscReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EscReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EscReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EscReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EscReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EscReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EscReport_& instance) = 0;

            protected:
                EscReport_DataReaderView () {};
                ~EscReport_DataReaderView () {};
            private:
                EscReport_DataReaderView (const EscReport_DataReaderView &);
                EscReport_DataReaderView & operator = (const EscReport_DataReaderView &);
            };
        }

    }

}

#endif
