#ifndef _H_3F53D919EAAA28180C99309DCBE185FF_EscStatus__H_
#define _H_3F53D919EAAA28180C99309DCBE185FF_EscStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "px4_msgs/msg/dds_opensplice/EscReport_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace EscStatus_Constants
            {
                const ::DDS::Octet CONNECTED_ESC_MAX_ = 8;

                const ::DDS::Octet ESC_CONNECTION_TYPE_PPM_ = 0;

                const ::DDS::Octet ESC_CONNECTION_TYPE_SERIAL_ = 1;

                const ::DDS::Octet ESC_CONNECTION_TYPE_ONESHOT_ = 2;

                const ::DDS::Octet ESC_CONNECTION_TYPE_I2C_ = 3;

                const ::DDS::Octet ESC_CONNECTION_TYPE_CAN_ = 4;

                const ::DDS::Octet ESC_CONNECTION_TYPE_DSHOT_ = 5;

            }

            struct  EscStatus_
            {
                struct _esc__uniq_{};
                typedef ::px4_msgs::msg::dds_::EscReport_ _esc__slice;
                typedef ::px4_msgs::msg::dds_::EscReport_ _esc_[8];
                typedef DDS_DCPS_FArray_var< _esc_, _esc__slice, struct _esc__uniq_ > _esc__var;
                typedef _esc_ _esc__out;
                typedef DDS_DCPS_Array_forany< _esc_, _esc__slice, struct _esc__uniq_ > _esc__forany;
                static _esc__slice *_esc__alloc();
                static void _esc__free(_esc__slice *);
                static void _esc__copy(_esc__slice *to, const _esc__slice *from);
                static _esc__slice *_esc__dup(const _esc__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::UShort counter_;
                ::DDS::Octet esc_count_;
                ::DDS::Octet esc_connectiontype_;
                ::DDS::Octet esc_online_flags_;
                _esc_ esc_;
            };

            typedef DDS_DCPSStruct_var<EscStatus_> EscStatus__var;
            typedef EscStatus_& EscStatus__out;

        }

    }

}

#endif /* _H_3F53D919EAAA28180C99309DCBE185FF_EscStatus__H_ */
