#ifndef _H_6A4F3C597227CD767AE5DEEF4D85041B_EstimatorStatus_DCPS_H_
#define _H_6A4F3C597227CD767AE5DEEF4D85041B_EstimatorStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EstimatorStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EstimatorStatus_TypeSupportInterface;

            typedef EstimatorStatus_TypeSupportInterface * EstimatorStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EstimatorStatus_TypeSupportInterface> EstimatorStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EstimatorStatus_TypeSupportInterface> EstimatorStatus_TypeSupportInterface_out;


            class EstimatorStatus_DataWriter;

            typedef EstimatorStatus_DataWriter * EstimatorStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EstimatorStatus_DataWriter> EstimatorStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < EstimatorStatus_DataWriter> EstimatorStatus_DataWriter_out;


            class EstimatorStatus_DataReader;

            typedef EstimatorStatus_DataReader * EstimatorStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EstimatorStatus_DataReader> EstimatorStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < EstimatorStatus_DataReader> EstimatorStatus_DataReader_out;


            class EstimatorStatus_DataReaderView;

            typedef EstimatorStatus_DataReaderView * EstimatorStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EstimatorStatus_DataReaderView> EstimatorStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EstimatorStatus_DataReaderView> EstimatorStatus_DataReaderView_out;

            struct EstimatorStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < EstimatorStatus_, struct EstimatorStatus_Seq_uniq_> EstimatorStatus_Seq;
            typedef DDS_DCPSSequence_var < EstimatorStatus_Seq> EstimatorStatus_Seq_var;
            typedef DDS_DCPSSequence_out < EstimatorStatus_Seq> EstimatorStatus_Seq_out;

            class  EstimatorStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EstimatorStatus_TypeSupportInterface_ptr _ptr_type;
                typedef EstimatorStatus_TypeSupportInterface_var _var_type;

                static EstimatorStatus_TypeSupportInterface_ptr _duplicate (EstimatorStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EstimatorStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EstimatorStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EstimatorStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EstimatorStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EstimatorStatus_TypeSupportInterface () {};
                ~EstimatorStatus_TypeSupportInterface () {};
            private:
                EstimatorStatus_TypeSupportInterface (const EstimatorStatus_TypeSupportInterface &);
                EstimatorStatus_TypeSupportInterface & operator = (const EstimatorStatus_TypeSupportInterface &);
            };

            class  EstimatorStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EstimatorStatus_DataWriter_ptr _ptr_type;
                typedef EstimatorStatus_DataWriter_var _var_type;

                static EstimatorStatus_DataWriter_ptr _duplicate (EstimatorStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EstimatorStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EstimatorStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EstimatorStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EstimatorStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EstimatorStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EstimatorStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EstimatorStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EstimatorStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EstimatorStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EstimatorStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EstimatorStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EstimatorStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EstimatorStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EstimatorStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EstimatorStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EstimatorStatus_& instance_data) = 0;

            protected:
                EstimatorStatus_DataWriter () {};
                ~EstimatorStatus_DataWriter () {};
            private:
                EstimatorStatus_DataWriter (const EstimatorStatus_DataWriter &);
                EstimatorStatus_DataWriter & operator = (const EstimatorStatus_DataWriter &);
            };

            class  EstimatorStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EstimatorStatus_DataReader_ptr _ptr_type;
                typedef EstimatorStatus_DataReader_var _var_type;

                static EstimatorStatus_DataReader_ptr _duplicate (EstimatorStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EstimatorStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EstimatorStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EstimatorStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EstimatorStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EstimatorStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EstimatorStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EstimatorStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EstimatorStatus_& instance) = 0;

            protected:
                EstimatorStatus_DataReader () {};
                ~EstimatorStatus_DataReader () {};
            private:
                EstimatorStatus_DataReader (const EstimatorStatus_DataReader &);
                EstimatorStatus_DataReader & operator = (const EstimatorStatus_DataReader &);
            };

            class  EstimatorStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EstimatorStatus_DataReaderView_ptr _ptr_type;
                typedef EstimatorStatus_DataReaderView_var _var_type;

                static EstimatorStatus_DataReaderView_ptr _duplicate (EstimatorStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EstimatorStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EstimatorStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EstimatorStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EstimatorStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EstimatorStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EstimatorStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EstimatorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EstimatorStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EstimatorStatus_& instance) = 0;

            protected:
                EstimatorStatus_DataReaderView () {};
                ~EstimatorStatus_DataReaderView () {};
            private:
                EstimatorStatus_DataReaderView (const EstimatorStatus_DataReaderView &);
                EstimatorStatus_DataReaderView & operator = (const EstimatorStatus_DataReaderView &);
            };
        }

    }

}

#endif
