#ifndef _H_6752679FB217016B0FA0F2906C663C27_GeofenceResult_DCPS_H_
#define _H_6752679FB217016B0FA0F2906C663C27_GeofenceResult_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GeofenceResult_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GeofenceResult_TypeSupportInterface;

            typedef GeofenceResult_TypeSupportInterface * GeofenceResult_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GeofenceResult_TypeSupportInterface> GeofenceResult_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GeofenceResult_TypeSupportInterface> GeofenceResult_TypeSupportInterface_out;


            class GeofenceResult_DataWriter;

            typedef GeofenceResult_DataWriter * GeofenceResult_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GeofenceResult_DataWriter> GeofenceResult_DataWriter_var;
            typedef DDS_DCPSInterface_out < GeofenceResult_DataWriter> GeofenceResult_DataWriter_out;


            class GeofenceResult_DataReader;

            typedef GeofenceResult_DataReader * GeofenceResult_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GeofenceResult_DataReader> GeofenceResult_DataReader_var;
            typedef DDS_DCPSInterface_out < GeofenceResult_DataReader> GeofenceResult_DataReader_out;


            class GeofenceResult_DataReaderView;

            typedef GeofenceResult_DataReaderView * GeofenceResult_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GeofenceResult_DataReaderView> GeofenceResult_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GeofenceResult_DataReaderView> GeofenceResult_DataReaderView_out;

            struct GeofenceResult_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GeofenceResult_, struct GeofenceResult_Seq_uniq_> GeofenceResult_Seq;
            typedef DDS_DCPSSequence_var < GeofenceResult_Seq> GeofenceResult_Seq_var;
            typedef DDS_DCPSSequence_out < GeofenceResult_Seq> GeofenceResult_Seq_out;

            class  GeofenceResult_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GeofenceResult_TypeSupportInterface_ptr _ptr_type;
                typedef GeofenceResult_TypeSupportInterface_var _var_type;

                static GeofenceResult_TypeSupportInterface_ptr _duplicate (GeofenceResult_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeofenceResult_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GeofenceResult_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeofenceResult_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GeofenceResult_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GeofenceResult_TypeSupportInterface () {};
                ~GeofenceResult_TypeSupportInterface () {};
            private:
                GeofenceResult_TypeSupportInterface (const GeofenceResult_TypeSupportInterface &);
                GeofenceResult_TypeSupportInterface & operator = (const GeofenceResult_TypeSupportInterface &);
            };

            class  GeofenceResult_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GeofenceResult_DataWriter_ptr _ptr_type;
                typedef GeofenceResult_DataWriter_var _var_type;

                static GeofenceResult_DataWriter_ptr _duplicate (GeofenceResult_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeofenceResult_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GeofenceResult_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeofenceResult_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GeofenceResult_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GeofenceResult_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GeofenceResult_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GeofenceResult_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GeofenceResult_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GeofenceResult_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GeofenceResult_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GeofenceResult_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GeofenceResult_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GeofenceResult_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GeofenceResult_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GeofenceResult_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeofenceResult_& instance_data) = 0;

            protected:
                GeofenceResult_DataWriter () {};
                ~GeofenceResult_DataWriter () {};
            private:
                GeofenceResult_DataWriter (const GeofenceResult_DataWriter &);
                GeofenceResult_DataWriter & operator = (const GeofenceResult_DataWriter &);
            };

            class  GeofenceResult_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GeofenceResult_DataReader_ptr _ptr_type;
                typedef GeofenceResult_DataReader_var _var_type;

                static GeofenceResult_DataReader_ptr _duplicate (GeofenceResult_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeofenceResult_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GeofenceResult_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeofenceResult_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GeofenceResult_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GeofenceResult_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GeofenceResult_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GeofenceResult_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeofenceResult_& instance) = 0;

            protected:
                GeofenceResult_DataReader () {};
                ~GeofenceResult_DataReader () {};
            private:
                GeofenceResult_DataReader (const GeofenceResult_DataReader &);
                GeofenceResult_DataReader & operator = (const GeofenceResult_DataReader &);
            };

            class  GeofenceResult_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GeofenceResult_DataReaderView_ptr _ptr_type;
                typedef GeofenceResult_DataReaderView_var _var_type;

                static GeofenceResult_DataReaderView_ptr _duplicate (GeofenceResult_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GeofenceResult_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GeofenceResult_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GeofenceResult_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GeofenceResult_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GeofenceResult_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GeofenceResult_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GeofenceResult_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GeofenceResult_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GeofenceResult_& instance) = 0;

            protected:
                GeofenceResult_DataReaderView () {};
                ~GeofenceResult_DataReaderView () {};
            private:
                GeofenceResult_DataReaderView (const GeofenceResult_DataReaderView &);
                GeofenceResult_DataReaderView & operator = (const GeofenceResult_DataReaderView &);
            };
        }

    }

}

#endif
