#ifndef _H_B9C1366E232D656AD9B72D9F2F2A3B97_HomePosition_DCPS_H_
#define _H_B9C1366E232D656AD9B72D9F2F2A3B97_HomePosition_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HomePosition_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HomePosition_TypeSupportInterface;

            typedef HomePosition_TypeSupportInterface * HomePosition_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HomePosition_TypeSupportInterface> HomePosition_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HomePosition_TypeSupportInterface> HomePosition_TypeSupportInterface_out;


            class HomePosition_DataWriter;

            typedef HomePosition_DataWriter * HomePosition_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HomePosition_DataWriter> HomePosition_DataWriter_var;
            typedef DDS_DCPSInterface_out < HomePosition_DataWriter> HomePosition_DataWriter_out;


            class HomePosition_DataReader;

            typedef HomePosition_DataReader * HomePosition_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HomePosition_DataReader> HomePosition_DataReader_var;
            typedef DDS_DCPSInterface_out < HomePosition_DataReader> HomePosition_DataReader_out;


            class HomePosition_DataReaderView;

            typedef HomePosition_DataReaderView * HomePosition_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HomePosition_DataReaderView> HomePosition_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HomePosition_DataReaderView> HomePosition_DataReaderView_out;

            struct HomePosition_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < HomePosition_, struct HomePosition_Seq_uniq_> HomePosition_Seq;
            typedef DDS_DCPSSequence_var < HomePosition_Seq> HomePosition_Seq_var;
            typedef DDS_DCPSSequence_out < HomePosition_Seq> HomePosition_Seq_out;

            class  HomePosition_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HomePosition_TypeSupportInterface_ptr _ptr_type;
                typedef HomePosition_TypeSupportInterface_var _var_type;

                static HomePosition_TypeSupportInterface_ptr _duplicate (HomePosition_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HomePosition_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HomePosition_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HomePosition_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HomePosition_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HomePosition_TypeSupportInterface () {};
                ~HomePosition_TypeSupportInterface () {};
            private:
                HomePosition_TypeSupportInterface (const HomePosition_TypeSupportInterface &);
                HomePosition_TypeSupportInterface & operator = (const HomePosition_TypeSupportInterface &);
            };

            class  HomePosition_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HomePosition_DataWriter_ptr _ptr_type;
                typedef HomePosition_DataWriter_var _var_type;

                static HomePosition_DataWriter_ptr _duplicate (HomePosition_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HomePosition_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HomePosition_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HomePosition_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HomePosition_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HomePosition_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HomePosition_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HomePosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HomePosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HomePosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HomePosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HomePosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HomePosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HomePosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HomePosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HomePosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HomePosition_& instance_data) = 0;

            protected:
                HomePosition_DataWriter () {};
                ~HomePosition_DataWriter () {};
            private:
                HomePosition_DataWriter (const HomePosition_DataWriter &);
                HomePosition_DataWriter & operator = (const HomePosition_DataWriter &);
            };

            class  HomePosition_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HomePosition_DataReader_ptr _ptr_type;
                typedef HomePosition_DataReader_var _var_type;

                static HomePosition_DataReader_ptr _duplicate (HomePosition_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HomePosition_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HomePosition_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HomePosition_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HomePosition_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HomePosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HomePosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HomePosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HomePosition_& instance) = 0;

            protected:
                HomePosition_DataReader () {};
                ~HomePosition_DataReader () {};
            private:
                HomePosition_DataReader (const HomePosition_DataReader &);
                HomePosition_DataReader & operator = (const HomePosition_DataReader &);
            };

            class  HomePosition_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HomePosition_DataReaderView_ptr _ptr_type;
                typedef HomePosition_DataReaderView_var _var_type;

                static HomePosition_DataReaderView_ptr _duplicate (HomePosition_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HomePosition_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HomePosition_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HomePosition_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HomePosition_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HomePosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HomePosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HomePosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HomePosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HomePosition_& instance) = 0;

            protected:
                HomePosition_DataReaderView () {};
                ~HomePosition_DataReaderView () {};
            private:
                HomePosition_DataReaderView (const HomePosition_DataReaderView &);
                HomePosition_DataReaderView & operator = (const HomePosition_DataReaderView &);
            };
        }

    }

}

#endif
