#ifndef _H_8487552C92778AC9E0A1B2FFF19A5E39_IridiumsbdStatus_DCPS_H_
#define _H_8487552C92778AC9E0A1B2FFF19A5E39_IridiumsbdStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IridiumsbdStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class IridiumsbdStatus_TypeSupportInterface;

            typedef IridiumsbdStatus_TypeSupportInterface * IridiumsbdStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IridiumsbdStatus_TypeSupportInterface> IridiumsbdStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IridiumsbdStatus_TypeSupportInterface> IridiumsbdStatus_TypeSupportInterface_out;


            class IridiumsbdStatus_DataWriter;

            typedef IridiumsbdStatus_DataWriter * IridiumsbdStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IridiumsbdStatus_DataWriter> IridiumsbdStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < IridiumsbdStatus_DataWriter> IridiumsbdStatus_DataWriter_out;


            class IridiumsbdStatus_DataReader;

            typedef IridiumsbdStatus_DataReader * IridiumsbdStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IridiumsbdStatus_DataReader> IridiumsbdStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < IridiumsbdStatus_DataReader> IridiumsbdStatus_DataReader_out;


            class IridiumsbdStatus_DataReaderView;

            typedef IridiumsbdStatus_DataReaderView * IridiumsbdStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IridiumsbdStatus_DataReaderView> IridiumsbdStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IridiumsbdStatus_DataReaderView> IridiumsbdStatus_DataReaderView_out;

            struct IridiumsbdStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < IridiumsbdStatus_, struct IridiumsbdStatus_Seq_uniq_> IridiumsbdStatus_Seq;
            typedef DDS_DCPSSequence_var < IridiumsbdStatus_Seq> IridiumsbdStatus_Seq_var;
            typedef DDS_DCPSSequence_out < IridiumsbdStatus_Seq> IridiumsbdStatus_Seq_out;

            class  IridiumsbdStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IridiumsbdStatus_TypeSupportInterface_ptr _ptr_type;
                typedef IridiumsbdStatus_TypeSupportInterface_var _var_type;

                static IridiumsbdStatus_TypeSupportInterface_ptr _duplicate (IridiumsbdStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IridiumsbdStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IridiumsbdStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IridiumsbdStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IridiumsbdStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IridiumsbdStatus_TypeSupportInterface () {};
                ~IridiumsbdStatus_TypeSupportInterface () {};
            private:
                IridiumsbdStatus_TypeSupportInterface (const IridiumsbdStatus_TypeSupportInterface &);
                IridiumsbdStatus_TypeSupportInterface & operator = (const IridiumsbdStatus_TypeSupportInterface &);
            };

            class  IridiumsbdStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IridiumsbdStatus_DataWriter_ptr _ptr_type;
                typedef IridiumsbdStatus_DataWriter_var _var_type;

                static IridiumsbdStatus_DataWriter_ptr _duplicate (IridiumsbdStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IridiumsbdStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IridiumsbdStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IridiumsbdStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IridiumsbdStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IridiumsbdStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IridiumsbdStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IridiumsbdStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IridiumsbdStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IridiumsbdStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IridiumsbdStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IridiumsbdStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IridiumsbdStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IridiumsbdStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IridiumsbdStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IridiumsbdStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IridiumsbdStatus_& instance_data) = 0;

            protected:
                IridiumsbdStatus_DataWriter () {};
                ~IridiumsbdStatus_DataWriter () {};
            private:
                IridiumsbdStatus_DataWriter (const IridiumsbdStatus_DataWriter &);
                IridiumsbdStatus_DataWriter & operator = (const IridiumsbdStatus_DataWriter &);
            };

            class  IridiumsbdStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IridiumsbdStatus_DataReader_ptr _ptr_type;
                typedef IridiumsbdStatus_DataReader_var _var_type;

                static IridiumsbdStatus_DataReader_ptr _duplicate (IridiumsbdStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IridiumsbdStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IridiumsbdStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IridiumsbdStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IridiumsbdStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IridiumsbdStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IridiumsbdStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IridiumsbdStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IridiumsbdStatus_& instance) = 0;

            protected:
                IridiumsbdStatus_DataReader () {};
                ~IridiumsbdStatus_DataReader () {};
            private:
                IridiumsbdStatus_DataReader (const IridiumsbdStatus_DataReader &);
                IridiumsbdStatus_DataReader & operator = (const IridiumsbdStatus_DataReader &);
            };

            class  IridiumsbdStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IridiumsbdStatus_DataReaderView_ptr _ptr_type;
                typedef IridiumsbdStatus_DataReaderView_var _var_type;

                static IridiumsbdStatus_DataReaderView_ptr _duplicate (IridiumsbdStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IridiumsbdStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IridiumsbdStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IridiumsbdStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IridiumsbdStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IridiumsbdStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IridiumsbdStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IridiumsbdStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IridiumsbdStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IridiumsbdStatus_& instance) = 0;

            protected:
                IridiumsbdStatus_DataReaderView () {};
                ~IridiumsbdStatus_DataReaderView () {};
            private:
                IridiumsbdStatus_DataReaderView (const IridiumsbdStatus_DataReaderView &);
                IridiumsbdStatus_DataReaderView & operator = (const IridiumsbdStatus_DataReaderView &);
            };
        }

    }

}

#endif
