#ifndef _H_5A09E56EA4776439DAE3709927FE56C1_IrlockReport_DCPS_H_
#define _H_5A09E56EA4776439DAE3709927FE56C1_IrlockReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IrlockReport_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class IrlockReport_TypeSupportInterface;

            typedef IrlockReport_TypeSupportInterface * IrlockReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IrlockReport_TypeSupportInterface> IrlockReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IrlockReport_TypeSupportInterface> IrlockReport_TypeSupportInterface_out;


            class IrlockReport_DataWriter;

            typedef IrlockReport_DataWriter * IrlockReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IrlockReport_DataWriter> IrlockReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < IrlockReport_DataWriter> IrlockReport_DataWriter_out;


            class IrlockReport_DataReader;

            typedef IrlockReport_DataReader * IrlockReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IrlockReport_DataReader> IrlockReport_DataReader_var;
            typedef DDS_DCPSInterface_out < IrlockReport_DataReader> IrlockReport_DataReader_out;


            class IrlockReport_DataReaderView;

            typedef IrlockReport_DataReaderView * IrlockReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IrlockReport_DataReaderView> IrlockReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IrlockReport_DataReaderView> IrlockReport_DataReaderView_out;

            struct IrlockReport_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < IrlockReport_, struct IrlockReport_Seq_uniq_> IrlockReport_Seq;
            typedef DDS_DCPSSequence_var < IrlockReport_Seq> IrlockReport_Seq_var;
            typedef DDS_DCPSSequence_out < IrlockReport_Seq> IrlockReport_Seq_out;

            class  IrlockReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IrlockReport_TypeSupportInterface_ptr _ptr_type;
                typedef IrlockReport_TypeSupportInterface_var _var_type;

                static IrlockReport_TypeSupportInterface_ptr _duplicate (IrlockReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IrlockReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IrlockReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IrlockReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IrlockReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IrlockReport_TypeSupportInterface () {};
                ~IrlockReport_TypeSupportInterface () {};
            private:
                IrlockReport_TypeSupportInterface (const IrlockReport_TypeSupportInterface &);
                IrlockReport_TypeSupportInterface & operator = (const IrlockReport_TypeSupportInterface &);
            };

            class  IrlockReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IrlockReport_DataWriter_ptr _ptr_type;
                typedef IrlockReport_DataWriter_var _var_type;

                static IrlockReport_DataWriter_ptr _duplicate (IrlockReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IrlockReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IrlockReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IrlockReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IrlockReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IrlockReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IrlockReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IrlockReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IrlockReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IrlockReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IrlockReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IrlockReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IrlockReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IrlockReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IrlockReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IrlockReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IrlockReport_& instance_data) = 0;

            protected:
                IrlockReport_DataWriter () {};
                ~IrlockReport_DataWriter () {};
            private:
                IrlockReport_DataWriter (const IrlockReport_DataWriter &);
                IrlockReport_DataWriter & operator = (const IrlockReport_DataWriter &);
            };

            class  IrlockReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IrlockReport_DataReader_ptr _ptr_type;
                typedef IrlockReport_DataReader_var _var_type;

                static IrlockReport_DataReader_ptr _duplicate (IrlockReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IrlockReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IrlockReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IrlockReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IrlockReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IrlockReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IrlockReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IrlockReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IrlockReport_& instance) = 0;

            protected:
                IrlockReport_DataReader () {};
                ~IrlockReport_DataReader () {};
            private:
                IrlockReport_DataReader (const IrlockReport_DataReader &);
                IrlockReport_DataReader & operator = (const IrlockReport_DataReader &);
            };

            class  IrlockReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IrlockReport_DataReaderView_ptr _ptr_type;
                typedef IrlockReport_DataReaderView_var _var_type;

                static IrlockReport_DataReaderView_ptr _duplicate (IrlockReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IrlockReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IrlockReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IrlockReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IrlockReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IrlockReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IrlockReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IrlockReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IrlockReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IrlockReport_& instance) = 0;

            protected:
                IrlockReport_DataReaderView () {};
                ~IrlockReport_DataReaderView () {};
            private:
                IrlockReport_DataReaderView (const IrlockReport_DataReaderView &);
                IrlockReport_DataReaderView & operator = (const IrlockReport_DataReaderView &);
            };
        }

    }

}

#endif
