#ifndef _H_E6A8C6C69BF53EFEAB971E80F21A61D6_LandingGear_DCPS_H_
#define _H_E6A8C6C69BF53EFEAB971E80F21A61D6_LandingGear_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LandingGear_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LandingGear_TypeSupportInterface;

            typedef LandingGear_TypeSupportInterface * LandingGear_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LandingGear_TypeSupportInterface> LandingGear_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LandingGear_TypeSupportInterface> LandingGear_TypeSupportInterface_out;


            class LandingGear_DataWriter;

            typedef LandingGear_DataWriter * LandingGear_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LandingGear_DataWriter> LandingGear_DataWriter_var;
            typedef DDS_DCPSInterface_out < LandingGear_DataWriter> LandingGear_DataWriter_out;


            class LandingGear_DataReader;

            typedef LandingGear_DataReader * LandingGear_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LandingGear_DataReader> LandingGear_DataReader_var;
            typedef DDS_DCPSInterface_out < LandingGear_DataReader> LandingGear_DataReader_out;


            class LandingGear_DataReaderView;

            typedef LandingGear_DataReaderView * LandingGear_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LandingGear_DataReaderView> LandingGear_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LandingGear_DataReaderView> LandingGear_DataReaderView_out;

            struct LandingGear_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LandingGear_, struct LandingGear_Seq_uniq_> LandingGear_Seq;
            typedef DDS_DCPSSequence_var < LandingGear_Seq> LandingGear_Seq_var;
            typedef DDS_DCPSSequence_out < LandingGear_Seq> LandingGear_Seq_out;

            class  LandingGear_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LandingGear_TypeSupportInterface_ptr _ptr_type;
                typedef LandingGear_TypeSupportInterface_var _var_type;

                static LandingGear_TypeSupportInterface_ptr _duplicate (LandingGear_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingGear_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LandingGear_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingGear_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingGear_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LandingGear_TypeSupportInterface () {};
                ~LandingGear_TypeSupportInterface () {};
            private:
                LandingGear_TypeSupportInterface (const LandingGear_TypeSupportInterface &);
                LandingGear_TypeSupportInterface & operator = (const LandingGear_TypeSupportInterface &);
            };

            class  LandingGear_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LandingGear_DataWriter_ptr _ptr_type;
                typedef LandingGear_DataWriter_var _var_type;

                static LandingGear_DataWriter_ptr _duplicate (LandingGear_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingGear_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LandingGear_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingGear_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingGear_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LandingGear_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LandingGear_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LandingGear_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LandingGear_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LandingGear_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LandingGear_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LandingGear_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LandingGear_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LandingGear_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LandingGear_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LandingGear_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingGear_& instance_data) = 0;

            protected:
                LandingGear_DataWriter () {};
                ~LandingGear_DataWriter () {};
            private:
                LandingGear_DataWriter (const LandingGear_DataWriter &);
                LandingGear_DataWriter & operator = (const LandingGear_DataWriter &);
            };

            class  LandingGear_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LandingGear_DataReader_ptr _ptr_type;
                typedef LandingGear_DataReader_var _var_type;

                static LandingGear_DataReader_ptr _duplicate (LandingGear_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingGear_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LandingGear_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingGear_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingGear_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LandingGear_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LandingGear_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LandingGear_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingGear_& instance) = 0;

            protected:
                LandingGear_DataReader () {};
                ~LandingGear_DataReader () {};
            private:
                LandingGear_DataReader (const LandingGear_DataReader &);
                LandingGear_DataReader & operator = (const LandingGear_DataReader &);
            };

            class  LandingGear_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LandingGear_DataReaderView_ptr _ptr_type;
                typedef LandingGear_DataReaderView_var _var_type;

                static LandingGear_DataReaderView_ptr _duplicate (LandingGear_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LandingGear_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LandingGear_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LandingGear_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LandingGear_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LandingGear_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LandingGear_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LandingGear_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LandingGear_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LandingGear_& instance) = 0;

            protected:
                LandingGear_DataReaderView () {};
                ~LandingGear_DataReaderView () {};
            private:
                LandingGear_DataReaderView (const LandingGear_DataReaderView &);
                LandingGear_DataReaderView & operator = (const LandingGear_DataReaderView &);
            };
        }

    }

}

#endif
