#ifndef _H_BB12BCC3CE6C5AE6206480B054E7BC86_LedControl__H_
#define _H_BB12BCC3CE6C5AE6206480B054E7BC86_LedControl__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace LedControl_Constants
            {
                const ::DDS::Octet COLOR_OFF_ = 0;

                const ::DDS::Octet COLOR_RED_ = 1;

                const ::DDS::Octet COLOR_GREEN_ = 2;

                const ::DDS::Octet COLOR_BLUE_ = 3;

                const ::DDS::Octet COLOR_YELLOW_ = 4;

                const ::DDS::Octet COLOR_PURPLE_ = 5;

                const ::DDS::Octet COLOR_AMBER_ = 6;

                const ::DDS::Octet COLOR_CYAN_ = 7;

                const ::DDS::Octet COLOR_WHITE_ = 8;

                const ::DDS::Octet MODE_OFF_ = 0;

                const ::DDS::Octet MODE_ON_ = 1;

                const ::DDS::Octet MODE_DISABLED_ = 2;

                const ::DDS::Octet MODE_BLINK_SLOW_ = 3;

                const ::DDS::Octet MODE_BLINK_NORMAL_ = 4;

                const ::DDS::Octet MODE_BLINK_FAST_ = 5;

                const ::DDS::Octet MODE_BREATHE_ = 6;

                const ::DDS::Octet MODE_FLASH_ = 7;

                const ::DDS::Octet MAX_PRIORITY_ = 2;

                const ::DDS::Octet ORB_QUEUE_LENGTH_ = 4;

            }

            struct  LedControl_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet led_mask_;
                ::DDS::Octet color_;
                ::DDS::Octet mode_;
                ::DDS::Octet num_blinks_;
                ::DDS::Octet priority_;
            };

            typedef DDS_DCPSStruct_var<LedControl_> LedControl__var;
            typedef LedControl_& LedControl__out;

        }

    }

}

#endif /* _H_BB12BCC3CE6C5AE6206480B054E7BC86_LedControl__H_ */
