#ifndef _H_BB12BCC3CE6C5AE6206480B054E7BC86_LedControl_DCPS_H_
#define _H_BB12BCC3CE6C5AE6206480B054E7BC86_LedControl_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LedControl_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LedControl_TypeSupportInterface;

            typedef LedControl_TypeSupportInterface * LedControl_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LedControl_TypeSupportInterface> LedControl_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LedControl_TypeSupportInterface> LedControl_TypeSupportInterface_out;


            class LedControl_DataWriter;

            typedef LedControl_DataWriter * LedControl_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LedControl_DataWriter> LedControl_DataWriter_var;
            typedef DDS_DCPSInterface_out < LedControl_DataWriter> LedControl_DataWriter_out;


            class LedControl_DataReader;

            typedef LedControl_DataReader * LedControl_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LedControl_DataReader> LedControl_DataReader_var;
            typedef DDS_DCPSInterface_out < LedControl_DataReader> LedControl_DataReader_out;


            class LedControl_DataReaderView;

            typedef LedControl_DataReaderView * LedControl_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LedControl_DataReaderView> LedControl_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LedControl_DataReaderView> LedControl_DataReaderView_out;

            struct LedControl_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LedControl_, struct LedControl_Seq_uniq_> LedControl_Seq;
            typedef DDS_DCPSSequence_var < LedControl_Seq> LedControl_Seq_var;
            typedef DDS_DCPSSequence_out < LedControl_Seq> LedControl_Seq_out;

            class  LedControl_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LedControl_TypeSupportInterface_ptr _ptr_type;
                typedef LedControl_TypeSupportInterface_var _var_type;

                static LedControl_TypeSupportInterface_ptr _duplicate (LedControl_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LedControl_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LedControl_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LedControl_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LedControl_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LedControl_TypeSupportInterface () {};
                ~LedControl_TypeSupportInterface () {};
            private:
                LedControl_TypeSupportInterface (const LedControl_TypeSupportInterface &);
                LedControl_TypeSupportInterface & operator = (const LedControl_TypeSupportInterface &);
            };

            class  LedControl_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LedControl_DataWriter_ptr _ptr_type;
                typedef LedControl_DataWriter_var _var_type;

                static LedControl_DataWriter_ptr _duplicate (LedControl_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LedControl_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LedControl_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LedControl_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LedControl_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LedControl_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LedControl_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LedControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LedControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LedControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LedControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LedControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LedControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LedControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LedControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LedControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LedControl_& instance_data) = 0;

            protected:
                LedControl_DataWriter () {};
                ~LedControl_DataWriter () {};
            private:
                LedControl_DataWriter (const LedControl_DataWriter &);
                LedControl_DataWriter & operator = (const LedControl_DataWriter &);
            };

            class  LedControl_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LedControl_DataReader_ptr _ptr_type;
                typedef LedControl_DataReader_var _var_type;

                static LedControl_DataReader_ptr _duplicate (LedControl_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LedControl_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LedControl_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LedControl_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LedControl_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LedControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LedControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LedControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LedControl_& instance) = 0;

            protected:
                LedControl_DataReader () {};
                ~LedControl_DataReader () {};
            private:
                LedControl_DataReader (const LedControl_DataReader &);
                LedControl_DataReader & operator = (const LedControl_DataReader &);
            };

            class  LedControl_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LedControl_DataReaderView_ptr _ptr_type;
                typedef LedControl_DataReaderView_var _var_type;

                static LedControl_DataReaderView_ptr _duplicate (LedControl_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LedControl_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LedControl_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LedControl_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LedControl_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LedControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LedControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LedControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LedControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LedControl_& instance) = 0;

            protected:
                LedControl_DataReaderView () {};
                ~LedControl_DataReaderView () {};
            private:
                LedControl_DataReaderView (const LedControl_DataReaderView &);
                LedControl_DataReaderView & operator = (const LedControl_DataReaderView &);
            };
        }

    }

}

#endif
