#ifndef _H_75290E4B34E575E10FF58D3842F4CE41_LogMessage_DCPS_H_
#define _H_75290E4B34E575E10FF58D3842F4CE41_LogMessage_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LogMessage_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LogMessage_TypeSupportInterface;

            typedef LogMessage_TypeSupportInterface * LogMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LogMessage_TypeSupportInterface> LogMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LogMessage_TypeSupportInterface> LogMessage_TypeSupportInterface_out;


            class LogMessage_DataWriter;

            typedef LogMessage_DataWriter * LogMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LogMessage_DataWriter> LogMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < LogMessage_DataWriter> LogMessage_DataWriter_out;


            class LogMessage_DataReader;

            typedef LogMessage_DataReader * LogMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LogMessage_DataReader> LogMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < LogMessage_DataReader> LogMessage_DataReader_out;


            class LogMessage_DataReaderView;

            typedef LogMessage_DataReaderView * LogMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LogMessage_DataReaderView> LogMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LogMessage_DataReaderView> LogMessage_DataReaderView_out;

            struct LogMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LogMessage_, struct LogMessage_Seq_uniq_> LogMessage_Seq;
            typedef DDS_DCPSSequence_var < LogMessage_Seq> LogMessage_Seq_var;
            typedef DDS_DCPSSequence_out < LogMessage_Seq> LogMessage_Seq_out;

            class  LogMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LogMessage_TypeSupportInterface_ptr _ptr_type;
                typedef LogMessage_TypeSupportInterface_var _var_type;

                static LogMessage_TypeSupportInterface_ptr _duplicate (LogMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LogMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LogMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LogMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LogMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LogMessage_TypeSupportInterface () {};
                ~LogMessage_TypeSupportInterface () {};
            private:
                LogMessage_TypeSupportInterface (const LogMessage_TypeSupportInterface &);
                LogMessage_TypeSupportInterface & operator = (const LogMessage_TypeSupportInterface &);
            };

            class  LogMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LogMessage_DataWriter_ptr _ptr_type;
                typedef LogMessage_DataWriter_var _var_type;

                static LogMessage_DataWriter_ptr _duplicate (LogMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LogMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LogMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LogMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LogMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LogMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LogMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LogMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LogMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LogMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LogMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LogMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LogMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LogMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LogMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LogMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LogMessage_& instance_data) = 0;

            protected:
                LogMessage_DataWriter () {};
                ~LogMessage_DataWriter () {};
            private:
                LogMessage_DataWriter (const LogMessage_DataWriter &);
                LogMessage_DataWriter & operator = (const LogMessage_DataWriter &);
            };

            class  LogMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LogMessage_DataReader_ptr _ptr_type;
                typedef LogMessage_DataReader_var _var_type;

                static LogMessage_DataReader_ptr _duplicate (LogMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LogMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LogMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LogMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LogMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LogMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LogMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LogMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LogMessage_& instance) = 0;

            protected:
                LogMessage_DataReader () {};
                ~LogMessage_DataReader () {};
            private:
                LogMessage_DataReader (const LogMessage_DataReader &);
                LogMessage_DataReader & operator = (const LogMessage_DataReader &);
            };

            class  LogMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LogMessage_DataReaderView_ptr _ptr_type;
                typedef LogMessage_DataReaderView_var _var_type;

                static LogMessage_DataReaderView_ptr _duplicate (LogMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LogMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LogMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LogMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LogMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LogMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LogMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LogMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LogMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LogMessage_& instance) = 0;

            protected:
                LogMessage_DataReaderView () {};
                ~LogMessage_DataReaderView () {};
            private:
                LogMessage_DataReaderView (const LogMessage_DataReaderView &);
                LogMessage_DataReaderView & operator = (const LogMessage_DataReaderView &);
            };
        }

    }

}

#endif
