#ifndef _H_8F224EF25A60A1EE1E46D679FFEEB2DC_McVirtualAttitudeSetpoint__H_
#define _H_8F224EF25A60A1EE1E46D679FFEEB2DC_McVirtualAttitudeSetpoint__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace McVirtualAttitudeSetpoint_Constants
            {
                const ::DDS::Octet FLAPS_OFF_ = 0;

                const ::DDS::Octet FLAPS_LAND_ = 1;

                const ::DDS::Octet FLAPS_TAKEOFF_ = 2;

            }

            struct  McVirtualAttitudeSetpoint_
            {
                struct _q_d__uniq_{};
                typedef ::DDS::Float _q_d__slice;
                typedef ::DDS::Float _q_d_[4];
                typedef DDS_DCPS_FArray_var< _q_d_, _q_d__slice, struct _q_d__uniq_ > _q_d__var;
                typedef _q_d_ _q_d__out;
                typedef DDS_DCPS_Array_forany< _q_d_, _q_d__slice, struct _q_d__uniq_ > _q_d__forany;
                static _q_d__slice *_q_d__alloc();
                static void _q_d__free(_q_d__slice *);
                static void _q_d__copy(_q_d__slice *to, const _q_d__slice *from);
                static _q_d__slice *_q_d__dup(const _q_d__slice *from);
                struct _thrust_body__uniq_{};
                typedef ::DDS::Float _thrust_body__slice;
                typedef ::DDS::Float _thrust_body_[3];
                typedef DDS_DCPS_FArray_var< _thrust_body_, _thrust_body__slice, struct _thrust_body__uniq_ > _thrust_body__var;
                typedef _thrust_body_ _thrust_body__out;
                typedef DDS_DCPS_Array_forany< _thrust_body_, _thrust_body__slice, struct _thrust_body__uniq_ > _thrust_body__forany;
                static _thrust_body__slice *_thrust_body__alloc();
                static void _thrust_body__free(_thrust_body__slice *);
                static void _thrust_body__copy(_thrust_body__slice *to, const _thrust_body__slice *from);
                static _thrust_body__slice *_thrust_body__dup(const _thrust_body__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::Float roll_body_;
                ::DDS::Float pitch_body_;
                ::DDS::Float yaw_body_;
                ::DDS::Float yaw_sp_move_rate_;
                _q_d_ q_d_;
                ::DDS::Boolean q_d_valid_;
                _thrust_body_ thrust_body_;
                ::DDS::Boolean roll_reset_integral_;
                ::DDS::Boolean pitch_reset_integral_;
                ::DDS::Boolean yaw_reset_integral_;
                ::DDS::Boolean fw_control_yaw_;
                ::DDS::Octet apply_flaps_;
            };

            typedef DDS_DCPSStruct_var<McVirtualAttitudeSetpoint_> McVirtualAttitudeSetpoint__var;
            typedef McVirtualAttitudeSetpoint_& McVirtualAttitudeSetpoint__out;

        }

    }

}

#endif /* _H_8F224EF25A60A1EE1E46D679FFEEB2DC_McVirtualAttitudeSetpoint__H_ */
