#ifndef _H_04E06A1319219DD98441BB811D3278C3_ObstacleDistanceFused_DCPS_H_
#define _H_04E06A1319219DD98441BB811D3278C3_ObstacleDistanceFused_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObstacleDistanceFused_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObstacleDistanceFused_TypeSupportInterface;

            typedef ObstacleDistanceFused_TypeSupportInterface * ObstacleDistanceFused_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObstacleDistanceFused_TypeSupportInterface> ObstacleDistanceFused_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObstacleDistanceFused_TypeSupportInterface> ObstacleDistanceFused_TypeSupportInterface_out;


            class ObstacleDistanceFused_DataWriter;

            typedef ObstacleDistanceFused_DataWriter * ObstacleDistanceFused_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObstacleDistanceFused_DataWriter> ObstacleDistanceFused_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObstacleDistanceFused_DataWriter> ObstacleDistanceFused_DataWriter_out;


            class ObstacleDistanceFused_DataReader;

            typedef ObstacleDistanceFused_DataReader * ObstacleDistanceFused_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObstacleDistanceFused_DataReader> ObstacleDistanceFused_DataReader_var;
            typedef DDS_DCPSInterface_out < ObstacleDistanceFused_DataReader> ObstacleDistanceFused_DataReader_out;


            class ObstacleDistanceFused_DataReaderView;

            typedef ObstacleDistanceFused_DataReaderView * ObstacleDistanceFused_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObstacleDistanceFused_DataReaderView> ObstacleDistanceFused_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObstacleDistanceFused_DataReaderView> ObstacleDistanceFused_DataReaderView_out;

            struct ObstacleDistanceFused_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ObstacleDistanceFused_, struct ObstacleDistanceFused_Seq_uniq_> ObstacleDistanceFused_Seq;
            typedef DDS_DCPSSequence_var < ObstacleDistanceFused_Seq> ObstacleDistanceFused_Seq_var;
            typedef DDS_DCPSSequence_out < ObstacleDistanceFused_Seq> ObstacleDistanceFused_Seq_out;

            class  ObstacleDistanceFused_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObstacleDistanceFused_TypeSupportInterface_ptr _ptr_type;
                typedef ObstacleDistanceFused_TypeSupportInterface_var _var_type;

                static ObstacleDistanceFused_TypeSupportInterface_ptr _duplicate (ObstacleDistanceFused_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleDistanceFused_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleDistanceFused_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleDistanceFused_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleDistanceFused_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObstacleDistanceFused_TypeSupportInterface () {};
                ~ObstacleDistanceFused_TypeSupportInterface () {};
            private:
                ObstacleDistanceFused_TypeSupportInterface (const ObstacleDistanceFused_TypeSupportInterface &);
                ObstacleDistanceFused_TypeSupportInterface & operator = (const ObstacleDistanceFused_TypeSupportInterface &);
            };

            class  ObstacleDistanceFused_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObstacleDistanceFused_DataWriter_ptr _ptr_type;
                typedef ObstacleDistanceFused_DataWriter_var _var_type;

                static ObstacleDistanceFused_DataWriter_ptr _duplicate (ObstacleDistanceFused_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleDistanceFused_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleDistanceFused_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleDistanceFused_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleDistanceFused_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObstacleDistanceFused_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObstacleDistanceFused_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObstacleDistanceFused_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObstacleDistanceFused_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObstacleDistanceFused_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObstacleDistanceFused_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObstacleDistanceFused_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObstacleDistanceFused_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObstacleDistanceFused_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObstacleDistanceFused_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObstacleDistanceFused_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleDistanceFused_& instance_data) = 0;

            protected:
                ObstacleDistanceFused_DataWriter () {};
                ~ObstacleDistanceFused_DataWriter () {};
            private:
                ObstacleDistanceFused_DataWriter (const ObstacleDistanceFused_DataWriter &);
                ObstacleDistanceFused_DataWriter & operator = (const ObstacleDistanceFused_DataWriter &);
            };

            class  ObstacleDistanceFused_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObstacleDistanceFused_DataReader_ptr _ptr_type;
                typedef ObstacleDistanceFused_DataReader_var _var_type;

                static ObstacleDistanceFused_DataReader_ptr _duplicate (ObstacleDistanceFused_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleDistanceFused_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleDistanceFused_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleDistanceFused_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleDistanceFused_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleDistanceFused_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleDistanceFused_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleDistanceFused_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleDistanceFused_& instance) = 0;

            protected:
                ObstacleDistanceFused_DataReader () {};
                ~ObstacleDistanceFused_DataReader () {};
            private:
                ObstacleDistanceFused_DataReader (const ObstacleDistanceFused_DataReader &);
                ObstacleDistanceFused_DataReader & operator = (const ObstacleDistanceFused_DataReader &);
            };

            class  ObstacleDistanceFused_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObstacleDistanceFused_DataReaderView_ptr _ptr_type;
                typedef ObstacleDistanceFused_DataReaderView_var _var_type;

                static ObstacleDistanceFused_DataReaderView_ptr _duplicate (ObstacleDistanceFused_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleDistanceFused_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleDistanceFused_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleDistanceFused_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleDistanceFused_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleDistanceFused_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleDistanceFused_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleDistanceFused_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleDistanceFused_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleDistanceFused_& instance) = 0;

            protected:
                ObstacleDistanceFused_DataReaderView () {};
                ~ObstacleDistanceFused_DataReaderView () {};
            private:
                ObstacleDistanceFused_DataReaderView (const ObstacleDistanceFused_DataReaderView &);
                ObstacleDistanceFused_DataReaderView & operator = (const ObstacleDistanceFused_DataReaderView &);
            };
        }

    }

}

#endif
