#ifndef _H_CA95F2F26E18E43733CABE3621E851EC_ObstacleDistance__H_
#define _H_CA95F2F26E18E43733CABE3621E851EC_ObstacleDistance__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ObstacleDistance_Constants
            {
                const ::DDS::Octet MAV_FRAME_GLOBAL_ = 0;

                const ::DDS::Octet MAV_FRAME_LOCAL_NED_ = 1;

                const ::DDS::Octet MAV_FRAME_BODY_FRD_ = 12;

                const ::DDS::Octet MAV_DISTANCE_SENSOR_LASER_ = 0;

                const ::DDS::Octet MAV_DISTANCE_SENSOR_ULTRASOUND_ = 1;

                const ::DDS::Octet MAV_DISTANCE_SENSOR_INFRARED_ = 2;

                const ::DDS::Octet MAV_DISTANCE_SENSOR_RADAR_ = 3;

            }

            struct  ObstacleDistance_
            {
                struct _distances__uniq_{};
                typedef ::DDS::UShort _distances__slice;
                typedef ::DDS::UShort _distances_[72];
                typedef DDS_DCPS_FArray_var< _distances_, _distances__slice, struct _distances__uniq_ > _distances__var;
                typedef _distances_ _distances__out;
                typedef DDS_DCPS_Array_forany< _distances_, _distances__slice, struct _distances__uniq_ > _distances__forany;
                static _distances__slice *_distances__alloc();
                static void _distances__free(_distances__slice *);
                static void _distances__copy(_distances__slice *to, const _distances__slice *from);
                static _distances__slice *_distances__dup(const _distances__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet frame_;
                ::DDS::Octet sensor_type_;
                _distances_ distances_;
                ::DDS::Float increment_;
                ::DDS::UShort min_distance_;
                ::DDS::UShort max_distance_;
                ::DDS::Float angle_offset_;
            };

            typedef DDS_DCPSStruct_var<ObstacleDistance_> ObstacleDistance__var;
            typedef ObstacleDistance_& ObstacleDistance__out;

        }

    }

}

#endif /* _H_CA95F2F26E18E43733CABE3621E851EC_ObstacleDistance__H_ */
