#ifndef _H_DBE9702DE4C43AFF145DCD96B263E43F_OffboardControlMode_DCPS_H_
#define _H_DBE9702DE4C43AFF145DCD96B263E43F_OffboardControlMode_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "OffboardControlMode_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class OffboardControlMode_TypeSupportInterface;

            typedef OffboardControlMode_TypeSupportInterface * OffboardControlMode_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OffboardControlMode_TypeSupportInterface> OffboardControlMode_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OffboardControlMode_TypeSupportInterface> OffboardControlMode_TypeSupportInterface_out;


            class OffboardControlMode_DataWriter;

            typedef OffboardControlMode_DataWriter * OffboardControlMode_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OffboardControlMode_DataWriter> OffboardControlMode_DataWriter_var;
            typedef DDS_DCPSInterface_out < OffboardControlMode_DataWriter> OffboardControlMode_DataWriter_out;


            class OffboardControlMode_DataReader;

            typedef OffboardControlMode_DataReader * OffboardControlMode_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OffboardControlMode_DataReader> OffboardControlMode_DataReader_var;
            typedef DDS_DCPSInterface_out < OffboardControlMode_DataReader> OffboardControlMode_DataReader_out;


            class OffboardControlMode_DataReaderView;

            typedef OffboardControlMode_DataReaderView * OffboardControlMode_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OffboardControlMode_DataReaderView> OffboardControlMode_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OffboardControlMode_DataReaderView> OffboardControlMode_DataReaderView_out;

            struct OffboardControlMode_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < OffboardControlMode_, struct OffboardControlMode_Seq_uniq_> OffboardControlMode_Seq;
            typedef DDS_DCPSSequence_var < OffboardControlMode_Seq> OffboardControlMode_Seq_var;
            typedef DDS_DCPSSequence_out < OffboardControlMode_Seq> OffboardControlMode_Seq_out;

            class  OffboardControlMode_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OffboardControlMode_TypeSupportInterface_ptr _ptr_type;
                typedef OffboardControlMode_TypeSupportInterface_var _var_type;

                static OffboardControlMode_TypeSupportInterface_ptr _duplicate (OffboardControlMode_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OffboardControlMode_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OffboardControlMode_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OffboardControlMode_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OffboardControlMode_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OffboardControlMode_TypeSupportInterface () {};
                ~OffboardControlMode_TypeSupportInterface () {};
            private:
                OffboardControlMode_TypeSupportInterface (const OffboardControlMode_TypeSupportInterface &);
                OffboardControlMode_TypeSupportInterface & operator = (const OffboardControlMode_TypeSupportInterface &);
            };

            class  OffboardControlMode_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OffboardControlMode_DataWriter_ptr _ptr_type;
                typedef OffboardControlMode_DataWriter_var _var_type;

                static OffboardControlMode_DataWriter_ptr _duplicate (OffboardControlMode_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OffboardControlMode_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OffboardControlMode_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OffboardControlMode_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OffboardControlMode_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OffboardControlMode_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OffboardControlMode_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OffboardControlMode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OffboardControlMode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OffboardControlMode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OffboardControlMode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OffboardControlMode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OffboardControlMode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OffboardControlMode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OffboardControlMode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OffboardControlMode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OffboardControlMode_& instance_data) = 0;

            protected:
                OffboardControlMode_DataWriter () {};
                ~OffboardControlMode_DataWriter () {};
            private:
                OffboardControlMode_DataWriter (const OffboardControlMode_DataWriter &);
                OffboardControlMode_DataWriter & operator = (const OffboardControlMode_DataWriter &);
            };

            class  OffboardControlMode_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OffboardControlMode_DataReader_ptr _ptr_type;
                typedef OffboardControlMode_DataReader_var _var_type;

                static OffboardControlMode_DataReader_ptr _duplicate (OffboardControlMode_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OffboardControlMode_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OffboardControlMode_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OffboardControlMode_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OffboardControlMode_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OffboardControlMode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OffboardControlMode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OffboardControlMode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OffboardControlMode_& instance) = 0;

            protected:
                OffboardControlMode_DataReader () {};
                ~OffboardControlMode_DataReader () {};
            private:
                OffboardControlMode_DataReader (const OffboardControlMode_DataReader &);
                OffboardControlMode_DataReader & operator = (const OffboardControlMode_DataReader &);
            };

            class  OffboardControlMode_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OffboardControlMode_DataReaderView_ptr _ptr_type;
                typedef OffboardControlMode_DataReaderView_var _var_type;

                static OffboardControlMode_DataReaderView_ptr _duplicate (OffboardControlMode_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OffboardControlMode_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OffboardControlMode_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OffboardControlMode_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OffboardControlMode_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OffboardControlMode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OffboardControlMode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OffboardControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OffboardControlMode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OffboardControlMode_& instance) = 0;

            protected:
                OffboardControlMode_DataReaderView () {};
                ~OffboardControlMode_DataReaderView () {};
            private:
                OffboardControlMode_DataReaderView (const OffboardControlMode_DataReaderView &);
                OffboardControlMode_DataReaderView & operator = (const OffboardControlMode_DataReaderView &);
            };
        }

    }

}

#endif
