#ifndef _H_0B8A0C41F45D2C3B18091BE5E02EBAAC_OpticalFlow__H_
#define _H_0B8A0C41F45D2C3B18091BE5E02EBAAC_OpticalFlow__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  OpticalFlow_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet sensor_id_;
                ::DDS::Float pixel_flow_x_integral_;
                ::DDS::Float pixel_flow_y_integral_;
                ::DDS::Float gyro_x_rate_integral_;
                ::DDS::Float gyro_y_rate_integral_;
                ::DDS::Float gyro_z_rate_integral_;
                ::DDS::Float ground_distance_m_;
                ::DDS::ULong integration_timespan_;
                ::DDS::ULong time_since_last_sonar_update_;
                ::DDS::UShort frame_count_since_last_readout_;
                ::DDS::Short gyro_temperature_;
                ::DDS::Octet quality_;
                ::DDS::Float max_flow_rate_;
                ::DDS::Float min_ground_distance_;
                ::DDS::Float max_ground_distance_;
            };

            typedef DDS_DCPSStruct_var<OpticalFlow_> OpticalFlow__var;
            typedef OpticalFlow_& OpticalFlow__out;

        }

    }

}

#endif /* _H_0B8A0C41F45D2C3B18091BE5E02EBAAC_OpticalFlow__H_ */
