#ifndef _H_9C6B203CF2280507B465C3377AE9560B_ParameterUpdate_DCPS_H_
#define _H_9C6B203CF2280507B465C3377AE9560B_ParameterUpdate_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ParameterUpdate_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ParameterUpdate_TypeSupportInterface;

            typedef ParameterUpdate_TypeSupportInterface * ParameterUpdate_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ParameterUpdate_TypeSupportInterface> ParameterUpdate_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ParameterUpdate_TypeSupportInterface> ParameterUpdate_TypeSupportInterface_out;


            class ParameterUpdate_DataWriter;

            typedef ParameterUpdate_DataWriter * ParameterUpdate_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ParameterUpdate_DataWriter> ParameterUpdate_DataWriter_var;
            typedef DDS_DCPSInterface_out < ParameterUpdate_DataWriter> ParameterUpdate_DataWriter_out;


            class ParameterUpdate_DataReader;

            typedef ParameterUpdate_DataReader * ParameterUpdate_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ParameterUpdate_DataReader> ParameterUpdate_DataReader_var;
            typedef DDS_DCPSInterface_out < ParameterUpdate_DataReader> ParameterUpdate_DataReader_out;


            class ParameterUpdate_DataReaderView;

            typedef ParameterUpdate_DataReaderView * ParameterUpdate_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ParameterUpdate_DataReaderView> ParameterUpdate_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ParameterUpdate_DataReaderView> ParameterUpdate_DataReaderView_out;

            struct ParameterUpdate_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ParameterUpdate_, struct ParameterUpdate_Seq_uniq_> ParameterUpdate_Seq;
            typedef DDS_DCPSSequence_var < ParameterUpdate_Seq> ParameterUpdate_Seq_var;
            typedef DDS_DCPSSequence_out < ParameterUpdate_Seq> ParameterUpdate_Seq_out;

            class  ParameterUpdate_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ParameterUpdate_TypeSupportInterface_ptr _ptr_type;
                typedef ParameterUpdate_TypeSupportInterface_var _var_type;

                static ParameterUpdate_TypeSupportInterface_ptr _duplicate (ParameterUpdate_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ParameterUpdate_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ParameterUpdate_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ParameterUpdate_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ParameterUpdate_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ParameterUpdate_TypeSupportInterface () {};
                ~ParameterUpdate_TypeSupportInterface () {};
            private:
                ParameterUpdate_TypeSupportInterface (const ParameterUpdate_TypeSupportInterface &);
                ParameterUpdate_TypeSupportInterface & operator = (const ParameterUpdate_TypeSupportInterface &);
            };

            class  ParameterUpdate_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ParameterUpdate_DataWriter_ptr _ptr_type;
                typedef ParameterUpdate_DataWriter_var _var_type;

                static ParameterUpdate_DataWriter_ptr _duplicate (ParameterUpdate_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ParameterUpdate_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ParameterUpdate_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ParameterUpdate_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ParameterUpdate_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ParameterUpdate_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ParameterUpdate_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ParameterUpdate_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ParameterUpdate_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ParameterUpdate_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ParameterUpdate_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ParameterUpdate_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ParameterUpdate_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ParameterUpdate_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ParameterUpdate_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ParameterUpdate_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ParameterUpdate_& instance_data) = 0;

            protected:
                ParameterUpdate_DataWriter () {};
                ~ParameterUpdate_DataWriter () {};
            private:
                ParameterUpdate_DataWriter (const ParameterUpdate_DataWriter &);
                ParameterUpdate_DataWriter & operator = (const ParameterUpdate_DataWriter &);
            };

            class  ParameterUpdate_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ParameterUpdate_DataReader_ptr _ptr_type;
                typedef ParameterUpdate_DataReader_var _var_type;

                static ParameterUpdate_DataReader_ptr _duplicate (ParameterUpdate_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ParameterUpdate_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ParameterUpdate_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ParameterUpdate_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ParameterUpdate_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ParameterUpdate_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ParameterUpdate_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ParameterUpdate_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ParameterUpdate_& instance) = 0;

            protected:
                ParameterUpdate_DataReader () {};
                ~ParameterUpdate_DataReader () {};
            private:
                ParameterUpdate_DataReader (const ParameterUpdate_DataReader &);
                ParameterUpdate_DataReader & operator = (const ParameterUpdate_DataReader &);
            };

            class  ParameterUpdate_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ParameterUpdate_DataReaderView_ptr _ptr_type;
                typedef ParameterUpdate_DataReaderView_var _var_type;

                static ParameterUpdate_DataReaderView_ptr _duplicate (ParameterUpdate_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ParameterUpdate_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ParameterUpdate_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ParameterUpdate_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ParameterUpdate_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ParameterUpdate_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ParameterUpdate_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ParameterUpdate_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ParameterUpdate_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ParameterUpdate_& instance) = 0;

            protected:
                ParameterUpdate_DataReaderView () {};
                ~ParameterUpdate_DataReaderView () {};
            private:
                ParameterUpdate_DataReaderView (const ParameterUpdate_DataReaderView &);
                ParameterUpdate_DataReaderView & operator = (const ParameterUpdate_DataReaderView &);
            };
        }

    }

}

#endif
