#ifndef _H_0A96579DA3F6117450AAE599B56FEC1A_Ping_DCPS_H_
#define _H_0A96579DA3F6117450AAE599B56FEC1A_Ping_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Ping_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Ping_TypeSupportInterface;

            typedef Ping_TypeSupportInterface * Ping_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Ping_TypeSupportInterface> Ping_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Ping_TypeSupportInterface> Ping_TypeSupportInterface_out;


            class Ping_DataWriter;

            typedef Ping_DataWriter * Ping_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Ping_DataWriter> Ping_DataWriter_var;
            typedef DDS_DCPSInterface_out < Ping_DataWriter> Ping_DataWriter_out;


            class Ping_DataReader;

            typedef Ping_DataReader * Ping_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Ping_DataReader> Ping_DataReader_var;
            typedef DDS_DCPSInterface_out < Ping_DataReader> Ping_DataReader_out;


            class Ping_DataReaderView;

            typedef Ping_DataReaderView * Ping_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Ping_DataReaderView> Ping_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Ping_DataReaderView> Ping_DataReaderView_out;

            struct Ping_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Ping_, struct Ping_Seq_uniq_> Ping_Seq;
            typedef DDS_DCPSSequence_var < Ping_Seq> Ping_Seq_var;
            typedef DDS_DCPSSequence_out < Ping_Seq> Ping_Seq_out;

            class  Ping_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Ping_TypeSupportInterface_ptr _ptr_type;
                typedef Ping_TypeSupportInterface_var _var_type;

                static Ping_TypeSupportInterface_ptr _duplicate (Ping_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ping_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Ping_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ping_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Ping_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Ping_TypeSupportInterface () {};
                ~Ping_TypeSupportInterface () {};
            private:
                Ping_TypeSupportInterface (const Ping_TypeSupportInterface &);
                Ping_TypeSupportInterface & operator = (const Ping_TypeSupportInterface &);
            };

            class  Ping_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Ping_DataWriter_ptr _ptr_type;
                typedef Ping_DataWriter_var _var_type;

                static Ping_DataWriter_ptr _duplicate (Ping_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ping_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Ping_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ping_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Ping_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Ping_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Ping_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Ping_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Ping_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Ping_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Ping_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Ping_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Ping_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Ping_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Ping_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Ping_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ping_& instance_data) = 0;

            protected:
                Ping_DataWriter () {};
                ~Ping_DataWriter () {};
            private:
                Ping_DataWriter (const Ping_DataWriter &);
                Ping_DataWriter & operator = (const Ping_DataWriter &);
            };

            class  Ping_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Ping_DataReader_ptr _ptr_type;
                typedef Ping_DataReader_var _var_type;

                static Ping_DataReader_ptr _duplicate (Ping_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ping_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Ping_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ping_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Ping_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Ping_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Ping_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Ping_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ping_& instance) = 0;

            protected:
                Ping_DataReader () {};
                ~Ping_DataReader () {};
            private:
                Ping_DataReader (const Ping_DataReader &);
                Ping_DataReader & operator = (const Ping_DataReader &);
            };

            class  Ping_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Ping_DataReaderView_ptr _ptr_type;
                typedef Ping_DataReaderView_var _var_type;

                static Ping_DataReaderView_ptr _duplicate (Ping_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ping_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Ping_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ping_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Ping_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Ping_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Ping_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Ping_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Ping_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ping_& instance) = 0;

            protected:
                Ping_DataReaderView () {};
                ~Ping_DataReaderView () {};
            private:
                Ping_DataReaderView (const Ping_DataReaderView &);
                Ping_DataReaderView & operator = (const Ping_DataReaderView &);
            };
        }

    }

}

#endif
