#ifndef _H_DF9B68C9B1ABDE74C3962CCFC571DB4A_PositionControllerStatus_DCPS_H_
#define _H_DF9B68C9B1ABDE74C3962CCFC571DB4A_PositionControllerStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionControllerStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionControllerStatus_TypeSupportInterface;

            typedef PositionControllerStatus_TypeSupportInterface * PositionControllerStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionControllerStatus_TypeSupportInterface> PositionControllerStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionControllerStatus_TypeSupportInterface> PositionControllerStatus_TypeSupportInterface_out;


            class PositionControllerStatus_DataWriter;

            typedef PositionControllerStatus_DataWriter * PositionControllerStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionControllerStatus_DataWriter> PositionControllerStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionControllerStatus_DataWriter> PositionControllerStatus_DataWriter_out;


            class PositionControllerStatus_DataReader;

            typedef PositionControllerStatus_DataReader * PositionControllerStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionControllerStatus_DataReader> PositionControllerStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionControllerStatus_DataReader> PositionControllerStatus_DataReader_out;


            class PositionControllerStatus_DataReaderView;

            typedef PositionControllerStatus_DataReaderView * PositionControllerStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionControllerStatus_DataReaderView> PositionControllerStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionControllerStatus_DataReaderView> PositionControllerStatus_DataReaderView_out;

            struct PositionControllerStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PositionControllerStatus_, struct PositionControllerStatus_Seq_uniq_> PositionControllerStatus_Seq;
            typedef DDS_DCPSSequence_var < PositionControllerStatus_Seq> PositionControllerStatus_Seq_var;
            typedef DDS_DCPSSequence_out < PositionControllerStatus_Seq> PositionControllerStatus_Seq_out;

            class  PositionControllerStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionControllerStatus_TypeSupportInterface_ptr _ptr_type;
                typedef PositionControllerStatus_TypeSupportInterface_var _var_type;

                static PositionControllerStatus_TypeSupportInterface_ptr _duplicate (PositionControllerStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionControllerStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionControllerStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionControllerStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionControllerStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionControllerStatus_TypeSupportInterface () {};
                ~PositionControllerStatus_TypeSupportInterface () {};
            private:
                PositionControllerStatus_TypeSupportInterface (const PositionControllerStatus_TypeSupportInterface &);
                PositionControllerStatus_TypeSupportInterface & operator = (const PositionControllerStatus_TypeSupportInterface &);
            };

            class  PositionControllerStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionControllerStatus_DataWriter_ptr _ptr_type;
                typedef PositionControllerStatus_DataWriter_var _var_type;

                static PositionControllerStatus_DataWriter_ptr _duplicate (PositionControllerStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionControllerStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionControllerStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionControllerStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionControllerStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionControllerStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionControllerStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionControllerStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionControllerStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionControllerStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionControllerStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionControllerStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionControllerStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionControllerStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionControllerStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionControllerStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionControllerStatus_& instance_data) = 0;

            protected:
                PositionControllerStatus_DataWriter () {};
                ~PositionControllerStatus_DataWriter () {};
            private:
                PositionControllerStatus_DataWriter (const PositionControllerStatus_DataWriter &);
                PositionControllerStatus_DataWriter & operator = (const PositionControllerStatus_DataWriter &);
            };

            class  PositionControllerStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionControllerStatus_DataReader_ptr _ptr_type;
                typedef PositionControllerStatus_DataReader_var _var_type;

                static PositionControllerStatus_DataReader_ptr _duplicate (PositionControllerStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionControllerStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionControllerStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionControllerStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionControllerStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionControllerStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionControllerStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionControllerStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionControllerStatus_& instance) = 0;

            protected:
                PositionControllerStatus_DataReader () {};
                ~PositionControllerStatus_DataReader () {};
            private:
                PositionControllerStatus_DataReader (const PositionControllerStatus_DataReader &);
                PositionControllerStatus_DataReader & operator = (const PositionControllerStatus_DataReader &);
            };

            class  PositionControllerStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionControllerStatus_DataReaderView_ptr _ptr_type;
                typedef PositionControllerStatus_DataReaderView_var _var_type;

                static PositionControllerStatus_DataReaderView_ptr _duplicate (PositionControllerStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionControllerStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionControllerStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionControllerStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionControllerStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionControllerStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionControllerStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionControllerStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionControllerStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionControllerStatus_& instance) = 0;

            protected:
                PositionControllerStatus_DataReaderView () {};
                ~PositionControllerStatus_DataReaderView () {};
            private:
                PositionControllerStatus_DataReaderView (const PositionControllerStatus_DataReaderView &);
                PositionControllerStatus_DataReaderView & operator = (const PositionControllerStatus_DataReaderView &);
            };
        }

    }

}

#endif
