#ifndef _H_0DBC0DD1EA3804234BF3A4091344C9EA_PositionSetpointTriplet_DCPS_H_
#define _H_0DBC0DD1EA3804234BF3A4091344C9EA_PositionSetpointTriplet_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionSetpointTriplet_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionSetpointTriplet_TypeSupportInterface;

            typedef PositionSetpointTriplet_TypeSupportInterface * PositionSetpointTriplet_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionSetpointTriplet_TypeSupportInterface> PositionSetpointTriplet_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionSetpointTriplet_TypeSupportInterface> PositionSetpointTriplet_TypeSupportInterface_out;


            class PositionSetpointTriplet_DataWriter;

            typedef PositionSetpointTriplet_DataWriter * PositionSetpointTriplet_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionSetpointTriplet_DataWriter> PositionSetpointTriplet_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionSetpointTriplet_DataWriter> PositionSetpointTriplet_DataWriter_out;


            class PositionSetpointTriplet_DataReader;

            typedef PositionSetpointTriplet_DataReader * PositionSetpointTriplet_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionSetpointTriplet_DataReader> PositionSetpointTriplet_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionSetpointTriplet_DataReader> PositionSetpointTriplet_DataReader_out;


            class PositionSetpointTriplet_DataReaderView;

            typedef PositionSetpointTriplet_DataReaderView * PositionSetpointTriplet_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionSetpointTriplet_DataReaderView> PositionSetpointTriplet_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionSetpointTriplet_DataReaderView> PositionSetpointTriplet_DataReaderView_out;

            struct PositionSetpointTriplet_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PositionSetpointTriplet_, struct PositionSetpointTriplet_Seq_uniq_> PositionSetpointTriplet_Seq;
            typedef DDS_DCPSSequence_var < PositionSetpointTriplet_Seq> PositionSetpointTriplet_Seq_var;
            typedef DDS_DCPSSequence_out < PositionSetpointTriplet_Seq> PositionSetpointTriplet_Seq_out;

            class  PositionSetpointTriplet_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionSetpointTriplet_TypeSupportInterface_ptr _ptr_type;
                typedef PositionSetpointTriplet_TypeSupportInterface_var _var_type;

                static PositionSetpointTriplet_TypeSupportInterface_ptr _duplicate (PositionSetpointTriplet_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionSetpointTriplet_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionSetpointTriplet_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionSetpointTriplet_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionSetpointTriplet_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionSetpointTriplet_TypeSupportInterface () {};
                ~PositionSetpointTriplet_TypeSupportInterface () {};
            private:
                PositionSetpointTriplet_TypeSupportInterface (const PositionSetpointTriplet_TypeSupportInterface &);
                PositionSetpointTriplet_TypeSupportInterface & operator = (const PositionSetpointTriplet_TypeSupportInterface &);
            };

            class  PositionSetpointTriplet_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionSetpointTriplet_DataWriter_ptr _ptr_type;
                typedef PositionSetpointTriplet_DataWriter_var _var_type;

                static PositionSetpointTriplet_DataWriter_ptr _duplicate (PositionSetpointTriplet_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionSetpointTriplet_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionSetpointTriplet_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionSetpointTriplet_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionSetpointTriplet_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionSetpointTriplet_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionSetpointTriplet_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionSetpointTriplet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionSetpointTriplet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionSetpointTriplet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionSetpointTriplet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionSetpointTriplet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionSetpointTriplet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionSetpointTriplet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionSetpointTriplet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionSetpointTriplet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionSetpointTriplet_& instance_data) = 0;

            protected:
                PositionSetpointTriplet_DataWriter () {};
                ~PositionSetpointTriplet_DataWriter () {};
            private:
                PositionSetpointTriplet_DataWriter (const PositionSetpointTriplet_DataWriter &);
                PositionSetpointTriplet_DataWriter & operator = (const PositionSetpointTriplet_DataWriter &);
            };

            class  PositionSetpointTriplet_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionSetpointTriplet_DataReader_ptr _ptr_type;
                typedef PositionSetpointTriplet_DataReader_var _var_type;

                static PositionSetpointTriplet_DataReader_ptr _duplicate (PositionSetpointTriplet_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionSetpointTriplet_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionSetpointTriplet_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionSetpointTriplet_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionSetpointTriplet_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionSetpointTriplet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionSetpointTriplet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionSetpointTriplet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionSetpointTriplet_& instance) = 0;

            protected:
                PositionSetpointTriplet_DataReader () {};
                ~PositionSetpointTriplet_DataReader () {};
            private:
                PositionSetpointTriplet_DataReader (const PositionSetpointTriplet_DataReader &);
                PositionSetpointTriplet_DataReader & operator = (const PositionSetpointTriplet_DataReader &);
            };

            class  PositionSetpointTriplet_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionSetpointTriplet_DataReaderView_ptr _ptr_type;
                typedef PositionSetpointTriplet_DataReaderView_var _var_type;

                static PositionSetpointTriplet_DataReaderView_ptr _duplicate (PositionSetpointTriplet_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionSetpointTriplet_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionSetpointTriplet_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionSetpointTriplet_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionSetpointTriplet_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionSetpointTriplet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionSetpointTriplet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionSetpointTriplet_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionSetpointTriplet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionSetpointTriplet_& instance) = 0;

            protected:
                PositionSetpointTriplet_DataReaderView () {};
                ~PositionSetpointTriplet_DataReaderView () {};
            private:
                PositionSetpointTriplet_DataReaderView (const PositionSetpointTriplet_DataReaderView &);
                PositionSetpointTriplet_DataReaderView & operator = (const PositionSetpointTriplet_DataReaderView &);
            };
        }

    }

}

#endif
