#ifndef H_18953F1F51A2D931FCD305A8D6038F98_PositionSetpoint_SPLTYPES_H
#define H_18953F1F51A2D931FCD305A8D6038F98_PositionSetpoint_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_PositionSetpoint_.h"


extern c_metaObject __PositionSetpoint__px4_msgs__load (c_base base);

extern c_metaObject __PositionSetpoint__px4_msgs_msg__load (c_base base);

extern c_metaObject __PositionSetpoint__px4_msgs_msg_dds___load (c_base base);

extern c_metaObject __PositionSetpoint__px4_msgs_msg_dds__PositionSetpoint_Constants__load (c_base base);

extern const char *px4_msgs_msg_dds__PositionSetpoint__metaDescriptor[];
extern const int px4_msgs_msg_dds__PositionSetpoint__metaDescriptorArrLength;
extern const int px4_msgs_msg_dds__PositionSetpoint__metaDescriptorLength;
extern c_metaObject __px4_msgs_msg_dds__PositionSetpoint___load (c_base base);
struct _px4_msgs_msg_dds__PositionSetpoint_ ;
extern  v_copyin_result __px4_msgs_msg_dds__PositionSetpoint___copyIn(c_base base, const struct px4_msgs::msg::dds_::PositionSetpoint_ *from, struct _px4_msgs_msg_dds__PositionSetpoint_ *to);
extern  void __px4_msgs_msg_dds__PositionSetpoint___copyOut(const void *_from, void *_to);
struct _px4_msgs_msg_dds__PositionSetpoint_ {
    c_ulonglong timestamp_;
    c_bool valid_;
    c_octet type_;
    c_float x_;
    c_float y_;
    c_float z_;
    c_bool position_valid_;
    c_float vx_;
    c_float vy_;
    c_float vz_;
    c_bool velocity_valid_;
    c_octet velocity_frame_;
    c_bool alt_valid_;
    c_double lat_;
    c_double lon_;
    c_float alt_;
    c_float yaw_;
    c_bool yaw_valid_;
    c_float yawspeed_;
    c_bool yawspeed_valid_;
    c_octet landing_gear_;
    c_float loiter_radius_;
    c_octet loiter_direction_;
    c_float pitch_min_;
    c_float a_x_;
    c_float a_y_;
    c_float a_z_;
    c_bool acceleration_valid_;
    c_bool acceleration_is_force_;
    c_float acceptance_radius_;
    c_float cruising_speed_;
    c_float cruising_throttle_;
    c_bool allow_weather_vane_;
};

#undef OS_API
#endif
