#ifndef _H_FBC187E5ECD81D96E155EBF8320DD6EF_PowerButtonState_DCPS_H_
#define _H_FBC187E5ECD81D96E155EBF8320DD6EF_PowerButtonState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PowerButtonState_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PowerButtonState_TypeSupportInterface;

            typedef PowerButtonState_TypeSupportInterface * PowerButtonState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PowerButtonState_TypeSupportInterface> PowerButtonState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PowerButtonState_TypeSupportInterface> PowerButtonState_TypeSupportInterface_out;


            class PowerButtonState_DataWriter;

            typedef PowerButtonState_DataWriter * PowerButtonState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PowerButtonState_DataWriter> PowerButtonState_DataWriter_var;
            typedef DDS_DCPSInterface_out < PowerButtonState_DataWriter> PowerButtonState_DataWriter_out;


            class PowerButtonState_DataReader;

            typedef PowerButtonState_DataReader * PowerButtonState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PowerButtonState_DataReader> PowerButtonState_DataReader_var;
            typedef DDS_DCPSInterface_out < PowerButtonState_DataReader> PowerButtonState_DataReader_out;


            class PowerButtonState_DataReaderView;

            typedef PowerButtonState_DataReaderView * PowerButtonState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PowerButtonState_DataReaderView> PowerButtonState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PowerButtonState_DataReaderView> PowerButtonState_DataReaderView_out;

            struct PowerButtonState_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PowerButtonState_, struct PowerButtonState_Seq_uniq_> PowerButtonState_Seq;
            typedef DDS_DCPSSequence_var < PowerButtonState_Seq> PowerButtonState_Seq_var;
            typedef DDS_DCPSSequence_out < PowerButtonState_Seq> PowerButtonState_Seq_out;

            class  PowerButtonState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PowerButtonState_TypeSupportInterface_ptr _ptr_type;
                typedef PowerButtonState_TypeSupportInterface_var _var_type;

                static PowerButtonState_TypeSupportInterface_ptr _duplicate (PowerButtonState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerButtonState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PowerButtonState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerButtonState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerButtonState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PowerButtonState_TypeSupportInterface () {};
                ~PowerButtonState_TypeSupportInterface () {};
            private:
                PowerButtonState_TypeSupportInterface (const PowerButtonState_TypeSupportInterface &);
                PowerButtonState_TypeSupportInterface & operator = (const PowerButtonState_TypeSupportInterface &);
            };

            class  PowerButtonState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PowerButtonState_DataWriter_ptr _ptr_type;
                typedef PowerButtonState_DataWriter_var _var_type;

                static PowerButtonState_DataWriter_ptr _duplicate (PowerButtonState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerButtonState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PowerButtonState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerButtonState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerButtonState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PowerButtonState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PowerButtonState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PowerButtonState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PowerButtonState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PowerButtonState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PowerButtonState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PowerButtonState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PowerButtonState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PowerButtonState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PowerButtonState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PowerButtonState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerButtonState_& instance_data) = 0;

            protected:
                PowerButtonState_DataWriter () {};
                ~PowerButtonState_DataWriter () {};
            private:
                PowerButtonState_DataWriter (const PowerButtonState_DataWriter &);
                PowerButtonState_DataWriter & operator = (const PowerButtonState_DataWriter &);
            };

            class  PowerButtonState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PowerButtonState_DataReader_ptr _ptr_type;
                typedef PowerButtonState_DataReader_var _var_type;

                static PowerButtonState_DataReader_ptr _duplicate (PowerButtonState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerButtonState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PowerButtonState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerButtonState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerButtonState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PowerButtonState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PowerButtonState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PowerButtonState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerButtonState_& instance) = 0;

            protected:
                PowerButtonState_DataReader () {};
                ~PowerButtonState_DataReader () {};
            private:
                PowerButtonState_DataReader (const PowerButtonState_DataReader &);
                PowerButtonState_DataReader & operator = (const PowerButtonState_DataReader &);
            };

            class  PowerButtonState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PowerButtonState_DataReaderView_ptr _ptr_type;
                typedef PowerButtonState_DataReaderView_var _var_type;

                static PowerButtonState_DataReaderView_ptr _duplicate (PowerButtonState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerButtonState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PowerButtonState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerButtonState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerButtonState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PowerButtonState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PowerButtonState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PowerButtonState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PowerButtonState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerButtonState_& instance) = 0;

            protected:
                PowerButtonState_DataReaderView () {};
                ~PowerButtonState_DataReaderView () {};
            private:
                PowerButtonState_DataReaderView (const PowerButtonState_DataReaderView &);
                PowerButtonState_DataReaderView & operator = (const PowerButtonState_DataReaderView &);
            };
        }

    }

}

#endif
