#ifndef _H_FA2E7966A303C5293E575EAFB18AC85B_RadioStatus_DCPS_H_
#define _H_FA2E7966A303C5293E575EAFB18AC85B_RadioStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RadioStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RadioStatus_TypeSupportInterface;

            typedef RadioStatus_TypeSupportInterface * RadioStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RadioStatus_TypeSupportInterface> RadioStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RadioStatus_TypeSupportInterface> RadioStatus_TypeSupportInterface_out;


            class RadioStatus_DataWriter;

            typedef RadioStatus_DataWriter * RadioStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RadioStatus_DataWriter> RadioStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < RadioStatus_DataWriter> RadioStatus_DataWriter_out;


            class RadioStatus_DataReader;

            typedef RadioStatus_DataReader * RadioStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RadioStatus_DataReader> RadioStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < RadioStatus_DataReader> RadioStatus_DataReader_out;


            class RadioStatus_DataReaderView;

            typedef RadioStatus_DataReaderView * RadioStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RadioStatus_DataReaderView> RadioStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RadioStatus_DataReaderView> RadioStatus_DataReaderView_out;

            struct RadioStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RadioStatus_, struct RadioStatus_Seq_uniq_> RadioStatus_Seq;
            typedef DDS_DCPSSequence_var < RadioStatus_Seq> RadioStatus_Seq_var;
            typedef DDS_DCPSSequence_out < RadioStatus_Seq> RadioStatus_Seq_out;

            class  RadioStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RadioStatus_TypeSupportInterface_ptr _ptr_type;
                typedef RadioStatus_TypeSupportInterface_var _var_type;

                static RadioStatus_TypeSupportInterface_ptr _duplicate (RadioStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadioStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RadioStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadioStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RadioStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RadioStatus_TypeSupportInterface () {};
                ~RadioStatus_TypeSupportInterface () {};
            private:
                RadioStatus_TypeSupportInterface (const RadioStatus_TypeSupportInterface &);
                RadioStatus_TypeSupportInterface & operator = (const RadioStatus_TypeSupportInterface &);
            };

            class  RadioStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RadioStatus_DataWriter_ptr _ptr_type;
                typedef RadioStatus_DataWriter_var _var_type;

                static RadioStatus_DataWriter_ptr _duplicate (RadioStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadioStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RadioStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadioStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RadioStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RadioStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RadioStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RadioStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RadioStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RadioStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RadioStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RadioStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RadioStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RadioStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RadioStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RadioStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadioStatus_& instance_data) = 0;

            protected:
                RadioStatus_DataWriter () {};
                ~RadioStatus_DataWriter () {};
            private:
                RadioStatus_DataWriter (const RadioStatus_DataWriter &);
                RadioStatus_DataWriter & operator = (const RadioStatus_DataWriter &);
            };

            class  RadioStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RadioStatus_DataReader_ptr _ptr_type;
                typedef RadioStatus_DataReader_var _var_type;

                static RadioStatus_DataReader_ptr _duplicate (RadioStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadioStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RadioStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadioStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RadioStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadioStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadioStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadioStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadioStatus_& instance) = 0;

            protected:
                RadioStatus_DataReader () {};
                ~RadioStatus_DataReader () {};
            private:
                RadioStatus_DataReader (const RadioStatus_DataReader &);
                RadioStatus_DataReader & operator = (const RadioStatus_DataReader &);
            };

            class  RadioStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RadioStatus_DataReaderView_ptr _ptr_type;
                typedef RadioStatus_DataReaderView_var _var_type;

                static RadioStatus_DataReaderView_ptr _duplicate (RadioStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadioStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RadioStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadioStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RadioStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadioStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadioStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadioStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadioStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadioStatus_& instance) = 0;

            protected:
                RadioStatus_DataReaderView () {};
                ~RadioStatus_DataReaderView () {};
            private:
                RadioStatus_DataReaderView (const RadioStatus_DataReaderView &);
                RadioStatus_DataReaderView & operator = (const RadioStatus_DataReaderView &);
            };
        }

    }

}

#endif
