#ifndef _H_87DBDFAD5B6B9D21BC6C01E32526F1B3_RcChannels__H_
#define _H_87DBDFAD5B6B9D21BC6C01E32526F1B3_RcChannels__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace RcChannels_Constants
            {
                const ::DDS::Octet RC_CHANNELS_FUNCTION_THROTTLE_ = 0;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_ROLL_ = 1;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_PITCH_ = 2;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_YAW_ = 3;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_MODE_ = 4;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_RETURN_ = 5;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_POSCTL_ = 6;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_LOITER_ = 7;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_OFFBOARD_ = 8;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_ACRO_ = 9;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_FLAPS_ = 10;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_AUX_1_ = 11;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_AUX_2_ = 12;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_AUX_3_ = 13;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_AUX_4_ = 14;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_AUX_5_ = 15;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_PARAM_1_ = 16;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_PARAM_2_ = 17;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_PARAM_3_5_ = 18;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_RATTITUDE_ = 19;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_KILLSWITCH_ = 20;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_TRANSITION_ = 21;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_GEAR_ = 22;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_ARMSWITCH_ = 23;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_STAB_ = 24;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_AUX_6_ = 25;

                const ::DDS::Octet RC_CHANNELS_FUNCTION_MAN_ = 26;

            }

            struct  RcChannels_
            {
                struct _channels__uniq_{};
                typedef ::DDS::Float _channels__slice;
                typedef ::DDS::Float _channels_[18];
                typedef DDS_DCPS_FArray_var< _channels_, _channels__slice, struct _channels__uniq_ > _channels__var;
                typedef _channels_ _channels__out;
                typedef DDS_DCPS_Array_forany< _channels_, _channels__slice, struct _channels__uniq_ > _channels__forany;
                static _channels__slice *_channels__alloc();
                static void _channels__free(_channels__slice *);
                static void _channels__copy(_channels__slice *to, const _channels__slice *from);
                static _channels__slice *_channels__dup(const _channels__slice *from);
                struct _function__uniq_{};
                typedef ::DDS::Octet _function__slice;
                typedef ::DDS::Octet _function_[27];
                typedef DDS_DCPS_FArray_var< _function_, _function__slice, struct _function__uniq_ > _function__var;
                typedef _function_ _function__out;
                typedef DDS_DCPS_Array_forany< _function_, _function__slice, struct _function__uniq_ > _function__forany;
                static _function__slice *_function__alloc();
                static void _function__free(_function__slice *);
                static void _function__copy(_function__slice *to, const _function__slice *from);
                static _function__slice *_function__dup(const _function__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::ULongLong timestamp_last_valid_;
                _channels_ channels_;
                ::DDS::Octet channel_count_;
                _function_ function_;
                ::DDS::Octet rssi_;
                ::DDS::Boolean signal_lost_;
                ::DDS::ULong frame_drop_count_;
            };

            typedef DDS_DCPSStruct_var<RcChannels_> RcChannels__var;
            typedef RcChannels_& RcChannels__out;

        }

    }

}

#endif /* _H_87DBDFAD5B6B9D21BC6C01E32526F1B3_RcChannels__H_ */
