#ifndef _H_A74203456CA33BAA5F27795989EB74CE_SatelliteInfo__H_
#define _H_A74203456CA33BAA5F27795989EB74CE_SatelliteInfo__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SatelliteInfo_Constants
            {
                const ::DDS::Octet SAT_INFO_MAX_SATELLITES_ = 20;

            }

            struct  SatelliteInfo_
            {
                struct _svid__uniq_{};
                typedef ::DDS::Octet _svid__slice;
                typedef ::DDS::Octet _svid_[20];
                typedef DDS_DCPS_FArray_var< _svid_, _svid__slice, struct _svid__uniq_ > _svid__var;
                typedef _svid_ _svid__out;
                typedef DDS_DCPS_Array_forany< _svid_, _svid__slice, struct _svid__uniq_ > _svid__forany;
                static _svid__slice *_svid__alloc();
                static void _svid__free(_svid__slice *);
                static void _svid__copy(_svid__slice *to, const _svid__slice *from);
                static _svid__slice *_svid__dup(const _svid__slice *from);
                struct _used__uniq_{};
                typedef ::DDS::Octet _used__slice;
                typedef ::DDS::Octet _used_[20];
                typedef DDS_DCPS_FArray_var< _used_, _used__slice, struct _used__uniq_ > _used__var;
                typedef _used_ _used__out;
                typedef DDS_DCPS_Array_forany< _used_, _used__slice, struct _used__uniq_ > _used__forany;
                static _used__slice *_used__alloc();
                static void _used__free(_used__slice *);
                static void _used__copy(_used__slice *to, const _used__slice *from);
                static _used__slice *_used__dup(const _used__slice *from);
                struct _elevation__uniq_{};
                typedef ::DDS::Octet _elevation__slice;
                typedef ::DDS::Octet _elevation_[20];
                typedef DDS_DCPS_FArray_var< _elevation_, _elevation__slice, struct _elevation__uniq_ > _elevation__var;
                typedef _elevation_ _elevation__out;
                typedef DDS_DCPS_Array_forany< _elevation_, _elevation__slice, struct _elevation__uniq_ > _elevation__forany;
                static _elevation__slice *_elevation__alloc();
                static void _elevation__free(_elevation__slice *);
                static void _elevation__copy(_elevation__slice *to, const _elevation__slice *from);
                static _elevation__slice *_elevation__dup(const _elevation__slice *from);
                struct _azimuth__uniq_{};
                typedef ::DDS::Octet _azimuth__slice;
                typedef ::DDS::Octet _azimuth_[20];
                typedef DDS_DCPS_FArray_var< _azimuth_, _azimuth__slice, struct _azimuth__uniq_ > _azimuth__var;
                typedef _azimuth_ _azimuth__out;
                typedef DDS_DCPS_Array_forany< _azimuth_, _azimuth__slice, struct _azimuth__uniq_ > _azimuth__forany;
                static _azimuth__slice *_azimuth__alloc();
                static void _azimuth__free(_azimuth__slice *);
                static void _azimuth__copy(_azimuth__slice *to, const _azimuth__slice *from);
                static _azimuth__slice *_azimuth__dup(const _azimuth__slice *from);
                struct _snr__uniq_{};
                typedef ::DDS::Octet _snr__slice;
                typedef ::DDS::Octet _snr_[20];
                typedef DDS_DCPS_FArray_var< _snr_, _snr__slice, struct _snr__uniq_ > _snr__var;
                typedef _snr_ _snr__out;
                typedef DDS_DCPS_Array_forany< _snr_, _snr__slice, struct _snr__uniq_ > _snr__forany;
                static _snr__slice *_snr__alloc();
                static void _snr__free(_snr__slice *);
                static void _snr__copy(_snr__slice *to, const _snr__slice *from);
                static _snr__slice *_snr__dup(const _snr__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet count_;
                _svid_ svid_;
                _used_ used_;
                _elevation_ elevation_;
                _azimuth_ azimuth_;
                _snr_ snr_;
            };

            typedef DDS_DCPSStruct_var<SatelliteInfo_> SatelliteInfo__var;
            typedef SatelliteInfo_& SatelliteInfo__out;

        }

    }

}

#endif /* _H_A74203456CA33BAA5F27795989EB74CE_SatelliteInfo__H_ */
