#ifndef _H_8E03DF5D5EA045839489A81F83FD158A_SensorAccel_DCPS_H_
#define _H_8E03DF5D5EA045839489A81F83FD158A_SensorAccel_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorAccel_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorAccel_TypeSupportInterface;

            typedef SensorAccel_TypeSupportInterface * SensorAccel_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorAccel_TypeSupportInterface> SensorAccel_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorAccel_TypeSupportInterface> SensorAccel_TypeSupportInterface_out;


            class SensorAccel_DataWriter;

            typedef SensorAccel_DataWriter * SensorAccel_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorAccel_DataWriter> SensorAccel_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorAccel_DataWriter> SensorAccel_DataWriter_out;


            class SensorAccel_DataReader;

            typedef SensorAccel_DataReader * SensorAccel_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorAccel_DataReader> SensorAccel_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorAccel_DataReader> SensorAccel_DataReader_out;


            class SensorAccel_DataReaderView;

            typedef SensorAccel_DataReaderView * SensorAccel_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorAccel_DataReaderView> SensorAccel_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorAccel_DataReaderView> SensorAccel_DataReaderView_out;

            struct SensorAccel_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorAccel_, struct SensorAccel_Seq_uniq_> SensorAccel_Seq;
            typedef DDS_DCPSSequence_var < SensorAccel_Seq> SensorAccel_Seq_var;
            typedef DDS_DCPSSequence_out < SensorAccel_Seq> SensorAccel_Seq_out;

            class  SensorAccel_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorAccel_TypeSupportInterface_ptr _ptr_type;
                typedef SensorAccel_TypeSupportInterface_var _var_type;

                static SensorAccel_TypeSupportInterface_ptr _duplicate (SensorAccel_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorAccel_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorAccel_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorAccel_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorAccel_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorAccel_TypeSupportInterface () {};
                ~SensorAccel_TypeSupportInterface () {};
            private:
                SensorAccel_TypeSupportInterface (const SensorAccel_TypeSupportInterface &);
                SensorAccel_TypeSupportInterface & operator = (const SensorAccel_TypeSupportInterface &);
            };

            class  SensorAccel_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorAccel_DataWriter_ptr _ptr_type;
                typedef SensorAccel_DataWriter_var _var_type;

                static SensorAccel_DataWriter_ptr _duplicate (SensorAccel_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorAccel_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorAccel_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorAccel_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorAccel_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorAccel_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorAccel_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorAccel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorAccel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorAccel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorAccel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorAccel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorAccel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorAccel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorAccel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorAccel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorAccel_& instance_data) = 0;

            protected:
                SensorAccel_DataWriter () {};
                ~SensorAccel_DataWriter () {};
            private:
                SensorAccel_DataWriter (const SensorAccel_DataWriter &);
                SensorAccel_DataWriter & operator = (const SensorAccel_DataWriter &);
            };

            class  SensorAccel_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorAccel_DataReader_ptr _ptr_type;
                typedef SensorAccel_DataReader_var _var_type;

                static SensorAccel_DataReader_ptr _duplicate (SensorAccel_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorAccel_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorAccel_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorAccel_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorAccel_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorAccel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorAccel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorAccel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorAccel_& instance) = 0;

            protected:
                SensorAccel_DataReader () {};
                ~SensorAccel_DataReader () {};
            private:
                SensorAccel_DataReader (const SensorAccel_DataReader &);
                SensorAccel_DataReader & operator = (const SensorAccel_DataReader &);
            };

            class  SensorAccel_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorAccel_DataReaderView_ptr _ptr_type;
                typedef SensorAccel_DataReaderView_var _var_type;

                static SensorAccel_DataReaderView_ptr _duplicate (SensorAccel_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorAccel_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorAccel_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorAccel_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorAccel_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorAccel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorAccel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorAccel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorAccel_& instance) = 0;

            protected:
                SensorAccel_DataReaderView () {};
                ~SensorAccel_DataReaderView () {};
            private:
                SensorAccel_DataReaderView (const SensorAccel_DataReaderView &);
                SensorAccel_DataReaderView & operator = (const SensorAccel_DataReaderView &);
            };
        }

    }

}

#endif
