#ifndef _H_5435A06DAC1B43BDD183E3C6A345193B_SensorBaro_DCPS_H_
#define _H_5435A06DAC1B43BDD183E3C6A345193B_SensorBaro_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorBaro_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorBaro_TypeSupportInterface;

            typedef SensorBaro_TypeSupportInterface * SensorBaro_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorBaro_TypeSupportInterface> SensorBaro_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorBaro_TypeSupportInterface> SensorBaro_TypeSupportInterface_out;


            class SensorBaro_DataWriter;

            typedef SensorBaro_DataWriter * SensorBaro_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorBaro_DataWriter> SensorBaro_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorBaro_DataWriter> SensorBaro_DataWriter_out;


            class SensorBaro_DataReader;

            typedef SensorBaro_DataReader * SensorBaro_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorBaro_DataReader> SensorBaro_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorBaro_DataReader> SensorBaro_DataReader_out;


            class SensorBaro_DataReaderView;

            typedef SensorBaro_DataReaderView * SensorBaro_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorBaro_DataReaderView> SensorBaro_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorBaro_DataReaderView> SensorBaro_DataReaderView_out;

            struct SensorBaro_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorBaro_, struct SensorBaro_Seq_uniq_> SensorBaro_Seq;
            typedef DDS_DCPSSequence_var < SensorBaro_Seq> SensorBaro_Seq_var;
            typedef DDS_DCPSSequence_out < SensorBaro_Seq> SensorBaro_Seq_out;

            class  SensorBaro_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorBaro_TypeSupportInterface_ptr _ptr_type;
                typedef SensorBaro_TypeSupportInterface_var _var_type;

                static SensorBaro_TypeSupportInterface_ptr _duplicate (SensorBaro_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorBaro_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorBaro_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorBaro_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorBaro_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorBaro_TypeSupportInterface () {};
                ~SensorBaro_TypeSupportInterface () {};
            private:
                SensorBaro_TypeSupportInterface (const SensorBaro_TypeSupportInterface &);
                SensorBaro_TypeSupportInterface & operator = (const SensorBaro_TypeSupportInterface &);
            };

            class  SensorBaro_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorBaro_DataWriter_ptr _ptr_type;
                typedef SensorBaro_DataWriter_var _var_type;

                static SensorBaro_DataWriter_ptr _duplicate (SensorBaro_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorBaro_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorBaro_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorBaro_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorBaro_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorBaro_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorBaro_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorBaro_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorBaro_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorBaro_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorBaro_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorBaro_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorBaro_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorBaro_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorBaro_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorBaro_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorBaro_& instance_data) = 0;

            protected:
                SensorBaro_DataWriter () {};
                ~SensorBaro_DataWriter () {};
            private:
                SensorBaro_DataWriter (const SensorBaro_DataWriter &);
                SensorBaro_DataWriter & operator = (const SensorBaro_DataWriter &);
            };

            class  SensorBaro_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorBaro_DataReader_ptr _ptr_type;
                typedef SensorBaro_DataReader_var _var_type;

                static SensorBaro_DataReader_ptr _duplicate (SensorBaro_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorBaro_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorBaro_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorBaro_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorBaro_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorBaro_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorBaro_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorBaro_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorBaro_& instance) = 0;

            protected:
                SensorBaro_DataReader () {};
                ~SensorBaro_DataReader () {};
            private:
                SensorBaro_DataReader (const SensorBaro_DataReader &);
                SensorBaro_DataReader & operator = (const SensorBaro_DataReader &);
            };

            class  SensorBaro_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorBaro_DataReaderView_ptr _ptr_type;
                typedef SensorBaro_DataReaderView_var _var_type;

                static SensorBaro_DataReaderView_ptr _duplicate (SensorBaro_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorBaro_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorBaro_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorBaro_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorBaro_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorBaro_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorBaro_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorBaro_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorBaro_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorBaro_& instance) = 0;

            protected:
                SensorBaro_DataReaderView () {};
                ~SensorBaro_DataReaderView () {};
            private:
                SensorBaro_DataReaderView (const SensorBaro_DataReaderView &);
                SensorBaro_DataReaderView & operator = (const SensorBaro_DataReaderView &);
            };
        }

    }

}

#endif
