#ifndef _H_F21BF179C04C13ADED27196AFA3CB373_SensorBias_DCPS_H_
#define _H_F21BF179C04C13ADED27196AFA3CB373_SensorBias_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorBias_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorBias_TypeSupportInterface;

            typedef SensorBias_TypeSupportInterface * SensorBias_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorBias_TypeSupportInterface> SensorBias_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorBias_TypeSupportInterface> SensorBias_TypeSupportInterface_out;


            class SensorBias_DataWriter;

            typedef SensorBias_DataWriter * SensorBias_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorBias_DataWriter> SensorBias_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorBias_DataWriter> SensorBias_DataWriter_out;


            class SensorBias_DataReader;

            typedef SensorBias_DataReader * SensorBias_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorBias_DataReader> SensorBias_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorBias_DataReader> SensorBias_DataReader_out;


            class SensorBias_DataReaderView;

            typedef SensorBias_DataReaderView * SensorBias_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorBias_DataReaderView> SensorBias_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorBias_DataReaderView> SensorBias_DataReaderView_out;

            struct SensorBias_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorBias_, struct SensorBias_Seq_uniq_> SensorBias_Seq;
            typedef DDS_DCPSSequence_var < SensorBias_Seq> SensorBias_Seq_var;
            typedef DDS_DCPSSequence_out < SensorBias_Seq> SensorBias_Seq_out;

            class  SensorBias_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorBias_TypeSupportInterface_ptr _ptr_type;
                typedef SensorBias_TypeSupportInterface_var _var_type;

                static SensorBias_TypeSupportInterface_ptr _duplicate (SensorBias_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorBias_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorBias_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorBias_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorBias_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorBias_TypeSupportInterface () {};
                ~SensorBias_TypeSupportInterface () {};
            private:
                SensorBias_TypeSupportInterface (const SensorBias_TypeSupportInterface &);
                SensorBias_TypeSupportInterface & operator = (const SensorBias_TypeSupportInterface &);
            };

            class  SensorBias_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorBias_DataWriter_ptr _ptr_type;
                typedef SensorBias_DataWriter_var _var_type;

                static SensorBias_DataWriter_ptr _duplicate (SensorBias_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorBias_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorBias_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorBias_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorBias_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorBias_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorBias_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorBias_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorBias_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorBias_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorBias_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorBias_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorBias_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorBias_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorBias_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorBias_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorBias_& instance_data) = 0;

            protected:
                SensorBias_DataWriter () {};
                ~SensorBias_DataWriter () {};
            private:
                SensorBias_DataWriter (const SensorBias_DataWriter &);
                SensorBias_DataWriter & operator = (const SensorBias_DataWriter &);
            };

            class  SensorBias_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorBias_DataReader_ptr _ptr_type;
                typedef SensorBias_DataReader_var _var_type;

                static SensorBias_DataReader_ptr _duplicate (SensorBias_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorBias_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorBias_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorBias_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorBias_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorBias_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorBias_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorBias_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorBias_& instance) = 0;

            protected:
                SensorBias_DataReader () {};
                ~SensorBias_DataReader () {};
            private:
                SensorBias_DataReader (const SensorBias_DataReader &);
                SensorBias_DataReader & operator = (const SensorBias_DataReader &);
            };

            class  SensorBias_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorBias_DataReaderView_ptr _ptr_type;
                typedef SensorBias_DataReaderView_var _var_type;

                static SensorBias_DataReaderView_ptr _duplicate (SensorBias_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorBias_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorBias_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorBias_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorBias_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorBias_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorBias_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorBias_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorBias_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorBias_& instance) = 0;

            protected:
                SensorBias_DataReaderView () {};
                ~SensorBias_DataReaderView () {};
            private:
                SensorBias_DataReaderView (const SensorBias_DataReaderView &);
                SensorBias_DataReaderView & operator = (const SensorBias_DataReaderView &);
            };
        }

    }

}

#endif
