#ifndef _H_59B90CC062F77810C1236218B6B7EC1A_SensorCombined__H_
#define _H_59B90CC062F77810C1236218B6B7EC1A_SensorCombined__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SensorCombined_Constants
            {
                const ::DDS::Long RELATIVE_TIMESTAMP_INVALID_ = 2147483647;

            }

            struct  SensorCombined_
            {
                struct _gyro_rad__uniq_{};
                typedef ::DDS::Float _gyro_rad__slice;
                typedef ::DDS::Float _gyro_rad_[3];
                typedef DDS_DCPS_FArray_var< _gyro_rad_, _gyro_rad__slice, struct _gyro_rad__uniq_ > _gyro_rad__var;
                typedef _gyro_rad_ _gyro_rad__out;
                typedef DDS_DCPS_Array_forany< _gyro_rad_, _gyro_rad__slice, struct _gyro_rad__uniq_ > _gyro_rad__forany;
                static _gyro_rad__slice *_gyro_rad__alloc();
                static void _gyro_rad__free(_gyro_rad__slice *);
                static void _gyro_rad__copy(_gyro_rad__slice *to, const _gyro_rad__slice *from);
                static _gyro_rad__slice *_gyro_rad__dup(const _gyro_rad__slice *from);
                struct _accelerometer_m_s2__uniq_{};
                typedef ::DDS::Float _accelerometer_m_s2__slice;
                typedef ::DDS::Float _accelerometer_m_s2_[3];
                typedef DDS_DCPS_FArray_var< _accelerometer_m_s2_, _accelerometer_m_s2__slice, struct _accelerometer_m_s2__uniq_ > _accelerometer_m_s2__var;
                typedef _accelerometer_m_s2_ _accelerometer_m_s2__out;
                typedef DDS_DCPS_Array_forany< _accelerometer_m_s2_, _accelerometer_m_s2__slice, struct _accelerometer_m_s2__uniq_ > _accelerometer_m_s2__forany;
                static _accelerometer_m_s2__slice *_accelerometer_m_s2__alloc();
                static void _accelerometer_m_s2__free(_accelerometer_m_s2__slice *);
                static void _accelerometer_m_s2__copy(_accelerometer_m_s2__slice *to, const _accelerometer_m_s2__slice *from);
                static _accelerometer_m_s2__slice *_accelerometer_m_s2__dup(const _accelerometer_m_s2__slice *from);
                ::DDS::ULongLong timestamp_;
                _gyro_rad_ gyro_rad_;
                ::DDS::ULong gyro_integral_dt_;
                ::DDS::Long accelerometer_timestamp_relative_;
                _accelerometer_m_s2_ accelerometer_m_s2_;
                ::DDS::ULong accelerometer_integral_dt_;
            };

            typedef DDS_DCPSStruct_var<SensorCombined_> SensorCombined__var;
            typedef SensorCombined_& SensorCombined__out;

        }

    }

}

#endif /* _H_59B90CC062F77810C1236218B6B7EC1A_SensorCombined__H_ */
