#ifndef _H_59B90CC062F77810C1236218B6B7EC1A_SensorCombined_DCPS_H_
#define _H_59B90CC062F77810C1236218B6B7EC1A_SensorCombined_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorCombined_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorCombined_TypeSupportInterface;

            typedef SensorCombined_TypeSupportInterface * SensorCombined_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorCombined_TypeSupportInterface> SensorCombined_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorCombined_TypeSupportInterface> SensorCombined_TypeSupportInterface_out;


            class SensorCombined_DataWriter;

            typedef SensorCombined_DataWriter * SensorCombined_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorCombined_DataWriter> SensorCombined_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorCombined_DataWriter> SensorCombined_DataWriter_out;


            class SensorCombined_DataReader;

            typedef SensorCombined_DataReader * SensorCombined_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorCombined_DataReader> SensorCombined_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorCombined_DataReader> SensorCombined_DataReader_out;


            class SensorCombined_DataReaderView;

            typedef SensorCombined_DataReaderView * SensorCombined_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorCombined_DataReaderView> SensorCombined_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorCombined_DataReaderView> SensorCombined_DataReaderView_out;

            struct SensorCombined_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorCombined_, struct SensorCombined_Seq_uniq_> SensorCombined_Seq;
            typedef DDS_DCPSSequence_var < SensorCombined_Seq> SensorCombined_Seq_var;
            typedef DDS_DCPSSequence_out < SensorCombined_Seq> SensorCombined_Seq_out;

            class  SensorCombined_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorCombined_TypeSupportInterface_ptr _ptr_type;
                typedef SensorCombined_TypeSupportInterface_var _var_type;

                static SensorCombined_TypeSupportInterface_ptr _duplicate (SensorCombined_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorCombined_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorCombined_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorCombined_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorCombined_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorCombined_TypeSupportInterface () {};
                ~SensorCombined_TypeSupportInterface () {};
            private:
                SensorCombined_TypeSupportInterface (const SensorCombined_TypeSupportInterface &);
                SensorCombined_TypeSupportInterface & operator = (const SensorCombined_TypeSupportInterface &);
            };

            class  SensorCombined_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorCombined_DataWriter_ptr _ptr_type;
                typedef SensorCombined_DataWriter_var _var_type;

                static SensorCombined_DataWriter_ptr _duplicate (SensorCombined_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorCombined_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorCombined_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorCombined_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorCombined_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorCombined_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorCombined_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorCombined_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorCombined_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorCombined_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorCombined_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorCombined_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorCombined_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorCombined_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorCombined_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorCombined_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorCombined_& instance_data) = 0;

            protected:
                SensorCombined_DataWriter () {};
                ~SensorCombined_DataWriter () {};
            private:
                SensorCombined_DataWriter (const SensorCombined_DataWriter &);
                SensorCombined_DataWriter & operator = (const SensorCombined_DataWriter &);
            };

            class  SensorCombined_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorCombined_DataReader_ptr _ptr_type;
                typedef SensorCombined_DataReader_var _var_type;

                static SensorCombined_DataReader_ptr _duplicate (SensorCombined_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorCombined_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorCombined_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorCombined_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorCombined_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorCombined_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorCombined_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorCombined_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorCombined_& instance) = 0;

            protected:
                SensorCombined_DataReader () {};
                ~SensorCombined_DataReader () {};
            private:
                SensorCombined_DataReader (const SensorCombined_DataReader &);
                SensorCombined_DataReader & operator = (const SensorCombined_DataReader &);
            };

            class  SensorCombined_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorCombined_DataReaderView_ptr _ptr_type;
                typedef SensorCombined_DataReaderView_var _var_type;

                static SensorCombined_DataReaderView_ptr _duplicate (SensorCombined_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorCombined_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorCombined_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorCombined_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorCombined_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorCombined_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorCombined_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorCombined_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorCombined_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorCombined_& instance) = 0;

            protected:
                SensorCombined_DataReaderView () {};
                ~SensorCombined_DataReaderView () {};
            private:
                SensorCombined_DataReaderView (const SensorCombined_DataReaderView &);
                SensorCombined_DataReaderView & operator = (const SensorCombined_DataReaderView &);
            };
        }

    }

}

#endif
