#ifndef _H_F112DDBB52392929D0A660892A613A20_SensorGyroControl_DCPS_H_
#define _H_F112DDBB52392929D0A660892A613A20_SensorGyroControl_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SensorGyroControl_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SensorGyroControl_TypeSupportInterface;

            typedef SensorGyroControl_TypeSupportInterface * SensorGyroControl_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SensorGyroControl_TypeSupportInterface> SensorGyroControl_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SensorGyroControl_TypeSupportInterface> SensorGyroControl_TypeSupportInterface_out;


            class SensorGyroControl_DataWriter;

            typedef SensorGyroControl_DataWriter * SensorGyroControl_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SensorGyroControl_DataWriter> SensorGyroControl_DataWriter_var;
            typedef DDS_DCPSInterface_out < SensorGyroControl_DataWriter> SensorGyroControl_DataWriter_out;


            class SensorGyroControl_DataReader;

            typedef SensorGyroControl_DataReader * SensorGyroControl_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SensorGyroControl_DataReader> SensorGyroControl_DataReader_var;
            typedef DDS_DCPSInterface_out < SensorGyroControl_DataReader> SensorGyroControl_DataReader_out;


            class SensorGyroControl_DataReaderView;

            typedef SensorGyroControl_DataReaderView * SensorGyroControl_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SensorGyroControl_DataReaderView> SensorGyroControl_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SensorGyroControl_DataReaderView> SensorGyroControl_DataReaderView_out;

            struct SensorGyroControl_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SensorGyroControl_, struct SensorGyroControl_Seq_uniq_> SensorGyroControl_Seq;
            typedef DDS_DCPSSequence_var < SensorGyroControl_Seq> SensorGyroControl_Seq_var;
            typedef DDS_DCPSSequence_out < SensorGyroControl_Seq> SensorGyroControl_Seq_out;

            class  SensorGyroControl_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SensorGyroControl_TypeSupportInterface_ptr _ptr_type;
                typedef SensorGyroControl_TypeSupportInterface_var _var_type;

                static SensorGyroControl_TypeSupportInterface_ptr _duplicate (SensorGyroControl_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorGyroControl_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SensorGyroControl_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorGyroControl_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorGyroControl_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SensorGyroControl_TypeSupportInterface () {};
                ~SensorGyroControl_TypeSupportInterface () {};
            private:
                SensorGyroControl_TypeSupportInterface (const SensorGyroControl_TypeSupportInterface &);
                SensorGyroControl_TypeSupportInterface & operator = (const SensorGyroControl_TypeSupportInterface &);
            };

            class  SensorGyroControl_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SensorGyroControl_DataWriter_ptr _ptr_type;
                typedef SensorGyroControl_DataWriter_var _var_type;

                static SensorGyroControl_DataWriter_ptr _duplicate (SensorGyroControl_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorGyroControl_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SensorGyroControl_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorGyroControl_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorGyroControl_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SensorGyroControl_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SensorGyroControl_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SensorGyroControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SensorGyroControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SensorGyroControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SensorGyroControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SensorGyroControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SensorGyroControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SensorGyroControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SensorGyroControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SensorGyroControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorGyroControl_& instance_data) = 0;

            protected:
                SensorGyroControl_DataWriter () {};
                ~SensorGyroControl_DataWriter () {};
            private:
                SensorGyroControl_DataWriter (const SensorGyroControl_DataWriter &);
                SensorGyroControl_DataWriter & operator = (const SensorGyroControl_DataWriter &);
            };

            class  SensorGyroControl_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SensorGyroControl_DataReader_ptr _ptr_type;
                typedef SensorGyroControl_DataReader_var _var_type;

                static SensorGyroControl_DataReader_ptr _duplicate (SensorGyroControl_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorGyroControl_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SensorGyroControl_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorGyroControl_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorGyroControl_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorGyroControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorGyroControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorGyroControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorGyroControl_& instance) = 0;

            protected:
                SensorGyroControl_DataReader () {};
                ~SensorGyroControl_DataReader () {};
            private:
                SensorGyroControl_DataReader (const SensorGyroControl_DataReader &);
                SensorGyroControl_DataReader & operator = (const SensorGyroControl_DataReader &);
            };

            class  SensorGyroControl_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SensorGyroControl_DataReaderView_ptr _ptr_type;
                typedef SensorGyroControl_DataReaderView_var _var_type;

                static SensorGyroControl_DataReaderView_ptr _duplicate (SensorGyroControl_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SensorGyroControl_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SensorGyroControl_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SensorGyroControl_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SensorGyroControl_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SensorGyroControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SensorGyroControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SensorGyroControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SensorGyroControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SensorGyroControl_& instance) = 0;

            protected:
                SensorGyroControl_DataReaderView () {};
                ~SensorGyroControl_DataReaderView () {};
            private:
                SensorGyroControl_DataReaderView (const SensorGyroControl_DataReaderView &);
                SensorGyroControl_DataReaderView & operator = (const SensorGyroControl_DataReaderView &);
            };
        }

    }

}

#endif
