#ifndef _H_9E7AA84D96F47EE02D03372A9B85BEAB_ServorailStatus_DCPS_H_
#define _H_9E7AA84D96F47EE02D03372A9B85BEAB_ServorailStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServorailStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ServorailStatus_TypeSupportInterface;

            typedef ServorailStatus_TypeSupportInterface * ServorailStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServorailStatus_TypeSupportInterface> ServorailStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServorailStatus_TypeSupportInterface> ServorailStatus_TypeSupportInterface_out;


            class ServorailStatus_DataWriter;

            typedef ServorailStatus_DataWriter * ServorailStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServorailStatus_DataWriter> ServorailStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServorailStatus_DataWriter> ServorailStatus_DataWriter_out;


            class ServorailStatus_DataReader;

            typedef ServorailStatus_DataReader * ServorailStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServorailStatus_DataReader> ServorailStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < ServorailStatus_DataReader> ServorailStatus_DataReader_out;


            class ServorailStatus_DataReaderView;

            typedef ServorailStatus_DataReaderView * ServorailStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServorailStatus_DataReaderView> ServorailStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServorailStatus_DataReaderView> ServorailStatus_DataReaderView_out;

            struct ServorailStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ServorailStatus_, struct ServorailStatus_Seq_uniq_> ServorailStatus_Seq;
            typedef DDS_DCPSSequence_var < ServorailStatus_Seq> ServorailStatus_Seq_var;
            typedef DDS_DCPSSequence_out < ServorailStatus_Seq> ServorailStatus_Seq_out;

            class  ServorailStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServorailStatus_TypeSupportInterface_ptr _ptr_type;
                typedef ServorailStatus_TypeSupportInterface_var _var_type;

                static ServorailStatus_TypeSupportInterface_ptr _duplicate (ServorailStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServorailStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServorailStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServorailStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServorailStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServorailStatus_TypeSupportInterface () {};
                ~ServorailStatus_TypeSupportInterface () {};
            private:
                ServorailStatus_TypeSupportInterface (const ServorailStatus_TypeSupportInterface &);
                ServorailStatus_TypeSupportInterface & operator = (const ServorailStatus_TypeSupportInterface &);
            };

            class  ServorailStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServorailStatus_DataWriter_ptr _ptr_type;
                typedef ServorailStatus_DataWriter_var _var_type;

                static ServorailStatus_DataWriter_ptr _duplicate (ServorailStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServorailStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServorailStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServorailStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServorailStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServorailStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServorailStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServorailStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServorailStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServorailStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServorailStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServorailStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServorailStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServorailStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServorailStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServorailStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServorailStatus_& instance_data) = 0;

            protected:
                ServorailStatus_DataWriter () {};
                ~ServorailStatus_DataWriter () {};
            private:
                ServorailStatus_DataWriter (const ServorailStatus_DataWriter &);
                ServorailStatus_DataWriter & operator = (const ServorailStatus_DataWriter &);
            };

            class  ServorailStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServorailStatus_DataReader_ptr _ptr_type;
                typedef ServorailStatus_DataReader_var _var_type;

                static ServorailStatus_DataReader_ptr _duplicate (ServorailStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServorailStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServorailStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServorailStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServorailStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServorailStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServorailStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServorailStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServorailStatus_& instance) = 0;

            protected:
                ServorailStatus_DataReader () {};
                ~ServorailStatus_DataReader () {};
            private:
                ServorailStatus_DataReader (const ServorailStatus_DataReader &);
                ServorailStatus_DataReader & operator = (const ServorailStatus_DataReader &);
            };

            class  ServorailStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServorailStatus_DataReaderView_ptr _ptr_type;
                typedef ServorailStatus_DataReaderView_var _var_type;

                static ServorailStatus_DataReaderView_ptr _duplicate (ServorailStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServorailStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServorailStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServorailStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServorailStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServorailStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServorailStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServorailStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServorailStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServorailStatus_& instance) = 0;

            protected:
                ServorailStatus_DataReaderView () {};
                ~ServorailStatus_DataReaderView () {};
            private:
                ServorailStatus_DataReaderView (const ServorailStatus_DataReaderView &);
                ServorailStatus_DataReaderView & operator = (const ServorailStatus_DataReaderView &);
            };
        }

    }

}

#endif
