#ifndef _H_34BC71A78C1B2BA4ADE43E86BCACCEF0_SystemPower__H_
#define _H_34BC71A78C1B2BA4ADE43E86BCACCEF0_SystemPower__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SystemPower_Constants
            {
                const ::DDS::Octet BRICK1_VALID_SHIFTS_ = 0;

                const ::DDS::Octet BRICK1_VALID_MASK_ = 1;

                const ::DDS::Octet BRICK2_VALID_SHIFTS_ = 1;

                const ::DDS::Octet BRICK2_VALID_MASK_ = 2;

                const ::DDS::Octet BRICK3_VALID_SHIFTS_ = 2;

                const ::DDS::Octet BRICK3_VALID_MASK_ = 4;

                const ::DDS::Octet BRICK4_VALID_SHIFTS_ = 3;

                const ::DDS::Octet BRICK4_VALID_MASK_ = 8;

            }

            struct  SystemPower_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Float voltage5v_v_;
                ::DDS::Float voltage3v3_v_;
                ::DDS::Octet v3v3_valid_;
                ::DDS::Octet usb_connected_;
                ::DDS::Octet brick_valid_;
                ::DDS::Octet usb_valid_;
                ::DDS::Octet servo_valid_;
                ::DDS::Octet periph_5v_oc_;
                ::DDS::Octet hipower_5v_oc_;
            };

            typedef DDS_DCPSStruct_var<SystemPower_> SystemPower__var;
            typedef SystemPower_& SystemPower__out;

        }

    }

}

#endif /* _H_34BC71A78C1B2BA4ADE43E86BCACCEF0_SystemPower__H_ */
