#ifndef _H_34BC71A78C1B2BA4ADE43E86BCACCEF0_SystemPower_DCPS_H_
#define _H_34BC71A78C1B2BA4ADE43E86BCACCEF0_SystemPower_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemPower_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemPower_TypeSupportInterface;

            typedef SystemPower_TypeSupportInterface * SystemPower_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemPower_TypeSupportInterface> SystemPower_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemPower_TypeSupportInterface> SystemPower_TypeSupportInterface_out;


            class SystemPower_DataWriter;

            typedef SystemPower_DataWriter * SystemPower_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemPower_DataWriter> SystemPower_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemPower_DataWriter> SystemPower_DataWriter_out;


            class SystemPower_DataReader;

            typedef SystemPower_DataReader * SystemPower_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemPower_DataReader> SystemPower_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemPower_DataReader> SystemPower_DataReader_out;


            class SystemPower_DataReaderView;

            typedef SystemPower_DataReaderView * SystemPower_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemPower_DataReaderView> SystemPower_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemPower_DataReaderView> SystemPower_DataReaderView_out;

            struct SystemPower_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SystemPower_, struct SystemPower_Seq_uniq_> SystemPower_Seq;
            typedef DDS_DCPSSequence_var < SystemPower_Seq> SystemPower_Seq_var;
            typedef DDS_DCPSSequence_out < SystemPower_Seq> SystemPower_Seq_out;

            class  SystemPower_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemPower_TypeSupportInterface_ptr _ptr_type;
                typedef SystemPower_TypeSupportInterface_var _var_type;

                static SystemPower_TypeSupportInterface_ptr _duplicate (SystemPower_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemPower_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemPower_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemPower_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemPower_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemPower_TypeSupportInterface () {};
                ~SystemPower_TypeSupportInterface () {};
            private:
                SystemPower_TypeSupportInterface (const SystemPower_TypeSupportInterface &);
                SystemPower_TypeSupportInterface & operator = (const SystemPower_TypeSupportInterface &);
            };

            class  SystemPower_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemPower_DataWriter_ptr _ptr_type;
                typedef SystemPower_DataWriter_var _var_type;

                static SystemPower_DataWriter_ptr _duplicate (SystemPower_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemPower_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemPower_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemPower_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemPower_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemPower_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemPower_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemPower_& instance_data) = 0;

            protected:
                SystemPower_DataWriter () {};
                ~SystemPower_DataWriter () {};
            private:
                SystemPower_DataWriter (const SystemPower_DataWriter &);
                SystemPower_DataWriter & operator = (const SystemPower_DataWriter &);
            };

            class  SystemPower_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemPower_DataReader_ptr _ptr_type;
                typedef SystemPower_DataReader_var _var_type;

                static SystemPower_DataReader_ptr _duplicate (SystemPower_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemPower_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemPower_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemPower_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemPower_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemPower_& instance) = 0;

            protected:
                SystemPower_DataReader () {};
                ~SystemPower_DataReader () {};
            private:
                SystemPower_DataReader (const SystemPower_DataReader &);
                SystemPower_DataReader & operator = (const SystemPower_DataReader &);
            };

            class  SystemPower_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemPower_DataReaderView_ptr _ptr_type;
                typedef SystemPower_DataReaderView_var _var_type;

                static SystemPower_DataReaderView_ptr _duplicate (SystemPower_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemPower_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemPower_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemPower_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemPower_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemPower_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemPower_& instance) = 0;

            protected:
                SystemPower_DataReaderView () {};
                ~SystemPower_DataReaderView () {};
            private:
                SystemPower_DataReaderView (const SystemPower_DataReaderView &);
                SystemPower_DataReaderView & operator = (const SystemPower_DataReaderView &);
            };
        }

    }

}

#endif
