#ifndef _H_FD2866FFAD98A09647B405D52B7EC551_TecsStatus_DCPS_H_
#define _H_FD2866FFAD98A09647B405D52B7EC551_TecsStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TecsStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TecsStatus_TypeSupportInterface;

            typedef TecsStatus_TypeSupportInterface * TecsStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TecsStatus_TypeSupportInterface> TecsStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TecsStatus_TypeSupportInterface> TecsStatus_TypeSupportInterface_out;


            class TecsStatus_DataWriter;

            typedef TecsStatus_DataWriter * TecsStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TecsStatus_DataWriter> TecsStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < TecsStatus_DataWriter> TecsStatus_DataWriter_out;


            class TecsStatus_DataReader;

            typedef TecsStatus_DataReader * TecsStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TecsStatus_DataReader> TecsStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < TecsStatus_DataReader> TecsStatus_DataReader_out;


            class TecsStatus_DataReaderView;

            typedef TecsStatus_DataReaderView * TecsStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TecsStatus_DataReaderView> TecsStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TecsStatus_DataReaderView> TecsStatus_DataReaderView_out;

            struct TecsStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TecsStatus_, struct TecsStatus_Seq_uniq_> TecsStatus_Seq;
            typedef DDS_DCPSSequence_var < TecsStatus_Seq> TecsStatus_Seq_var;
            typedef DDS_DCPSSequence_out < TecsStatus_Seq> TecsStatus_Seq_out;

            class  TecsStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TecsStatus_TypeSupportInterface_ptr _ptr_type;
                typedef TecsStatus_TypeSupportInterface_var _var_type;

                static TecsStatus_TypeSupportInterface_ptr _duplicate (TecsStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TecsStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TecsStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TecsStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TecsStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TecsStatus_TypeSupportInterface () {};
                ~TecsStatus_TypeSupportInterface () {};
            private:
                TecsStatus_TypeSupportInterface (const TecsStatus_TypeSupportInterface &);
                TecsStatus_TypeSupportInterface & operator = (const TecsStatus_TypeSupportInterface &);
            };

            class  TecsStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TecsStatus_DataWriter_ptr _ptr_type;
                typedef TecsStatus_DataWriter_var _var_type;

                static TecsStatus_DataWriter_ptr _duplicate (TecsStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TecsStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TecsStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TecsStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TecsStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TecsStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TecsStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TecsStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TecsStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TecsStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TecsStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TecsStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TecsStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TecsStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TecsStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TecsStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TecsStatus_& instance_data) = 0;

            protected:
                TecsStatus_DataWriter () {};
                ~TecsStatus_DataWriter () {};
            private:
                TecsStatus_DataWriter (const TecsStatus_DataWriter &);
                TecsStatus_DataWriter & operator = (const TecsStatus_DataWriter &);
            };

            class  TecsStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TecsStatus_DataReader_ptr _ptr_type;
                typedef TecsStatus_DataReader_var _var_type;

                static TecsStatus_DataReader_ptr _duplicate (TecsStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TecsStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TecsStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TecsStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TecsStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TecsStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TecsStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TecsStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TecsStatus_& instance) = 0;

            protected:
                TecsStatus_DataReader () {};
                ~TecsStatus_DataReader () {};
            private:
                TecsStatus_DataReader (const TecsStatus_DataReader &);
                TecsStatus_DataReader & operator = (const TecsStatus_DataReader &);
            };

            class  TecsStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TecsStatus_DataReaderView_ptr _ptr_type;
                typedef TecsStatus_DataReaderView_var _var_type;

                static TecsStatus_DataReaderView_ptr _duplicate (TecsStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TecsStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TecsStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TecsStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TecsStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TecsStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TecsStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TecsStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TecsStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TecsStatus_& instance) = 0;

            protected:
                TecsStatus_DataReaderView () {};
                ~TecsStatus_DataReaderView () {};
            private:
                TecsStatus_DataReaderView (const TecsStatus_DataReaderView &);
                TecsStatus_DataReaderView & operator = (const TecsStatus_DataReaderView &);
            };
        }

    }

}

#endif
