#ifndef _H_BAB86D0C08ED66D917E380615EAAAC82_TestMotor__H_
#define _H_BAB86D0C08ED66D917E380615EAAAC82_TestMotor__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace TestMotor_Constants
            {
                const ::DDS::Octet NUM_MOTOR_OUTPUTS_ = 8;

                const ::DDS::Octet ACTION_STOP_ = 0;

                const ::DDS::Octet ACTION_RUN_ = 1;

                const ::DDS::Octet ORB_QUEUE_LENGTH_ = 4;

            }

            struct  TestMotor_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet action_;
                ::DDS::ULong motor_number_;
                ::DDS::Float value_;
                ::DDS::ULong timeout_ms_;
                ::DDS::Octet driver_instance_;
            };

            typedef DDS_DCPSStruct_var<TestMotor_> TestMotor__var;
            typedef TestMotor_& TestMotor__out;

        }

    }

}

#endif /* _H_BAB86D0C08ED66D917E380615EAAAC82_TestMotor__H_ */
