#ifndef _H_BAB86D0C08ED66D917E380615EAAAC82_TestMotor_DCPS_H_
#define _H_BAB86D0C08ED66D917E380615EAAAC82_TestMotor_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TestMotor_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TestMotor_TypeSupportInterface;

            typedef TestMotor_TypeSupportInterface * TestMotor_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TestMotor_TypeSupportInterface> TestMotor_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TestMotor_TypeSupportInterface> TestMotor_TypeSupportInterface_out;


            class TestMotor_DataWriter;

            typedef TestMotor_DataWriter * TestMotor_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TestMotor_DataWriter> TestMotor_DataWriter_var;
            typedef DDS_DCPSInterface_out < TestMotor_DataWriter> TestMotor_DataWriter_out;


            class TestMotor_DataReader;

            typedef TestMotor_DataReader * TestMotor_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TestMotor_DataReader> TestMotor_DataReader_var;
            typedef DDS_DCPSInterface_out < TestMotor_DataReader> TestMotor_DataReader_out;


            class TestMotor_DataReaderView;

            typedef TestMotor_DataReaderView * TestMotor_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TestMotor_DataReaderView> TestMotor_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TestMotor_DataReaderView> TestMotor_DataReaderView_out;

            struct TestMotor_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TestMotor_, struct TestMotor_Seq_uniq_> TestMotor_Seq;
            typedef DDS_DCPSSequence_var < TestMotor_Seq> TestMotor_Seq_var;
            typedef DDS_DCPSSequence_out < TestMotor_Seq> TestMotor_Seq_out;

            class  TestMotor_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TestMotor_TypeSupportInterface_ptr _ptr_type;
                typedef TestMotor_TypeSupportInterface_var _var_type;

                static TestMotor_TypeSupportInterface_ptr _duplicate (TestMotor_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestMotor_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TestMotor_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestMotor_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TestMotor_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TestMotor_TypeSupportInterface () {};
                ~TestMotor_TypeSupportInterface () {};
            private:
                TestMotor_TypeSupportInterface (const TestMotor_TypeSupportInterface &);
                TestMotor_TypeSupportInterface & operator = (const TestMotor_TypeSupportInterface &);
            };

            class  TestMotor_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TestMotor_DataWriter_ptr _ptr_type;
                typedef TestMotor_DataWriter_var _var_type;

                static TestMotor_DataWriter_ptr _duplicate (TestMotor_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestMotor_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TestMotor_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestMotor_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TestMotor_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TestMotor_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TestMotor_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TestMotor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TestMotor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TestMotor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TestMotor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TestMotor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TestMotor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TestMotor_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TestMotor_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TestMotor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestMotor_& instance_data) = 0;

            protected:
                TestMotor_DataWriter () {};
                ~TestMotor_DataWriter () {};
            private:
                TestMotor_DataWriter (const TestMotor_DataWriter &);
                TestMotor_DataWriter & operator = (const TestMotor_DataWriter &);
            };

            class  TestMotor_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TestMotor_DataReader_ptr _ptr_type;
                typedef TestMotor_DataReader_var _var_type;

                static TestMotor_DataReader_ptr _duplicate (TestMotor_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestMotor_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TestMotor_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestMotor_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TestMotor_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TestMotor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TestMotor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TestMotor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestMotor_& instance) = 0;

            protected:
                TestMotor_DataReader () {};
                ~TestMotor_DataReader () {};
            private:
                TestMotor_DataReader (const TestMotor_DataReader &);
                TestMotor_DataReader & operator = (const TestMotor_DataReader &);
            };

            class  TestMotor_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TestMotor_DataReaderView_ptr _ptr_type;
                typedef TestMotor_DataReaderView_var _var_type;

                static TestMotor_DataReaderView_ptr _duplicate (TestMotor_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestMotor_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TestMotor_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestMotor_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TestMotor_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TestMotor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TestMotor_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TestMotor_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TestMotor_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestMotor_& instance) = 0;

            protected:
                TestMotor_DataReaderView () {};
                ~TestMotor_DataReaderView () {};
            private:
                TestMotor_DataReaderView (const TestMotor_DataReaderView &);
                TestMotor_DataReaderView & operator = (const TestMotor_DataReaderView &);
            };
        }

    }

}

#endif
