#ifndef _H_9F42E50B207A1DAC54A2F56B0D56A444_TransponderReport__H_
#define _H_9F42E50B207A1DAC54A2F56B0D56A444_TransponderReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace TransponderReport_Constants
            {
                const ::DDS::UShort PX4_ADSB_FLAGS_VALID_COORDS_ = 1U;

                const ::DDS::UShort PX4_ADSB_FLAGS_VALID_ALTITUDE_ = 2U;

                const ::DDS::UShort PX4_ADSB_FLAGS_VALID_HEADING_ = 4U;

                const ::DDS::UShort PX4_ADSB_FLAGS_VALID_VELOCITY_ = 8U;

                const ::DDS::UShort PX4_ADSB_FLAGS_VALID_CALLSIGN_ = 16U;

                const ::DDS::UShort PX4_ADSB_FLAGS_VALID_SQUAWK_ = 32U;

                const ::DDS::UShort PX4_ADSB_FLAGS_RETRANSLATE_ = 256U;

                const ::DDS::Octet ORB_QUEUE_LENGTH_ = 10;

            }

            struct  TransponderReport_
            {
                struct _callsign__uniq_{};
                typedef ::DDS::Octet _callsign__slice;
                typedef ::DDS::Octet _callsign_[9];
                typedef DDS_DCPS_FArray_var< _callsign_, _callsign__slice, struct _callsign__uniq_ > _callsign__var;
                typedef _callsign_ _callsign__out;
                typedef DDS_DCPS_Array_forany< _callsign_, _callsign__slice, struct _callsign__uniq_ > _callsign__forany;
                static _callsign__slice *_callsign__alloc();
                static void _callsign__free(_callsign__slice *);
                static void _callsign__copy(_callsign__slice *to, const _callsign__slice *from);
                static _callsign__slice *_callsign__dup(const _callsign__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::ULong icao_address_;
                ::DDS::Double lat_;
                ::DDS::Double lon_;
                ::DDS::Octet altitude_type_;
                ::DDS::Float altitude_;
                ::DDS::Float heading_;
                ::DDS::Float hor_velocity_;
                ::DDS::Float ver_velocity_;
                _callsign_ callsign_;
                ::DDS::Octet emitter_type_;
                ::DDS::Octet tslc_;
                ::DDS::UShort flags_;
                ::DDS::UShort squawk_;
            };

            typedef DDS_DCPSStruct_var<TransponderReport_> TransponderReport__var;
            typedef TransponderReport_& TransponderReport__out;

        }

    }

}

#endif /* _H_9F42E50B207A1DAC54A2F56B0D56A444_TransponderReport__H_ */
