#ifndef _H_9391B9123B0896E13AD85A07AB5F801B_UavcanParameterRequest_DCPS_H_
#define _H_9391B9123B0896E13AD85A07AB5F801B_UavcanParameterRequest_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UavcanParameterRequest_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UavcanParameterRequest_TypeSupportInterface;

            typedef UavcanParameterRequest_TypeSupportInterface * UavcanParameterRequest_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UavcanParameterRequest_TypeSupportInterface> UavcanParameterRequest_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UavcanParameterRequest_TypeSupportInterface> UavcanParameterRequest_TypeSupportInterface_out;


            class UavcanParameterRequest_DataWriter;

            typedef UavcanParameterRequest_DataWriter * UavcanParameterRequest_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UavcanParameterRequest_DataWriter> UavcanParameterRequest_DataWriter_var;
            typedef DDS_DCPSInterface_out < UavcanParameterRequest_DataWriter> UavcanParameterRequest_DataWriter_out;


            class UavcanParameterRequest_DataReader;

            typedef UavcanParameterRequest_DataReader * UavcanParameterRequest_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UavcanParameterRequest_DataReader> UavcanParameterRequest_DataReader_var;
            typedef DDS_DCPSInterface_out < UavcanParameterRequest_DataReader> UavcanParameterRequest_DataReader_out;


            class UavcanParameterRequest_DataReaderView;

            typedef UavcanParameterRequest_DataReaderView * UavcanParameterRequest_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UavcanParameterRequest_DataReaderView> UavcanParameterRequest_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UavcanParameterRequest_DataReaderView> UavcanParameterRequest_DataReaderView_out;

            struct UavcanParameterRequest_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < UavcanParameterRequest_, struct UavcanParameterRequest_Seq_uniq_> UavcanParameterRequest_Seq;
            typedef DDS_DCPSSequence_var < UavcanParameterRequest_Seq> UavcanParameterRequest_Seq_var;
            typedef DDS_DCPSSequence_out < UavcanParameterRequest_Seq> UavcanParameterRequest_Seq_out;

            class  UavcanParameterRequest_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UavcanParameterRequest_TypeSupportInterface_ptr _ptr_type;
                typedef UavcanParameterRequest_TypeSupportInterface_var _var_type;

                static UavcanParameterRequest_TypeSupportInterface_ptr _duplicate (UavcanParameterRequest_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UavcanParameterRequest_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UavcanParameterRequest_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UavcanParameterRequest_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UavcanParameterRequest_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UavcanParameterRequest_TypeSupportInterface () {};
                ~UavcanParameterRequest_TypeSupportInterface () {};
            private:
                UavcanParameterRequest_TypeSupportInterface (const UavcanParameterRequest_TypeSupportInterface &);
                UavcanParameterRequest_TypeSupportInterface & operator = (const UavcanParameterRequest_TypeSupportInterface &);
            };

            class  UavcanParameterRequest_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UavcanParameterRequest_DataWriter_ptr _ptr_type;
                typedef UavcanParameterRequest_DataWriter_var _var_type;

                static UavcanParameterRequest_DataWriter_ptr _duplicate (UavcanParameterRequest_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UavcanParameterRequest_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UavcanParameterRequest_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UavcanParameterRequest_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UavcanParameterRequest_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UavcanParameterRequest_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UavcanParameterRequest_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UavcanParameterRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UavcanParameterRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UavcanParameterRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UavcanParameterRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UavcanParameterRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UavcanParameterRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UavcanParameterRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UavcanParameterRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UavcanParameterRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UavcanParameterRequest_& instance_data) = 0;

            protected:
                UavcanParameterRequest_DataWriter () {};
                ~UavcanParameterRequest_DataWriter () {};
            private:
                UavcanParameterRequest_DataWriter (const UavcanParameterRequest_DataWriter &);
                UavcanParameterRequest_DataWriter & operator = (const UavcanParameterRequest_DataWriter &);
            };

            class  UavcanParameterRequest_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UavcanParameterRequest_DataReader_ptr _ptr_type;
                typedef UavcanParameterRequest_DataReader_var _var_type;

                static UavcanParameterRequest_DataReader_ptr _duplicate (UavcanParameterRequest_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UavcanParameterRequest_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UavcanParameterRequest_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UavcanParameterRequest_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UavcanParameterRequest_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UavcanParameterRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UavcanParameterRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UavcanParameterRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UavcanParameterRequest_& instance) = 0;

            protected:
                UavcanParameterRequest_DataReader () {};
                ~UavcanParameterRequest_DataReader () {};
            private:
                UavcanParameterRequest_DataReader (const UavcanParameterRequest_DataReader &);
                UavcanParameterRequest_DataReader & operator = (const UavcanParameterRequest_DataReader &);
            };

            class  UavcanParameterRequest_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UavcanParameterRequest_DataReaderView_ptr _ptr_type;
                typedef UavcanParameterRequest_DataReaderView_var _var_type;

                static UavcanParameterRequest_DataReaderView_ptr _duplicate (UavcanParameterRequest_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UavcanParameterRequest_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UavcanParameterRequest_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UavcanParameterRequest_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UavcanParameterRequest_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UavcanParameterRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UavcanParameterRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UavcanParameterRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UavcanParameterRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UavcanParameterRequest_& instance) = 0;

            protected:
                UavcanParameterRequest_DataReaderView () {};
                ~UavcanParameterRequest_DataReaderView () {};
            private:
                UavcanParameterRequest_DataReaderView (const UavcanParameterRequest_DataReaderView &);
                UavcanParameterRequest_DataReaderView & operator = (const UavcanParameterRequest_DataReaderView &);
            };
        }

    }

}

#endif
