#ifndef _H_95BB80320060082406FEA9E4CA8690E8_VehicleAirData_DCPS_H_
#define _H_95BB80320060082406FEA9E4CA8690E8_VehicleAirData_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleAirData_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleAirData_TypeSupportInterface;

            typedef VehicleAirData_TypeSupportInterface * VehicleAirData_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleAirData_TypeSupportInterface> VehicleAirData_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleAirData_TypeSupportInterface> VehicleAirData_TypeSupportInterface_out;


            class VehicleAirData_DataWriter;

            typedef VehicleAirData_DataWriter * VehicleAirData_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleAirData_DataWriter> VehicleAirData_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleAirData_DataWriter> VehicleAirData_DataWriter_out;


            class VehicleAirData_DataReader;

            typedef VehicleAirData_DataReader * VehicleAirData_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleAirData_DataReader> VehicleAirData_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleAirData_DataReader> VehicleAirData_DataReader_out;


            class VehicleAirData_DataReaderView;

            typedef VehicleAirData_DataReaderView * VehicleAirData_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleAirData_DataReaderView> VehicleAirData_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleAirData_DataReaderView> VehicleAirData_DataReaderView_out;

            struct VehicleAirData_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleAirData_, struct VehicleAirData_Seq_uniq_> VehicleAirData_Seq;
            typedef DDS_DCPSSequence_var < VehicleAirData_Seq> VehicleAirData_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleAirData_Seq> VehicleAirData_Seq_out;

            class  VehicleAirData_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleAirData_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleAirData_TypeSupportInterface_var _var_type;

                static VehicleAirData_TypeSupportInterface_ptr _duplicate (VehicleAirData_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAirData_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAirData_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAirData_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAirData_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleAirData_TypeSupportInterface () {};
                ~VehicleAirData_TypeSupportInterface () {};
            private:
                VehicleAirData_TypeSupportInterface (const VehicleAirData_TypeSupportInterface &);
                VehicleAirData_TypeSupportInterface & operator = (const VehicleAirData_TypeSupportInterface &);
            };

            class  VehicleAirData_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleAirData_DataWriter_ptr _ptr_type;
                typedef VehicleAirData_DataWriter_var _var_type;

                static VehicleAirData_DataWriter_ptr _duplicate (VehicleAirData_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAirData_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAirData_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAirData_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAirData_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleAirData_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleAirData_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleAirData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleAirData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleAirData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleAirData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleAirData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleAirData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleAirData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleAirData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleAirData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAirData_& instance_data) = 0;

            protected:
                VehicleAirData_DataWriter () {};
                ~VehicleAirData_DataWriter () {};
            private:
                VehicleAirData_DataWriter (const VehicleAirData_DataWriter &);
                VehicleAirData_DataWriter & operator = (const VehicleAirData_DataWriter &);
            };

            class  VehicleAirData_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleAirData_DataReader_ptr _ptr_type;
                typedef VehicleAirData_DataReader_var _var_type;

                static VehicleAirData_DataReader_ptr _duplicate (VehicleAirData_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAirData_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAirData_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAirData_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAirData_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAirData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAirData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAirData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAirData_& instance) = 0;

            protected:
                VehicleAirData_DataReader () {};
                ~VehicleAirData_DataReader () {};
            private:
                VehicleAirData_DataReader (const VehicleAirData_DataReader &);
                VehicleAirData_DataReader & operator = (const VehicleAirData_DataReader &);
            };

            class  VehicleAirData_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleAirData_DataReaderView_ptr _ptr_type;
                typedef VehicleAirData_DataReaderView_var _var_type;

                static VehicleAirData_DataReaderView_ptr _duplicate (VehicleAirData_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAirData_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAirData_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAirData_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAirData_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAirData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAirData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAirData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAirData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAirData_& instance) = 0;

            protected:
                VehicleAirData_DataReaderView () {};
                ~VehicleAirData_DataReaderView () {};
            private:
                VehicleAirData_DataReaderView (const VehicleAirData_DataReaderView &);
                VehicleAirData_DataReaderView & operator = (const VehicleAirData_DataReaderView &);
            };
        }

    }

}

#endif
