#ifndef _H_82E7D403A0EB112106B7AE040B0963A5_VehicleAttitudeGroundtruth_DCPS_H_
#define _H_82E7D403A0EB112106B7AE040B0963A5_VehicleAttitudeGroundtruth_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleAttitudeGroundtruth_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleAttitudeGroundtruth_TypeSupportInterface;

            typedef VehicleAttitudeGroundtruth_TypeSupportInterface * VehicleAttitudeGroundtruth_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitudeGroundtruth_TypeSupportInterface> VehicleAttitudeGroundtruth_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleAttitudeGroundtruth_TypeSupportInterface> VehicleAttitudeGroundtruth_TypeSupportInterface_out;


            class VehicleAttitudeGroundtruth_DataWriter;

            typedef VehicleAttitudeGroundtruth_DataWriter * VehicleAttitudeGroundtruth_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitudeGroundtruth_DataWriter> VehicleAttitudeGroundtruth_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleAttitudeGroundtruth_DataWriter> VehicleAttitudeGroundtruth_DataWriter_out;


            class VehicleAttitudeGroundtruth_DataReader;

            typedef VehicleAttitudeGroundtruth_DataReader * VehicleAttitudeGroundtruth_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitudeGroundtruth_DataReader> VehicleAttitudeGroundtruth_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleAttitudeGroundtruth_DataReader> VehicleAttitudeGroundtruth_DataReader_out;


            class VehicleAttitudeGroundtruth_DataReaderView;

            typedef VehicleAttitudeGroundtruth_DataReaderView * VehicleAttitudeGroundtruth_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitudeGroundtruth_DataReaderView> VehicleAttitudeGroundtruth_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleAttitudeGroundtruth_DataReaderView> VehicleAttitudeGroundtruth_DataReaderView_out;

            struct VehicleAttitudeGroundtruth_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleAttitudeGroundtruth_, struct VehicleAttitudeGroundtruth_Seq_uniq_> VehicleAttitudeGroundtruth_Seq;
            typedef DDS_DCPSSequence_var < VehicleAttitudeGroundtruth_Seq> VehicleAttitudeGroundtruth_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleAttitudeGroundtruth_Seq> VehicleAttitudeGroundtruth_Seq_out;

            class  VehicleAttitudeGroundtruth_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleAttitudeGroundtruth_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleAttitudeGroundtruth_TypeSupportInterface_var _var_type;

                static VehicleAttitudeGroundtruth_TypeSupportInterface_ptr _duplicate (VehicleAttitudeGroundtruth_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitudeGroundtruth_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitudeGroundtruth_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitudeGroundtruth_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitudeGroundtruth_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleAttitudeGroundtruth_TypeSupportInterface () {};
                ~VehicleAttitudeGroundtruth_TypeSupportInterface () {};
            private:
                VehicleAttitudeGroundtruth_TypeSupportInterface (const VehicleAttitudeGroundtruth_TypeSupportInterface &);
                VehicleAttitudeGroundtruth_TypeSupportInterface & operator = (const VehicleAttitudeGroundtruth_TypeSupportInterface &);
            };

            class  VehicleAttitudeGroundtruth_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleAttitudeGroundtruth_DataWriter_ptr _ptr_type;
                typedef VehicleAttitudeGroundtruth_DataWriter_var _var_type;

                static VehicleAttitudeGroundtruth_DataWriter_ptr _duplicate (VehicleAttitudeGroundtruth_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitudeGroundtruth_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitudeGroundtruth_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitudeGroundtruth_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitudeGroundtruth_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleAttitudeGroundtruth_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleAttitudeGroundtruth_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleAttitudeGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleAttitudeGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleAttitudeGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleAttitudeGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleAttitudeGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleAttitudeGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleAttitudeGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleAttitudeGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleAttitudeGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitudeGroundtruth_& instance_data) = 0;

            protected:
                VehicleAttitudeGroundtruth_DataWriter () {};
                ~VehicleAttitudeGroundtruth_DataWriter () {};
            private:
                VehicleAttitudeGroundtruth_DataWriter (const VehicleAttitudeGroundtruth_DataWriter &);
                VehicleAttitudeGroundtruth_DataWriter & operator = (const VehicleAttitudeGroundtruth_DataWriter &);
            };

            class  VehicleAttitudeGroundtruth_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleAttitudeGroundtruth_DataReader_ptr _ptr_type;
                typedef VehicleAttitudeGroundtruth_DataReader_var _var_type;

                static VehicleAttitudeGroundtruth_DataReader_ptr _duplicate (VehicleAttitudeGroundtruth_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitudeGroundtruth_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitudeGroundtruth_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitudeGroundtruth_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitudeGroundtruth_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAttitudeGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAttitudeGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAttitudeGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitudeGroundtruth_& instance) = 0;

            protected:
                VehicleAttitudeGroundtruth_DataReader () {};
                ~VehicleAttitudeGroundtruth_DataReader () {};
            private:
                VehicleAttitudeGroundtruth_DataReader (const VehicleAttitudeGroundtruth_DataReader &);
                VehicleAttitudeGroundtruth_DataReader & operator = (const VehicleAttitudeGroundtruth_DataReader &);
            };

            class  VehicleAttitudeGroundtruth_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleAttitudeGroundtruth_DataReaderView_ptr _ptr_type;
                typedef VehicleAttitudeGroundtruth_DataReaderView_var _var_type;

                static VehicleAttitudeGroundtruth_DataReaderView_ptr _duplicate (VehicleAttitudeGroundtruth_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitudeGroundtruth_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitudeGroundtruth_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitudeGroundtruth_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitudeGroundtruth_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAttitudeGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAttitudeGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAttitudeGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAttitudeGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitudeGroundtruth_& instance) = 0;

            protected:
                VehicleAttitudeGroundtruth_DataReaderView () {};
                ~VehicleAttitudeGroundtruth_DataReaderView () {};
            private:
                VehicleAttitudeGroundtruth_DataReaderView (const VehicleAttitudeGroundtruth_DataReaderView &);
                VehicleAttitudeGroundtruth_DataReaderView & operator = (const VehicleAttitudeGroundtruth_DataReaderView &);
            };
        }

    }

}

#endif
