#ifndef _H_B7251E60B66BC6F0FB10AFC43E8F24D0_VehicleAttitudeSetpoint_DCPS_H_
#define _H_B7251E60B66BC6F0FB10AFC43E8F24D0_VehicleAttitudeSetpoint_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleAttitudeSetpoint_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleAttitudeSetpoint_TypeSupportInterface;

            typedef VehicleAttitudeSetpoint_TypeSupportInterface * VehicleAttitudeSetpoint_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitudeSetpoint_TypeSupportInterface> VehicleAttitudeSetpoint_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleAttitudeSetpoint_TypeSupportInterface> VehicleAttitudeSetpoint_TypeSupportInterface_out;


            class VehicleAttitudeSetpoint_DataWriter;

            typedef VehicleAttitudeSetpoint_DataWriter * VehicleAttitudeSetpoint_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitudeSetpoint_DataWriter> VehicleAttitudeSetpoint_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleAttitudeSetpoint_DataWriter> VehicleAttitudeSetpoint_DataWriter_out;


            class VehicleAttitudeSetpoint_DataReader;

            typedef VehicleAttitudeSetpoint_DataReader * VehicleAttitudeSetpoint_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitudeSetpoint_DataReader> VehicleAttitudeSetpoint_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleAttitudeSetpoint_DataReader> VehicleAttitudeSetpoint_DataReader_out;


            class VehicleAttitudeSetpoint_DataReaderView;

            typedef VehicleAttitudeSetpoint_DataReaderView * VehicleAttitudeSetpoint_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitudeSetpoint_DataReaderView> VehicleAttitudeSetpoint_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleAttitudeSetpoint_DataReaderView> VehicleAttitudeSetpoint_DataReaderView_out;

            struct VehicleAttitudeSetpoint_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleAttitudeSetpoint_, struct VehicleAttitudeSetpoint_Seq_uniq_> VehicleAttitudeSetpoint_Seq;
            typedef DDS_DCPSSequence_var < VehicleAttitudeSetpoint_Seq> VehicleAttitudeSetpoint_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleAttitudeSetpoint_Seq> VehicleAttitudeSetpoint_Seq_out;

            class  VehicleAttitudeSetpoint_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleAttitudeSetpoint_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleAttitudeSetpoint_TypeSupportInterface_var _var_type;

                static VehicleAttitudeSetpoint_TypeSupportInterface_ptr _duplicate (VehicleAttitudeSetpoint_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitudeSetpoint_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitudeSetpoint_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitudeSetpoint_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitudeSetpoint_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleAttitudeSetpoint_TypeSupportInterface () {};
                ~VehicleAttitudeSetpoint_TypeSupportInterface () {};
            private:
                VehicleAttitudeSetpoint_TypeSupportInterface (const VehicleAttitudeSetpoint_TypeSupportInterface &);
                VehicleAttitudeSetpoint_TypeSupportInterface & operator = (const VehicleAttitudeSetpoint_TypeSupportInterface &);
            };

            class  VehicleAttitudeSetpoint_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleAttitudeSetpoint_DataWriter_ptr _ptr_type;
                typedef VehicleAttitudeSetpoint_DataWriter_var _var_type;

                static VehicleAttitudeSetpoint_DataWriter_ptr _duplicate (VehicleAttitudeSetpoint_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitudeSetpoint_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitudeSetpoint_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitudeSetpoint_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitudeSetpoint_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleAttitudeSetpoint_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleAttitudeSetpoint_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleAttitudeSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleAttitudeSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitudeSetpoint_& instance_data) = 0;

            protected:
                VehicleAttitudeSetpoint_DataWriter () {};
                ~VehicleAttitudeSetpoint_DataWriter () {};
            private:
                VehicleAttitudeSetpoint_DataWriter (const VehicleAttitudeSetpoint_DataWriter &);
                VehicleAttitudeSetpoint_DataWriter & operator = (const VehicleAttitudeSetpoint_DataWriter &);
            };

            class  VehicleAttitudeSetpoint_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleAttitudeSetpoint_DataReader_ptr _ptr_type;
                typedef VehicleAttitudeSetpoint_DataReader_var _var_type;

                static VehicleAttitudeSetpoint_DataReader_ptr _duplicate (VehicleAttitudeSetpoint_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitudeSetpoint_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitudeSetpoint_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitudeSetpoint_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitudeSetpoint_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitudeSetpoint_& instance) = 0;

            protected:
                VehicleAttitudeSetpoint_DataReader () {};
                ~VehicleAttitudeSetpoint_DataReader () {};
            private:
                VehicleAttitudeSetpoint_DataReader (const VehicleAttitudeSetpoint_DataReader &);
                VehicleAttitudeSetpoint_DataReader & operator = (const VehicleAttitudeSetpoint_DataReader &);
            };

            class  VehicleAttitudeSetpoint_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleAttitudeSetpoint_DataReaderView_ptr _ptr_type;
                typedef VehicleAttitudeSetpoint_DataReaderView_var _var_type;

                static VehicleAttitudeSetpoint_DataReaderView_ptr _duplicate (VehicleAttitudeSetpoint_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitudeSetpoint_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitudeSetpoint_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitudeSetpoint_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitudeSetpoint_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAttitudeSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAttitudeSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAttitudeSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitudeSetpoint_& instance) = 0;

            protected:
                VehicleAttitudeSetpoint_DataReaderView () {};
                ~VehicleAttitudeSetpoint_DataReaderView () {};
            private:
                VehicleAttitudeSetpoint_DataReaderView (const VehicleAttitudeSetpoint_DataReaderView &);
                VehicleAttitudeSetpoint_DataReaderView & operator = (const VehicleAttitudeSetpoint_DataReaderView &);
            };
        }

    }

}

#endif
