#ifndef _H_DF68CDCAF0EB662BC8B94189E83E7B40_VehicleAttitude_DCPS_H_
#define _H_DF68CDCAF0EB662BC8B94189E83E7B40_VehicleAttitude_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleAttitude_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleAttitude_TypeSupportInterface;

            typedef VehicleAttitude_TypeSupportInterface * VehicleAttitude_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitude_TypeSupportInterface> VehicleAttitude_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleAttitude_TypeSupportInterface> VehicleAttitude_TypeSupportInterface_out;


            class VehicleAttitude_DataWriter;

            typedef VehicleAttitude_DataWriter * VehicleAttitude_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitude_DataWriter> VehicleAttitude_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleAttitude_DataWriter> VehicleAttitude_DataWriter_out;


            class VehicleAttitude_DataReader;

            typedef VehicleAttitude_DataReader * VehicleAttitude_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitude_DataReader> VehicleAttitude_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleAttitude_DataReader> VehicleAttitude_DataReader_out;


            class VehicleAttitude_DataReaderView;

            typedef VehicleAttitude_DataReaderView * VehicleAttitude_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleAttitude_DataReaderView> VehicleAttitude_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleAttitude_DataReaderView> VehicleAttitude_DataReaderView_out;

            struct VehicleAttitude_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleAttitude_, struct VehicleAttitude_Seq_uniq_> VehicleAttitude_Seq;
            typedef DDS_DCPSSequence_var < VehicleAttitude_Seq> VehicleAttitude_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleAttitude_Seq> VehicleAttitude_Seq_out;

            class  VehicleAttitude_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleAttitude_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleAttitude_TypeSupportInterface_var _var_type;

                static VehicleAttitude_TypeSupportInterface_ptr _duplicate (VehicleAttitude_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitude_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitude_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitude_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitude_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleAttitude_TypeSupportInterface () {};
                ~VehicleAttitude_TypeSupportInterface () {};
            private:
                VehicleAttitude_TypeSupportInterface (const VehicleAttitude_TypeSupportInterface &);
                VehicleAttitude_TypeSupportInterface & operator = (const VehicleAttitude_TypeSupportInterface &);
            };

            class  VehicleAttitude_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleAttitude_DataWriter_ptr _ptr_type;
                typedef VehicleAttitude_DataWriter_var _var_type;

                static VehicleAttitude_DataWriter_ptr _duplicate (VehicleAttitude_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitude_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitude_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitude_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitude_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleAttitude_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleAttitude_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleAttitude_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleAttitude_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleAttitude_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleAttitude_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleAttitude_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleAttitude_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleAttitude_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleAttitude_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleAttitude_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitude_& instance_data) = 0;

            protected:
                VehicleAttitude_DataWriter () {};
                ~VehicleAttitude_DataWriter () {};
            private:
                VehicleAttitude_DataWriter (const VehicleAttitude_DataWriter &);
                VehicleAttitude_DataWriter & operator = (const VehicleAttitude_DataWriter &);
            };

            class  VehicleAttitude_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleAttitude_DataReader_ptr _ptr_type;
                typedef VehicleAttitude_DataReader_var _var_type;

                static VehicleAttitude_DataReader_ptr _duplicate (VehicleAttitude_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitude_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitude_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitude_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitude_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAttitude_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAttitude_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAttitude_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitude_& instance) = 0;

            protected:
                VehicleAttitude_DataReader () {};
                ~VehicleAttitude_DataReader () {};
            private:
                VehicleAttitude_DataReader (const VehicleAttitude_DataReader &);
                VehicleAttitude_DataReader & operator = (const VehicleAttitude_DataReader &);
            };

            class  VehicleAttitude_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleAttitude_DataReaderView_ptr _ptr_type;
                typedef VehicleAttitude_DataReaderView_var _var_type;

                static VehicleAttitude_DataReaderView_ptr _duplicate (VehicleAttitude_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleAttitude_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleAttitude_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleAttitude_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleAttitude_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleAttitude_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleAttitude_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleAttitude_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleAttitude_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleAttitude_& instance) = 0;

            protected:
                VehicleAttitude_DataReaderView () {};
                ~VehicleAttitude_DataReaderView () {};
            private:
                VehicleAttitude_DataReaderView (const VehicleAttitude_DataReaderView &);
                VehicleAttitude_DataReaderView & operator = (const VehicleAttitude_DataReaderView &);
            };
        }

    }

}

#endif
