#ifndef _H_0D6A74E2704A23C3BFD06B9969AACD61_VehicleCommandAck_DCPS_H_
#define _H_0D6A74E2704A23C3BFD06B9969AACD61_VehicleCommandAck_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleCommandAck_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleCommandAck_TypeSupportInterface;

            typedef VehicleCommandAck_TypeSupportInterface * VehicleCommandAck_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleCommandAck_TypeSupportInterface> VehicleCommandAck_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleCommandAck_TypeSupportInterface> VehicleCommandAck_TypeSupportInterface_out;


            class VehicleCommandAck_DataWriter;

            typedef VehicleCommandAck_DataWriter * VehicleCommandAck_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleCommandAck_DataWriter> VehicleCommandAck_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleCommandAck_DataWriter> VehicleCommandAck_DataWriter_out;


            class VehicleCommandAck_DataReader;

            typedef VehicleCommandAck_DataReader * VehicleCommandAck_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleCommandAck_DataReader> VehicleCommandAck_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleCommandAck_DataReader> VehicleCommandAck_DataReader_out;


            class VehicleCommandAck_DataReaderView;

            typedef VehicleCommandAck_DataReaderView * VehicleCommandAck_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleCommandAck_DataReaderView> VehicleCommandAck_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleCommandAck_DataReaderView> VehicleCommandAck_DataReaderView_out;

            struct VehicleCommandAck_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleCommandAck_, struct VehicleCommandAck_Seq_uniq_> VehicleCommandAck_Seq;
            typedef DDS_DCPSSequence_var < VehicleCommandAck_Seq> VehicleCommandAck_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleCommandAck_Seq> VehicleCommandAck_Seq_out;

            class  VehicleCommandAck_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleCommandAck_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleCommandAck_TypeSupportInterface_var _var_type;

                static VehicleCommandAck_TypeSupportInterface_ptr _duplicate (VehicleCommandAck_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleCommandAck_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleCommandAck_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleCommandAck_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleCommandAck_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleCommandAck_TypeSupportInterface () {};
                ~VehicleCommandAck_TypeSupportInterface () {};
            private:
                VehicleCommandAck_TypeSupportInterface (const VehicleCommandAck_TypeSupportInterface &);
                VehicleCommandAck_TypeSupportInterface & operator = (const VehicleCommandAck_TypeSupportInterface &);
            };

            class  VehicleCommandAck_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleCommandAck_DataWriter_ptr _ptr_type;
                typedef VehicleCommandAck_DataWriter_var _var_type;

                static VehicleCommandAck_DataWriter_ptr _duplicate (VehicleCommandAck_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleCommandAck_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleCommandAck_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleCommandAck_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleCommandAck_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleCommandAck_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleCommandAck_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleCommandAck_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleCommandAck_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleCommandAck_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleCommandAck_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleCommandAck_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleCommandAck_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleCommandAck_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleCommandAck_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleCommandAck_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleCommandAck_& instance_data) = 0;

            protected:
                VehicleCommandAck_DataWriter () {};
                ~VehicleCommandAck_DataWriter () {};
            private:
                VehicleCommandAck_DataWriter (const VehicleCommandAck_DataWriter &);
                VehicleCommandAck_DataWriter & operator = (const VehicleCommandAck_DataWriter &);
            };

            class  VehicleCommandAck_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleCommandAck_DataReader_ptr _ptr_type;
                typedef VehicleCommandAck_DataReader_var _var_type;

                static VehicleCommandAck_DataReader_ptr _duplicate (VehicleCommandAck_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleCommandAck_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleCommandAck_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleCommandAck_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleCommandAck_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleCommandAck_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleCommandAck_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleCommandAck_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleCommandAck_& instance) = 0;

            protected:
                VehicleCommandAck_DataReader () {};
                ~VehicleCommandAck_DataReader () {};
            private:
                VehicleCommandAck_DataReader (const VehicleCommandAck_DataReader &);
                VehicleCommandAck_DataReader & operator = (const VehicleCommandAck_DataReader &);
            };

            class  VehicleCommandAck_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleCommandAck_DataReaderView_ptr _ptr_type;
                typedef VehicleCommandAck_DataReaderView_var _var_type;

                static VehicleCommandAck_DataReaderView_ptr _duplicate (VehicleCommandAck_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleCommandAck_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleCommandAck_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleCommandAck_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleCommandAck_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleCommandAck_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleCommandAck_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleCommandAck_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleCommandAck_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleCommandAck_& instance) = 0;

            protected:
                VehicleCommandAck_DataReaderView () {};
                ~VehicleCommandAck_DataReaderView () {};
            private:
                VehicleCommandAck_DataReaderView (const VehicleCommandAck_DataReaderView &);
                VehicleCommandAck_DataReaderView & operator = (const VehicleCommandAck_DataReaderView &);
            };
        }

    }

}

#endif
