#ifndef _H_08D7877141F3C6D05A2D42E8B514DDF1_VehicleCommand__H_
#define _H_08D7877141F3C6D05A2D42E8B514DDF1_VehicleCommand__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace VehicleCommand_Constants
            {
                const ::DDS::UShort VEHICLE_CMD_CUSTOM_0_ = 0U;

                const ::DDS::UShort VEHICLE_CMD_CUSTOM_1_ = 1U;

                const ::DDS::UShort VEHICLE_CMD_CUSTOM_2_ = 2U;

                const ::DDS::UShort VEHICLE_CMD_NAV_WAYPOINT_ = 16U;

                const ::DDS::UShort VEHICLE_CMD_NAV_LOITER_UNLIM_ = 17U;

                const ::DDS::UShort VEHICLE_CMD_NAV_LOITER_TURNS_ = 18U;

                const ::DDS::UShort VEHICLE_CMD_NAV_LOITER_TIME_ = 19U;

                const ::DDS::UShort VEHICLE_CMD_NAV_RETURN_TO_LAUNCH_ = 20U;

                const ::DDS::UShort VEHICLE_CMD_NAV_LAND_ = 21U;

                const ::DDS::UShort VEHICLE_CMD_NAV_TAKEOFF_ = 22U;

                const ::DDS::UShort VEHICLE_CMD_NAV_PRECLAND_ = 23U;

                const ::DDS::UShort VEHICLE_CMD_DO_ORBIT_ = 34U;

                const ::DDS::UShort VEHICLE_CMD_NAV_ROI_ = 80U;

                const ::DDS::UShort VEHICLE_CMD_NAV_PATHPLANNING_ = 81U;

                const ::DDS::UShort VEHICLE_CMD_NAV_VTOL_TAKEOFF_ = 84U;

                const ::DDS::UShort VEHICLE_CMD_NAV_VTOL_LAND_ = 85U;

                const ::DDS::UShort VEHICLE_CMD_NAV_GUIDED_LIMITS_ = 90U;

                const ::DDS::UShort VEHICLE_CMD_NAV_GUIDED_MASTER_ = 91U;

                const ::DDS::UShort VEHICLE_CMD_NAV_GUIDED_ENABLE_ = 92U;

                const ::DDS::UShort VEHICLE_CMD_NAV_DELAY_ = 93U;

                const ::DDS::UShort VEHICLE_CMD_NAV_LAST_ = 95U;

                const ::DDS::UShort VEHICLE_CMD_CONDITION_DELAY_ = 112U;

                const ::DDS::UShort VEHICLE_CMD_CONDITION_CHANGE_ALT_ = 113U;

                const ::DDS::UShort VEHICLE_CMD_CONDITION_DISTANCE_ = 114U;

                const ::DDS::UShort VEHICLE_CMD_CONDITION_YAW_ = 115U;

                const ::DDS::UShort VEHICLE_CMD_CONDITION_LAST_ = 159U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_MODE_ = 176U;

                const ::DDS::UShort VEHICLE_CMD_DO_JUMP_ = 177U;

                const ::DDS::UShort VEHICLE_CMD_DO_CHANGE_SPEED_ = 178U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_HOME_ = 179U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_PARAMETER_ = 180U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_RELAY_ = 181U;

                const ::DDS::UShort VEHICLE_CMD_DO_REPEAT_RELAY_ = 182U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_SERVO_ = 183U;

                const ::DDS::UShort VEHICLE_CMD_DO_REPEAT_SERVO_ = 184U;

                const ::DDS::UShort VEHICLE_CMD_DO_FLIGHTTERMINATION_ = 185U;

                const ::DDS::UShort VEHICLE_CMD_DO_LAND_START_ = 189U;

                const ::DDS::UShort VEHICLE_CMD_DO_GO_AROUND_ = 191U;

                const ::DDS::UShort VEHICLE_CMD_DO_REPOSITION_ = 192U;

                const ::DDS::UShort VEHICLE_CMD_DO_PAUSE_CONTINUE_ = 193U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_ROI_LOCATION_ = 195U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_ROI_WPNEXT_OFFSET_ = 196U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_ROI_NONE_ = 197U;

                const ::DDS::UShort VEHICLE_CMD_DO_CONTROL_VIDEO_ = 200U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_ROI_ = 201U;

                const ::DDS::UShort VEHICLE_CMD_DO_DIGICAM_CONTROL_ = 203U;

                const ::DDS::UShort VEHICLE_CMD_DO_MOUNT_CONFIGURE_ = 204U;

                const ::DDS::UShort VEHICLE_CMD_DO_MOUNT_CONTROL_ = 205U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_CAM_TRIGG_DIST_ = 206U;

                const ::DDS::UShort VEHICLE_CMD_DO_FENCE_ENABLE_ = 207U;

                const ::DDS::UShort VEHICLE_CMD_DO_PARACHUTE_ = 208U;

                const ::DDS::UShort VEHICLE_CMD_DO_MOTOR_TEST_ = 209U;

                const ::DDS::UShort VEHICLE_CMD_DO_INVERTED_FLIGHT_ = 210U;

                const ::DDS::UShort VEHICLE_CMD_DO_SET_CAM_TRIGG_INTERVAL_ = 214U;

                const ::DDS::UShort VEHICLE_CMD_DO_MOUNT_CONTROL_QUAT_ = 220U;

                const ::DDS::UShort VEHICLE_CMD_DO_GUIDED_MASTER_ = 221U;

                const ::DDS::UShort VEHICLE_CMD_DO_GUIDED_LIMITS_ = 222U;

                const ::DDS::UShort VEHICLE_CMD_DO_LAST_ = 240U;

                const ::DDS::UShort VEHICLE_CMD_PREFLIGHT_CALIBRATION_ = 241U;

                const ::DDS::UShort PREFLIGHT_CALIBRATION_TEMPERATURE_CALIBRATION_ = 3U;

                const ::DDS::UShort VEHICLE_CMD_PREFLIGHT_SET_SENSOR_OFFSETS_ = 242U;

                const ::DDS::UShort VEHICLE_CMD_PREFLIGHT_STORAGE_ = 245U;

                const ::DDS::UShort VEHICLE_CMD_PREFLIGHT_REBOOT_SHUTDOWN_ = 246U;

                const ::DDS::UShort VEHICLE_CMD_MISSION_START_ = 300U;

                const ::DDS::UShort VEHICLE_CMD_COMPONENT_ARM_DISARM_ = 400U;

                const ::DDS::UShort VEHICLE_CMD_START_RX_PAIR_ = 500U;

                const ::DDS::UShort VEHICLE_CMD_SET_CAMERA_MODE_ = 530U;

                const ::DDS::UShort VEHICLE_CMD_DO_TRIGGER_CONTROL_ = 2003U;

                const ::DDS::UShort VEHICLE_CMD_DO_VTOL_TRANSITION_ = 3000U;

                const ::DDS::UShort VEHICLE_CMD_ARM_AUTHORIZATION_REQUEST_ = 3001U;

                const ::DDS::UShort VEHICLE_CMD_PAYLOAD_PREPARE_DEPLOY_ = 30001U;

                const ::DDS::UShort VEHICLE_CMD_PAYLOAD_CONTROL_DEPLOY_ = 30002U;

                const ::DDS::UShort VEHICLE_CMD_PREFLIGHT_UAVCAN_ = 243U;

                const ::DDS::UShort VEHICLE_CMD_LOGGING_START_ = 2510U;

                const ::DDS::UShort VEHICLE_CMD_LOGGING_STOP_ = 2511U;

                const ::DDS::UShort VEHICLE_CMD_CONTROL_HIGH_LATENCY_ = 2600U;

                const ::DDS::Octet VEHICLE_CMD_RESULT_ACCEPTED_ = 0;

                const ::DDS::Octet VEHICLE_CMD_RESULT_TEMPORARILY_REJECTED_ = 1;

                const ::DDS::Octet VEHICLE_CMD_RESULT_DENIED_ = 2;

                const ::DDS::Octet VEHICLE_CMD_RESULT_UNSUPPORTED_ = 3;

                const ::DDS::Octet VEHICLE_CMD_RESULT_FAILED_ = 4;

                const ::DDS::Octet VEHICLE_CMD_RESULT_IN_PROGRESS_ = 5;

                const ::DDS::Octet VEHICLE_CMD_RESULT_ENUM_END_ = 6;

                const ::DDS::Octet VEHICLE_MOUNT_MODE_RETRACT_ = 0;

                const ::DDS::Octet VEHICLE_MOUNT_MODE_NEUTRAL_ = 1;

                const ::DDS::Octet VEHICLE_MOUNT_MODE_MAVLINK_TARGETING_ = 2;

                const ::DDS::Octet VEHICLE_MOUNT_MODE_RC_TARGETING_ = 3;

                const ::DDS::Octet VEHICLE_MOUNT_MODE_GPS_POINT_ = 4;

                const ::DDS::Octet VEHICLE_MOUNT_MODE_ENUM_END_ = 5;

                const ::DDS::Octet VEHICLE_ROI_NONE_ = 0;

                const ::DDS::Octet VEHICLE_ROI_WPNEXT_ = 1;

                const ::DDS::Octet VEHICLE_ROI_WPINDEX_ = 2;

                const ::DDS::Octet VEHICLE_ROI_LOCATION_ = 3;

                const ::DDS::Octet VEHICLE_ROI_TARGET_ = 4;

                const ::DDS::Octet VEHICLE_ROI_ENUM_END_ = 5;

                const ::DDS::Octet ORB_QUEUE_LENGTH_ = 3;

            }

            struct  VehicleCommand_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Float param1_;
                ::DDS::Float param2_;
                ::DDS::Float param3_;
                ::DDS::Float param4_;
                ::DDS::Double param5_;
                ::DDS::Double param6_;
                ::DDS::Float param7_;
                ::DDS::UShort command_;
                ::DDS::Octet target_system_;
                ::DDS::Octet target_component_;
                ::DDS::Octet source_system_;
                ::DDS::Octet source_component_;
                ::DDS::Octet confirmation_;
                ::DDS::Boolean from_external_;
            };

            typedef DDS_DCPSStruct_var<VehicleCommand_> VehicleCommand__var;
            typedef VehicleCommand_& VehicleCommand__out;

        }

    }

}

#endif /* _H_08D7877141F3C6D05A2D42E8B514DDF1_VehicleCommand__H_ */
