#ifndef _H_55F039F3DD10D21A8B8681CEADB28A8A_VehicleConstraints_DCPS_H_
#define _H_55F039F3DD10D21A8B8681CEADB28A8A_VehicleConstraints_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleConstraints_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleConstraints_TypeSupportInterface;

            typedef VehicleConstraints_TypeSupportInterface * VehicleConstraints_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleConstraints_TypeSupportInterface> VehicleConstraints_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleConstraints_TypeSupportInterface> VehicleConstraints_TypeSupportInterface_out;


            class VehicleConstraints_DataWriter;

            typedef VehicleConstraints_DataWriter * VehicleConstraints_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleConstraints_DataWriter> VehicleConstraints_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleConstraints_DataWriter> VehicleConstraints_DataWriter_out;


            class VehicleConstraints_DataReader;

            typedef VehicleConstraints_DataReader * VehicleConstraints_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleConstraints_DataReader> VehicleConstraints_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleConstraints_DataReader> VehicleConstraints_DataReader_out;


            class VehicleConstraints_DataReaderView;

            typedef VehicleConstraints_DataReaderView * VehicleConstraints_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleConstraints_DataReaderView> VehicleConstraints_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleConstraints_DataReaderView> VehicleConstraints_DataReaderView_out;

            struct VehicleConstraints_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleConstraints_, struct VehicleConstraints_Seq_uniq_> VehicleConstraints_Seq;
            typedef DDS_DCPSSequence_var < VehicleConstraints_Seq> VehicleConstraints_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleConstraints_Seq> VehicleConstraints_Seq_out;

            class  VehicleConstraints_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleConstraints_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleConstraints_TypeSupportInterface_var _var_type;

                static VehicleConstraints_TypeSupportInterface_ptr _duplicate (VehicleConstraints_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleConstraints_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleConstraints_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleConstraints_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleConstraints_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleConstraints_TypeSupportInterface () {};
                ~VehicleConstraints_TypeSupportInterface () {};
            private:
                VehicleConstraints_TypeSupportInterface (const VehicleConstraints_TypeSupportInterface &);
                VehicleConstraints_TypeSupportInterface & operator = (const VehicleConstraints_TypeSupportInterface &);
            };

            class  VehicleConstraints_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleConstraints_DataWriter_ptr _ptr_type;
                typedef VehicleConstraints_DataWriter_var _var_type;

                static VehicleConstraints_DataWriter_ptr _duplicate (VehicleConstraints_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleConstraints_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleConstraints_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleConstraints_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleConstraints_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleConstraints_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleConstraints_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleConstraints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleConstraints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleConstraints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleConstraints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleConstraints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleConstraints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleConstraints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleConstraints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleConstraints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleConstraints_& instance_data) = 0;

            protected:
                VehicleConstraints_DataWriter () {};
                ~VehicleConstraints_DataWriter () {};
            private:
                VehicleConstraints_DataWriter (const VehicleConstraints_DataWriter &);
                VehicleConstraints_DataWriter & operator = (const VehicleConstraints_DataWriter &);
            };

            class  VehicleConstraints_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleConstraints_DataReader_ptr _ptr_type;
                typedef VehicleConstraints_DataReader_var _var_type;

                static VehicleConstraints_DataReader_ptr _duplicate (VehicleConstraints_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleConstraints_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleConstraints_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleConstraints_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleConstraints_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleConstraints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleConstraints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleConstraints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleConstraints_& instance) = 0;

            protected:
                VehicleConstraints_DataReader () {};
                ~VehicleConstraints_DataReader () {};
            private:
                VehicleConstraints_DataReader (const VehicleConstraints_DataReader &);
                VehicleConstraints_DataReader & operator = (const VehicleConstraints_DataReader &);
            };

            class  VehicleConstraints_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleConstraints_DataReaderView_ptr _ptr_type;
                typedef VehicleConstraints_DataReaderView_var _var_type;

                static VehicleConstraints_DataReaderView_ptr _duplicate (VehicleConstraints_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleConstraints_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleConstraints_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleConstraints_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleConstraints_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleConstraints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleConstraints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleConstraints_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleConstraints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleConstraints_& instance) = 0;

            protected:
                VehicleConstraints_DataReaderView () {};
                ~VehicleConstraints_DataReaderView () {};
            private:
                VehicleConstraints_DataReaderView (const VehicleConstraints_DataReaderView &);
                VehicleConstraints_DataReaderView & operator = (const VehicleConstraints_DataReaderView &);
            };
        }

    }

}

#endif
