#ifndef _H_A3A36BE5599B10F8E84C77491CEB46B9_VehicleControlMode__H_
#define _H_A3A36BE5599B10F8E84C77491CEB46B9_VehicleControlMode__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleControlMode_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Boolean flag_armed_;
                ::DDS::Boolean flag_external_manual_override_ok_;
                ::DDS::Boolean flag_control_manual_enabled_;
                ::DDS::Boolean flag_control_auto_enabled_;
                ::DDS::Boolean flag_control_offboard_enabled_;
                ::DDS::Boolean flag_control_rates_enabled_;
                ::DDS::Boolean flag_control_attitude_enabled_;
                ::DDS::Boolean flag_control_yawrate_override_enabled_;
                ::DDS::Boolean flag_control_rattitude_enabled_;
                ::DDS::Boolean flag_control_force_enabled_;
                ::DDS::Boolean flag_control_acceleration_enabled_;
                ::DDS::Boolean flag_control_velocity_enabled_;
                ::DDS::Boolean flag_control_position_enabled_;
                ::DDS::Boolean flag_control_altitude_enabled_;
                ::DDS::Boolean flag_control_climb_rate_enabled_;
                ::DDS::Boolean flag_control_termination_enabled_;
                ::DDS::Boolean flag_control_fixed_hdg_enabled_;
            };

            typedef DDS_DCPSStruct_var<VehicleControlMode_> VehicleControlMode__var;
            typedef VehicleControlMode_& VehicleControlMode__out;

        }

    }

}

#endif /* _H_A3A36BE5599B10F8E84C77491CEB46B9_VehicleControlMode__H_ */
