#ifndef _H_5A23C4970F1517462D0F7065DACFE9C1_VehicleGlobalPositionGroundtruth_DCPS_H_
#define _H_5A23C4970F1517462D0F7065DACFE9C1_VehicleGlobalPositionGroundtruth_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleGlobalPositionGroundtruth_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleGlobalPositionGroundtruth_TypeSupportInterface;

            typedef VehicleGlobalPositionGroundtruth_TypeSupportInterface * VehicleGlobalPositionGroundtruth_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleGlobalPositionGroundtruth_TypeSupportInterface> VehicleGlobalPositionGroundtruth_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleGlobalPositionGroundtruth_TypeSupportInterface> VehicleGlobalPositionGroundtruth_TypeSupportInterface_out;


            class VehicleGlobalPositionGroundtruth_DataWriter;

            typedef VehicleGlobalPositionGroundtruth_DataWriter * VehicleGlobalPositionGroundtruth_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleGlobalPositionGroundtruth_DataWriter> VehicleGlobalPositionGroundtruth_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleGlobalPositionGroundtruth_DataWriter> VehicleGlobalPositionGroundtruth_DataWriter_out;


            class VehicleGlobalPositionGroundtruth_DataReader;

            typedef VehicleGlobalPositionGroundtruth_DataReader * VehicleGlobalPositionGroundtruth_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleGlobalPositionGroundtruth_DataReader> VehicleGlobalPositionGroundtruth_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleGlobalPositionGroundtruth_DataReader> VehicleGlobalPositionGroundtruth_DataReader_out;


            class VehicleGlobalPositionGroundtruth_DataReaderView;

            typedef VehicleGlobalPositionGroundtruth_DataReaderView * VehicleGlobalPositionGroundtruth_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleGlobalPositionGroundtruth_DataReaderView> VehicleGlobalPositionGroundtruth_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleGlobalPositionGroundtruth_DataReaderView> VehicleGlobalPositionGroundtruth_DataReaderView_out;

            struct VehicleGlobalPositionGroundtruth_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleGlobalPositionGroundtruth_, struct VehicleGlobalPositionGroundtruth_Seq_uniq_> VehicleGlobalPositionGroundtruth_Seq;
            typedef DDS_DCPSSequence_var < VehicleGlobalPositionGroundtruth_Seq> VehicleGlobalPositionGroundtruth_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleGlobalPositionGroundtruth_Seq> VehicleGlobalPositionGroundtruth_Seq_out;

            class  VehicleGlobalPositionGroundtruth_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleGlobalPositionGroundtruth_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleGlobalPositionGroundtruth_TypeSupportInterface_var _var_type;

                static VehicleGlobalPositionGroundtruth_TypeSupportInterface_ptr _duplicate (VehicleGlobalPositionGroundtruth_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGlobalPositionGroundtruth_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGlobalPositionGroundtruth_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGlobalPositionGroundtruth_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGlobalPositionGroundtruth_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleGlobalPositionGroundtruth_TypeSupportInterface () {};
                ~VehicleGlobalPositionGroundtruth_TypeSupportInterface () {};
            private:
                VehicleGlobalPositionGroundtruth_TypeSupportInterface (const VehicleGlobalPositionGroundtruth_TypeSupportInterface &);
                VehicleGlobalPositionGroundtruth_TypeSupportInterface & operator = (const VehicleGlobalPositionGroundtruth_TypeSupportInterface &);
            };

            class  VehicleGlobalPositionGroundtruth_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleGlobalPositionGroundtruth_DataWriter_ptr _ptr_type;
                typedef VehicleGlobalPositionGroundtruth_DataWriter_var _var_type;

                static VehicleGlobalPositionGroundtruth_DataWriter_ptr _duplicate (VehicleGlobalPositionGroundtruth_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGlobalPositionGroundtruth_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGlobalPositionGroundtruth_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGlobalPositionGroundtruth_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGlobalPositionGroundtruth_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleGlobalPositionGroundtruth_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleGlobalPositionGroundtruth_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleGlobalPositionGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleGlobalPositionGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleGlobalPositionGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleGlobalPositionGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleGlobalPositionGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleGlobalPositionGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleGlobalPositionGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleGlobalPositionGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleGlobalPositionGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGlobalPositionGroundtruth_& instance_data) = 0;

            protected:
                VehicleGlobalPositionGroundtruth_DataWriter () {};
                ~VehicleGlobalPositionGroundtruth_DataWriter () {};
            private:
                VehicleGlobalPositionGroundtruth_DataWriter (const VehicleGlobalPositionGroundtruth_DataWriter &);
                VehicleGlobalPositionGroundtruth_DataWriter & operator = (const VehicleGlobalPositionGroundtruth_DataWriter &);
            };

            class  VehicleGlobalPositionGroundtruth_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleGlobalPositionGroundtruth_DataReader_ptr _ptr_type;
                typedef VehicleGlobalPositionGroundtruth_DataReader_var _var_type;

                static VehicleGlobalPositionGroundtruth_DataReader_ptr _duplicate (VehicleGlobalPositionGroundtruth_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGlobalPositionGroundtruth_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGlobalPositionGroundtruth_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGlobalPositionGroundtruth_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGlobalPositionGroundtruth_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleGlobalPositionGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleGlobalPositionGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleGlobalPositionGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGlobalPositionGroundtruth_& instance) = 0;

            protected:
                VehicleGlobalPositionGroundtruth_DataReader () {};
                ~VehicleGlobalPositionGroundtruth_DataReader () {};
            private:
                VehicleGlobalPositionGroundtruth_DataReader (const VehicleGlobalPositionGroundtruth_DataReader &);
                VehicleGlobalPositionGroundtruth_DataReader & operator = (const VehicleGlobalPositionGroundtruth_DataReader &);
            };

            class  VehicleGlobalPositionGroundtruth_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleGlobalPositionGroundtruth_DataReaderView_ptr _ptr_type;
                typedef VehicleGlobalPositionGroundtruth_DataReaderView_var _var_type;

                static VehicleGlobalPositionGroundtruth_DataReaderView_ptr _duplicate (VehicleGlobalPositionGroundtruth_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGlobalPositionGroundtruth_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGlobalPositionGroundtruth_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGlobalPositionGroundtruth_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGlobalPositionGroundtruth_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleGlobalPositionGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleGlobalPositionGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleGlobalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleGlobalPositionGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGlobalPositionGroundtruth_& instance) = 0;

            protected:
                VehicleGlobalPositionGroundtruth_DataReaderView () {};
                ~VehicleGlobalPositionGroundtruth_DataReaderView () {};
            private:
                VehicleGlobalPositionGroundtruth_DataReaderView (const VehicleGlobalPositionGroundtruth_DataReaderView &);
                VehicleGlobalPositionGroundtruth_DataReaderView & operator = (const VehicleGlobalPositionGroundtruth_DataReaderView &);
            };
        }

    }

}

#endif
