#ifndef _H_52A8ADF71669655F95956FDBDCDDFE57_VehicleGpsPosition_DCPS_H_
#define _H_52A8ADF71669655F95956FDBDCDDFE57_VehicleGpsPosition_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleGpsPosition_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleGpsPosition_TypeSupportInterface;

            typedef VehicleGpsPosition_TypeSupportInterface * VehicleGpsPosition_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleGpsPosition_TypeSupportInterface> VehicleGpsPosition_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleGpsPosition_TypeSupportInterface> VehicleGpsPosition_TypeSupportInterface_out;


            class VehicleGpsPosition_DataWriter;

            typedef VehicleGpsPosition_DataWriter * VehicleGpsPosition_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleGpsPosition_DataWriter> VehicleGpsPosition_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleGpsPosition_DataWriter> VehicleGpsPosition_DataWriter_out;


            class VehicleGpsPosition_DataReader;

            typedef VehicleGpsPosition_DataReader * VehicleGpsPosition_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleGpsPosition_DataReader> VehicleGpsPosition_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleGpsPosition_DataReader> VehicleGpsPosition_DataReader_out;


            class VehicleGpsPosition_DataReaderView;

            typedef VehicleGpsPosition_DataReaderView * VehicleGpsPosition_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleGpsPosition_DataReaderView> VehicleGpsPosition_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleGpsPosition_DataReaderView> VehicleGpsPosition_DataReaderView_out;

            struct VehicleGpsPosition_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleGpsPosition_, struct VehicleGpsPosition_Seq_uniq_> VehicleGpsPosition_Seq;
            typedef DDS_DCPSSequence_var < VehicleGpsPosition_Seq> VehicleGpsPosition_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleGpsPosition_Seq> VehicleGpsPosition_Seq_out;

            class  VehicleGpsPosition_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleGpsPosition_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleGpsPosition_TypeSupportInterface_var _var_type;

                static VehicleGpsPosition_TypeSupportInterface_ptr _duplicate (VehicleGpsPosition_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGpsPosition_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGpsPosition_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGpsPosition_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGpsPosition_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleGpsPosition_TypeSupportInterface () {};
                ~VehicleGpsPosition_TypeSupportInterface () {};
            private:
                VehicleGpsPosition_TypeSupportInterface (const VehicleGpsPosition_TypeSupportInterface &);
                VehicleGpsPosition_TypeSupportInterface & operator = (const VehicleGpsPosition_TypeSupportInterface &);
            };

            class  VehicleGpsPosition_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleGpsPosition_DataWriter_ptr _ptr_type;
                typedef VehicleGpsPosition_DataWriter_var _var_type;

                static VehicleGpsPosition_DataWriter_ptr _duplicate (VehicleGpsPosition_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGpsPosition_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGpsPosition_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGpsPosition_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGpsPosition_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleGpsPosition_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleGpsPosition_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleGpsPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleGpsPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleGpsPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleGpsPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleGpsPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleGpsPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleGpsPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleGpsPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleGpsPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGpsPosition_& instance_data) = 0;

            protected:
                VehicleGpsPosition_DataWriter () {};
                ~VehicleGpsPosition_DataWriter () {};
            private:
                VehicleGpsPosition_DataWriter (const VehicleGpsPosition_DataWriter &);
                VehicleGpsPosition_DataWriter & operator = (const VehicleGpsPosition_DataWriter &);
            };

            class  VehicleGpsPosition_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleGpsPosition_DataReader_ptr _ptr_type;
                typedef VehicleGpsPosition_DataReader_var _var_type;

                static VehicleGpsPosition_DataReader_ptr _duplicate (VehicleGpsPosition_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGpsPosition_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGpsPosition_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGpsPosition_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGpsPosition_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleGpsPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleGpsPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleGpsPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGpsPosition_& instance) = 0;

            protected:
                VehicleGpsPosition_DataReader () {};
                ~VehicleGpsPosition_DataReader () {};
            private:
                VehicleGpsPosition_DataReader (const VehicleGpsPosition_DataReader &);
                VehicleGpsPosition_DataReader & operator = (const VehicleGpsPosition_DataReader &);
            };

            class  VehicleGpsPosition_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleGpsPosition_DataReaderView_ptr _ptr_type;
                typedef VehicleGpsPosition_DataReaderView_var _var_type;

                static VehicleGpsPosition_DataReaderView_ptr _duplicate (VehicleGpsPosition_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleGpsPosition_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleGpsPosition_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleGpsPosition_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleGpsPosition_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleGpsPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleGpsPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleGpsPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleGpsPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleGpsPosition_& instance) = 0;

            protected:
                VehicleGpsPosition_DataReaderView () {};
                ~VehicleGpsPosition_DataReaderView () {};
            private:
                VehicleGpsPosition_DataReaderView (const VehicleGpsPosition_DataReaderView &);
                VehicleGpsPosition_DataReaderView & operator = (const VehicleGpsPosition_DataReaderView &);
            };
        }

    }

}

#endif
