#ifndef _H_DE4688BFD780F47DFE9EB117A01E6DC2_VehicleLocalPositionGroundtruth_DCPS_H_
#define _H_DE4688BFD780F47DFE9EB117A01E6DC2_VehicleLocalPositionGroundtruth_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleLocalPositionGroundtruth_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleLocalPositionGroundtruth_TypeSupportInterface;

            typedef VehicleLocalPositionGroundtruth_TypeSupportInterface * VehicleLocalPositionGroundtruth_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleLocalPositionGroundtruth_TypeSupportInterface> VehicleLocalPositionGroundtruth_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleLocalPositionGroundtruth_TypeSupportInterface> VehicleLocalPositionGroundtruth_TypeSupportInterface_out;


            class VehicleLocalPositionGroundtruth_DataWriter;

            typedef VehicleLocalPositionGroundtruth_DataWriter * VehicleLocalPositionGroundtruth_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleLocalPositionGroundtruth_DataWriter> VehicleLocalPositionGroundtruth_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleLocalPositionGroundtruth_DataWriter> VehicleLocalPositionGroundtruth_DataWriter_out;


            class VehicleLocalPositionGroundtruth_DataReader;

            typedef VehicleLocalPositionGroundtruth_DataReader * VehicleLocalPositionGroundtruth_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleLocalPositionGroundtruth_DataReader> VehicleLocalPositionGroundtruth_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleLocalPositionGroundtruth_DataReader> VehicleLocalPositionGroundtruth_DataReader_out;


            class VehicleLocalPositionGroundtruth_DataReaderView;

            typedef VehicleLocalPositionGroundtruth_DataReaderView * VehicleLocalPositionGroundtruth_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleLocalPositionGroundtruth_DataReaderView> VehicleLocalPositionGroundtruth_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleLocalPositionGroundtruth_DataReaderView> VehicleLocalPositionGroundtruth_DataReaderView_out;

            struct VehicleLocalPositionGroundtruth_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleLocalPositionGroundtruth_, struct VehicleLocalPositionGroundtruth_Seq_uniq_> VehicleLocalPositionGroundtruth_Seq;
            typedef DDS_DCPSSequence_var < VehicleLocalPositionGroundtruth_Seq> VehicleLocalPositionGroundtruth_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleLocalPositionGroundtruth_Seq> VehicleLocalPositionGroundtruth_Seq_out;

            class  VehicleLocalPositionGroundtruth_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleLocalPositionGroundtruth_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleLocalPositionGroundtruth_TypeSupportInterface_var _var_type;

                static VehicleLocalPositionGroundtruth_TypeSupportInterface_ptr _duplicate (VehicleLocalPositionGroundtruth_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLocalPositionGroundtruth_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionGroundtruth_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionGroundtruth_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLocalPositionGroundtruth_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleLocalPositionGroundtruth_TypeSupportInterface () {};
                ~VehicleLocalPositionGroundtruth_TypeSupportInterface () {};
            private:
                VehicleLocalPositionGroundtruth_TypeSupportInterface (const VehicleLocalPositionGroundtruth_TypeSupportInterface &);
                VehicleLocalPositionGroundtruth_TypeSupportInterface & operator = (const VehicleLocalPositionGroundtruth_TypeSupportInterface &);
            };

            class  VehicleLocalPositionGroundtruth_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleLocalPositionGroundtruth_DataWriter_ptr _ptr_type;
                typedef VehicleLocalPositionGroundtruth_DataWriter_var _var_type;

                static VehicleLocalPositionGroundtruth_DataWriter_ptr _duplicate (VehicleLocalPositionGroundtruth_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLocalPositionGroundtruth_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionGroundtruth_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionGroundtruth_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLocalPositionGroundtruth_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleLocalPositionGroundtruth_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleLocalPositionGroundtruth_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleLocalPositionGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleLocalPositionGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleLocalPositionGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleLocalPositionGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleLocalPositionGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleLocalPositionGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleLocalPositionGroundtruth_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleLocalPositionGroundtruth_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleLocalPositionGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLocalPositionGroundtruth_& instance_data) = 0;

            protected:
                VehicleLocalPositionGroundtruth_DataWriter () {};
                ~VehicleLocalPositionGroundtruth_DataWriter () {};
            private:
                VehicleLocalPositionGroundtruth_DataWriter (const VehicleLocalPositionGroundtruth_DataWriter &);
                VehicleLocalPositionGroundtruth_DataWriter & operator = (const VehicleLocalPositionGroundtruth_DataWriter &);
            };

            class  VehicleLocalPositionGroundtruth_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleLocalPositionGroundtruth_DataReader_ptr _ptr_type;
                typedef VehicleLocalPositionGroundtruth_DataReader_var _var_type;

                static VehicleLocalPositionGroundtruth_DataReader_ptr _duplicate (VehicleLocalPositionGroundtruth_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLocalPositionGroundtruth_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionGroundtruth_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionGroundtruth_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLocalPositionGroundtruth_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleLocalPositionGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleLocalPositionGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleLocalPositionGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLocalPositionGroundtruth_& instance) = 0;

            protected:
                VehicleLocalPositionGroundtruth_DataReader () {};
                ~VehicleLocalPositionGroundtruth_DataReader () {};
            private:
                VehicleLocalPositionGroundtruth_DataReader (const VehicleLocalPositionGroundtruth_DataReader &);
                VehicleLocalPositionGroundtruth_DataReader & operator = (const VehicleLocalPositionGroundtruth_DataReader &);
            };

            class  VehicleLocalPositionGroundtruth_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleLocalPositionGroundtruth_DataReaderView_ptr _ptr_type;
                typedef VehicleLocalPositionGroundtruth_DataReaderView_var _var_type;

                static VehicleLocalPositionGroundtruth_DataReaderView_ptr _duplicate (VehicleLocalPositionGroundtruth_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleLocalPositionGroundtruth_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionGroundtruth_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleLocalPositionGroundtruth_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleLocalPositionGroundtruth_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleLocalPositionGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleLocalPositionGroundtruth_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleLocalPositionGroundtruth_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleLocalPositionGroundtruth_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleLocalPositionGroundtruth_& instance) = 0;

            protected:
                VehicleLocalPositionGroundtruth_DataReaderView () {};
                ~VehicleLocalPositionGroundtruth_DataReaderView () {};
            private:
                VehicleLocalPositionGroundtruth_DataReaderView (const VehicleLocalPositionGroundtruth_DataReaderView &);
                VehicleLocalPositionGroundtruth_DataReaderView & operator = (const VehicleLocalPositionGroundtruth_DataReaderView &);
            };
        }

    }

}

#endif
