#ifndef _H_395BCB6720A13D6EE76B9C74F10A766A_VehicleLocalPositionSetpoint__H_
#define _H_395BCB6720A13D6EE76B9C74F10A766A_VehicleLocalPositionSetpoint__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleLocalPositionSetpoint_
            {
                struct _acceleration__uniq_{};
                typedef ::DDS::Float _acceleration__slice;
                typedef ::DDS::Float _acceleration_[3];
                typedef DDS_DCPS_FArray_var< _acceleration_, _acceleration__slice, struct _acceleration__uniq_ > _acceleration__var;
                typedef _acceleration_ _acceleration__out;
                typedef DDS_DCPS_Array_forany< _acceleration_, _acceleration__slice, struct _acceleration__uniq_ > _acceleration__forany;
                static _acceleration__slice *_acceleration__alloc();
                static void _acceleration__free(_acceleration__slice *);
                static void _acceleration__copy(_acceleration__slice *to, const _acceleration__slice *from);
                static _acceleration__slice *_acceleration__dup(const _acceleration__slice *from);
                struct _jerk__uniq_{};
                typedef ::DDS::Float _jerk__slice;
                typedef ::DDS::Float _jerk_[3];
                typedef DDS_DCPS_FArray_var< _jerk_, _jerk__slice, struct _jerk__uniq_ > _jerk__var;
                typedef _jerk_ _jerk__out;
                typedef DDS_DCPS_Array_forany< _jerk_, _jerk__slice, struct _jerk__uniq_ > _jerk__forany;
                static _jerk__slice *_jerk__alloc();
                static void _jerk__free(_jerk__slice *);
                static void _jerk__copy(_jerk__slice *to, const _jerk__slice *from);
                static _jerk__slice *_jerk__dup(const _jerk__slice *from);
                struct _thrust__uniq_{};
                typedef ::DDS::Float _thrust__slice;
                typedef ::DDS::Float _thrust_[3];
                typedef DDS_DCPS_FArray_var< _thrust_, _thrust__slice, struct _thrust__uniq_ > _thrust__var;
                typedef _thrust_ _thrust__out;
                typedef DDS_DCPS_Array_forany< _thrust_, _thrust__slice, struct _thrust__uniq_ > _thrust__forany;
                static _thrust__slice *_thrust__alloc();
                static void _thrust__free(_thrust__slice *);
                static void _thrust__copy(_thrust__slice *to, const _thrust__slice *from);
                static _thrust__slice *_thrust__dup(const _thrust__slice *from);
                ::DDS::ULongLong timestamp_;
                ::DDS::Float x_;
                ::DDS::Float y_;
                ::DDS::Float z_;
                ::DDS::Float yaw_;
                ::DDS::Float yawspeed_;
                ::DDS::Float vx_;
                ::DDS::Float vy_;
                ::DDS::Float vz_;
                _acceleration_ acceleration_;
                _jerk_ jerk_;
                _thrust_ thrust_;
            };

            typedef DDS_DCPSStruct_var<VehicleLocalPositionSetpoint_> VehicleLocalPositionSetpoint__var;
            typedef VehicleLocalPositionSetpoint_& VehicleLocalPositionSetpoint__out;

        }

    }

}

#endif /* _H_395BCB6720A13D6EE76B9C74F10A766A_VehicleLocalPositionSetpoint__H_ */
