#ifndef _H_22E156B6D8DC7BA1ACC6368091EBEE78_VehicleMagnetometer_DCPS_H_
#define _H_22E156B6D8DC7BA1ACC6368091EBEE78_VehicleMagnetometer_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleMagnetometer_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleMagnetometer_TypeSupportInterface;

            typedef VehicleMagnetometer_TypeSupportInterface * VehicleMagnetometer_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleMagnetometer_TypeSupportInterface> VehicleMagnetometer_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleMagnetometer_TypeSupportInterface> VehicleMagnetometer_TypeSupportInterface_out;


            class VehicleMagnetometer_DataWriter;

            typedef VehicleMagnetometer_DataWriter * VehicleMagnetometer_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleMagnetometer_DataWriter> VehicleMagnetometer_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleMagnetometer_DataWriter> VehicleMagnetometer_DataWriter_out;


            class VehicleMagnetometer_DataReader;

            typedef VehicleMagnetometer_DataReader * VehicleMagnetometer_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleMagnetometer_DataReader> VehicleMagnetometer_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleMagnetometer_DataReader> VehicleMagnetometer_DataReader_out;


            class VehicleMagnetometer_DataReaderView;

            typedef VehicleMagnetometer_DataReaderView * VehicleMagnetometer_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleMagnetometer_DataReaderView> VehicleMagnetometer_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleMagnetometer_DataReaderView> VehicleMagnetometer_DataReaderView_out;

            struct VehicleMagnetometer_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleMagnetometer_, struct VehicleMagnetometer_Seq_uniq_> VehicleMagnetometer_Seq;
            typedef DDS_DCPSSequence_var < VehicleMagnetometer_Seq> VehicleMagnetometer_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleMagnetometer_Seq> VehicleMagnetometer_Seq_out;

            class  VehicleMagnetometer_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleMagnetometer_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleMagnetometer_TypeSupportInterface_var _var_type;

                static VehicleMagnetometer_TypeSupportInterface_ptr _duplicate (VehicleMagnetometer_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleMagnetometer_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleMagnetometer_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleMagnetometer_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleMagnetometer_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleMagnetometer_TypeSupportInterface () {};
                ~VehicleMagnetometer_TypeSupportInterface () {};
            private:
                VehicleMagnetometer_TypeSupportInterface (const VehicleMagnetometer_TypeSupportInterface &);
                VehicleMagnetometer_TypeSupportInterface & operator = (const VehicleMagnetometer_TypeSupportInterface &);
            };

            class  VehicleMagnetometer_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleMagnetometer_DataWriter_ptr _ptr_type;
                typedef VehicleMagnetometer_DataWriter_var _var_type;

                static VehicleMagnetometer_DataWriter_ptr _duplicate (VehicleMagnetometer_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleMagnetometer_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleMagnetometer_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleMagnetometer_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleMagnetometer_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleMagnetometer_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleMagnetometer_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleMagnetometer_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleMagnetometer_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleMagnetometer_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleMagnetometer_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleMagnetometer_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleMagnetometer_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleMagnetometer_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleMagnetometer_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleMagnetometer_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleMagnetometer_& instance_data) = 0;

            protected:
                VehicleMagnetometer_DataWriter () {};
                ~VehicleMagnetometer_DataWriter () {};
            private:
                VehicleMagnetometer_DataWriter (const VehicleMagnetometer_DataWriter &);
                VehicleMagnetometer_DataWriter & operator = (const VehicleMagnetometer_DataWriter &);
            };

            class  VehicleMagnetometer_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleMagnetometer_DataReader_ptr _ptr_type;
                typedef VehicleMagnetometer_DataReader_var _var_type;

                static VehicleMagnetometer_DataReader_ptr _duplicate (VehicleMagnetometer_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleMagnetometer_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleMagnetometer_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleMagnetometer_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleMagnetometer_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleMagnetometer_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleMagnetometer_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleMagnetometer_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleMagnetometer_& instance) = 0;

            protected:
                VehicleMagnetometer_DataReader () {};
                ~VehicleMagnetometer_DataReader () {};
            private:
                VehicleMagnetometer_DataReader (const VehicleMagnetometer_DataReader &);
                VehicleMagnetometer_DataReader & operator = (const VehicleMagnetometer_DataReader &);
            };

            class  VehicleMagnetometer_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleMagnetometer_DataReaderView_ptr _ptr_type;
                typedef VehicleMagnetometer_DataReaderView_var _var_type;

                static VehicleMagnetometer_DataReaderView_ptr _duplicate (VehicleMagnetometer_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleMagnetometer_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleMagnetometer_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleMagnetometer_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleMagnetometer_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleMagnetometer_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleMagnetometer_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleMagnetometer_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleMagnetometer_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleMagnetometer_& instance) = 0;

            protected:
                VehicleMagnetometer_DataReaderView () {};
                ~VehicleMagnetometer_DataReaderView () {};
            private:
                VehicleMagnetometer_DataReaderView (const VehicleMagnetometer_DataReaderView &);
                VehicleMagnetometer_DataReaderView & operator = (const VehicleMagnetometer_DataReaderView &);
            };
        }

    }

}

#endif
