#ifndef _H_54914A563BBFFFED6F63A67A9906961F_VehicleRatesSetpoint_DCPS_H_
#define _H_54914A563BBFFFED6F63A67A9906961F_VehicleRatesSetpoint_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleRatesSetpoint_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleRatesSetpoint_TypeSupportInterface;

            typedef VehicleRatesSetpoint_TypeSupportInterface * VehicleRatesSetpoint_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleRatesSetpoint_TypeSupportInterface> VehicleRatesSetpoint_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleRatesSetpoint_TypeSupportInterface> VehicleRatesSetpoint_TypeSupportInterface_out;


            class VehicleRatesSetpoint_DataWriter;

            typedef VehicleRatesSetpoint_DataWriter * VehicleRatesSetpoint_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleRatesSetpoint_DataWriter> VehicleRatesSetpoint_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleRatesSetpoint_DataWriter> VehicleRatesSetpoint_DataWriter_out;


            class VehicleRatesSetpoint_DataReader;

            typedef VehicleRatesSetpoint_DataReader * VehicleRatesSetpoint_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleRatesSetpoint_DataReader> VehicleRatesSetpoint_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleRatesSetpoint_DataReader> VehicleRatesSetpoint_DataReader_out;


            class VehicleRatesSetpoint_DataReaderView;

            typedef VehicleRatesSetpoint_DataReaderView * VehicleRatesSetpoint_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleRatesSetpoint_DataReaderView> VehicleRatesSetpoint_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleRatesSetpoint_DataReaderView> VehicleRatesSetpoint_DataReaderView_out;

            struct VehicleRatesSetpoint_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleRatesSetpoint_, struct VehicleRatesSetpoint_Seq_uniq_> VehicleRatesSetpoint_Seq;
            typedef DDS_DCPSSequence_var < VehicleRatesSetpoint_Seq> VehicleRatesSetpoint_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleRatesSetpoint_Seq> VehicleRatesSetpoint_Seq_out;

            class  VehicleRatesSetpoint_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleRatesSetpoint_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleRatesSetpoint_TypeSupportInterface_var _var_type;

                static VehicleRatesSetpoint_TypeSupportInterface_ptr _duplicate (VehicleRatesSetpoint_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleRatesSetpoint_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleRatesSetpoint_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleRatesSetpoint_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleRatesSetpoint_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleRatesSetpoint_TypeSupportInterface () {};
                ~VehicleRatesSetpoint_TypeSupportInterface () {};
            private:
                VehicleRatesSetpoint_TypeSupportInterface (const VehicleRatesSetpoint_TypeSupportInterface &);
                VehicleRatesSetpoint_TypeSupportInterface & operator = (const VehicleRatesSetpoint_TypeSupportInterface &);
            };

            class  VehicleRatesSetpoint_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleRatesSetpoint_DataWriter_ptr _ptr_type;
                typedef VehicleRatesSetpoint_DataWriter_var _var_type;

                static VehicleRatesSetpoint_DataWriter_ptr _duplicate (VehicleRatesSetpoint_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleRatesSetpoint_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleRatesSetpoint_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleRatesSetpoint_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleRatesSetpoint_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleRatesSetpoint_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleRatesSetpoint_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleRatesSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleRatesSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleRatesSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleRatesSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleRatesSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleRatesSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleRatesSetpoint_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleRatesSetpoint_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleRatesSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleRatesSetpoint_& instance_data) = 0;

            protected:
                VehicleRatesSetpoint_DataWriter () {};
                ~VehicleRatesSetpoint_DataWriter () {};
            private:
                VehicleRatesSetpoint_DataWriter (const VehicleRatesSetpoint_DataWriter &);
                VehicleRatesSetpoint_DataWriter & operator = (const VehicleRatesSetpoint_DataWriter &);
            };

            class  VehicleRatesSetpoint_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleRatesSetpoint_DataReader_ptr _ptr_type;
                typedef VehicleRatesSetpoint_DataReader_var _var_type;

                static VehicleRatesSetpoint_DataReader_ptr _duplicate (VehicleRatesSetpoint_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleRatesSetpoint_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleRatesSetpoint_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleRatesSetpoint_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleRatesSetpoint_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleRatesSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleRatesSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleRatesSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleRatesSetpoint_& instance) = 0;

            protected:
                VehicleRatesSetpoint_DataReader () {};
                ~VehicleRatesSetpoint_DataReader () {};
            private:
                VehicleRatesSetpoint_DataReader (const VehicleRatesSetpoint_DataReader &);
                VehicleRatesSetpoint_DataReader & operator = (const VehicleRatesSetpoint_DataReader &);
            };

            class  VehicleRatesSetpoint_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleRatesSetpoint_DataReaderView_ptr _ptr_type;
                typedef VehicleRatesSetpoint_DataReaderView_var _var_type;

                static VehicleRatesSetpoint_DataReaderView_ptr _duplicate (VehicleRatesSetpoint_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleRatesSetpoint_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleRatesSetpoint_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleRatesSetpoint_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleRatesSetpoint_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleRatesSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleRatesSetpoint_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleRatesSetpoint_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleRatesSetpoint_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleRatesSetpoint_& instance) = 0;

            protected:
                VehicleRatesSetpoint_DataReaderView () {};
                ~VehicleRatesSetpoint_DataReaderView () {};
            private:
                VehicleRatesSetpoint_DataReaderView (const VehicleRatesSetpoint_DataReaderView &);
                VehicleRatesSetpoint_DataReaderView & operator = (const VehicleRatesSetpoint_DataReaderView &);
            };
        }

    }

}

#endif
