#ifndef _H_82AAAD2B3D0B65018246E42A85936E16_VehicleRoi__H_
#define _H_82AAAD2B3D0B65018246E42A85936E16_VehicleRoi__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace VehicleRoi_Constants
            {
                const ::DDS::Octet ROI_NONE_ = 0;

                const ::DDS::Octet ROI_WPNEXT_ = 1;

                const ::DDS::Octet ROI_WPINDEX_ = 2;

                const ::DDS::Octet ROI_LOCATION_ = 3;

                const ::DDS::Octet ROI_TARGET_ = 4;

                const ::DDS::Octet ROI_ENUM_END_ = 5;

            }

            struct  VehicleRoi_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet mode_;
                ::DDS::Double lat_;
                ::DDS::Double lon_;
                ::DDS::Float alt_;
                ::DDS::Float roll_offset_;
                ::DDS::Float pitch_offset_;
                ::DDS::Float yaw_offset_;
            };

            typedef DDS_DCPSStruct_var<VehicleRoi_> VehicleRoi__var;
            typedef VehicleRoi_& VehicleRoi__out;

        }

    }

}

#endif /* _H_82AAAD2B3D0B65018246E42A85936E16_VehicleRoi__H_ */
