#ifndef _H_82AAAD2B3D0B65018246E42A85936E16_VehicleRoi_DCPS_H_
#define _H_82AAAD2B3D0B65018246E42A85936E16_VehicleRoi_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleRoi_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleRoi_TypeSupportInterface;

            typedef VehicleRoi_TypeSupportInterface * VehicleRoi_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleRoi_TypeSupportInterface> VehicleRoi_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleRoi_TypeSupportInterface> VehicleRoi_TypeSupportInterface_out;


            class VehicleRoi_DataWriter;

            typedef VehicleRoi_DataWriter * VehicleRoi_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleRoi_DataWriter> VehicleRoi_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleRoi_DataWriter> VehicleRoi_DataWriter_out;


            class VehicleRoi_DataReader;

            typedef VehicleRoi_DataReader * VehicleRoi_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleRoi_DataReader> VehicleRoi_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleRoi_DataReader> VehicleRoi_DataReader_out;


            class VehicleRoi_DataReaderView;

            typedef VehicleRoi_DataReaderView * VehicleRoi_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleRoi_DataReaderView> VehicleRoi_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleRoi_DataReaderView> VehicleRoi_DataReaderView_out;

            struct VehicleRoi_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleRoi_, struct VehicleRoi_Seq_uniq_> VehicleRoi_Seq;
            typedef DDS_DCPSSequence_var < VehicleRoi_Seq> VehicleRoi_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleRoi_Seq> VehicleRoi_Seq_out;

            class  VehicleRoi_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleRoi_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleRoi_TypeSupportInterface_var _var_type;

                static VehicleRoi_TypeSupportInterface_ptr _duplicate (VehicleRoi_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleRoi_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleRoi_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleRoi_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleRoi_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleRoi_TypeSupportInterface () {};
                ~VehicleRoi_TypeSupportInterface () {};
            private:
                VehicleRoi_TypeSupportInterface (const VehicleRoi_TypeSupportInterface &);
                VehicleRoi_TypeSupportInterface & operator = (const VehicleRoi_TypeSupportInterface &);
            };

            class  VehicleRoi_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleRoi_DataWriter_ptr _ptr_type;
                typedef VehicleRoi_DataWriter_var _var_type;

                static VehicleRoi_DataWriter_ptr _duplicate (VehicleRoi_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleRoi_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleRoi_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleRoi_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleRoi_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleRoi_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleRoi_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleRoi_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleRoi_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleRoi_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleRoi_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleRoi_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleRoi_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleRoi_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleRoi_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleRoi_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleRoi_& instance_data) = 0;

            protected:
                VehicleRoi_DataWriter () {};
                ~VehicleRoi_DataWriter () {};
            private:
                VehicleRoi_DataWriter (const VehicleRoi_DataWriter &);
                VehicleRoi_DataWriter & operator = (const VehicleRoi_DataWriter &);
            };

            class  VehicleRoi_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleRoi_DataReader_ptr _ptr_type;
                typedef VehicleRoi_DataReader_var _var_type;

                static VehicleRoi_DataReader_ptr _duplicate (VehicleRoi_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleRoi_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleRoi_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleRoi_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleRoi_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleRoi_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleRoi_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleRoi_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleRoi_& instance) = 0;

            protected:
                VehicleRoi_DataReader () {};
                ~VehicleRoi_DataReader () {};
            private:
                VehicleRoi_DataReader (const VehicleRoi_DataReader &);
                VehicleRoi_DataReader & operator = (const VehicleRoi_DataReader &);
            };

            class  VehicleRoi_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleRoi_DataReaderView_ptr _ptr_type;
                typedef VehicleRoi_DataReaderView_var _var_type;

                static VehicleRoi_DataReaderView_ptr _duplicate (VehicleRoi_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleRoi_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleRoi_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleRoi_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleRoi_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleRoi_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleRoi_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleRoi_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleRoi_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleRoi_& instance) = 0;

            protected:
                VehicleRoi_DataReaderView () {};
                ~VehicleRoi_DataReaderView () {};
            private:
                VehicleRoi_DataReaderView (const VehicleRoi_DataReaderView &);
                VehicleRoi_DataReaderView & operator = (const VehicleRoi_DataReaderView &);
            };
        }

    }

}

#endif
