#ifndef _H_9FBC318E0FDAA884310A0A48C7C05D16_VehicleStatusFlags__H_
#define _H_9FBC318E0FDAA884310A0A48C7C05D16_VehicleStatusFlags__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleStatusFlags_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Boolean condition_calibration_enabled_;
                ::DDS::Boolean condition_system_sensors_initialized_;
                ::DDS::Boolean condition_system_hotplug_timeout_;
                ::DDS::Boolean condition_system_returned_to_home_;
                ::DDS::Boolean condition_auto_mission_available_;
                ::DDS::Boolean condition_global_position_valid_;
                ::DDS::Boolean condition_home_position_valid_;
                ::DDS::Boolean condition_local_position_valid_;
                ::DDS::Boolean condition_local_velocity_valid_;
                ::DDS::Boolean condition_local_altitude_valid_;
                ::DDS::Boolean condition_power_input_valid_;
                ::DDS::Boolean condition_battery_healthy_;
                ::DDS::Boolean condition_escs_error_;
                ::DDS::Boolean circuit_breaker_engaged_power_check_;
                ::DDS::Boolean circuit_breaker_engaged_airspd_check_;
                ::DDS::Boolean circuit_breaker_engaged_enginefailure_check_;
                ::DDS::Boolean circuit_breaker_engaged_gpsfailure_check_;
                ::DDS::Boolean circuit_breaker_flight_termination_disabled_;
                ::DDS::Boolean circuit_breaker_engaged_usb_check_;
                ::DDS::Boolean circuit_breaker_engaged_posfailure_check_;
                ::DDS::Boolean offboard_control_signal_found_once_;
                ::DDS::Boolean offboard_control_signal_lost_;
                ::DDS::Boolean offboard_control_set_by_command_;
                ::DDS::Boolean offboard_control_loss_timeout_;
                ::DDS::Boolean rc_signal_found_once_;
                ::DDS::Boolean rc_input_blocked_;
                ::DDS::Boolean rc_calibration_valid_;
                ::DDS::Boolean vtol_transition_failure_;
                ::DDS::Boolean usb_connected_;
                ::DDS::Boolean avoidance_system_required_;
                ::DDS::Boolean avoidance_system_valid_;
            };

            typedef DDS_DCPSStruct_var<VehicleStatusFlags_> VehicleStatusFlags__var;
            typedef VehicleStatusFlags_& VehicleStatusFlags__out;

        }

    }

}

#endif /* _H_9FBC318E0FDAA884310A0A48C7C05D16_VehicleStatusFlags__H_ */
