#ifndef _H_0D99B8547E4364416545A609D81D4621_VehicleVisualOdometry_DCPS_H_
#define _H_0D99B8547E4364416545A609D81D4621_VehicleVisualOdometry_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleVisualOdometry_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleVisualOdometry_TypeSupportInterface;

            typedef VehicleVisualOdometry_TypeSupportInterface * VehicleVisualOdometry_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisualOdometry_TypeSupportInterface> VehicleVisualOdometry_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleVisualOdometry_TypeSupportInterface> VehicleVisualOdometry_TypeSupportInterface_out;


            class VehicleVisualOdometry_DataWriter;

            typedef VehicleVisualOdometry_DataWriter * VehicleVisualOdometry_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisualOdometry_DataWriter> VehicleVisualOdometry_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleVisualOdometry_DataWriter> VehicleVisualOdometry_DataWriter_out;


            class VehicleVisualOdometry_DataReader;

            typedef VehicleVisualOdometry_DataReader * VehicleVisualOdometry_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisualOdometry_DataReader> VehicleVisualOdometry_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleVisualOdometry_DataReader> VehicleVisualOdometry_DataReader_out;


            class VehicleVisualOdometry_DataReaderView;

            typedef VehicleVisualOdometry_DataReaderView * VehicleVisualOdometry_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleVisualOdometry_DataReaderView> VehicleVisualOdometry_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleVisualOdometry_DataReaderView> VehicleVisualOdometry_DataReaderView_out;

            struct VehicleVisualOdometry_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleVisualOdometry_, struct VehicleVisualOdometry_Seq_uniq_> VehicleVisualOdometry_Seq;
            typedef DDS_DCPSSequence_var < VehicleVisualOdometry_Seq> VehicleVisualOdometry_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleVisualOdometry_Seq> VehicleVisualOdometry_Seq_out;

            class  VehicleVisualOdometry_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleVisualOdometry_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleVisualOdometry_TypeSupportInterface_var _var_type;

                static VehicleVisualOdometry_TypeSupportInterface_ptr _duplicate (VehicleVisualOdometry_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisualOdometry_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometry_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometry_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisualOdometry_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleVisualOdometry_TypeSupportInterface () {};
                ~VehicleVisualOdometry_TypeSupportInterface () {};
            private:
                VehicleVisualOdometry_TypeSupportInterface (const VehicleVisualOdometry_TypeSupportInterface &);
                VehicleVisualOdometry_TypeSupportInterface & operator = (const VehicleVisualOdometry_TypeSupportInterface &);
            };

            class  VehicleVisualOdometry_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleVisualOdometry_DataWriter_ptr _ptr_type;
                typedef VehicleVisualOdometry_DataWriter_var _var_type;

                static VehicleVisualOdometry_DataWriter_ptr _duplicate (VehicleVisualOdometry_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisualOdometry_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometry_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometry_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisualOdometry_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleVisualOdometry_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleVisualOdometry_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleVisualOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleVisualOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleVisualOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleVisualOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleVisualOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleVisualOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleVisualOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleVisualOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleVisualOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisualOdometry_& instance_data) = 0;

            protected:
                VehicleVisualOdometry_DataWriter () {};
                ~VehicleVisualOdometry_DataWriter () {};
            private:
                VehicleVisualOdometry_DataWriter (const VehicleVisualOdometry_DataWriter &);
                VehicleVisualOdometry_DataWriter & operator = (const VehicleVisualOdometry_DataWriter &);
            };

            class  VehicleVisualOdometry_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleVisualOdometry_DataReader_ptr _ptr_type;
                typedef VehicleVisualOdometry_DataReader_var _var_type;

                static VehicleVisualOdometry_DataReader_ptr _duplicate (VehicleVisualOdometry_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisualOdometry_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometry_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometry_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisualOdometry_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleVisualOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleVisualOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleVisualOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisualOdometry_& instance) = 0;

            protected:
                VehicleVisualOdometry_DataReader () {};
                ~VehicleVisualOdometry_DataReader () {};
            private:
                VehicleVisualOdometry_DataReader (const VehicleVisualOdometry_DataReader &);
                VehicleVisualOdometry_DataReader & operator = (const VehicleVisualOdometry_DataReader &);
            };

            class  VehicleVisualOdometry_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleVisualOdometry_DataReaderView_ptr _ptr_type;
                typedef VehicleVisualOdometry_DataReaderView_var _var_type;

                static VehicleVisualOdometry_DataReaderView_ptr _duplicate (VehicleVisualOdometry_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleVisualOdometry_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometry_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleVisualOdometry_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleVisualOdometry_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleVisualOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleVisualOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleVisualOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleVisualOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleVisualOdometry_& instance) = 0;

            protected:
                VehicleVisualOdometry_DataReaderView () {};
                ~VehicleVisualOdometry_DataReaderView () {};
            private:
                VehicleVisualOdometry_DataReaderView (const VehicleVisualOdometry_DataReaderView &);
                VehicleVisualOdometry_DataReaderView & operator = (const VehicleVisualOdometry_DataReaderView &);
            };
        }

    }

}

#endif
