#ifndef _H_805EDE33480F45E1860BA993B19248B5_VtolVehicleStatus_DCPS_H_
#define _H_805EDE33480F45E1860BA993B19248B5_VtolVehicleStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VtolVehicleStatus_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VtolVehicleStatus_TypeSupportInterface;

            typedef VtolVehicleStatus_TypeSupportInterface * VtolVehicleStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VtolVehicleStatus_TypeSupportInterface> VtolVehicleStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VtolVehicleStatus_TypeSupportInterface> VtolVehicleStatus_TypeSupportInterface_out;


            class VtolVehicleStatus_DataWriter;

            typedef VtolVehicleStatus_DataWriter * VtolVehicleStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VtolVehicleStatus_DataWriter> VtolVehicleStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < VtolVehicleStatus_DataWriter> VtolVehicleStatus_DataWriter_out;


            class VtolVehicleStatus_DataReader;

            typedef VtolVehicleStatus_DataReader * VtolVehicleStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VtolVehicleStatus_DataReader> VtolVehicleStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < VtolVehicleStatus_DataReader> VtolVehicleStatus_DataReader_out;


            class VtolVehicleStatus_DataReaderView;

            typedef VtolVehicleStatus_DataReaderView * VtolVehicleStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VtolVehicleStatus_DataReaderView> VtolVehicleStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VtolVehicleStatus_DataReaderView> VtolVehicleStatus_DataReaderView_out;

            struct VtolVehicleStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VtolVehicleStatus_, struct VtolVehicleStatus_Seq_uniq_> VtolVehicleStatus_Seq;
            typedef DDS_DCPSSequence_var < VtolVehicleStatus_Seq> VtolVehicleStatus_Seq_var;
            typedef DDS_DCPSSequence_out < VtolVehicleStatus_Seq> VtolVehicleStatus_Seq_out;

            class  VtolVehicleStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VtolVehicleStatus_TypeSupportInterface_ptr _ptr_type;
                typedef VtolVehicleStatus_TypeSupportInterface_var _var_type;

                static VtolVehicleStatus_TypeSupportInterface_ptr _duplicate (VtolVehicleStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VtolVehicleStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VtolVehicleStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VtolVehicleStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VtolVehicleStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VtolVehicleStatus_TypeSupportInterface () {};
                ~VtolVehicleStatus_TypeSupportInterface () {};
            private:
                VtolVehicleStatus_TypeSupportInterface (const VtolVehicleStatus_TypeSupportInterface &);
                VtolVehicleStatus_TypeSupportInterface & operator = (const VtolVehicleStatus_TypeSupportInterface &);
            };

            class  VtolVehicleStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VtolVehicleStatus_DataWriter_ptr _ptr_type;
                typedef VtolVehicleStatus_DataWriter_var _var_type;

                static VtolVehicleStatus_DataWriter_ptr _duplicate (VtolVehicleStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VtolVehicleStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VtolVehicleStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VtolVehicleStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VtolVehicleStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VtolVehicleStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VtolVehicleStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VtolVehicleStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VtolVehicleStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VtolVehicleStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VtolVehicleStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VtolVehicleStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VtolVehicleStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VtolVehicleStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VtolVehicleStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VtolVehicleStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VtolVehicleStatus_& instance_data) = 0;

            protected:
                VtolVehicleStatus_DataWriter () {};
                ~VtolVehicleStatus_DataWriter () {};
            private:
                VtolVehicleStatus_DataWriter (const VtolVehicleStatus_DataWriter &);
                VtolVehicleStatus_DataWriter & operator = (const VtolVehicleStatus_DataWriter &);
            };

            class  VtolVehicleStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VtolVehicleStatus_DataReader_ptr _ptr_type;
                typedef VtolVehicleStatus_DataReader_var _var_type;

                static VtolVehicleStatus_DataReader_ptr _duplicate (VtolVehicleStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VtolVehicleStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VtolVehicleStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VtolVehicleStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VtolVehicleStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VtolVehicleStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VtolVehicleStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VtolVehicleStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VtolVehicleStatus_& instance) = 0;

            protected:
                VtolVehicleStatus_DataReader () {};
                ~VtolVehicleStatus_DataReader () {};
            private:
                VtolVehicleStatus_DataReader (const VtolVehicleStatus_DataReader &);
                VtolVehicleStatus_DataReader & operator = (const VtolVehicleStatus_DataReader &);
            };

            class  VtolVehicleStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VtolVehicleStatus_DataReaderView_ptr _ptr_type;
                typedef VtolVehicleStatus_DataReaderView_var _var_type;

                static VtolVehicleStatus_DataReaderView_ptr _duplicate (VtolVehicleStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VtolVehicleStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VtolVehicleStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VtolVehicleStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VtolVehicleStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VtolVehicleStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VtolVehicleStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VtolVehicleStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VtolVehicleStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VtolVehicleStatus_& instance) = 0;

            protected:
                VtolVehicleStatus_DataReaderView () {};
                ~VtolVehicleStatus_DataReaderView () {};
            private:
                VtolVehicleStatus_DataReaderView (const VtolVehicleStatus_DataReaderView &);
                VtolVehicleStatus_DataReaderView & operator = (const VtolVehicleStatus_DataReaderView &);
            };
        }

    }

}

#endif
