#ifndef _H_0EC979730CEF451D3A4300C54BAB391D_WindEstimate_DCPS_H_
#define _H_0EC979730CEF451D3A4300C54BAB391D_WindEstimate_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WindEstimate_.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WindEstimate_TypeSupportInterface;

            typedef WindEstimate_TypeSupportInterface * WindEstimate_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WindEstimate_TypeSupportInterface> WindEstimate_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WindEstimate_TypeSupportInterface> WindEstimate_TypeSupportInterface_out;


            class WindEstimate_DataWriter;

            typedef WindEstimate_DataWriter * WindEstimate_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WindEstimate_DataWriter> WindEstimate_DataWriter_var;
            typedef DDS_DCPSInterface_out < WindEstimate_DataWriter> WindEstimate_DataWriter_out;


            class WindEstimate_DataReader;

            typedef WindEstimate_DataReader * WindEstimate_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WindEstimate_DataReader> WindEstimate_DataReader_var;
            typedef DDS_DCPSInterface_out < WindEstimate_DataReader> WindEstimate_DataReader_out;


            class WindEstimate_DataReaderView;

            typedef WindEstimate_DataReaderView * WindEstimate_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WindEstimate_DataReaderView> WindEstimate_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WindEstimate_DataReaderView> WindEstimate_DataReaderView_out;

            struct WindEstimate_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < WindEstimate_, struct WindEstimate_Seq_uniq_> WindEstimate_Seq;
            typedef DDS_DCPSSequence_var < WindEstimate_Seq> WindEstimate_Seq_var;
            typedef DDS_DCPSSequence_out < WindEstimate_Seq> WindEstimate_Seq_out;

            class  WindEstimate_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WindEstimate_TypeSupportInterface_ptr _ptr_type;
                typedef WindEstimate_TypeSupportInterface_var _var_type;

                static WindEstimate_TypeSupportInterface_ptr _duplicate (WindEstimate_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WindEstimate_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WindEstimate_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WindEstimate_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WindEstimate_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WindEstimate_TypeSupportInterface () {};
                ~WindEstimate_TypeSupportInterface () {};
            private:
                WindEstimate_TypeSupportInterface (const WindEstimate_TypeSupportInterface &);
                WindEstimate_TypeSupportInterface & operator = (const WindEstimate_TypeSupportInterface &);
            };

            class  WindEstimate_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WindEstimate_DataWriter_ptr _ptr_type;
                typedef WindEstimate_DataWriter_var _var_type;

                static WindEstimate_DataWriter_ptr _duplicate (WindEstimate_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WindEstimate_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WindEstimate_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WindEstimate_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WindEstimate_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WindEstimate_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WindEstimate_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WindEstimate_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WindEstimate_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WindEstimate_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WindEstimate_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WindEstimate_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WindEstimate_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WindEstimate_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WindEstimate_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WindEstimate_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WindEstimate_& instance_data) = 0;

            protected:
                WindEstimate_DataWriter () {};
                ~WindEstimate_DataWriter () {};
            private:
                WindEstimate_DataWriter (const WindEstimate_DataWriter &);
                WindEstimate_DataWriter & operator = (const WindEstimate_DataWriter &);
            };

            class  WindEstimate_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WindEstimate_DataReader_ptr _ptr_type;
                typedef WindEstimate_DataReader_var _var_type;

                static WindEstimate_DataReader_ptr _duplicate (WindEstimate_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WindEstimate_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WindEstimate_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WindEstimate_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WindEstimate_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WindEstimate_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WindEstimate_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WindEstimate_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WindEstimate_& instance) = 0;

            protected:
                WindEstimate_DataReader () {};
                ~WindEstimate_DataReader () {};
            private:
                WindEstimate_DataReader (const WindEstimate_DataReader &);
                WindEstimate_DataReader & operator = (const WindEstimate_DataReader &);
            };

            class  WindEstimate_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WindEstimate_DataReaderView_ptr _ptr_type;
                typedef WindEstimate_DataReaderView_var _var_type;

                static WindEstimate_DataReaderView_ptr _duplicate (WindEstimate_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WindEstimate_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WindEstimate_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WindEstimate_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WindEstimate_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WindEstimate_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WindEstimate_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WindEstimate_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WindEstimate_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WindEstimate_& instance) = 0;

            protected:
                WindEstimate_DataReaderView () {};
                ~WindEstimate_DataReaderView () {};
            private:
                WindEstimate_DataReaderView (const WindEstimate_DataReaderView &);
                WindEstimate_DataReaderView & operator = (const WindEstimate_DataReaderView &);
            };
        }

    }

}

#endif
