// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/Ekf2Innovations.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__EKF2_INNOVATIONS__STRUCT_HPP_
#define PX4_MSGS__MSG__EKF2_INNOVATIONS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__Ekf2Innovations __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__Ekf2Innovations __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Ekf2Innovations_
{
  using Type = Ekf2Innovations_<ContainerAllocator>;

  explicit Ekf2Innovations_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 6>::iterator, float>(this->vel_pos_innov.begin(), this->vel_pos_innov.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->mag_innov.begin(), this->mag_innov.end(), 0.0f);
      this->heading_innov = 0.0f;
      this->airspeed_innov = 0.0f;
      this->beta_innov = 0.0f;
      std::fill<typename std::array<float, 2>::iterator, float>(this->flow_innov.begin(), this->flow_innov.end(), 0.0f);
      this->hagl_innov = 0.0f;
      std::fill<typename std::array<float, 6>::iterator, float>(this->vel_pos_innov_var.begin(), this->vel_pos_innov_var.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->mag_innov_var.begin(), this->mag_innov_var.end(), 0.0f);
      this->heading_innov_var = 0.0f;
      this->airspeed_innov_var = 0.0f;
      this->beta_innov_var = 0.0f;
      std::fill<typename std::array<float, 2>::iterator, float>(this->flow_innov_var.begin(), this->flow_innov_var.end(), 0.0f);
      this->hagl_innov_var = 0.0f;
      std::fill<typename std::array<float, 3>::iterator, float>(this->output_tracking_error.begin(), this->output_tracking_error.end(), 0.0f);
      std::fill<typename std::array<float, 2>::iterator, float>(this->drag_innov.begin(), this->drag_innov.end(), 0.0f);
      std::fill<typename std::array<float, 2>::iterator, float>(this->drag_innov_var.begin(), this->drag_innov_var.end(), 0.0f);
      std::fill<typename std::array<float, 2>::iterator, float>(this->aux_vel_innov.begin(), this->aux_vel_innov.end(), 0.0f);
    }
  }

  explicit Ekf2Innovations_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : vel_pos_innov(_alloc),
    mag_innov(_alloc),
    flow_innov(_alloc),
    vel_pos_innov_var(_alloc),
    mag_innov_var(_alloc),
    flow_innov_var(_alloc),
    output_tracking_error(_alloc),
    drag_innov(_alloc),
    drag_innov_var(_alloc),
    aux_vel_innov(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 6>::iterator, float>(this->vel_pos_innov.begin(), this->vel_pos_innov.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->mag_innov.begin(), this->mag_innov.end(), 0.0f);
      this->heading_innov = 0.0f;
      this->airspeed_innov = 0.0f;
      this->beta_innov = 0.0f;
      std::fill<typename std::array<float, 2>::iterator, float>(this->flow_innov.begin(), this->flow_innov.end(), 0.0f);
      this->hagl_innov = 0.0f;
      std::fill<typename std::array<float, 6>::iterator, float>(this->vel_pos_innov_var.begin(), this->vel_pos_innov_var.end(), 0.0f);
      std::fill<typename std::array<float, 3>::iterator, float>(this->mag_innov_var.begin(), this->mag_innov_var.end(), 0.0f);
      this->heading_innov_var = 0.0f;
      this->airspeed_innov_var = 0.0f;
      this->beta_innov_var = 0.0f;
      std::fill<typename std::array<float, 2>::iterator, float>(this->flow_innov_var.begin(), this->flow_innov_var.end(), 0.0f);
      this->hagl_innov_var = 0.0f;
      std::fill<typename std::array<float, 3>::iterator, float>(this->output_tracking_error.begin(), this->output_tracking_error.end(), 0.0f);
      std::fill<typename std::array<float, 2>::iterator, float>(this->drag_innov.begin(), this->drag_innov.end(), 0.0f);
      std::fill<typename std::array<float, 2>::iterator, float>(this->drag_innov_var.begin(), this->drag_innov_var.end(), 0.0f);
      std::fill<typename std::array<float, 2>::iterator, float>(this->aux_vel_innov.begin(), this->aux_vel_innov.end(), 0.0f);
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _vel_pos_innov_type =
    std::array<float, 6>;
  _vel_pos_innov_type vel_pos_innov;
  using _mag_innov_type =
    std::array<float, 3>;
  _mag_innov_type mag_innov;
  using _heading_innov_type =
    float;
  _heading_innov_type heading_innov;
  using _airspeed_innov_type =
    float;
  _airspeed_innov_type airspeed_innov;
  using _beta_innov_type =
    float;
  _beta_innov_type beta_innov;
  using _flow_innov_type =
    std::array<float, 2>;
  _flow_innov_type flow_innov;
  using _hagl_innov_type =
    float;
  _hagl_innov_type hagl_innov;
  using _vel_pos_innov_var_type =
    std::array<float, 6>;
  _vel_pos_innov_var_type vel_pos_innov_var;
  using _mag_innov_var_type =
    std::array<float, 3>;
  _mag_innov_var_type mag_innov_var;
  using _heading_innov_var_type =
    float;
  _heading_innov_var_type heading_innov_var;
  using _airspeed_innov_var_type =
    float;
  _airspeed_innov_var_type airspeed_innov_var;
  using _beta_innov_var_type =
    float;
  _beta_innov_var_type beta_innov_var;
  using _flow_innov_var_type =
    std::array<float, 2>;
  _flow_innov_var_type flow_innov_var;
  using _hagl_innov_var_type =
    float;
  _hagl_innov_var_type hagl_innov_var;
  using _output_tracking_error_type =
    std::array<float, 3>;
  _output_tracking_error_type output_tracking_error;
  using _drag_innov_type =
    std::array<float, 2>;
  _drag_innov_type drag_innov;
  using _drag_innov_var_type =
    std::array<float, 2>;
  _drag_innov_var_type drag_innov_var;
  using _aux_vel_innov_type =
    std::array<float, 2>;
  _aux_vel_innov_type aux_vel_innov;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__vel_pos_innov(
    const std::array<float, 6> & _arg)
  {
    this->vel_pos_innov = _arg;
    return *this;
  }
  Type & set__mag_innov(
    const std::array<float, 3> & _arg)
  {
    this->mag_innov = _arg;
    return *this;
  }
  Type & set__heading_innov(
    const float & _arg)
  {
    this->heading_innov = _arg;
    return *this;
  }
  Type & set__airspeed_innov(
    const float & _arg)
  {
    this->airspeed_innov = _arg;
    return *this;
  }
  Type & set__beta_innov(
    const float & _arg)
  {
    this->beta_innov = _arg;
    return *this;
  }
  Type & set__flow_innov(
    const std::array<float, 2> & _arg)
  {
    this->flow_innov = _arg;
    return *this;
  }
  Type & set__hagl_innov(
    const float & _arg)
  {
    this->hagl_innov = _arg;
    return *this;
  }
  Type & set__vel_pos_innov_var(
    const std::array<float, 6> & _arg)
  {
    this->vel_pos_innov_var = _arg;
    return *this;
  }
  Type & set__mag_innov_var(
    const std::array<float, 3> & _arg)
  {
    this->mag_innov_var = _arg;
    return *this;
  }
  Type & set__heading_innov_var(
    const float & _arg)
  {
    this->heading_innov_var = _arg;
    return *this;
  }
  Type & set__airspeed_innov_var(
    const float & _arg)
  {
    this->airspeed_innov_var = _arg;
    return *this;
  }
  Type & set__beta_innov_var(
    const float & _arg)
  {
    this->beta_innov_var = _arg;
    return *this;
  }
  Type & set__flow_innov_var(
    const std::array<float, 2> & _arg)
  {
    this->flow_innov_var = _arg;
    return *this;
  }
  Type & set__hagl_innov_var(
    const float & _arg)
  {
    this->hagl_innov_var = _arg;
    return *this;
  }
  Type & set__output_tracking_error(
    const std::array<float, 3> & _arg)
  {
    this->output_tracking_error = _arg;
    return *this;
  }
  Type & set__drag_innov(
    const std::array<float, 2> & _arg)
  {
    this->drag_innov = _arg;
    return *this;
  }
  Type & set__drag_innov_var(
    const std::array<float, 2> & _arg)
  {
    this->drag_innov_var = _arg;
    return *this;
  }
  Type & set__aux_vel_innov(
    const std::array<float, 2> & _arg)
  {
    this->aux_vel_innov = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    px4_msgs::msg::Ekf2Innovations_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::Ekf2Innovations_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::Ekf2Innovations_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::Ekf2Innovations_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::Ekf2Innovations_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::Ekf2Innovations_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::Ekf2Innovations_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::Ekf2Innovations_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::Ekf2Innovations_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::Ekf2Innovations_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__Ekf2Innovations
    std::shared_ptr<px4_msgs::msg::Ekf2Innovations_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__Ekf2Innovations
    std::shared_ptr<px4_msgs::msg::Ekf2Innovations_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Ekf2Innovations_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->vel_pos_innov != other.vel_pos_innov) {
      return false;
    }
    if (this->mag_innov != other.mag_innov) {
      return false;
    }
    if (this->heading_innov != other.heading_innov) {
      return false;
    }
    if (this->airspeed_innov != other.airspeed_innov) {
      return false;
    }
    if (this->beta_innov != other.beta_innov) {
      return false;
    }
    if (this->flow_innov != other.flow_innov) {
      return false;
    }
    if (this->hagl_innov != other.hagl_innov) {
      return false;
    }
    if (this->vel_pos_innov_var != other.vel_pos_innov_var) {
      return false;
    }
    if (this->mag_innov_var != other.mag_innov_var) {
      return false;
    }
    if (this->heading_innov_var != other.heading_innov_var) {
      return false;
    }
    if (this->airspeed_innov_var != other.airspeed_innov_var) {
      return false;
    }
    if (this->beta_innov_var != other.beta_innov_var) {
      return false;
    }
    if (this->flow_innov_var != other.flow_innov_var) {
      return false;
    }
    if (this->hagl_innov_var != other.hagl_innov_var) {
      return false;
    }
    if (this->output_tracking_error != other.output_tracking_error) {
      return false;
    }
    if (this->drag_innov != other.drag_innov) {
      return false;
    }
    if (this->drag_innov_var != other.drag_innov_var) {
      return false;
    }
    if (this->aux_vel_innov != other.aux_vel_innov) {
      return false;
    }
    return true;
  }
  bool operator!=(const Ekf2Innovations_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Ekf2Innovations_

// alias to use template instance with default allocator
using Ekf2Innovations =
  px4_msgs::msg::Ekf2Innovations_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__EKF2_INNOVATIONS__STRUCT_HPP_
