// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/SensorCombined.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__SENSOR_COMBINED__STRUCT_HPP_
#define PX4_MSGS__MSG__SENSOR_COMBINED__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__SensorCombined __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__SensorCombined __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorCombined_
{
  using Type = SensorCombined_<ContainerAllocator>;

  explicit SensorCombined_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_rad.begin(), this->gyro_rad.end(), 0.0f);
      this->gyro_integral_dt = 0ul;
      this->accelerometer_timestamp_relative = 0l;
      std::fill<typename std::array<float, 3>::iterator, float>(this->accelerometer_m_s2.begin(), this->accelerometer_m_s2.end(), 0.0f);
      this->accelerometer_integral_dt = 0ul;
    }
  }

  explicit SensorCombined_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : gyro_rad(_alloc),
    accelerometer_m_s2(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 3>::iterator, float>(this->gyro_rad.begin(), this->gyro_rad.end(), 0.0f);
      this->gyro_integral_dt = 0ul;
      this->accelerometer_timestamp_relative = 0l;
      std::fill<typename std::array<float, 3>::iterator, float>(this->accelerometer_m_s2.begin(), this->accelerometer_m_s2.end(), 0.0f);
      this->accelerometer_integral_dt = 0ul;
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _gyro_rad_type =
    std::array<float, 3>;
  _gyro_rad_type gyro_rad;
  using _gyro_integral_dt_type =
    uint32_t;
  _gyro_integral_dt_type gyro_integral_dt;
  using _accelerometer_timestamp_relative_type =
    int32_t;
  _accelerometer_timestamp_relative_type accelerometer_timestamp_relative;
  using _accelerometer_m_s2_type =
    std::array<float, 3>;
  _accelerometer_m_s2_type accelerometer_m_s2;
  using _accelerometer_integral_dt_type =
    uint32_t;
  _accelerometer_integral_dt_type accelerometer_integral_dt;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__gyro_rad(
    const std::array<float, 3> & _arg)
  {
    this->gyro_rad = _arg;
    return *this;
  }
  Type & set__gyro_integral_dt(
    const uint32_t & _arg)
  {
    this->gyro_integral_dt = _arg;
    return *this;
  }
  Type & set__accelerometer_timestamp_relative(
    const int32_t & _arg)
  {
    this->accelerometer_timestamp_relative = _arg;
    return *this;
  }
  Type & set__accelerometer_m_s2(
    const std::array<float, 3> & _arg)
  {
    this->accelerometer_m_s2 = _arg;
    return *this;
  }
  Type & set__accelerometer_integral_dt(
    const uint32_t & _arg)
  {
    this->accelerometer_integral_dt = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t RELATIVE_TIMESTAMP_INVALID =
    2147483647;

  // pointer types
  using RawPtr =
    px4_msgs::msg::SensorCombined_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::SensorCombined_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorCombined_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorCombined_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorCombined_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorCombined_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorCombined_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorCombined_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorCombined_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorCombined_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__SensorCombined
    std::shared_ptr<px4_msgs::msg::SensorCombined_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__SensorCombined
    std::shared_ptr<px4_msgs::msg::SensorCombined_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorCombined_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->gyro_rad != other.gyro_rad) {
      return false;
    }
    if (this->gyro_integral_dt != other.gyro_integral_dt) {
      return false;
    }
    if (this->accelerometer_timestamp_relative != other.accelerometer_timestamp_relative) {
      return false;
    }
    if (this->accelerometer_m_s2 != other.accelerometer_m_s2) {
      return false;
    }
    if (this->accelerometer_integral_dt != other.accelerometer_integral_dt) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorCombined_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorCombined_

// alias to use template instance with default allocator
using SensorCombined =
  px4_msgs::msg::SensorCombined_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr int32_t SensorCombined_<ContainerAllocator>::RELATIVE_TIMESTAMP_INVALID;

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__SENSOR_COMBINED__STRUCT_HPP_
