// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/SensorMag.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__SENSOR_MAG__STRUCT_HPP_
#define PX4_MSGS__MSG__SENSOR_MAG__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__SensorMag __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__SensorMag __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorMag_
{
  using Type = SensorMag_<ContainerAllocator>;

  explicit SensorMag_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->device_id = 0ul;
      this->error_count = 0ull;
      this->x = 0.0f;
      this->y = 0.0f;
      this->z = 0.0f;
      this->temperature = 0.0f;
      this->scaling = 0.0f;
      this->x_raw = 0;
      this->y_raw = 0;
      this->z_raw = 0;
      this->is_external = false;
    }
  }

  explicit SensorMag_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->device_id = 0ul;
      this->error_count = 0ull;
      this->x = 0.0f;
      this->y = 0.0f;
      this->z = 0.0f;
      this->temperature = 0.0f;
      this->scaling = 0.0f;
      this->x_raw = 0;
      this->y_raw = 0;
      this->z_raw = 0;
      this->is_external = false;
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _device_id_type =
    uint32_t;
  _device_id_type device_id;
  using _error_count_type =
    uint64_t;
  _error_count_type error_count;
  using _x_type =
    float;
  _x_type x;
  using _y_type =
    float;
  _y_type y;
  using _z_type =
    float;
  _z_type z;
  using _temperature_type =
    float;
  _temperature_type temperature;
  using _scaling_type =
    float;
  _scaling_type scaling;
  using _x_raw_type =
    int16_t;
  _x_raw_type x_raw;
  using _y_raw_type =
    int16_t;
  _y_raw_type y_raw;
  using _z_raw_type =
    int16_t;
  _z_raw_type z_raw;
  using _is_external_type =
    bool;
  _is_external_type is_external;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__device_id(
    const uint32_t & _arg)
  {
    this->device_id = _arg;
    return *this;
  }
  Type & set__error_count(
    const uint64_t & _arg)
  {
    this->error_count = _arg;
    return *this;
  }
  Type & set__x(
    const float & _arg)
  {
    this->x = _arg;
    return *this;
  }
  Type & set__y(
    const float & _arg)
  {
    this->y = _arg;
    return *this;
  }
  Type & set__z(
    const float & _arg)
  {
    this->z = _arg;
    return *this;
  }
  Type & set__temperature(
    const float & _arg)
  {
    this->temperature = _arg;
    return *this;
  }
  Type & set__scaling(
    const float & _arg)
  {
    this->scaling = _arg;
    return *this;
  }
  Type & set__x_raw(
    const int16_t & _arg)
  {
    this->x_raw = _arg;
    return *this;
  }
  Type & set__y_raw(
    const int16_t & _arg)
  {
    this->y_raw = _arg;
    return *this;
  }
  Type & set__z_raw(
    const int16_t & _arg)
  {
    this->z_raw = _arg;
    return *this;
  }
  Type & set__is_external(
    const bool & _arg)
  {
    this->is_external = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    px4_msgs::msg::SensorMag_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::SensorMag_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorMag_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorMag_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorMag_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorMag_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorMag_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorMag_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorMag_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorMag_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__SensorMag
    std::shared_ptr<px4_msgs::msg::SensorMag_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__SensorMag
    std::shared_ptr<px4_msgs::msg::SensorMag_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorMag_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->device_id != other.device_id) {
      return false;
    }
    if (this->error_count != other.error_count) {
      return false;
    }
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    if (this->z != other.z) {
      return false;
    }
    if (this->temperature != other.temperature) {
      return false;
    }
    if (this->scaling != other.scaling) {
      return false;
    }
    if (this->x_raw != other.x_raw) {
      return false;
    }
    if (this->y_raw != other.y_raw) {
      return false;
    }
    if (this->z_raw != other.z_raw) {
      return false;
    }
    if (this->is_external != other.is_external) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorMag_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorMag_

// alias to use template instance with default allocator
using SensorMag =
  px4_msgs::msg::SensorMag_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__SENSOR_MAG__STRUCT_HPP_
