// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/SensorPreflight.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__SENSOR_PREFLIGHT__STRUCT_HPP_
#define PX4_MSGS__MSG__SENSOR_PREFLIGHT__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__SensorPreflight __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__SensorPreflight __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorPreflight_
{
  using Type = SensorPreflight_<ContainerAllocator>;

  explicit SensorPreflight_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->accel_inconsistency_m_s_s = 0.0f;
      this->gyro_inconsistency_rad_s = 0.0f;
      this->mag_inconsistency_angle = 0.0f;
    }
  }

  explicit SensorPreflight_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      this->accel_inconsistency_m_s_s = 0.0f;
      this->gyro_inconsistency_rad_s = 0.0f;
      this->mag_inconsistency_angle = 0.0f;
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _accel_inconsistency_m_s_s_type =
    float;
  _accel_inconsistency_m_s_s_type accel_inconsistency_m_s_s;
  using _gyro_inconsistency_rad_s_type =
    float;
  _gyro_inconsistency_rad_s_type gyro_inconsistency_rad_s;
  using _mag_inconsistency_angle_type =
    float;
  _mag_inconsistency_angle_type mag_inconsistency_angle;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__accel_inconsistency_m_s_s(
    const float & _arg)
  {
    this->accel_inconsistency_m_s_s = _arg;
    return *this;
  }
  Type & set__gyro_inconsistency_rad_s(
    const float & _arg)
  {
    this->gyro_inconsistency_rad_s = _arg;
    return *this;
  }
  Type & set__mag_inconsistency_angle(
    const float & _arg)
  {
    this->mag_inconsistency_angle = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    px4_msgs::msg::SensorPreflight_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::SensorPreflight_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorPreflight_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::SensorPreflight_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorPreflight_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorPreflight_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::SensorPreflight_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::SensorPreflight_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorPreflight_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::SensorPreflight_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__SensorPreflight
    std::shared_ptr<px4_msgs::msg::SensorPreflight_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__SensorPreflight
    std::shared_ptr<px4_msgs::msg::SensorPreflight_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorPreflight_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->accel_inconsistency_m_s_s != other.accel_inconsistency_m_s_s) {
      return false;
    }
    if (this->gyro_inconsistency_rad_s != other.gyro_inconsistency_rad_s) {
      return false;
    }
    if (this->mag_inconsistency_angle != other.mag_inconsistency_angle) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorPreflight_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorPreflight_

// alias to use template instance with default allocator
using SensorPreflight =
  px4_msgs::msg::SensorPreflight_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__SENSOR_PREFLIGHT__STRUCT_HPP_
