// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from px4_msgs:msg/SubsystemInfo.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__SUBSYSTEM_INFO__STRUCT_H_
#define PX4_MSGS__MSG__SUBSYSTEM_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SUBSYSTEM_TYPE_GYRO'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_GYRO = 1ull
};

/// Constant 'SUBSYSTEM_TYPE_ACC'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_ACC = 2ull
};

/// Constant 'SUBSYSTEM_TYPE_MAG'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_MAG = 4ull
};

/// Constant 'SUBSYSTEM_TYPE_ABSPRESSURE'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_ABSPRESSURE = 8ull
};

/// Constant 'SUBSYSTEM_TYPE_DIFFPRESSURE'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_DIFFPRESSURE = 16ull
};

/// Constant 'SUBSYSTEM_TYPE_GPS'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_GPS = 32ull
};

/// Constant 'SUBSYSTEM_TYPE_OPTICALFLOW'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_OPTICALFLOW = 64ull
};

/// Constant 'SUBSYSTEM_TYPE_CVPOSITION'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_CVPOSITION = 128ull
};

/// Constant 'SUBSYSTEM_TYPE_LASERPOSITION'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_LASERPOSITION = 256ull
};

/// Constant 'SUBSYSTEM_TYPE_EXTERNALGROUNDTRUTH'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_EXTERNALGROUNDTRUTH = 512ull
};

/// Constant 'SUBSYSTEM_TYPE_ANGULARRATECONTROL'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_ANGULARRATECONTROL = 1024ull
};

/// Constant 'SUBSYSTEM_TYPE_ATTITUDESTABILIZATION'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_ATTITUDESTABILIZATION = 2048ull
};

/// Constant 'SUBSYSTEM_TYPE_YAWPOSITION'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_YAWPOSITION = 4096ull
};

/// Constant 'SUBSYSTEM_TYPE_ALTITUDECONTROL'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_ALTITUDECONTROL = 8192ull
};

/// Constant 'SUBSYSTEM_TYPE_POSITIONCONTROL'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_POSITIONCONTROL = 16384ull
};

/// Constant 'SUBSYSTEM_TYPE_MOTORCONTROL'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_MOTORCONTROL = 32768ull
};

/// Constant 'SUBSYSTEM_TYPE_RCRECEIVER'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_RCRECEIVER = 65536ull
};

/// Constant 'SUBSYSTEM_TYPE_GYRO2'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_GYRO2 = 131072ull
};

/// Constant 'SUBSYSTEM_TYPE_ACC2'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_ACC2 = 262144ull
};

/// Constant 'SUBSYSTEM_TYPE_MAG2'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_MAG2 = 524288ull
};

/// Constant 'SUBSYSTEM_TYPE_GEOFENCE'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_GEOFENCE = 1048576ull
};

/// Constant 'SUBSYSTEM_TYPE_AHRS'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_AHRS = 2097152ull
};

/// Constant 'SUBSYSTEM_TYPE_TERRAIN'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_TERRAIN = 4194304ull
};

/// Constant 'SUBSYSTEM_TYPE_REVERSEMOTOR'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_REVERSEMOTOR = 8388608ull
};

/// Constant 'SUBSYSTEM_TYPE_LOGGING'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_LOGGING = 16777216ull
};

/// Constant 'SUBSYSTEM_TYPE_SENSORBATTERY'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_SENSORBATTERY = 33554432ull
};

/// Constant 'SUBSYSTEM_TYPE_SENSORPROXIMITY'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_SENSORPROXIMITY = 67108864ull
};

/// Constant 'SUBSYSTEM_TYPE_SATCOM'.
enum
{
  px4_msgs__msg__SubsystemInfo__SUBSYSTEM_TYPE_SATCOM = 134217728ull
};

/// Constant 'ORB_QUEUE_LENGTH'.
enum
{
  px4_msgs__msg__SubsystemInfo__ORB_QUEUE_LENGTH = 5
};

// Struct defined in msg/SubsystemInfo in the package px4_msgs.
typedef struct px4_msgs__msg__SubsystemInfo
{
  uint64_t timestamp;
  bool present;
  bool enabled;
  bool ok;
  uint64_t subsystem_type;
} px4_msgs__msg__SubsystemInfo;

// Struct for a sequence of px4_msgs__msg__SubsystemInfo.
typedef struct px4_msgs__msg__SubsystemInfo__Sequence
{
  px4_msgs__msg__SubsystemInfo * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} px4_msgs__msg__SubsystemInfo__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PX4_MSGS__MSG__SUBSYSTEM_INFO__STRUCT_H_
