// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from px4_msgs:msg/TelemetryStatus.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__TELEMETRY_STATUS__STRUCT_H_
#define PX4_MSGS__MSG__TELEMETRY_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'LINK_TYPE_GENERIC'.
enum
{
  px4_msgs__msg__TelemetryStatus__LINK_TYPE_GENERIC = 0
};

/// Constant 'LINK_TYPE_3DR_RADIO'.
enum
{
  px4_msgs__msg__TelemetryStatus__LINK_TYPE_3DR_RADIO = 1
};

/// Constant 'LINK_TYPE_UBIQUITY_BULLET'.
enum
{
  px4_msgs__msg__TelemetryStatus__LINK_TYPE_UBIQUITY_BULLET = 2
};

/// Constant 'LINK_TYPE_WIRE'.
enum
{
  px4_msgs__msg__TelemetryStatus__LINK_TYPE_WIRE = 3
};

/// Constant 'LINK_TYPE_USB'.
enum
{
  px4_msgs__msg__TelemetryStatus__LINK_TYPE_USB = 4
};

/// Constant 'LINK_TYPE_IRIDIUM'.
enum
{
  px4_msgs__msg__TelemetryStatus__LINK_TYPE_IRIDIUM = 5
};

/// Constant 'COMPONENT_ID_ALL'.
enum
{
  px4_msgs__msg__TelemetryStatus__COMPONENT_ID_ALL = 0
};

/// Constant 'COMPONENT_ID_AUTOPILOT1'.
enum
{
  px4_msgs__msg__TelemetryStatus__COMPONENT_ID_AUTOPILOT1 = 1
};

/// Constant 'COMPONENT_ID_CAMERA'.
enum
{
  px4_msgs__msg__TelemetryStatus__COMPONENT_ID_CAMERA = 100
};

/// Constant 'COMPONENT_ID_OBSTACLE_AVOIDANCE'.
enum
{
  px4_msgs__msg__TelemetryStatus__COMPONENT_ID_OBSTACLE_AVOIDANCE = 196
};

/// Constant 'MAV_TYPE_GENERIC'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_TYPE_GENERIC = 0
};

/// Constant 'MAV_TYPE_GCS'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_TYPE_GCS = 6
};

/// Constant 'MAV_TYPE_ONBOARD_CONTROLLER'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_TYPE_ONBOARD_CONTROLLER = 18
};

/// Constant 'MAV_STATE_UNINIT'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_UNINIT = 0
};

/// Constant 'MAV_STATE_BOOT'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_BOOT = 1
};

/// Constant 'MAV_STATE_CALIBRATING'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_CALIBRATING = 2
};

/// Constant 'MAV_STATE_STANDBY'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_STANDBY = 3
};

/// Constant 'MAV_STATE_ACTIVE'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_ACTIVE = 4
};

/// Constant 'MAV_STATE_CRITICAL'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_CRITICAL = 5
};

/// Constant 'MAV_STATE_EMERGENCY'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_EMERGENCY = 6
};

/// Constant 'MAV_STATE_POWEROFF'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_POWEROFF = 7
};

/// Constant 'MAV_STATE_FLIGHT_TERMINATION'.
enum
{
  px4_msgs__msg__TelemetryStatus__MAV_STATE_FLIGHT_TERMINATION = 8
};

/// Constant 'ORB_QUEUE_LENGTH'.
enum
{
  px4_msgs__msg__TelemetryStatus__ORB_QUEUE_LENGTH = 3
};

// Struct defined in msg/TelemetryStatus in the package px4_msgs.
typedef struct px4_msgs__msg__TelemetryStatus
{
  uint64_t timestamp;
  uint64_t heartbeat_time;
  uint8_t remote_system_id;
  uint8_t remote_component_id;
  uint8_t remote_type;
  uint8_t remote_system_status;
  uint8_t type;
  uint8_t mode;
  bool flow_control;
  bool forwarding;
  bool mavlink_v2;
  bool ftp;
  uint8_t streams;
  float data_rate;
  float rate_multiplier;
  float rate_rx;
  float rate_tx;
  float rate_txerr;
} px4_msgs__msg__TelemetryStatus;

// Struct for a sequence of px4_msgs__msg__TelemetryStatus.
typedef struct px4_msgs__msg__TelemetryStatus__Sequence
{
  px4_msgs__msg__TelemetryStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} px4_msgs__msg__TelemetryStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PX4_MSGS__MSG__TELEMETRY_STATUS__STRUCT_H_
