// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from px4_msgs:msg/VehicleVisionAttitude.idl
// generated code does not contain a copyright notice

#ifndef PX4_MSGS__MSG__VEHICLE_VISION_ATTITUDE__STRUCT_HPP_
#define PX4_MSGS__MSG__VEHICLE_VISION_ATTITUDE__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__px4_msgs__msg__VehicleVisionAttitude __attribute__((deprecated))
#else
# define DEPRECATED__px4_msgs__msg__VehicleVisionAttitude __declspec(deprecated)
#endif

namespace px4_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VehicleVisionAttitude_
{
  using Type = VehicleVisionAttitude_<ContainerAllocator>;

  explicit VehicleVisionAttitude_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 4>::iterator, float>(this->q.begin(), this->q.end(), 0.0f);
      std::fill<typename std::array<float, 4>::iterator, float>(this->delta_q_reset.begin(), this->delta_q_reset.end(), 0.0f);
      this->quat_reset_counter = 0;
    }
  }

  explicit VehicleVisionAttitude_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : q(_alloc),
    delta_q_reset(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
      std::fill<typename std::array<float, 4>::iterator, float>(this->q.begin(), this->q.end(), 0.0f);
      std::fill<typename std::array<float, 4>::iterator, float>(this->delta_q_reset.begin(), this->delta_q_reset.end(), 0.0f);
      this->quat_reset_counter = 0;
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _q_type =
    std::array<float, 4>;
  _q_type q;
  using _delta_q_reset_type =
    std::array<float, 4>;
  _delta_q_reset_type delta_q_reset;
  using _quat_reset_counter_type =
    uint8_t;
  _quat_reset_counter_type quat_reset_counter;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__q(
    const std::array<float, 4> & _arg)
  {
    this->q = _arg;
    return *this;
  }
  Type & set__delta_q_reset(
    const std::array<float, 4> & _arg)
  {
    this->delta_q_reset = _arg;
    return *this;
  }
  Type & set__quat_reset_counter(
    const uint8_t & _arg)
  {
    this->quat_reset_counter = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator> *;
  using ConstRawPtr =
    const px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__px4_msgs__msg__VehicleVisionAttitude
    std::shared_ptr<px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__px4_msgs__msg__VehicleVisionAttitude
    std::shared_ptr<px4_msgs::msg::VehicleVisionAttitude_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VehicleVisionAttitude_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->q != other.q) {
      return false;
    }
    if (this->delta_q_reset != other.delta_q_reset) {
      return false;
    }
    if (this->quat_reset_counter != other.quat_reset_counter) {
      return false;
    }
    return true;
  }
  bool operator!=(const VehicleVisionAttitude_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VehicleVisionAttitude_

// alias to use template instance with default allocator
using VehicleVisionAttitude =
  px4_msgs::msg::VehicleVisionAttitude_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace px4_msgs

#endif  // PX4_MSGS__MSG__VEHICLE_VISION_ATTITUDE__STRUCT_HPP_
